{************************************************************************
  This Unit was modified to be interfaced in IBObjects
  by Lorenzo Mengoni - (Ancona, Italy)

  for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.
  See the ORIGINAL Copyright in source files
                                                                         }
{
 * The contents of this file are subject to the InterBase Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.
 *
 * You may obtain a copy of the License at http://www.Inprise.com/IPL.html.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.  The Original Code was created by Inprise
 * Corporation and its predecessors.
 *
 * Portions created by Inprise Corporation are Copyright (C) Inprise
 * Corporation. All Rights Reserved.
 *
 * Contributor(s):  Krzysztof Golko.
}

{
6.December.2003, Lorenzo:
- Added CheckGDS32 a function hat check the presence of gds32.dll
- patched GetLangText for return untranslated input in case of missing translation
29.December.2003, Lorenzo
- Added Chinese gb2312 and  big5 to predefined lang
}

unit IBOCGlobal;

interface

{$define initlangfile}

Uses
  IB_Constants,
  IB_Session,
{$IFDEF MSWINDOWS}
  Controls, Classes, Graphics, Windows, StdCtrls, ActnList, Menus, Buttons, ComCtrls, ExtCtrls, Forms, Grids, DbGrids,
{$ENDIF}
{$IFDEF LINUX}
  Classes, QControls, QGraphics, QStdCtrls, QActnList, QMenus, QButtons, QComCtrls, QExtCtrls, QForms, QGrids, QDbGrids,
{$ENDIF}
  IBOCPersistentTypes, IBOCPersistent, SynEditHighlighter, SynHighlighterSQL,
  SynEdit, SynMemo, IniFiles;

const
  CRLF = #13#10;              // carriage return linefeed pair

  IBC_LOCALSERVER = 'Local Server';

  NUM_SETTINGS = 24;

  NULL_FLAG = '*^*^*';



  DlgDbFilters = 'Database File (*.gdb *.fdb)|*.gdb;*.fdb'+
                 '|Firebird  (*.fdb)|*.fdb'+
                 '|Interbase (*.gdb)|*.gdb'+
                 '|All files (*.*)|*.*';

  DlgBakFilters = 'Database File (*.gbk *.fbk)|*.gbk;*.fbk'+
                  '|Firebird  (*.fbk)|*.fbk'+
                  '|Interbase (*.gbk)|*.gbk'+
                  '|All files (*.*)|*.*';


(*

ALTER DATABASE
ALTER DOMAIN
ALTER EXCEPTION
ALTER INDEX
ALTER PROCEDURE
ALTER TABLE
ALTER TRIGGER
AVG()
CAST()
CLOSE
COMMIT
CONNECT
COUNT()
CREATE DATABASE
CREATE DOMAIN
CREATE EXCEPTION
CREATE GENERATOR
CREATE INDEX
CREATE PROCEDURE
CREATE ROLE
CREATE SHADOW
CREATE TABLE
CREATE TRIGGER
CREATE VIEW
DECLARE CURSOR
DECLARE EXTERNAL FUNCTION
DECLARE FILTER
DECLARE STATEMENT
DECLARE TABLE
DELETE
DESCRIBE
DISCONNECT
DROP DATABASE
DROP DOMAIN
DROP EXCEPTION
DROP EXTERNAL FUNCTION
DROP FILTER
DROP INDEX
DROP PROCEDURE
DROP ROLE
DROP SHADOW
DROP TABLE
DROP TRIGGER
DROP VIEW
EVENT INIT
EVENT WAIT
EXECUTE
EXECUTE IMMEDIATE
EXECUTE PROCEDURE
FETCH
GEN_ID()
GRANT
INSERT
MAX()
MIN()
OPEN
PREPARE
REVOKE
ROLLBACK
SELECT
SET DATABASE
SET GENERATOR
SET NAMES
SET SQL DIALECT
SET STATISTICS
SET TRANSACTION
SHOW SQL DIALECT
SUM()
UPDATE
UPPER()
WHENEVER

*)

const
  ReservedTokenCount = 312;

var
  fCheckGDS32Ok:boolean;
  fCheckGDS32Msg:String;

  ReservedTokens: array [0..ReservedTokenCount-1] of string = (
   'ABS',
   'ACTION',
   'ACTIVE',
   'ADD',
   'ADMIN',
   'AFTER',
   'ALL',
   'ALTER',
   'AND',
   'ANY',
   'AS',
   'ASC',
   'ASCENDING',
   'AT',
   'AUTO',
   'AUTODDL',
   'AVG',
   'BASE_NAME',
   'BASED',
   'BASENAME',
   'BEFORE',
   'BEGIN',
   'BETWEEN',
   'BIGINT',
   'BLOB',
   'BLOBEDIT',
   'BOOLEAN',
   'BOTH',
   'BREAK',
   'BUFFER',
   'BY',
   'CACHE',
   'CASCADE',
   'CASE',
   'CAST',
   'CHAR_LENGTH',
   'CHAR',
   'CHARACTER_LENGTH',
   'CHARACTER',
   'CHECK_POINT_LEN',
   'CHECK_POINT_LENGTH',
   'CHECK',
   'CLOSE',
   'COALESCE',
   'COLLATE',
   'COLLATION',
   'COLUMN',
   'COMMIT',
   'COMMITTED',
   'COMPILETIME',
   'COMPUTED',
   'CONDITIONAL',
   'CONNECT',
   'CONSTRAINT',
   'CONTAINING',
   'CONTINUE',
   'COUNT',
   'CREATE',
   'CSTRING',
   'CURRENT_CONNECTION',
   'CURRENT_ROLE',
   'CURRENT_TRANSACTION',
   'CURRENT_USER',
   'CURRENT',
   'CURSOR',
   'DATABASE',
   'DATE',
   'DAY',
   'DEBUG',
   'DEC',
   'DECIMAL',
   'DECLARE',
   'DEFAULT',
   'DELETE',
   'DELETING',
   'DESC',
   'DESCENDING',
   'DESCRIBE',
   'DESCRIPTOR',
   'DISCONNECT',
   'DISPLAY',
   'DISTINCT',
   'DO',
   'DOMAIN',
   'DOUBLE',
   'DROP',
   'ECHO',
   'EDIT',
   'ELSE',
   'END',
   'ENTRY_POINT',
   'ESCAPE',
   'EVENT',
   'EXCEPTION',
   'EXECUTE',
   'EXISTS',
   'EXIT',
   'EXTERN',
   'EXTERNAL',
   'EXTRACT',
   'FALSE',
   'FETCH',
   'FILE',
   'FILTER',
   'FIRST',
   'FLOAT',
   'FOR',
   'FOREIGN',
   'FOUND',
   'FREE_IT',
   'FROM',
   'FULL',
   'FUNCTION',
   'GDSCODE',
   'GEN_ID',
   'GENERATOR',
   'GLOBAL',
   'GOTO',
   'GRANT',
   'GROUP_COMMIT_',
   'GROUP_COMMIT_WAIT',
   'GROUP',
   'HAVING',
   'HELP',
   'IF',
   'IIF',
   'IMMEDIATE',
   'IN',
   'INACTIVE',
   'INDEX',
   'INDICATOR',
   'INIT',
   'INNER',
   'INPUT_TYPE',
   'INPUT',
   'INSERT',
   'INSERTING',
   'INT',
   'INTEGER',
   'INTO',
   'IS',
   'ISOLATION',
   'ISQL',
   'JOIN',
   'KEY',
   'LAST',
   'LC_MESSAGES',
   'LC_TYPE',
   'LEADING',
   'LEAVE',
   'LEFT',
   'LENGTH',
   'LEV',
   'LEVEL',
   'LIKE',
   'LOCK',
   'LOG_BUF_SIZE',
   'LOG_BUFFER_SIZE',
   'LOGFILE',
   'LONG',
   'MANUAL',
   'MAX_SEGMENT',
   'MAX',
   'MAXIMUM_SEGMENT',
   'MAXIMUM',
   'MENT',
   'MERGE',
   'MESSAGE',
   'MIN',
   'MINIMUM',
   'MODULE_NAME',
   'MONTH',
   'NAMES',
   'NATIONAL',
   'NATURAL',
   'NCHAR',
   'NO',
   'NOAUTO',
   'NOT',
   'NULL',
   'NULLIF',
   'NULLS',
   'NUM_LOG_BUFFERS',
   'NUM_LOG_BUFS',
   'NUMERIC',
   'OCTET_LENGTH',
   'OF',
   'ON',
   'ONLY',
   'OPEN',
   'OPTION',
   'OR',
   'ORDER',
   'OUTER',
   'OUTPUT_TYPE',
   'OUTPUT',
   'OVERFLOW',
   'PAGE_SIZE',
   'PAGE',
   'PAGES',
   'PARAMETER',
   'PASSWORD',
   'PASSWORD',
   'PERCENT',
   'PLAN',
   'POSITION',
   'POST_EVENT',
   'PRECISION',
   'PREPARE',
   'PRESERVE',
   'PRIMARY',
   'PRIVILEGES',
   'PROCEDURE',
   'PROTECTED',
   'PUBLIC',
   'QUIT',
   'RAW_PARTITIONS',
   'READ',
   'REAL',
   'RECORD_VERSION',
   'RECREATE',
   'REFERENCES',
   'RELEASE',
   'RESERV',
   'RESERVING',
   'RESTRICT',
   'RETAIN',
   'RETURN',
   'RETURNING_VALUES',
   'RETURNS',
   'REVOKE',
   'RIGHT',
   'ROLE',
   'ROLLBACK',
   'ROW_COUNT',
   'ROWS',
   'RUNTIME',
   'SAVEPOINT',
   'SCHEMA',
   'SEGMENT',
   'SELECT',
   'SET',
   'SHADOW',
   'SHARED',
   'SHELL',
   'SHOW',
   'SINGULAR',
   'SIZE',
   'SKIP',
   'SMALLINT',
   'SNAPSHOT',
   'SOME',
   'SORT',
   'SQL',
   'SQLCODE',
   'SQLERROR',
   'SQLWARNING',
   'STABILITY',
   'STARTING',
   'STARTS',
   'STATE',
   'STATEMENT',
   'STATIC',
   'STATISTICS',
   'SUB_TYPE',
   'SUBSTRING',
   'SUM',
   'SUSPEND',
   'TABLE',
   'TEMPORARY',
   'TERMINATOR',
   'THEN',
   'TIES',
   'TIME',
   'TO',
   'TRAILING',
   'TRANSACTION',
   'TRANSLATE',
   'TRANSLATION',
   'TRIGGER',
   'TRIM',
   'TRIM',
   'TRUE',
   'TRUE',
   'TYPE',
   'TYPE',
   'UNCOMMITTED',
   'UNION',
   'UNIQUE',
   'UNKNOWN',
   'UPDATE',
   'UPDATING',
   'UPPER',
   'USER',
   'USING',
   'VALUE',
   'VALUES',
   'VARCHAR',
   'VARIABLE',
   'VARYING',
   'VERSION',
   'VIEW',
   'WAIT_TIME',
   'WAIT',
   'WHEN',
   'WHENEVER',
   'WHERE',
   'WHILE',
   'WITH',
   'WORK',
   'WRITE',
   'YEAR'
   );

var ReservedTokens2:string;

const

{Boolean Settings}
  SYSTEM_DATA = 0;
  DEPENDENCIES = 1;
  USE_DEFAULT_EDITOR = 2;
  SHOW_QUERY_PLAN = 3;
  AUTO_COMMIT_DDL = 4;
  SHOW_STATS = 5;
  SHOW_LIST = 6;
  SAVE_ISQL_OUTPUT = 7;
  UPDATE_ON_CONNECT = 8;
  UPDATE_ON_CREATE = 9;
  CLEAR_INPUT = 10;

{String Settings}
  CHARACTER_SET = 11;
  BLOB_DISPLAY = 12;
  BLOB_SUBTYPE = 13;
  ISQL_TERMINATOR = 14;

{Integer Settings}
  COMMIT_ON_EXIT = 15;
  VIEW_STYLE = 16;
  DEFAULT_DIALECT = 17;
  FORCE_UPPERCASE_IDENTIFIER = 18;

{Font Settings}
  FONT_NAME = 19;
  FONT_CHARSET = 20;

{Font Settings}
  SYNTAX_FONT_NAME = 21;
  SYNTAX_FONT_CHARSET = 22;

  GUI_LANGUAGE = 23;



type

  TAppSetting = record
    Name: String;
    Setting: variant;
  end;

  TXFont = Class(TFont)
  end;

{  TASCIIChars = set of 0..255;
  TAppSettings = array[0..17] of TAppSetting; }

var
  gPersistentInfo: TibcPersistentInfo;

  gExternalApps: TStringList;
  gApplShutdown: boolean;
  gWinTempPath: String;
  gAppSettings: TPersistentSettings;

  gApplExePath: string;

  gTransIniFile:TIniFile;
  gGUILanguageFile:TIniFile;

const
  { Transactions }
  TRA_DDL = 1;  // ddl transaction
  TRA_DFLT = 2;  // default transaction

  { Tree Nodes.  Must be in the same order as NODE_ARRAY below! }
  NODE_SERVERS = 000;
  NODE_SERVER = 001;
  NODE_DATABASES = 002;
  NODE_DATABASE = 003;
  NODE_BACKUP_ALIASES = 004;
  NODE_BACKUP_ALIAS = 005;
  NODE_USERS = 006;
  NODE_USER = 007;
  NODE_CERTIFICATES = 008;
  NODE_CERTIFICATE = 009;
  NODE_DOMAINS = 010;
  NODE_DOMAIN = 011;
  NODE_TABLES = 012;
  NODE_TABLE = 013;
  NODE_VIEWS = 014;
  NODE_VIEW = 015;
  NODE_PROCEDURES = 016;
  NODE_PROCEDURE = 017;
  NODE_FUNCTIONS = 018;
  NODE_FUNCTION = 019;
  NODE_GENERATORS = 020;
  NODE_GENERATOR = 021;
  NODE_EXCEPTIONS = 022;
  NODE_EXCEPTION = 023;
  NODE_BLOB_FILTERS = 024;
  NODE_BLOB_FILTER = 025;
  NODE_ROLES = 026;
  NODE_ROLE = 027;
  NODE_COLUMNS = 028;
  NODE_COLUMN = 029;
  NODE_INDEXES = 030;
  NODE_INDEX = 031;
  NODE_REFERENTIAL_CONSTRAINTS = 032;
  NODE_REFERENTIAL_CONSTRAINT = 033;
  NODE_UNIQUE_CONSTRAINTS = 034;
  NODE_UNIQUE_CONSTRAINT = 035;
  NODE_CHECK_CONSTRAINTS = 036;
  NODE_CHECK_CONSTRAINT = 037;
  NODE_TRIGGERS = 038;
  NODE_TRIGGER = 039;
  NODE_LOGS = 040;
  NODE_UNK = 999;

  { Number of nodes starting at 0 }
  NODES = 41;


  { Image list indexes }
  NODE_SERVERS_INACTIVE_IMG = 1;
  NODE_DATABASES_DISCONNECTED_IMG = 2;
  NODE_BACKUP_ALIAS_IMG = 3;
  NODE_USER_IMG = 4;
  NODE_CERTIFICATE_IMG = 5;
  NODE_DOMAINS_IMG = 6;
  NODE_TABLES_IMG = 7;
  NODE_VIEWS_IMG = 8;
  NODE_PROCEDURES_IMG = 9;
  NODE_FUNCTIONS_IMG = 10;
  NODE_GENERATORS_IMG = 11;
  NODE_EXCEPTIONS_IMG = 12;
  NODE_BLOB_FILTERS_IMG = 13;
  NODE_ROLES_IMG = 14;
  NODE_COLUMNS_IMG = 15;
  NODE_INDEXES_IMG = 16;
  NODE_REFERENTIAL_CONSTRAINTS_IMG = 17;
  NODE_UNIQUE_CONSTRAINTS_IMG = 18;
  NODE_CHECK_CONSTRAINTS_IMG = 19;
  NODE_TRIGGERS_IMG = 20;
  NODE_UNK_IMG = 21;
  NODE_SERVERS_ACTIVE_IMG = 22;
  NODE_DATABASES_CONNECTED_IMG = 23;
  NODE_DATABASES_IMG = 24;
  NODE_BACKUP_ALIASES_IMG = 25;
  NODE_USERS_IMG = 26;
  NODE_CERTIFICATES_IMG = 27;
  NODE_LOGS_IMG = 29;
  NODE_PROGRAM_ICON_IMG = 31;
  NODE_WISQL_IMG = 32;
  IMG_GRANT_OPT = 46;
  IMG_WHITE = 51;

  { This array must be in the same order as the node constants above }
  NODE_ARRAY: array [0..NODES] of String = (
    'Servers',
    'Server',
    'Databases',
    'Database',
    'Backup',
    'Backup',
    'Users',
    'User',
    'Certificates',
    'Certificate',
    'Domains',
    'Domain',
    'Tables',
    'Table',
    'Views',
    'View',
    'Stored Procedures',
    'Stored Procedure',
    'External Functions',
    'External Function',
    'Generators',
    'Generator',
    'Exceptions',
    'Exception',
    'Blob Filters',
    'Blob Filter',
    'Roles',
    'Role',
    'Columns',
    'Column',
    'Indexes',
    'Index',
    'Referential Constraints',
    'Referential Constraint',
    'Unique Constraints',
    'Unique Constraint',
    'Check Constraints',
    'Check Constraint',
    'Triggers',
    'Trigger',
    'Server Log',
    'Unknown');

  DEL = '~|';
  SING_QUOTE = '''';

  APP_VERSION = 'Version 1.0';

  ENABLE = true;
  DISABLE = false;

  SUCCESS = 0;
  FAILURE = -1;
  EMPTY = -2;
  CANCELED = -3;
  RETRY = -4;
  REGISTER_SERVER = 0;
  SELECT_SERVER = 1;

  FROM_MEMORY = 'M';
  FROM_FILE = 'F';

  DEP_TABLE = 0;
  DEP_VIEW = 1;
  DEP_TRIGGER = 2;
  DEP_COMPUTED_FIELD = 3;
  DEP_VALIDATION = 4;
  DEP_PROCEDURE = 5;
  DEP_EXPRESSION_INDEX = 6;
  DEP_EXCEPTION = 7;
  DEP_USER = 8;
  DEP_FIELD = 9;
  DEP_INDEX = 10;

  NULL_STR = '<null>';
  NULL_BLOB = '(Blob)';
  BLOB_STR = '(BLOB)';

{ From jrd\obj.h ... object types }
  obj_relation =           0;
  obj_view     =           1;
  obj_trigger  =           2;
  obj_computed =           3;
  obj_validation =         4;
  obj_procedure  =         5;
  obj_expression_index =   6;
  obj_exception        =   7;
  obj_user             =   8;
  obj_field            =   9;
  obj_index            =   10;
  obj_count            =   11;
  obj_user_group       =   12;
  obj_sql_role         =   13;

{ This list must be in the same order as the
  constants below!}

  SETTINGS: array [0..NUM_SETTINGS-1] of String = (
{Boolean Options}
    'SystemData',
    'Dependencies',
    'UseDefaultEditor',
    'ShowQueryPlan',
    'AutoCommitDDL',
    'ShowStatistics',
    'ShowInListFormat',
    'SaveISQLOutput',
    'UpdateOnConnect',
    'UpdateOnCreate',
    'ClearInput',

{String Options}
    'CharacterSet',
    'BlobDisplay',
    'BlobSubtype',
    'ISQLTerminator',

{Integer Settings}
    'CommitOnExit',
    'ViewStyle',
    'DefaultDialect',
    'Force Uppercase Identifier',

{Font Settings}
    'Font Name',
    'Font Charset',

{Font Settings}
    'Syntax Font Name',
    'Syntax Font Charset',
{Language}
    'Language'
    );

type
   TLangRec=record
     Caption:string;
     Id:string;
   end;


const
   NUM_LANGUAGES = 28;
   gLanguagesArray:array[0..NUM_LANGUAGES-1] of TLangRec =
   (
      (Caption:'Brazilian Portuguese'; Id:'pt-br'; ),
      (Caption:'Bulgarian'; Id:'bg'; ),
      (Caption:'Catalan'; Id:'ca'; ),
      (Caption:'Chinese Traditional'; Id:'cn-trad';),
      (Caption:'Chinese big5'; Id:'cn-big5';),
      (Caption:'Chinese gb2312'; Id:'cn-gb2312';),
      (Caption:'Croatian'; Id:'hr';),
      (Caption:'Czech'; Id:'cz'; ),
      (Caption:'Danish'; Id:'da'),
      (Caption:'Dutch'; Id:'nl'; ),
      (Caption:'English'; Id:'en'; ),
      (Caption:'Estonian'; Id:'et';),
      (Caption:'French'; Id:'fr'; ),
      (Caption:'German'; Id:'de'; ),
      (Caption:'Greek-Modern'; Id:'el'; ),
      (Caption:'Italiano'; Id:'it'; ),
      (Caption:'Japanese'; Id:'ja'; ),
      (Caption:'Korean'; Id:'ko'; ),
      (Caption:'Luxembourgeois'; Id:'ltz'; ),
      (Caption:'Norwegian'; Id:'no'; ),
      (Caption:'Norwegian Nynorsk'; Id:'nn'; ),
      (Caption:'Polish'; Id:'pl'; ),
      (Caption:'Portugese'; Id:'pt'; ),
      (Caption:'Romanian'; Id:'ro'; ),
      (Caption:'Russian'; Id:'ru'; ),
      (Caption:'Slovak'; Id:'sk'; ),
      (Caption:'Spanish'; Id:'es'; ),
      (Caption:'Swedish'; Id:'sv'; )
   );

procedure GetLanguageList(const List:TStrings);
function GetLanguageId(const Value:string):string;
function ConvertFieldType(ftype, flen, fscale, fsubtype, fprecision : Integer; Dialect : Integer) : String;
function ConvertTabs(Data : String; Editor : TSynEdit) : String;
function CheckNameKey(const Key: Char; const SQLDialect:integer):Char;
function ConvertNameUppercase(const Name: String):String;
function NodeMatch(A,B:integer):boolean;
function NodeImg(A:Integer):integer;
function AdjustName(const Name: String; const SQLDialect:integer):String;
//procedure SetFonts(const o:TObject; const NewFont:TFont);
//procedure SetAllFonts(const o:TObject; const NewFont:TFont);
procedure SetAllFontsNameCharset(const o:TComponent; const aFontName:TFontName; const aFontCharset:TFontCharset);
procedure SetFontsNameCharset(const o:TObject; const aFontName:TFontName; const aFontCharset:TFontCharset);
procedure SetAllSyntaxFontsNameCharset(const o:TComponent; const aFontName:TFontName; const aFontCharset:TFontCharset);
procedure GetAllCaptionAndText(const path:string; const o:TComponent; const inifile:TIniFile);
procedure MergeIniFiles(source,dest:TIniFile);
{$ifdef initlangfile}
procedure WriteAllCaptionAndText(const path:string; const o:TComponent; const inifile:TIniFile);
procedure WritePrompts;
{$endif}
function GetLangText(const Text:string):string;
function GetLangType(const Text:string):string; overload;
function GetPrompt(const Id:integer):string;
function GetLangType(const id:integer):string; overload;
function GetTypeArticle(const id:integer):string; overload;
function GetTypeArticle(const Text:string):string; overload;
function GetLanguageString(const Id:string):string;
function CheckGDS32(var msg:string):boolean;
procedure GlobalTestClientLibrary;
procedure GlobalTestHistance;

type

  TTokenType = (ttkNone, ttkKeyWord, ttkIdent, ttkNumber, ttkString, ttkComment,
                ttkTerm, ttkComma, ttkBracket, ttkOperator, ttkOther);

  TToken = record
    Offset : Longint;
    Len : LongInt;
    TokenType : TTokenType;
    TokenText : String;
  end;

  TParseState = (psNormal, psIdent, psKeyword, psNumber,
                 psString, psComment, psBracket, psOperator,
                 psTerminator, psComma);

  TTextParser = class(TObject)
  private
    FInput : String;
    FTermChar : Char;
    Ch, Next: Char;
    FState : TParseState;
    FOutPut : String;
    FPrior : Boolean;
    FIndex : Integer;
    StrDelimCount : Integer;
    procedure PushChar(Ch: Char);
    procedure Mark;

    procedure SetInput(Value : String);
    function GetNextToken : TToken;
  public
    property NextToken : TToken read GetNextToken;
    property Input : String read FInput write SetInPut;
    property TerminatorChar : Char read FTermChar write FTermChar;
  end;


implementation

uses IB_Header, SysUtils, TypInfo;

function CheckGDS32(var msg:string):boolean;
{$IFDEF MSWINDOWS}
var
  SaveCW: word;
  _GDS_Handle:THandle;
{$ENDIF}
begin
{$IFDEF LINUX}
  result :=true;
  msg:='';
{$ENDIF}
{$IFDEF MSWINDOWS}
  msg:='';
  try
    asm fstcw [SaveCW] end;
    _GDS_Handle := LoadLibrary( pchar(IB_GDS32) );
    asm fldcw [SaveCW] end;
    try
      if _GDS_Handle < 32 then
      begin
        msg:='Error while loading library '+IB_GDS32+': '+SysErrorMessage(GetLastError);
        result := false;
        //IB_Constants.IB_GDS32 := 'fbclient.dll';
      end
      else
        result := true;
    finally
      try
        FreeLibrary(_GDS_Handle);
      except
      end;
    end;
  except
    on e:Exception do
    begin
      result :=false;
      msg:=e.Message;
    end;
  end;
{$ENDIF}
end;


function GetLanguageId(const Value:string):string;
var n:integer;
begin
  result := '';
  for n := 0 to NUM_LANGUAGES-1 do
  begin
    if gLanguagesArray[n].Caption = value then
    begin
      result := gLanguagesArray[n].Id;
      break;
    end;
  end;
end;

function GetLanguageString(const Id:string):string;
var n:integer;
begin
  result := '';
  for n := 0 to NUM_LANGUAGES-1 do
  begin
    if gLanguagesArray[n].Id = Id then
    begin
      result := gLanguagesArray[n].Caption;
      break;
    end;
  end;
end;

procedure GetLanguageList(const List:TStrings);
var n:integer;
begin
  List.Clear;
  for n := 0 to NUM_LANGUAGES-1 do
  begin
    List.Add(gLanguagesArray[n].Caption);
  end;
end;

procedure InitSettings;
var
  I: integer;
begin
  gAppSettings := TPersistentSettings.Create(NUM_SETTINGS);
  for i := 0 to NUM_SETTINGS - 1 do
  begin
    gAppSettings.Names[I] := SETTINGS[i];
    case i of
      SYSTEM_DATA:
        gAppSettings.Values[i] := false;
      DEPENDENCIES:
        gAppSettings.Values[i] := true;
      USE_DEFAULT_EDITOR:
        gAppSettings.Values[i] := true;
      SHOW_QUERY_PLAN:
        gAppSettings.Values[i] := true;
      AUTO_COMMIT_DDL:
        gAppSettings.Values[i] := true;
      SHOW_STATS:
        gAppSettings.Values[i] := true;
      SHOW_LIST:
        gAppSettings.Values[i] := false;
      SAVE_ISQL_OUTPUT:
        gAppSettings.Values[i] := false;
      UPDATE_ON_CONNECT:

        gAppSettings.Values[i] := false;
      UPDATE_ON_CREATE:
        gAppSettings.Values[i] := false;
      CLEAR_INPUT:
        gAppSettings.Values[i] := true;

      CHARACTER_SET:
        gAppSettings.Values[i] := 'None';
      BLOB_DISPLAY:
        gAppSettings.Values[i] := 'Restrict';
      BLOB_SUBTYPE:
        gAppSettings.Values[i] := 'Text';
      ISQL_TERMINATOR:
        gAppSettings.Values[i] := ';';

      COMMIT_ON_EXIT:
        gAppSettings.Values[i] := 0;
      VIEW_STYLE:
        gAppSettings.Values[i] := 3;
      DEFAULT_DIALECT:
        gAppSettings.Values[i] := 3;
      FORCE_UPPERCASE_IDENTIFIER:
        gAppSettings.Values[i] := False;
      FONT_NAME:
{$IFDEF MSWINDOWS}
        gAppSettings.Values[i] := 'MS Sans Serif';
{$ENDIF}
{$IFDEF LINUX}
        gAppSettings.Values[i] := 'Helvetica';
{$ENDIF}
      FONT_CHARSET:
{$IFDEF MSWINDOWS}
        gAppSettings.Values[i] := DEFAULT_CHARSET;
{$ENDIF}
{$IFDEF LINUX}
        gAppSettings.Values[i] := fcsDefaultCharSet;
{$ENDIF}
      SYNTAX_FONT_NAME:
{$IFDEF MSWINDOWS}
        gAppSettings.Values[i] := 'Courier New';
{$ENDIF}
{$IFDEF LINUX}
        gAppSettings.Values[i] := 'Helvetica';
{$ENDIF}
      SYNTAX_FONT_CHARSET:
{$IFDEF MSWINDOWS}
        gAppSettings.Values[i] := DEFAULT_CHARSET;
{$ENDIF}
{$IFDEF LINUX}
        gAppSettings.Values[i] := fcsDefaultCharSet;
{$ENDIF}
      GUI_LANGUAGE:
        gAppSettings.Values[i] := 'en';
    end;
  end;
end;

function ConvertFieldType(ftype, flen, fscale, fsubtype, fprecision : Integer; Dialect : Integer) : String;
begin
  fScale := Abs(fscale);
  Case ftype of
    blr_short :
      begin
        if Dialect = 3 then
        begin
          case fsubtype of
            0 :
              begin
                Result := 'smallint';
              end;
            1 :
              begin
                Result := 'numeric(' + IntToStr(fprecision) + ', ' + IntToStr(fscale) + ')'
              end;
            2 :
              begin
                Result := 'decimal(' + IntToStr(fprecision) + ', ' + IntToStr(fscale) + ')'
              end;
          end;
        end
        else
        begin
          if fscale <> 0 then
          begin
            Result := 'decimal(4, ' + IntToStr(fscale) + ')'
          end
          else
            Result := 'smallint';
        end;
      end;

    blr_long :
      begin
        if Dialect = 3  then
        begin
          case fsubtype of
            0 :
              begin
                Result := 'integer';
              end;
            1 :
              begin
                Result := 'numeric(' + IntToStr(fprecision) + ', ' + IntToStr(fscale) + ')'
              end;
            2 :
              begin
                Result := 'decimal(' + IntToStr(fprecision) + ', ' + IntToStr(fscale) + ')'
              end;
          end;
        end
        else
        begin
          if fscale <> 0 then
          begin
            Result := 'decimal(9, ' + IntToStr(fscale) + ')'
          end
          else
            Result := 'integer';
        end;
      end;

    blr_int64 :
      begin
        if Dialect = 3  then
        begin
          case fsubtype of
            0 :
              begin
                Result := 'decimal(18, 0)';
              end;
            1 :
              begin
                Result := 'numeric(' + IntToStr(fprecision) + ', ' + IntToStr(fscale) + ')'
              end;
            2 :
              begin
                Result := 'decimal(' + IntToStr(fprecision) + ', ' + IntToStr(fscale) + ')'
              end;
          end;
        end;
      end;

    blr_float :
      begin
        Result := 'float';
      end;


    blr_text :
      begin
        Result := 'char(' + IntToStr(flen) + ')';
      end;

    blr_double :
      begin
        if fscale <> 0 then
        begin
          Result := 'decimal(15, ' + IntToStr(fscale) + ')';
        end
        else
          Result := 'double precision';
      end;

    blr_timestamp :
      begin
        if Dialect = 3 then
          Result := 'timestamp'
        else
          Result := 'date'
      end;

    blr_sql_time :
      begin
        Result := 'time'
      end;

    blr_sql_date :
      begin
        Result := 'date'
      end;

    blr_varying :
      begin
        Result := 'varchar(' + IntToStr(flen) + ')';
      end;

    blr_cstring :
      begin
        Result := 'cstring(' + IntToStr(flen) + ')';
      end;

    blr_blob :
      begin
        Result := 'blob';
      end;
  end;
end;

function ConvertTabs(Data : String; Editor : TSynEdit) : String;
var
  Idx : Integer;
  Idy : Integer;
  Tmp : String;

begin
  Tmp := '';
  for Idx := 1 to Length(Data) do
  begin
    if Data[Idx] = #9 then
    begin
      for Idy := 1 to Editor.TabWidth do
        Tmp := Tmp + ' ';
    end
    else
      Tmp := Tmp + Data[Idx];
  end;
  Result := Tmp;
end;

const
  STRDELIM1 = '"';
  STRDELIM2 = #39;


const
  DIGIT = ['0'..'9'];
  ALPHA = ['A'..'Z', 'a'..'z'];
  IDENT = ALPHA + DIGIT + ['_', '$'];

  ZERO =  '0';
  NINE =  '9';
  TAB =   #9;
  SPACE = ' ';
  CR =    #13;
  NULL =  #0;
  LF =    #10;

procedure TTextParser.SetInput(Value : String);
begin
  FInput := Value;
  FTermChar := ';';
  Findex := 1;
end;

procedure TTextParser.PushChar(Ch: Char);
begin
  FOutput := FOutPut + Ch;
  Inc(FIndex);
end;

procedure TTextParser.Mark;
begin
  FPrior := False;
end;

function TTextParser.GetNextToken : TToken;
begin
  if Not (Length(FInput) > 0) then
    raise Exception.Create(GetLangText('No input'));
  if FIndex > Length(FInput) then
  begin
    Result.Offset := 0;
    Result.Len := 0;
    Result.TokenType := ttkNone;
    Result.TokenText := '';
  end;

  while FIndex <= Length(FInput) do
  begin
    Ch := FInput[FIndex];
    if FIndex < Length(FInput) then
      Next := FInput[FIndex + 1]
    else
      Next := #0;

    case FState of
      psIdent :
        begin
          if not (Ch in  ALPHA + [ZERO..NINE, '_', '$']) then
          begin
            Result.Offset := FIndex - Length(FOutPut);
            Result.Len := Length(FOutPut);
            Result.TokenType := ttkIdent;
            Result.TokenText := FOutPut;
            FState := psNormal;
            Exit;
          end
          else
            FOutPut := FOutPut + Ch;
        end;

      psOperator :
        begin
          if not (Ch in ['>','<','=','+','-']) then
          begin
            Result.Offset := FIndex - Length(FOutPut);
            Result.Len := Length(FOutPut);
            Result.TokenType := ttkOperator;
            Result.TokenText := FOutPut;
            FState := psNormal;
            Exit;
          end
          else
            FOutPut := FOutPut + Ch;
        end;

      psBracket :
        begin
          Result.Offset := FIndex - Length(FOutPut);
          Result.Len := Length(FOutPut);
          Result.TokenType := ttkBracket;
          Result.TokenText := FOutPut;
          FState := psNormal;
          Exit;
        end;

      psTerminator :
        begin
          Result.Offset := FIndex - Length(FOutPut);
          Result.Len := Length(FOutPut);
          Result.TokenType := ttkTerm;
          Result.TokenText := FOutPut;
          FState := psNormal;
          Exit;
        end;

      psComma :
        begin
          Result.Offset := FIndex - Length(FOutPut);
          Result.Len := Length(FOutPut);
          Result.TokenType := ttkComma;
          Result.TokenText := FOutPut;
          FState := psNormal;
          Exit;
        end;

      psNumber :
        begin
          if not (Ch in [ZERO..NINE,'.','E','e']) then
          begin
            Result.Offset := FIndex - Length(FOutPut);
            Result.Len := Length(FOutPut);
            Result.TokenType := ttkNumber;
            Result.TokenText := FOutPut;
            FState := psNormal;
            Exit;
          end
          else
            FOutPut := FOutPut + Ch;
        end;

      psString :
        begin
          case Ch of
            STRDELIM1, STRDELIM2:
              begin
                FOutPut := FOutPut + Ch;
                StrDelimCount := StrDelimCount + 1;
                if Not Odd(StrDelimCount) then
                begin
                  if Not (Next in [STRDELIM1, STRDELIM2]) then
                  begin
                    Result.Offset := FIndex - Length(FOutPut);
                    Result.Len := Length(FOutPut);
                    Result.TokenType := ttkString;
                    Result.TokenText := FOutPut;
                    FState := psNormal;
                    PushChar(Next);
                    Exit;
                  end
                  else
                  begin
                    PushChar(Next);
                    StrDelimCount := StrDelimCount + 1;
                  end;
                end
                else
                begin
                  StrDelimCount := StrDelimCount + 1;
                end;
              end;
          else
            begin
              FOutPut := FOutPut + Ch;
            end;
          end;
        end;

      psNormal :
        begin
          if Ch = FTermChar then
          begin
            FState := psTerminator;
          end
          else
          begin
            case Ch of
              SPACE, NULL, TAB, CR, LF : ;

              '>','<','=','+','-' :
                begin
                  FState := psOperator;
                end;

              '[',']','(',')' :
                begin
                  FState := psBracket;
                end;

              ',' :
                begin
                  FState := psComma;
                end;

              ZERO..NINE :
                begin
                  FState := psNumber;
                end;

              '#','$' :
                begin
                  if Next in DIGIT then
                  begin
                    FState := psNumber;
                    Mark;
                  end;
                end;

              'A'..'Z','a'..'z', '_' :
                begin
                  begin
                    FState := psIdent;
                    Mark;
                  end;
                end;

              STRDELIM1, STRDELIM2:
                begin
                  begin
                    FState := psString;
                    StrDelimCount := 1;
                    Mark;
                  end;
                end;


              '/' :
                begin
                  if Next = '*' then
                  begin
                    FState := psComment;
                    Mark;
                  end;
                end;
            end;
          end;
          FOutPut := Ch;
        end;

      psComment :
        begin
          if Ch = '*' then
          begin
            FOutput := FOutPut + Ch;
            if Next = '/' then
            begin
              PushChar(Next);
              Result.Offset := FIndex - Length(FOutPut);
              Result.Len := Length(FOutPut);
              Result.TokenType := ttkComment;
              Result.TokenText := FOutPut;
              FState := psNormal;
              Exit
            end;
          end
          else
            FOutput := FOutPut + Ch;
        end;
    end;
    Inc(FIndex);
  end;
  if FIndex > Length(FInput) then
  begin
    Result.Offset := 0;
    Result.Len := 0;
    Result.TokenType := ttkNone;
    Result.TokenText := '';
  end;
end;

function CheckNameKey(const Key: Char; const SQLDialect:integer):Char;
begin
  Result := Key;
  if (SQLDialect = 1) or gAppSettings[FORCE_UPPERCASE_IDENTIFIER] then
  begin
    Result := UpCase(Result);
    if not (Result in ['A'..'Z','0'..'9','_','$',^H]) then
    begin
      MessageBeep(0);
      Result := #0;
    end;
  end;
end;

function AdjustName(const Name: String; const SQLDialect:integer):String;
var n:integer;
begin
  Result := '';
  if (SQLDialect = 1) or gAppSettings[FORCE_UPPERCASE_IDENTIFIER] then
  begin
    for n:=1 to Length(Name) do
    if not (Name[n] in ['a'..'z','A'..'Z','0'..'9','_','$']) then
    begin
      Result := Result + UpCase(Name[n]);
    end;
  end;
end;

function ConvertNameUppercase(const Name: String):String;
begin
  Result := StringReplace(Uppercase(Name),' ','_',[rfReplaceAll]);
end;

function NodeMatch(A,B:integer):boolean;
begin
  Result := a=b;
  if Result then exit;
  case a of
    NODE_SERVERS  : Result := b =                         NODE_SERVER ;
    NODE_DATABASES  : Result := b =                       NODE_DATABASE ;
    NODE_BACKUP_ALIASES  : Result := b =                  NODE_BACKUP_ALIAS ;
    NODE_USERS  : Result := b =                           NODE_USER ;
    NODE_CERTIFICATES  : Result := b =                    NODE_CERTIFICATE ;
    NODE_DOMAINS  : Result := b =                         NODE_DOMAIN ;
    NODE_TABLES  : Result := b =                          NODE_TABLE ;
    NODE_VIEWS  : Result := b =                           NODE_VIEW ;
    NODE_PROCEDURES  : Result := b =                      NODE_PROCEDURE ;
    NODE_FUNCTIONS  : Result := b =                       NODE_FUNCTION ;
    NODE_GENERATORS  : Result := b =                      NODE_GENERATOR ;
    NODE_EXCEPTIONS  : Result := b =                      NODE_EXCEPTION ;
    NODE_BLOB_FILTERS  : Result := b =                    NODE_BLOB_FILTER ;
    NODE_ROLES  : Result := b =                           NODE_ROLE ;
    NODE_COLUMNS  : Result := b =                         NODE_COLUMN ;
    NODE_INDEXES  : Result := b =                         NODE_INDEX ;
    NODE_REFERENTIAL_CONSTRAINTS  : Result := b =         NODE_REFERENTIAL_CONSTRAINT ;
    NODE_UNIQUE_CONSTRAINTS  : Result := b =              NODE_UNIQUE_CONSTRAINT ;
    NODE_CHECK_CONSTRAINTS  : Result := b =               NODE_CHECK_CONSTRAINT ;
    NODE_TRIGGERS  : Result := b =                        NODE_TRIGGER ;

    NODE_SERVER  : Result := b =                          NODE_SERVERS ;
    NODE_DATABASE  : Result := b =                        NODE_DATABASES ;
    NODE_BACKUP_ALIAS  : Result := b =                    NODE_BACKUP_ALIASES ;
    NODE_USER  : Result := b =                            NODE_USERS ;
    NODE_CERTIFICATE  : Result := b =                     NODE_CERTIFICATES ;
    NODE_DOMAIN  : Result := b =                          NODE_DOMAINS ;
    NODE_TABLE  : Result := b =                           NODE_TABLES ;
    NODE_VIEW  : Result := b =                            NODE_VIEWS ;
    NODE_PROCEDURE  : Result := b =                       NODE_PROCEDURES ;
    NODE_FUNCTION  : Result := b =                        NODE_FUNCTIONS ;
    NODE_GENERATOR  : Result := b =                       NODE_GENERATORS ;
    NODE_EXCEPTION  : Result := b =                       NODE_EXCEPTIONS ;
    NODE_BLOB_FILTER  : Result := b =                     NODE_BLOB_FILTERS ;
    NODE_ROLE  : Result := b =                            NODE_ROLES ;
    NODE_COLUMN  : Result := b =                          NODE_COLUMNS ;
    NODE_INDEX  : Result := b =                           NODE_INDEXES ;
    NODE_REFERENTIAL_CONSTRAINT  : Result := b =          NODE_REFERENTIAL_CONSTRAINTS ;
    NODE_UNIQUE_CONSTRAINT  : Result := b =               NODE_UNIQUE_CONSTRAINTS ;
    NODE_CHECK_CONSTRAINT  : Result := b =                NODE_CHECK_CONSTRAINTS ;
    NODE_TRIGGER  : Result := b =                         NODE_TRIGGERS ;
  end;
end;

function NodeImg(A:Integer):integer;
begin
  result := -1;
  case a of
    NODE_SERVERS  : Result :=                          NODE_SERVERS_ACTIVE_IMG;
    NODE_DATABASES  : Result :=                        NODE_DATABASES_IMG;
    NODE_BACKUP_ALIASES  : Result :=                   NODE_BACKUP_ALIAS_IMG;
    NODE_USERS  : Result :=                            NODE_USER_IMG;
    NODE_CERTIFICATES  : Result :=                     NODE_CERTIFICATE_IMG;
    NODE_DOMAINS  : Result :=                          NODE_DOMAINS_IMG;
    NODE_TABLES  : Result :=                           NODE_TABLES_IMG;
    NODE_VIEWS  : Result :=                            NODE_VIEWS_IMG;
    NODE_PROCEDURES  : Result :=                       NODE_PROCEDURES_IMG;
    NODE_FUNCTIONS  : Result :=                        NODE_FUNCTIONS_IMG;
    NODE_GENERATORS  : Result :=                       NODE_GENERATORS_IMG;
    NODE_EXCEPTIONS  : Result :=                       NODE_EXCEPTIONS_IMG;
    NODE_BLOB_FILTERS  : Result :=                     NODE_BLOB_FILTERS_IMG;
    NODE_ROLES  : Result :=                            NODE_ROLES_IMG;
    NODE_COLUMNS  : Result :=                          NODE_COLUMNS_IMG;
    NODE_INDEXES  : Result :=                          NODE_INDEXES_IMG;
    NODE_REFERENTIAL_CONSTRAINTS  : Result :=          NODE_REFERENTIAL_CONSTRAINTS_IMG;
    NODE_UNIQUE_CONSTRAINTS  : Result :=               NODE_UNIQUE_CONSTRAINTS_IMG;
    NODE_CHECK_CONSTRAINTS  : Result :=                NODE_CHECK_CONSTRAINTS_IMG;
    NODE_TRIGGERS  : Result :=                         NODE_TRIGGERS_IMG;

    NODE_SERVER  : Result :=                           NODE_SERVERS_ACTIVE_IMG;
    NODE_DATABASE  : Result :=                         NODE_DATABASES_IMG;
    NODE_BACKUP_ALIAS  : Result :=                     NODE_BACKUP_ALIASES_IMG;
    NODE_USER  : Result :=                             NODE_USERS_IMG;
    NODE_CERTIFICATE  : Result :=                      NODE_CERTIFICATES_IMG;
    NODE_DOMAIN  : Result :=                           NODE_DOMAINS_IMG;
    NODE_TABLE  : Result :=                            NODE_TABLES_IMG;
    NODE_VIEW  : Result :=                             NODE_VIEWS_IMG;
    NODE_PROCEDURE  : Result :=                        NODE_PROCEDURES_IMG;
    NODE_FUNCTION  : Result :=                         NODE_FUNCTIONS_IMG;
    NODE_GENERATOR  : Result :=                        NODE_GENERATORS_IMG;
    NODE_EXCEPTION  : Result :=                        NODE_EXCEPTIONS_IMG;
    NODE_BLOB_FILTER  : Result :=                      NODE_BLOB_FILTERS_IMG;
    NODE_ROLE  : Result :=                             NODE_ROLES_IMG;
    NODE_COLUMN  : Result :=                           NODE_COLUMNS_IMG;
    NODE_INDEX  : Result :=                            NODE_INDEXES_IMG;
    NODE_REFERENTIAL_CONSTRAINT  : Result :=           NODE_REFERENTIAL_CONSTRAINTS_IMG;
    NODE_UNIQUE_CONSTRAINT  : Result :=                NODE_UNIQUE_CONSTRAINTS_IMG;
    NODE_CHECK_CONSTRAINT  : Result :=                 NODE_CHECK_CONSTRAINTS_IMG;
    NODE_TRIGGER  : Result :=                          NODE_TRIGGERS_IMG;
  end;
end;

function tok(sep: string; var s: string): string;
     function isoneof(c, s: string): Boolean;
     var
        iTmp: integer;
     begin
          Result := False;
          for iTmp := 1 to Length(s) do
          begin
              if c = Copy(s, iTmp, 1) then
              begin
                   Result := True;
                   Exit;
              end;
          end;
     end;
var
   c, t: string;
begin
     if s = '' then
     begin
          Result := s;
          Exit;
     end;
     c := Copy(s, 1, 1);
     while isoneof(c, sep) do
     begin
          s := Copy(s, 2, Length(s) - 1);
          c := Copy(s, 1, 1);
     end;
     t := '';
     while (not isoneof(c, sep)) and (s <> '') do
     begin
          t := t + c;
          s := Copy(s, 2, length(s)-1);
          c := Copy(s, 1, 1);
     end;
     Result := t;
end;

function FontToStr(font: TFont): string;

  procedure yes(var str:string);
  begin
       str := str + 'y';
  end;

  procedure no(var str:string);
  begin
       str := str + 'n';
  end;

begin
     {encode all attributes of a TFont into a string}
     Result := '';
     Result := Result + IntToStr(font.Color) + '|';
     Result := Result + IntToStr(font.Height) + '|';
     Result := Result + font.Name + '|';
     Result := Result + IntToStr(Ord(font.Pitch)) + '|';
     Result := Result + IntToStr(font.PixelsPerInch) + '|';
     Result := Result + IntToStr(font.size) + '|';
     if fsBold in font.style then yes(Result) else no(Result);
     if fsItalic in font.style then yes(Result) else no(Result);
     if fsUnderline in font.style then yes(Result) else no(Result);
     if fsStrikeout in font.style then yes(Result) else no(Result);
end;

procedure StrToFont(str: string; font: TFont);
begin
     if str = '' then Exit;
     font.Color := StrToInt(tok('|', str));
     font.Height := StrToInt(tok('|', str));
     font.Name := tok('|', str);
     font.Pitch := TFontPitch(StrToInt(tok('|', str)));
     font.PixelsPerInch := StrToInt(tok('|', str));
     font.Size := StrToInt(tok('|', str));
     font.Style := [];
//     if Length str[0] = 'y' then font.Style := font.Style + [fsBold];
     if str[1] = 'y' then font.Style := font.Style + [fsItalic];
     if str[2] = 'y' then font.Style := font.Style + [fsUnderline];
     if str[3] = 'y' then font.Style := font.Style + [fsStrikeout];
end;

function GetObjectProperty(Instance: TPersistent; const PropName: string): TObject;
var
  PropInfo: PPropInfo;
begin
  Result := nil;
  PropInfo := TypInfo.GetPropInfo(Instance.ClassInfo, PropName);
  if (PropInfo <> nil) and (PropInfo^.PropType^.Kind = tkClass) then
    Result := TObject(GetOrdProp(Instance, PropInfo));
end;

procedure SetFonts(const o:TObject; const NewFont:TFont);
var
  PTI:PTypeInfo;
  PList : PPropList;
  Count : Integer;
  I : integer;
begin
  if not o.ClassType.InheritsFrom(TFont) then exit;
  PTI:=o.ClassInfo ;
  Count := GetTypeData(PTI)^.PropCount;
  if Count = 0 then exit;
  GetMem(PList, Count * SizeOf(Pointer));
  try
    GetPropInfos(PTI, PList);
    for I := 0 To Count - 1 Do
    begin
      if PList^[I]^.Name = 'Charset' then SetOrdProp(o, PList^[I], NewFont.Charset) else
      if PList^[I]^.Name = 'Color' then SetOrdProp(o, PList^[I], NewFont.Color) else
      if PList^[I]^.Name = 'Height' then SetOrdProp(o, PList^[I], NewFont.Height) else
      if PList^[I]^.Name = 'Name' then SetStrProp(o, PList^[I], NewFont.Name) else
      if PList^[I]^.Name = 'Pitch' then SetPropValue(o, PList^[I].Name, NewFont.Pitch) else
      if PList^[I]^.Name = 'Size' then SetOrdProp(o, PList^[I], NewFont.Size) else
      if PList^[I]^.Name = 'Style' then SetPropValue(o, PList^[I].Name, NewFont.Pitch);
    end;
  finally
    FreeMem(PList, Count * SizeOf(Pointer));
  end;
end;


procedure SetAllFonts(const o:TObject; const NewFont:TFont);
var
  PTI:PTypeInfo;
  PList : PPropList;
  Count : Integer;
  I : integer;
  ClassValue :TObject;
begin
  if not Assigned(o) then exit;
  SetFonts(o,NewFont);
  PTI:=o.ClassInfo ;
  Count := GetTypeData(PTI)^.PropCount;
  if Count = 0 then exit;
  GetMem(PList, Count * SizeOf(Pointer));
  try
    GetPropInfos(PTI, PList);
    for I := 0 To Count - 1 Do
    begin
      if PList^[I]^.PropType^.Kind = tkClass then
      begin
        ClassValue := TObject(GetOrdProp(o, PList^[I]));
        SetAllFonts(ClassValue, NewFont);
      end;
    end;
  finally
    FreeMem(PList, Count * SizeOf(Pointer));
  end;
end;

  //contribution by Tsutomu Hayashi
type
  TMyControl = Class(TControl)
  end;
  //contribution by Tsutomu Hayashi

procedure SetFontsNameCharset(const o:TObject; const aFontName:TFontName; const aFontCharset:TFontCharset);
var
  PTI:PTypeInfo;
  PList : PPropList;
  Count : Integer;
  I : integer;
begin
  if o.ClassType.InheritsFrom(TFont) then
  begin
    PTI:=o.ClassInfo ;
    Count := GetTypeData(PTI)^.PropCount;
    if Count = 0 then exit;
    GetMem(PList, Count * SizeOf(Pointer));
    try
      GetPropInfos(PTI, PList);
      for I := 0 To Count - 1 Do
      begin
        if PList^[I]^.Name = 'Charset' then SetOrdProp(o, PList^[I], aFontCharset) else
        if PList^[I]^.Name = 'Name' then SetStrProp(o, PList^[I], aFontName);
      end;
    finally
      FreeMem(PList, Count * SizeOf(Pointer));
    end;
  end
  else
  if o is TControl then
  //contribution by Tsutomu Hayashi
  try
    TMyControl(o).Font.Charset := aFontCharset;
    TMyControl(o).Font.Name    := aFontName;
  except
  end
  //contribution by Tsutomu Hayashi
end;

procedure SetAllFontsNameCharset(const o:TComponent; const aFontName:TFontName; const aFontCharset:TFontCharset);
var
  n : integer;
begin
  if not Assigned(o) then exit;
  if (o is TCustomSynEdit) then exit;
  SetFontsNameCharset(o,aFontName,aFontCharset);
  for n:=0 to Pred(o.ComponentCount) do
    SetAllFontsNameCharset(o.Components[n],aFontName,aFontCharset);
end;

procedure SetAllSyntaxFontsNameCharset(const o:TComponent; const aFontName:TFontName; const aFontCharset:TFontCharset);
var n:integer;
begin
  if not Assigned(o) then exit;
  if (o is TCustomSynEdit) then
  begin
    TCustomSynEdit(o).Font.Name := aFontName;
    TCustomSynEdit(o).Font.Charset := aFontCharset;
  end
  else
  for n:=0 to Pred(o.ComponentCount) do
    SetAllSyntaxFontsNameCharset(o.Components[n],aFontName,aFontCharset);
end;

function Last(const c:char; const s:string):integer;
var n:integer;
begin
  result := 0;
  for n:=Length(s) downto 0 do
  if s[n] = c then
  begin
    result := n;
    break;
  end;
end;

function CalSection(const path:string; const o:TComponent):string;

  function GetName:string;
  var p,t:integer;
      s:string;
  begin
    if o is TCustomForm then
    begin
      result := o.Name;
      p := Last('_',o.Name);
      if p>0 then
      begin
        s := copy(o.Name,p+1,maxint);
        t:=StrToIntDef(s,-1);
        if t<>-1 then
          result := copy(o.Name,1,p-1);
      end;
    end
    else
      result := o.Name;
  end;

begin
  Result :='';
  if o.Name <> '' then
  begin
    if path<>'' then
      Result := path+'.'+GetName
    else
      Result := GetName;
  end
  else
    if path<>'' then
      Result := path;
end;

function EncodeLineBreak(const Value:String):String;
begin
  result := StringReplace(Value,CRLF,'^M',[rfReplaceAll]);
  result := StringReplace(result,#13,'^M',[rfReplaceAll]);
  result := StringReplace(result,#10,'^M',[rfReplaceAll]);
end;

function DecodeLineBreak(const Value:String):String;
begin
  result := StringReplace(Value,'^M',sLineBreak,[rfReplaceAll]);
end;

procedure WriteCaptionAndHint(const inifile:TIniFile;
                              const o:TComponent;
                              const sec,Caption,Hint:string);
begin
  if (Caption<>'') or (Hint<>'') then
  begin
    if o.InheritsFrom(TCustomAction) then
      inifile.WriteString(sec,'Class','TAction')
    else
      inifile.WriteString(sec,'Class',o.ClassName);
    if (Caption<>'') then
      inifile.WriteString(sec,'Caption',EncodeLineBreak(Caption));
    if (Hint<>'') then
      inifile.WriteString(sec,'Hint',EncodeLineBreak(Hint));
  end;
end;

procedure WriteAllCaptionAndText(const path:string; const o:TComponent; const inifile:TIniFile);
var n:integer;
    sec:string;
begin
  if not Assigned(o) then exit;
  sec := CalSection(path,o);
  if (o is TCustomForm) then
  begin
    WriteCaptionAndHint(inifile,o,sec,TCustomForm(o).Caption,TCustomForm(o).Hint);
    for n:=0 to Pred(o.ComponentCount) do
      WriteAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TCustomLabel) then
  begin
    WriteCaptionAndHint(inifile,o,sec,TCustomLabel(o).Caption,TCustomLabel(o).Hint);
  end
  else
  if (o is TCustomAction) then
  begin
    WriteCaptionAndHint(inifile,o,sec,TCustomAction(o).Caption,TCustomAction(o).Hint);
  end
  else
  if (o is TActionList) then
  begin
    for n:=0 to Pred(TActionList(o).ActionCount) do
      if TActionList(o).Actions[n] is TAction then
        WriteCaptionAndHint(inifile,o,sec,TActionList(o).Actions[n].Name,TAction(TActionList(o).Actions[n]).Hint)
      else
        WriteCaptionAndHint(inifile,o,sec,TActionList(o).Actions[n].Name,'');
  end
  else
  if (o is TMenuItem) then
  begin
    if (TMenuItem(o).Action = nil) and (TMenuItem(o).Caption<>'-' )then
    begin
      WriteCaptionAndHint(inifile,o,sec,TMenuItem(o).Caption,TMenuItem(o).Hint);
    end;
  end
  else
  if (o is TButton) then
  begin
    if TButton(o).Action = nil then
    begin
      if (TButton(o).Caption<>'') or (TButton(o).Hint<>'') then
      begin
        WriteCaptionAndHint(inifile,o,sec,TButton(o).Caption,TButton(o).Hint);
      end;
    end;
  end
  else
  if (o is TBitBtn) then
  begin
    if TBitBtn(o).Action = nil then
    begin
      if (TBitBtn(o).Caption<>'') or (TBitBtn(o).Hint<>'') then
      begin
        WriteCaptionAndHint(inifile,o,sec,TBitBtn(o).Caption,TBitBtn(o).Hint);
      end;
    end;
  end
  else
  if (o is TSpeedButton) then
  begin
    if TSpeedButton(o).Action = nil then
    begin
      WriteCaptionAndHint(inifile,o,sec,TSpeedButton(o).Caption,TSpeedButton(o).Hint);
    end;
  end
  else
  if (o is TCheckBox) then
  begin
    if TCheckBox(o).Action = nil then
    begin
      WriteCaptionAndHint(inifile,o,sec,TCheckBox(o).Caption,TCheckBox(o).Hint);
    end;
  end
  else
  if (o is TTabSheet) then
  begin
    WriteCaptionAndHint(inifile,o,sec,TTabSheet(o).Caption,TTabSheet(o).Hint);
    for n:=0 to Pred(o.ComponentCount) do
      WriteAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TGroupBox) then
  begin
    WriteCaptionAndHint(inifile,o,sec,TGroupBox(o).Caption,TGroupBox(o).Hint);
    for n:=0 to Pred(o.ComponentCount) do
      WriteAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TRadioButton) then
  begin
    if TRadioButton(o).Action = nil then
    begin
      WriteCaptionAndHint(inifile,o,sec,TRadioButton(o).Caption,TRadioButton(o).Hint);
    end;
    for n:=0 to Pred(o.ComponentCount) do
      WriteAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TRadioGroup) then
  begin
    WriteCaptionAndHint(inifile,o,sec,TRadioGroup(o).Caption,TRadioGroup(o).Hint);
    inifile.WriteInteger(sec,'Items.Count',TRadioGroup(o).Items.Count);
    for n:=0 to Pred(TRadioGroup(o).Items.Count) do
    begin
      inifile.WriteString(sec,'Item'+inttostr(n),TRadioGroup(o).Items[n]);
    end;
    for n:=0 to Pred(o.ComponentCount) do
      WriteAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TListView) then
  begin
    inifile.WriteString(sec,'Class',o.ClassName);
    inifile.WriteString(sec,'Hint',TListView(o).Hint);
    inifile.WriteInteger(sec,'Columns.Count',TListView(o).Columns.Count);
    for n:=0 to Pred(TListView(o).Columns.Count) do
    begin
      inifile.WriteString(sec,'Column'+inttostr(n)+'.Caption',TListView(o).Columns[n].Caption);
    end;
    for n:=0 to Pred(o.ComponentCount) do
      WriteAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TPageControl) then
  begin
    inifile.WriteString(sec,'Class',o.ClassName);
    inifile.WriteString(sec,'Hint',TPageControl(o).Hint);
    inifile.WriteInteger(sec,'PageCount',TPageControl(o).PageCount);
    for n:=0 to Pred(TPageControl(o).PageCount) do
      WriteAllCaptionAndText(sec,TPageControl(o).Pages[n],inifile);
  end
  else
  if (o is TDbGrid) then
  begin
    inifile.WriteString(sec,'Class',o.ClassName);
    inifile.WriteString(sec,'Hint',TDbGrid(o).Hint);
    inifile.WriteInteger(sec,'Columns.Count',TDbGrid(o).Columns.Count);
    for n:=0 to Pred(TDbGrid(o).Columns.Count) do
      inifile.WriteString(sec,'Column'+inttostr(n)+'.Caption',TDbGrid(o).Columns[n].Title.Caption);
  end
  else
  for n:=0 to Pred(o.ComponentCount) do
    WriteAllCaptionAndText(sec,o.Components[n],inifile);
end;

procedure GetAllCaptionAndText(const path:string; const o:TComponent; const inifile:TIniFile);
var n,ic:integer;
    sec,value:string;
begin
  if not Assigned(o) then exit;
  sec := CalSection(path,o);
  if (o is TCustomForm) then
  begin
    TCustomForm(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TCustomForm(o).Caption));
    TCustomForm(o).Hint := DecodeLineBreak(inifile.ReadString(sec,'Hint',TCustomForm(o).Hint));
    if TCustomForm(o).Hint <> '' then TCustomForm(o).ShowHint := true;
    for n:=0 to Pred(o.ComponentCount) do
      GetAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TCustomLabel) then
  begin
    Value := DecodeLineBreak(inifile.ReadString(sec,'Caption',TCustomLabel(o).Caption));
    if (o is TLabel) and (Value <> TCustomLabel(o).Caption) then
      TLabel(o).AutoSize := true;
    TCustomLabel(o).Caption := Value;
    TCustomLabel(o).Hint := DecodeLineBreak(inifile.ReadString(sec,'Hint',TCustomLabel(o).Hint));
    if TCustomLabel(o).Hint <> '' then TCustomLabel(o).ShowHint := true;
  end
  else
  if (o.InheritsFrom(TCustomAction)) then
  begin
//    TCustomAction(o).OnExecute
//    TCustomAction(o).OnExecute
//    TCustomAction(o).OnExecute
    TCustomAction(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TCustomAction(o).Caption));
    TCustomAction(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TCustomAction(o).Hint));
  end
  else
  if (o is TActionList) then
  begin
    for n:=0 to Pred(TActionList(o).ActionCount) do
      GetAllCaptionAndText(sec,TActionList(o).Actions[n],inifile);
  end
  else
  if (o is TMenuItem) then
  begin
    if (TMenuItem(o).Action = nil) and (TMenuItem(o).Caption<>'-' )then
    begin
      TMenuItem(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TMenuItem(o).Caption));
      TMenuItem(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TMenuItem(o).Hint));
    end;
  end
  else
  if (o is TButton) then
  begin
    if TButton(o).Action = nil then
    begin
      TButton(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TButton(o).Caption));
      TButton(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TButton(o).Hint));
      if TButton(o).Hint <> '' then TButton(o).ShowHint := true;
    end;
  end
  else
  if (o is TBitBtn) then
  begin
    if TBitBtn(o).Action = nil then
    begin
      TBitBtn(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TBitBtn(o).Caption));
      TBitBtn(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TBitBtn(o).Hint));
      if TBitBtn(o).Hint <> '' then TBitBtn(o).ShowHint := true;
    end;
  end
  else
  if (o is TSpeedButton) then
  begin
    if TSpeedButton(o).Action = nil then
    begin
      TSpeedButton(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TSpeedButton(o).Caption));
      TSpeedButton(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TSpeedButton(o).Hint));
      if TSpeedButton(o).Hint <> '' then TSpeedButton(o).ShowHint := true;
    end;
  end
  else
  if (o is TCheckBox) then
  begin
    if TCheckBox(o).Action = nil then
    begin
      TCheckBox(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TCheckBox(o).Caption));
      TCheckBox(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TCheckBox(o).Hint));
      if TCheckBox(o).Hint <> '' then TCheckBox(o).ShowHint := true;
    end;
  end
  else
  if (o is TTabSheet) then
  begin
    if TTabSheet(o).Action = nil then
    begin
      TTabSheet(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TTabSheet(o).Caption));
      TTabSheet(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TTabSheet(o).Hint));
      if TTabSheet(o).Hint <> '' then TTabSheet(o).ShowHint := true;
    end;
    for n:=0 to Pred(o.ComponentCount) do
      GetAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TGroupBox) then
  begin
    if TGroupBox(o).Action = nil then
    begin
      TGroupBox(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TGroupBox(o).Caption));
      TGroupBox(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TGroupBox(o).Hint));
      if TGroupBox(o).Hint <> '' then TGroupBox(o).ShowHint := true;
    end;
    for n:=0 to Pred(o.ComponentCount) do
      GetAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
(*  if (o is TRadioButton) then
  begin
    if TRadioButton(o).Action = nil then
    begin
      TRadioButton(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TRadioButton(o).Caption));
      TRadioButton(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TRadioButton(o).Hint));
      if TRadioButton(o).Hint <> '' then TGroupBox(o).ShowHint := true;
    end;
    for n:=0 to Pred(o.ComponentCount) do
      GetAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else*)
  if (o is TRadioGroup) then
  begin
    if TRadioGroup(o).Action = nil then
    begin
      TRadioGroup(o).Caption := DecodeLineBreak(inifile.ReadString(sec,'Caption',TRadioGroup(o).Caption));
      TRadioGroup(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TRadioGroup(o).Hint));
      if TRadioGroup(o).Hint <> '' then TRadioGroup(o).ShowHint := true;
      ic :=  inifile.ReadInteger(sec,'Items.Count',TRadioGroup(o).Items.Count);
      if (ic>0) and (TRadioGroup(o).Items.Count>=ic) then
        for n:=0 to Pred(TRadioGroup(o).Items.Count) do
        begin
          TRadioGroup(o).Items[n] := DecodeLineBreak(inifile.ReadString(sec,'Item'+inttostr(n),TRadioGroup(o).Items[n]));
        end;
    end;
    for n:=0 to Pred(o.ComponentCount) do
      GetAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TListView) then
  begin
    if TListView(o).Action = nil then
    begin
      TListView(o).Hint :=    DecodeLineBreak(inifile.ReadString(sec,'Hint',TListView(o).Hint));
      if TListView(o).Hint <> '' then TListView(o).ShowHint := true;
      ic := inifile.ReadInteger(sec,'Columns.Count',0);
      if (ic>0) and (TListView(o).Columns.Count>=ic) then
        for n:=0 to Pred(TListView(o).Columns.Count) do
        begin
          TListView(o).Columns[n].Caption := DecodeLineBreak(inifile.ReadString(sec,'Column'+inttostr(n)+'.Caption',TListView(o).Columns[n].Caption));
        end;
    end;
    for n:=0 to Pred(o.ComponentCount) do
      GetAllCaptionAndText(sec,o.Components[n],inifile);
  end
  else
  if (o is TDbGrid) then
  begin
    TDbGrid(o).Hint := DecodeLineBreak(inifile.ReadString(sec,'Hint',TDbGrid(o).Hint));
    ic := inifile.ReadInteger(sec,'Columns.Count',0);
    if (ic>0) and (TDbGrid(o).Columns.Count>=ic) then
      for n:=0 to Pred(TDbGrid(o).Columns.Count) do
      begin
        TDbGrid(o).Columns[n].Title.Caption := DecodeLineBreak(inifile.ReadString(sec,'Column'+inttostr(n)+'.Caption',TDbGrid(o).Columns[n].Title.Caption));
      end;
  end
  else
  if (o is TPageControl) then
  begin
    TPageControl(o).Hint :=DecodeLineBreak(inifile.ReadString(sec,'Hint',TPageControl(o).Hint));
    for n:=0 to Pred(TPageControl(o).PageCount) do
      GetAllCaptionAndText(sec,TPageControl(o).Pages[n],inifile);
  end
  else
  for n:=0 to Pred(o.ComponentCount) do
    GetAllCaptionAndText(sec,o.Components[n],inifile);
end;


procedure MergeIniFiles(source,dest:TIniFile);
var secList:TStringList;
    vallist:TStringList;
    ns,nv:integer;
    value:string;
    name:string;
begin
  secList:=TStringList.Create;
  vallist:=TStringList.Create;
  try
    source.ReadSections(secList);
    for ns:=0 to secList.Count-1 do
    begin
      source.ReadSectionValues(secList[ns],vallist);
      for nv:=0 to vallist.Count-1 do
      begin
        name := vallist.Names[nv];
        value := source.ReadString(secList[ns],name,'');
        dest.DeleteKey(secList[ns],name);
        dest.WriteString(secList[ns],name,value);
      end;
    end;
  finally
    secList.Free;
    vallist.Free;
  end;
end;

function GetLangText(const Text:string):string;
begin
  result := Text;
  if Assigned(gGUILanguageFile) then
    result := gGUILanguageFile.ReadString('global',text,text);
  if Result = '' then Result := Text;
end;

function GetLangType(const Text:string):string;
begin
  result := Text;
  if Assigned(gGUILanguageFile) then
    result := gGUILanguageFile.ReadString('node_types',text,text);
  if Result = '' then Result := Text;
end;

function GetLangType(const id:integer):string;
begin
  result := GetLangType(NODE_ARRAY[Id]);
end;

function GetTypeArticle(const Text:string):string;
begin
  result := 'The';
  if Assigned(gGUILanguageFile) then
    result := gGUILanguageFile.ReadString('node_articles',text,'The');
  if Result = '' then Result := Text;
end;

function GetTypeArticle(const id:integer):string;
begin
  result := GetTypeArticle(NODE_ARRAY[Id]);
end;

type
  TPromptRec=record
    id:string;
    msg:string;
  end;
const
  NUM_PROMPTS = 140;
  default_prompt:array [0..NUM_PROMPTS-1] of TPromptRec = (
  (id:'prompt0';  msg:'OK to overwrite %s'),
  (id:'prompt1';  msg:'Could not open file "%s".'),
  (id:'prompt2';  msg:'Not yet in Kylix'),
  (id:'prompt3';  msg:'Are you sure that you want to drop the selected database?'),
  (id:'prompt4';  msg:'Transactions are active.'+CRLF+'Would you like to commit the transactions?'+CRLF+CRLF+'Choosing NO will rollback the active transactions.'),
  (id:'prompt5';  msg:'Data saved to file: %s'),
  (id:'prompt6';  msg:'format not specified'),
  (id:'prompt7';  msg:'Save Query Output'),
  (id:'prompt8';  msg:'%s new %s must have a name.'),
  (id:'prompt9';  msg:'%s %s name is still the default. Are you sure you wish to use the default name?'),
  (id:'prompt10'; msg:'%s %s %s has changed. Do you wish to save changes?'),
  (id:'prompt11'; msg:'Are you sure that you want to un-register the selected database?'),
  (id:'prompt12'; msg:'Are you sure that you want to close the connection to the selected database?'),
  (id:'prompt13'; msg:'Sweeping a large database may take a while and can impact server performance during that time. Do you wish to perform a sweep?'),
  (id:'prompt14'; msg:'Are you sure that you want to drop the selected database?'),
  (id:'prompt15'; msg:'Are you sure that you want to close the connection to the selected server?'),
  (id:'prompt16'; msg:'Invalid option value'),
  (id:'prompt17'; msg:'Limbo transaction recovery completed.'),
  (id:'prompt18'; msg:'Array Upper Bound must be greater than Array Lower Bound.'),
  (id:'prompt19'; msg:'Primary Key Contraint must have a Name'),
  (id:'prompt20'; msg:'Unique Key Contraint must have a Name'),
  (id:'prompt21'; msg:'Please select field(s) to be used in Primary Key'),
  (id:'prompt22'; msg:'Please select field(s) to be used in Unique Key'),
  (id:'prompt23'; msg:'Foreign Key Contraint must have a Name'),
  (id:'prompt24'; msg:'Please select field to be used in Foreign Key'),
  (id:'prompt25'; msg:'Please select field to be referenced in Foreign Key'),
  (id:'prompt26'; msg:'Check constraint must have a name'),
  (id:'prompt27'; msg:'Check constraint must contain an expression'),
  (id:'prompt28'; msg:'Are you sure you wish to delete this dimension?'),
  (id:'prompt29'; msg:'You cannot change the description until the object has been compiled.'),
  (id:'prompt30'; msg:'Save changes to description?'),
  (id:'prompt31'; msg:'Exception must have a message.'),
  (id:'prompt32'; msg:'The new table must have a name.'),
  (id:'prompt33'; msg:'Setting Not Null require to set a value into existing null data or subsequent backup will be invalid'#13+#13+'Do you want to continue and specify a value to fill Nulls?'),
  (id:'prompt34'; msg:'Resetting Not Null is not safe if the field is used in a unique index, subsequent backup will be invalid'+#13+#13+'Do you want to continue?'),
  (id:'prompt35'; msg:'The Description for %s %s has changed. Do you wish to save changes?'),
  (id:'prompt36'; msg:'Please select columns(s) to be used in the Index'),
  (id:'prompt37'; msg:'You cannot view the Metadata until the object has been compiled.'),
  (id:'prompt38'; msg:'You cannot change from Edit View until the object has been compiled.'),
  (id:'prompt39'; msg:'There is an open transaction for the results - Commit or Rollback before changing View.'),
  (id:'prompt40'; msg:'Stored Procedure source has changed. Recompile?'),
  (id:'prompt41'; msg:'Executing Stored Procedure...'),
  (id:'prompt42'; msg:'Stored Procedure - %s - Running'),
  (id:'prompt43'; msg:'Are you shure to drop %s %s ?'),
  (id:'prompt44'; msg:'Do You want to delete all visible records from table %s ?'),
  (id:'prompt45'; msg:'Trigger must be assigned a position.'),
  (id:'prompt46'; msg:'Trigger must have a name.'),
  (id:'prompt47'; msg:'The UDF must have an Entry Point.'),
  (id:'prompt48'; msg:'The UDF must have a Library Name.'),
  (id:'prompt49'; msg:'The UDF must have a Return Parameter.'),
  (id:'prompt50'; msg:'Are you sure you want to delete this Parameter?'),
  (id:'prompt51'; msg:'Are you sure you wish to delete this dimension?'),
  (id:'prompt52'; msg:'The column must have a name.'),
  (id:'prompt53'; msg:'The domain name is empty.'),
  (id:'prompt54'; msg:'There is no computed by expression.'),
  (id:'prompt55'; msg:'You must enter a Parameter.'),
  (id:'prompt56'; msg:'Plan could not be retrieved'),
  (id:'prompt57'; msg:'Unable to parse script'),
  (id:'prompt58'; msg:'No active connection'),
  (id:'prompt59'; msg:'An error occured JvParsing CONNECT statement.'),
  (id:'prompt60'; msg:'Commit or Rollback the current transaction'),
  (id:'prompt61'; msg:'An error occured JvParsing CREATE statement.'),
  (id:'prompt62'; msg:'Invalid client dialect'),
  (id:'prompt63'; msg:'Unable to open file'),
  (id:'prompt64'; msg:'Database dialect (%d) does not match client dialect (%d).'),
  (id:'prompt65'; msg:'Unable to set the client dialect to %d'),
  (id:'prompt66'; msg:'Unable to display Array Information'),
  (id:'prompt67'; msg:'Search string ''%s'' not found'),
  (id:'prompt68'; msg:'Unable to parse script'),
  (id:'prompt69'; msg:'Are you sure that you want to un-register %s?'),
  (id:'prompt70'; msg:'Are you sure that you want to remove "%s" from the alias list?'),
  (id:'prompt71'; msg:'Are you sure that you want to delete user: %s?'),
  (id:'prompt72'; msg:'An error occurred while attemting to create directory %s. Operation cancelled.'),
  (id:'prompt73'; msg:'The directory %s does not exist. Do you wish to create it?'),
  (id:'prompt74'; msg:'An error occured while trying to connect to ''%s''. This server may be an earlier version. As a result many features will be not work properly.'),
  (id:'prompt75'; msg:'Attempting to attach to %s using NetBEUI.%s%s'),
  (id:'prompt76'; msg:'Attached successfully to %s using %s the following named pipe: %s %s.%S%S NetBEUI Communication Test Passed!'),
  (id:'prompt77'; msg:'An error occurred attempting to connect to %s%susing the following named pipe:%s%s%s%sNetBEUI Communication Test Failed!'),
  (id:'prompt78'; msg:'Could not initialize Netware client library.%s%sSPX Communication Test Failed!'),
  (id:'prompt79'; msg:'Attempting to attach to %s using SPX.%s%s'),
  (id:'prompt80'; msg:'An error occurred attempting to connect to %s%susing the SPX protocol.%s%sSPX Communication Test Failed!'),
  (id:'prompt81'; msg:'Attached successfully to %s%s   using the SPX protocol.SPX Communication Test Passed!'),
  (id:'prompt82'; msg:'An error occurred attempting to connect to %s%s   using the SPX protocol.%s%sYou do not seem to have the proper NetWare client installed.%s%sSPX Communication Test Failed!'),
  (id:'prompt83'; msg:'The user you wish to delete is the same user you are logged into the server as.%s Are you sure that you want to delete user: %s?'),
  (id:'prompt84'; msg:'Attempting to connect to:'),
  (id:'prompt85'; msg:'Attaching    ... Passed!'),
  (id:'prompt86'; msg:'Detaching    ... Passed!'),
  (id:'prompt87'; msg:'An Server error has occurred while detaching.'),
  (id:'prompt88'; msg:'An Server error has occurred while attaching.'),
  (id:'prompt89'; msg:'Server Communication Test Passed!'),
  (id:'prompt90'; msg:'Server Communication Test Failed!'),
  (id:'prompt91'; msg:'Attempting connection to %s.'),
  (id:'prompt92'; msg:'Socket for connection obtained.'),
  (id:'prompt93'; msg:'Socket Request Failed'),
  (id:'prompt94'; msg:'Remote Socket Request Failed'),
  (id:'prompt95'; msg:'Remote Socket did not respond'),
  (id:'prompt96'; msg:'Failed to connect to host ''%s'','),
  (id:'prompt97'; msg:'on port %s. Error Num: '),
  (id:'prompt98'; msg:'Connection established to host ''%s'','),
  (id:'prompt99'; msg:'on port %s'),
  (id:'prompt100'; msg:'TCP/IP Communication Test Passed!'),
  (id:'prompt101'; msg:'TCP/IP Communication Test Failed!'),
  (id:'prompt102'; msg:'Pinging %s [%s] with %d bytes of data:'),
  (id:'prompt103'; msg:'%d bytes from %s: icmp_seq=%d ttl=%d time%s%d ms'),
  (id:'prompt104'; msg:'Critical connection error'),
  (id:'prompt105'; msg:'Can''t get file version information for %s'),
  (id:'prompt106'; msg:'  Host Site: %s'),
  (id:'prompt107'; msg:'is in limbo'),
  (id:'prompt108'; msg:'has been committed'),
  (id:'prompt109'; msg:'has been rolled back'),
  (id:'prompt110'; msg:'is in an unknown state'),
  (id:'prompt111'; msg:'  Transaction %d %s.'),
  (id:'prompt112'; msg:'  Remote Site: %s'),
  (id:'prompt113'; msg:'  Database Path: %s'),
  (id:'prompt114'; msg:'Recommended Action: %s'),
  (id:'prompt115'; msg:'Please select an item from the Transactions tab.'),
  (id:'prompt116'; msg:'Repairing transaction %s'),
  (id:'prompt117'; msg:'Select a transaction for information about that transaction.'),
  (id:'prompt118'; msg:'Secondary files unavailable.'),
  (id:'prompt119'; msg:'Database owner unavailable.'),
  (id:'prompt120'; msg:'The Sweep Interval must be a value from %d to %d.  Please enter a valid sweep interval value.'),
  (id:'prompt121'; msg:'Database Properties cannot be changed while the database is read-only.'),
  (id:'prompt122'; msg:'Null must be "NULL" or empty'),
  (id:'prompt123'; msg:'can''t Edit NULL'),
  (id:'prompt124'; msg:'Once %s is dropped it can no longer be accessed.'+CRLF+'Do you wish to continue?'),
  (id:'prompt125'; msg:'You must specify a validation option'),
  (id:'prompt126'; msg:'can not be used to administer pre-InterBase 6.0 servers'),
  (id:'prompt127'; msg:'Parent must be TScrollBox or its descendant.'),
  (id:'prompt128'; msg:'This table is already inserted.'),
  (id:'prompt129'; msg:'These tables are already linked.'),
  (id:'prompt130'; msg:'File %s is not QBuilder''s query file.'),
  (id:'prompt131'; msg:'Columns are not selected.'),
  (id:'prompt132'; msg:''),
  (id:'prompt133'; msg:''),
  (id:'prompt134'; msg:''),
  (id:'prompt135'; msg:''),
  (id:'prompt136'; msg:''),
  (id:'prompt137'; msg:''),
  (id:'prompt138'; msg:''),
  (id:'prompt139'; msg:'')
  );

(*;prompt126=Parent must be TScrollBox or its descendant.
;prompt127=This table is already inserted.
;prompt128=These tables are already linked.
;prompt129=File %s is not QBuilder's query file.
;prompt130=Columns are not selected.*)


function GetPrompt(const Id:integer):string;
var sId,def:string;
begin
  result := '';
  def := default_prompt[id].msg;
  sId := default_prompt[id].id;
  if Assigned(gGUILanguageFile) then
    result := gGUILanguageFile.ReadString('prompts',sId,'');
  if result = '' then result := def;
  result := StringReplace(result,'^M',sLineBreak,[rfReplaceAll]);
end;

procedure WritePrompts;
var 
    n:integer;
begin
  for n:=0 to NUM_PROMPTS-1 do
  begin
    gTransIniFile.WriteString('prompts',default_prompt[n].id,EncodeLineBreak(default_prompt[n].msg));
  end;
end;


/////////////////////////

procedure LocaleFontChanged(const LocalFontName:String; const LocalCharSet:TFontCharset);
Var
lstChanged : TList;

procedure ChangeInstanceFontName(Instance : TObject);
Var
  Count      : Integer;
  Size       : Integer;
  I          : Integer;

  PropList   : PPropList;
  ClassList  : PPropList;

  PropType   : PPTypeInfo;
  ClassValue : TObject;
begin
  If not Assigned(Instance) or (Instance.ClassInfo = nil) Then Exit;
  If lstChanged.IndexOf(Instance) >= 0 Then Exit;

  lstChanged.Add(Instance);

 // Get string properties
  Count := GetPropList(Instance.ClassInfo, [tkString, tkLString,                                               tkWString, tkInteger], nil);
  Size := Count * SizeOf(Pointer);
  GetMem(PropList, Size);
  GetPropList(Instance.ClassInfo,  [tkString, tkLString,
                                    tkWString, tkInteger], PropList);

  For I := 0 To Count - 1 Do
  begin
    PropType := PropList^[I]^.PropType;
    If PropType^.Name = 'TFontName' Then
      SetStrProp(Instance, PropList^[I], LocalFontName);
    If PropType^.Name = 'TFontCharset' Then
      SetOrdProp(Instance, PropList^[I], LocalCharSet);
  end;

  FreeMem(PropList, Size);

  // Get class properties
  Count := GetPropList(Instance.ClassInfo, [tkClass], nil);
  Size := Count * SizeOf(Pointer);
  GetMem(ClassList, Size);
  GetPropList(Instance.ClassInfo,  [tkClass], ClassList);

  For I := 0 To Count - 1 Do
  begin
    ClassValue := TObject(GetOrdProp(Instance, ClassList^[I]));
    If Assigned(ClassValue) Then
    begin
      ChangeInstanceFontName(ClassValue);
    end;
  end;

  FreeMem(ClassList, Size);

  // problem : can't recognize not published properties
  // below is patch solutions for this problem

  // check components list
  If Instance is TComponent Then
  begin
    With TComponent(Instance) Do
    begin
      For I := 0 To ComponentCount - 1 Do
       ChangeInstanceFontName(Components[I]);
    end;
  end;

end;

begin
  lstChanged := TList.Create;
//  ChangeInstanceFontName(Self);
  lstChanged.Free;
end;

procedure initreserverd;
var n:integer;
begin
  ReservedTokens2 := '';
  for n:=Low(ReservedTokens) to High(ReservedTokens) do
    ReservedTokens2 := ReservedTokens2 + ' '+ReservedTokens[n]+' ';
end;


procedure GlobalTestClientLibrary;
begin
  //Lorenzo: need to check if library client gds32.dll is ready
  fCheckGDS32Ok := CheckGDS32(fCheckGDS32Msg);
  if not fCheckGDS32Ok then
  begin
{$IFDEF MSWINDOWS}
    //Lorenzo: simulate IBObjects startup
    FGDS_RefCount := -1;
    //Lorenzo: let's try to load fbclient.dll
    IB_Constants.IB_GDS32 := 'fbclient.dll';
    ReserveSessionHookRef;
    fCheckGDS32Ok := CheckGDS32(fCheckGDS32Msg);
{$ENDIF}
{$IFDEF LINUX}
    //Lorenzo: may be I'll port to Linux
{$ENDIF}
  end;
  if not fCheckGDS32Ok then
     MessageBox(0,'Could not load client library','IBOConsole',MB_OK + MB_ICONERROR);
end;

procedure GlobalTestHistance;
begin
{$IFDEF MSWINDOWS}
  { Create a mutex to make sure only 1 instance is running }
  CreateMutex (nil, false, 'ibo_console_mtx');
  if GetLastError() = ERROR_ALREADY_EXISTS then
  begin
    { It's already running so Restore the other copy }
    SendMessage (HWND_BROADCAST,
                 RegisterWindowMessage('ibo_console_mtx'),
                 0,
                 0);
    Halt(0);
  end;
{$ENDIF}
end;


//////////////////////////
{$IFDEF use_TFontProps}
var x:TFont;
{$ENDIF}
initialization
  InitSettings;
{$IFDEF use_TFontProps}
  x := TFont.Create;
  try
    gAppSettings.FontProps.FontName   := x.Name;
    gAppSettings.FontProps.FontSize   := x.Size;
    gAppSettings.FontProps.FontColor  := x.Color;
    gAppSettings.FontProps.FontStyle  := x.Style;
    gAppSettings.FontProps.FontHeight := x.Height;
  finally
    x.Free;
  end;
{$ENDIF}
  gTransIniFile:= TIniFile.Create(ChangeFileExt(application.ExeName,'.deflang'));
  gGUILanguageFile:=nil;
  initreserverd;
finalization
  gTransIniFile.Free;
  if Assigned(gGUILanguageFile) then gGUILanguageFile.Free;
end.
