{
 * The contents of this file are subject to the InterBase Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.
 *
 * You may obtain a copy of the License at http://www.Inprise.com/IPL.html.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.  The Original Code was created by Inprise
 * Corporation and its predecessors.
 *
 * Portions created by Inprise Corporation are Copyright (C) Inprise
 * Corporation. All Rights Reserved.
 *
 * Contributor(s):  Krzysztof Golko.
}

unit IBOCPersistentUtils;

interface
uses
  Classes,
  IBOCPersistentTypes, IBOCPersistent,
{$IFDEF MSWINDOWS}
  Forms;
{$ENDIF}
{$IFDEF LINUX}
  QForms;
{$ENDIF}


procedure IBCGetFormSettings(AForm: TForm; var Extra: word; PersistentInfo: TibcPersistentInfo; Id: string);
procedure IBCStoreFormSettings(AForm: TForm; Extra: word; PersistentInfo: TibcPersistentInfo; Id: string);

implementation

const
  SETT_LEFT        = 0;
  SETT_TOP         = 1;
  SETT_WIDTH       = 2;
  SETT_HEIGHT      = 3;
  SETT_STATE       = 4;
  SETT_EXTRA       = 5;

var
  FormSettings: TPersistentSettings;

procedure IBCGetFormSettings(AForm: TForm; var Extra: word; PersistentInfo: TibcPersistentInfo; Id: string);
begin
{$IFDEF MSWINDOWS}
  PersistentInfo.GetSectionSettings(Id, FormSettings);
  if (FormSettings[SETT_STATE] = wsNormal) or
     (FormSettings[SETT_STATE] = wsMaximized) then
  begin
    AForm.SetBounds(FormSettings[SETT_LEFT], FormSettings[SETT_TOP],
              FormSettings[SETT_WIDTH], FormSettings[SETT_HEIGHT]);
    AForm.WindowState := FormSettings[SETT_STATE];
    Extra := FormSettings[SETT_EXTRA];
  end
  else
    Extra := 0;
{$ENDIF}
end;

procedure IBCStoreFormSettings(AForm: TForm; Extra: word; PersistentInfo: TibcPersistentInfo; Id: string);
begin
{$IFDEF MSWINDOWS}
//    if (FormSettings[SETT_STATE] = wsNormal) or
//       (FormSettings[SETT_STATE] = wsMaximized) then
  begin
    FormSettings[SETT_LEFT] := AForm.Left;
    FormSettings[SETT_TOP] := AForm.Top;
    FormSettings[SETT_WIDTH] := AForm.Width;
    FormSettings[SETT_HEIGHT] := AForm.Height;
    FormSettings[SETT_STATE] := AForm.WindowState;
    FormSettings[SETT_EXTRA] := Extra;
  end;
  PersistentInfo.StoreSectionSettings(Id, FormSettings);
{$ENDIF}
end;

procedure InitFormSettings;
begin
  FormSettings := TPersistentSettings.Create(6);

  FormSettings.Names[SETT_LEFT] := 'Left';
  FormSettings.Values[SETT_LEFT] := 0;
  FormSettings.Names[SETT_TOP] := 'Top';
  FormSettings.Values[SETT_TOP] := 0;
  FormSettings.Names[SETT_WIDTH] := 'Width';
  FormSettings.Values[SETT_WIDTH] := 0;
  FormSettings.Names[SETT_HEIGHT] := 'Height';
  FormSettings.Values[SETT_HEIGHT] := 0;
  FormSettings.Names[SETT_STATE] := 'State';
  FormSettings.Values[SETT_STATE] := wsNormal;
  FormSettings.Names[SETT_EXTRA] := 'Extra';
  FormSettings.Values[SETT_EXTRA] := 0;
end;

initialization

  InitFormSettings;

end.
