unit LMInstallUtils;

interface
uses Windows, Registry, Classes, SysUtils, ShlObj, ComObj, ActiveX;

function GetTempDirectory: string;
procedure DeleteLMRegistryKey(const Key:String); // 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\MyProgam'
function GetExtensionDocClass(ext:string):String;
function GetStringInReg(RootKey:HKey; KeyPath: String; ValName: String):String;
function GetIntInReg(RootKey: HKEY; KeyPath:String; ValName:String):Integer;
procedure GetKeyNames(RootKey: HKEY; Key:String; List:TStrings);
procedure GetKeyValueList(RootKey: HKEY; Key:String; List:TStrings);
procedure GetKeyValueNames(RootKey: HKEY; Key:String; List:TStrings);
function GetWinVersionText: string;
procedure MakeLink(PgmPath, PgmArgs, LinkPath, Descr: String);
function WinExec32(const Cmd: string; const CmdShow: Integer): Boolean;
function GetResourceStr(Num:integer;ID:PChar):PChar;
procedure SetRunOnce(const nome, prg:String);


procedure RegisterUnistallProgram(const Publisher,
                                        ProductName,
                                        ProductVersion,
                                        HelpLink,
                                        HelpTelephone,
                                        ModifyPath,
                                        UninstallString,
                                        URLUpdateInfo,
                                        UrlInfoAbout:string);

var
     sProgPath:string;
     sProductKeyPath:String;
     sStartDateKey:String;
     sWinStartMenuDir:String;
     sWinDektopDir:String;
     sWinProgramsDir:String;
     sWinSendToDir:String;
     sWinStartupDir:String;
     sWinNetHoodDir:String;
     sWinAppDataDir:String;
     sWinFontsDir:String;
     sWinPersonalDir:String;
     sWinStartMenuProgramsDir:String;
var
  WinVersionInfo: TOSVersionInfo; // structure to hold ver info
  WinMajVer: integer;             // Major OS ver no
  WinMinVer: integer;             // Minor OS ver no
  WinBuildNo: integer;            // Build no
  WinMajVerStr: string;             // Major OS ver no
  WinMinVerStr: string;             // Minor OS ver no
  WinBuildNoStr: string;            // Build no
//  MajVerNoStr: string;         // Major ver no
//  MinVerNoStr: string;         // Minor ver no
  WinPlatFormStr: string;           // Platform ID
  WinCSDVerStr: string;             // more build info ?
  Windows3X:boolean;
  Windows95:boolean;
  Windows98:boolean;
  WindowsNT:boolean;
  Windows2000:boolean;
  WindowsXP:boolean;

var
//HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Setup
    UnistallRootKey: HKEY = HKEY_LOCAL_MACHINE;
    UnistallKey:String = '\Software\Microsoft\Windows\CurrentVersion\Uninstall';
    WinSetupKey:String = '\Software\Microsoft\Windows\CurrentVersion\Setup';
    WinDir:String='';
    WinSysDir:String='';
    WinbootDirKey:String = '\Software\Microsoft\Windows\CurrentVersion\Setup\WinbootDir';
    ClassRoot : HKEY = HKEY_CLASSES_ROOT;
    CLSIDRoot : HKEY = HKEY_LOCAL_MACHINE;
    CLSIDKey:String = '\Software\CLASSES\CLSID';
    ShellFoldersKey:String = '\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders';


    swfCLSID:String = '{1171A62F-05D2-11D1-83FC-00A0C9089C5A}';
    ExtSwfKey:String ='\.swf';
    ExtPdfKey:String = '\.pdf';


implementation

var GetVersionOk:boolean;
(*REGEDIT4

[HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders]
"Favorites"="C:\\WINDOWS\\Preferiti"
"Desktop"="C:\\WINDOWS\\Desktop"
"Programs"="C:\\WINDOWS\\Menu Avvio\\Programmi"
"Fonts"="C:\\WINDOWS\\Fonts"
"SendTo"="C:\\WINDOWS\\SendTo"
"Start Menu"="C:\\WINDOWS\\Menu Avvio"
"Templates"="C:\\WINDOWS\\ShellNew"
"Startup"="C:\\WINDOWS\\Menu Avvio\\Programmi\\Esecuzione automatica"
"Recent"="C:\\WINDOWS\\Recent"
"AppData"="C:\\WINDOWS\\Application Data"
"Personal"="C:\\Documenti"
"Cache"="C:\\WINDOWS\\Temporary Internet Files\\"
"Cookies"="C:\\WINDOWS\\Cookies\\"
"History"="C:\\WINDOWS\\Cronologia\\"
"NetHood"="C:\\WINDOWS\\Risorse di rete"

[HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Setup]
"BootDir"="C:\\"
"BootHost"="C:\\"
"OldWinBootDir"="C:\\WINBOOT"
"WinDir"="C:\\WINDOWS"
"AppsDir"="C:\\"
"WinBootDir"="C:\\WINDOWS"
"HostWinBootDir"="C:\\WINDOWS"
"MachineDir"="C:\\"
"WinAdminDir"="C:\\WINDOWS"
"SharedDir"="C:\\WINDOWS"
"SysDir"="C:\\WINDOWS\\SYSTEM"
"SourcePath"="D:\\_INST\\WIN98\\"
"OldWinDir"=""
"UninstallDir"="C:\\UNINSTAL.000"
"BackupDir"="C:\\UNINSTAL.000"
"SetupTempDir"="C:\\WININST0.400"
"SetupScratchDir"="C:\\WINDOWS\\INF"
"MemphisDetectedLastDrive"="Z"
"CommandLine"="/T:C:\\WININST0.400 /SrcDir=D:\\_INST\\WIN98 /IZ /IS /IQ /IT /II /NR /II /C  /U:xxxxxxxxxxxxxxxxx"
"Wallpaper"="(None)"
"TileWallpaper"="1"
"Upgrade"=hex:00
"InstallClasses"="System,hdc,fdc,CDROM,PCMCIA,MultiFunction,SCSIAdapter,Adapter,USB,HID,Mouse,Keyboard"
"ConfigPath"="C:\\WINDOWS\\config"
"MediaPath"="C:\\WINDOWS\\media"
"ICMPath"="C:\\WINDOWS\\SYSTEM\\COLOR"
"OLSSrcPath"="D:\\_INST\\WIN98\\OLS"
"SetupBinary"="sucatreg.exe"
"InstallPathType"=hex:00,00,00,00
"lastdrive"="Z"

  MakeLink(exepath+'\DiaEdit.exe','',sDektop+ '\DiaEdit.lnk','Dia Edit');
  MakeLink(exepath+'\DiaEdit.exe','',sPrograms+ '\DiaEdit.lnk','Dia Edit');
*)

function GetExtensionDocClass(ext:string):String;
var  Reg :TRegistry;
begin
  Result := '';
  if ext = '' then exit;
  if (ext[1] <> '\') and (ext[2]<>'.') then
     ext := '\.'+ext;
  Reg := TRegistry.Create;
  try
      Reg.RootKey := ClassRoot;
      if Reg.OpenKey(ext, False)
      then
      begin
        Result := Reg.ReadString('');
      end
  finally
      Reg.CloseKey;
      Reg.Free;
  end;
end;

function GetStringInReg(RootKey:HKey; KeyPath: String; ValName: String):String;
var
  Reg: TRegistry;
begin
   result:='';
   Reg := TRegistry.Create;
   try
    try
      Reg.RootKey := RootKey;
      if Reg.OpenKey(KeyPath, False) then
         Result:=Reg.ReadString(ValName);
      Reg.CloseKey;
    except
      result:='';
    end;
   finally
      Reg.Free;
   end;
end;

function GetIntInReg(RootKey: HKEY; KeyPath:String; ValName:String):Integer;
var
  Reg: TRegistry;
begin
  REsult := 0;
  Reg := TRegistry.Create;
  try
    try
      Reg.RootKey := RootKey;
      if Reg.OpenKey(KeyPath, False)
      then
         REsult := Reg.ReadInteger(ValName);
      Reg.CloseKey;
    except
      result:=0;
    end;
  finally
      Reg.Free;
  end;
end;

procedure GetKeyNames(RootKey: HKEY; Key:String; List:TStrings);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    try
      Reg.RootKey := RootKey;
      if Reg.OpenKey(Key, False) then
      begin
        Reg.GetKeyNames(List);
        Reg.CloseKey;
      end;
    except
    end;
  finally
      Reg.Free;
  end;
end;

procedure GetKeyValueNames(RootKey: HKEY; Key:String; List:TStrings);
var
  Reg: TRegistry;
begin

  Reg := TRegistry.Create;
  try
    try
      Reg.RootKey := RootKey;
      if Reg.OpenKey(Key, False) then
      begin
        Reg.GetValueNames(List);
        Reg.CloseKey;
      end;
    except
    end;
  finally
      Reg.Free;
  end;
end;
(*
procedure GetKeyValueTreeView(RootKey: HKEY; Key:String; Tree:TTreeView);

  function AddKey(node:TTreeNode; key,cap:String):TTreeNode;
  var
     Reg: TRegistry;
  begin
     REsult := Nil;
     Reg := TRegistry.Create;
     Reg.RootKey := RootKey;
     if Reg.OpenKey(Key, False) then
     begin
        cap  := cap + ' = '+ Reg.ReadString('');
        REsult := Tree.Items.AddChild(node,cap);
     end;
     Reg.Free;
  end;
  procedure ScanNode(node:TTreeNode; Key,cap:String);
  var
    Reg: TRegistry;
    kn:TStringList;
    NewNode:TTreeNode;
    n:integer;
    val : string;
  begin
    Reg := TRegistry.Create;
    try
        Reg.RootKey := RootKey;
        if Reg.OpenKey(Key, False)
        then
        begin
          val := Reg.ReadString('');
          if val <> '' then
             cap  := cap + ' = '+ val;
          NewNode := Tree.Items.AddChild(node,cap);
          kn:=TStringList.Create;
          try
            Reg.GetKeyNames(kn);
            for n:=0 to kn.Count -1 do
            begin
               ScanNode(NewNode,Key+'\'+kn[n],kn[n]);
               //AddKey(NewNode,Key+'\'+kn[n],kn[n]);
            end;
          finally
            kn.Free;
          end;
        end;
    finally
        Reg.CloseKey;
        Reg.Free;
    end;
  end;

begin
  Tree.Items.Clear;
  ScanNode(nil,Key,Key);
end;

procedure GetKeyValueListView(RootKey: HKEY; Key:String; List:TListView);
var
  Reg: TRegistry;
  vn:TStringList;
  n:integer;
  val:String;
  it:TListItem;
begin
  Reg := TRegistry.Create;
  try
      Reg.RootKey := RootKey;
      if Reg.OpenKey(Key, False)
      then
      begin
        vn:=TStringList.Create;
        try
          Reg.GetValueNames(vn);
          for n:=0 to vn.Count -1 do
          begin
             case Reg.GetDataType(vn[n]) of
             rdUnknown: val := '<sconosciuto>';
             rdString:  val := Reg.ReadString(vn[n]);
             rdExpandString:   val := Reg.ReadString(vn[n]);
             rdInteger:   val := IntToStr(Reg.ReadInteger(vn[n]));
             rdBinary:    val :=' = <valore binario>';
             end;
             it:=List.Items.Add;
             if vn[n] = '' then
                it.Caption :='Predefinito'
             else
                it.Caption :=vn[n];
             it.SubItems.Add(val);
          end;
        finally
          vn.Free;
        end;
      end;
  finally
      Reg.CloseKey;
      Reg.Free;
  end;
end;
*)

procedure GetKeyValueList(RootKey: HKEY; Key:String; List:TStrings);
var
  Reg: TRegistry;
  vn:TStringList;
  n:integer;
  val:String;
begin
  Reg := TRegistry.Create;
  try
      Reg.RootKey := RootKey;
      if Reg.OpenKey(Key, False)
      then
      begin
        vn:=TStringList.Create;
        try
          Reg.GetValueNames(vn);
          for n:=0 to vn.Count -1 do
          begin
             case Reg.GetDataType(vn[n]) of
             rdUnknown: val := '<sconosciuto>';
             rdString:  val := Reg.ReadString(vn[n]);
             rdExpandString:   val := Reg.ReadString(vn[n]);
             rdInteger:   val := IntToStr(Reg.ReadInteger(vn[n]));
             rdBinary:    val :=' = <valore binario>';
             end;
             if vn[n] = '' then
                List.Add('predefinito = ' + val)
             else
                List.Add(vn[n] + ' = ' + val);
          end;
        finally
          vn.Free;
        end;
      end;
  finally
      Reg.CloseKey;
      Reg.Free;
  end;
end;
(*
function fileShellOpen(const aFile: String): Boolean;
begin
  Result := ShellExecute( Null, 'open', PChar(aFile), nil, nil, SW_NORMAL) <= 32;
end;
*)
(*
function fileShellPrint(const aFile: String): Boolean;
begin
  Result := ShellExecute( Null, 'print', PChar(aFile), nil, nil, SW_HIDE) <= 32;
end;

procedure UDLEditor(const FileName: String);
begin
     if FileExists(FileName) then ShellExecute(Null, 'open', PChar(FileName), '', '', 1);
end;
*)
(*
function LmShellExec(Cmd,Param,Verb:String):String;
var sei: TShellExecuteInfo;
    hnd:HWND;
begin
  Result := 'KO';
  try
    hnd:=0;
    FillChar(sei, sizeof(sei), 0);
    sei.cbSize := sizeof(sei);
    sei.fMask := SEE_MASK_NOCLOSEPROCESS;
    sei.Wnd := hnd;
    sei.lpVerb := StrNew(pchar(Verb));
    sei.lpFile := StrNew(pchar(Cmd));
    sei.lpParameters := StrNew(pchar(Param));
    sei.nShow := sw_Normal;

    if ShellExecuteEx(@sei) then
    begin
      WaitForSingleObject(sei.hProcess,INFINITE);
      Result := 'OK';
    end
    else
    begin
      Result := SysErrorMessage(GetLastError);
    end;
  finally
    StrDispose(sei.lpVerb);
    StrDispose(sei.lpFile);
    StrDispose(sei.lpParameters);
  end;
end;
*)
// Execute the application: File-name, Parameters (pl. file name what want to open), start dir,
// window size: (1: normal, 2: icon state, 3: maximal window
(*
function ExecuteProgram(const FileName, StartParameters, DefaultDir: String): THandle;
var
   acFileName,
   acParams,
   acDir : array[0..127] of Char;
   ShowCmd : Integer;
   hnd:HWND;
begin
     ShowCmd := 1;
//     case WindowState of
//          wsNormal    : ShowCmd := 1;
//          wsMinimized : ShowCmd := 2;
//          wsMaximized : ShowCmd := 3;
//     end;
     hnd:=0;
     Result := ShellExecute(hnd, nil,
                            StrPCopy(acFileName, FileName),
                            StrPCopy(acParams, StartParameters),
                            StrPCopy(acDir, DefaultDir), ShowCmd);
end;


function IsDelphiRun: boolean;
var
   H1, H2, H3, H4 : Hwnd;
const
     A1 : array[0..12] of char = 'TApplication'#0;
     A2 : array[0..15] of char = 'TAlignPalette'#0;
     A3 : array[0..18] of char = 'TPropertyInspector'#0;
     A4 : array[0..11] of char = 'TAppBuilder'#0;
     T1 : array[0..8]  of char = 'Delphi 4'#0;
begin
     H1 := FindWindow(A1, T1);
     H2 := FindWindow(A2, nil);
     H3 := FindWindow(A3, nil);
     H4 := FindWindow(A4, nil);
     Result := (H1 <> 0) and (H2 <> 0) and (H3 <> 0) and (H4 <> 0);
end;

procedure ViewTxtFile(FileName:String);
var
  Viewer: string;
begin
  if not FileExists(FileName) then exit;
  Viewer := 'notepad.exe';
  if ShellExecute(0, 'open', PChar(Viewer), PChar(FileName),
        PChar(ExtractFilePath(FileName)), SW_SHOWNORMAL) <= 32 then
  begin
    Viewer := 'wordpad.exe';
    if ShellExecute(0, 'open', PChar(Viewer), PChar(FileName),
        PChar(ExtractFilePath(FileName)), SW_SHOWNORMAL) <= 32 then
      ShowMessage('Could not find a viewer for the INI file');
  end;
end;
*)
function GetWinVersionText: string;
begin
  Result := '';
  if not GetVersionOk then exit;
  Result := WinPlatFormStr + ' ' +
            WinMajVerStr + '.' +
            WinMinVerStr + ' ' + '(Build ' +
            WinBuildNoStr + ':' +
            WinCSDVerStr + ')';
  end;


function GetTempDir: string;
var
  Buffer: array[0..1023] of Char;
begin
  SetString(Result, Buffer, GetTempPath(SizeOf(Buffer), Buffer));
end;

function GetResourceString(Num:integer;ID:PChar):String;
var
  Buf : PChar;
  ResHandle : Cardinal;
begin
  ResHandle := FindResource(HInstance,Makeintresource(Num),ID);
  Buf := PChar(LoadResource(HInstance,ResHandle));
  Result := Buf;
end;

function GetResourceStr(Num:integer;ID:PChar):PChar;
var
  Buf : PChar;
  ResHandle : Cardinal;
begin
  ResHandle := FindResource(HInstance,Makeintresource(Num),ID);
  Buf := PChar(LoadResource(HInstance,ResHandle));
  Result := Buf;
end;

function WinExec32(const Cmd: string; const CmdShow: Integer): Boolean;
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  FillChar(StartupInfo, SizeOf(TStartupInfo), #0);
  StartupInfo.cb := SizeOf(TStartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := CmdShow;
  Result := CreateProcess(nil, PChar(Cmd), nil, nil, False,
    NORMAL_PRIORITY_CLASS, nil, nil, StartupInfo, ProcessInfo);
  if Result then
  begin
    WaitForInputIdle(ProcessInfo.hProcess, Infinite);
    CloseHandle(ProcessInfo.hThread);
    CloseHandle(ProcessInfo.hProcess);
  end;
end;

procedure MakeLink(PgmPath, PgmArgs, LinkPath, Descr: String);
var
  AnObj: IUnknown;
  ShLink: IShellLink;
  PFile: IPersistFile;
  WFileName: WideString;
begin
  if UpperCase(ExtractFileExt(LinkPath)) <> '.LNK' then
  begin
     messagebox(0,'Errore: l''estensione del nome del file di collegamento deve essere .LNK','Errore',MB_ICONQUESTION+MB_YESNO);
     exit;
  end;

  // access to the two interfaces of the object
  AnObj := CreateComObject(CLSID_ShellLink);
  ShLink := AnObj as IShellLink;
  PFile := AnObj as IPersistFile;

  // NOTE: We're using a COM Object, so all string args must be PChar

  // set the link properties
  ShLink.SetPath(PChar(PgmPath));   // also called the link target
  ShLink.SetArguments(PChar(PgmArgs));
  ShLink.SetWorkingDirectory(PChar(ExtractFilePath(PgmPath)));
  ShLink.SetDescription(PChar(Descr));

  // Save with a WideString filename
  WFileName := LinkPath;
  PFile.Save(PWChar(WFileName), False);
end;

procedure RegisterUnistallProgram(const Publisher,
                                        ProductName,
                                        ProductVersion,
                                        HelpLink,
                                        HelpTelephone,
                                        ModifyPath,
                                        UninstallString,
                                        URLUpdateInfo,
                                        UrlInfoAbout:string);
var  Reg :TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.LazyWrite := false;
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\'+ProductName,True) then
    begin
      if Publisher <> '' then
      Reg.WriteString('Publisher',Publisher);
      if ProductVersion <> '' then
      Reg.WriteString('DisplayVersion',ProductVersion);
      if UrlInfoAbout <> '' then
      Reg.WriteString('URLInfoAbout',UrlInfoAbout);
      if HelpTelephone <> '' then
      Reg.WriteString('HelpTelephone',HelpTelephone);
      if HelpLink <> '' then
      Reg.WriteString('HelpLink',HelpLink);
      if URLUpdateInfo <> '' then
      Reg.WriteString('URLUpdateInfo',URLUpdateInfo);
      if UninstallString <> '' then
      Reg.WriteString('UninstallString',UninstallString);
      if ProductName <> '' then
      Reg.WriteString('DisplayName',ProductName);
      if ModifyPath <> '' then
        Reg.WriteString('ModifyPath',ModifyPath);
    end
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;


procedure DeleteLMRegistryKey(const Key:String); // 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\MyProgam'
var reg: TRegistry;
begin
  reg := TRegistry.Create;
  try
    reg.RootKey := HKEY_LOCAL_MACHINE;
    reg.LazyWrite := false;
    reg.DeleteKey(Key);
  finally
    reg.free;
  end;
end;


function GetTempDirectory: string;
var
  Path: array [0..260] of Char;
begin
  GetTempPath(Sizeof(Path), Path);
  Result := Path;
end;

procedure SetRunOnce(const nome, prg:String);
var reg: TRegistry;
begin
  reg := TRegistry.Create;
  try
    reg.RootKey := HKEY_LOCAL_MACHINE;
    reg.LazyWrite := false;
    reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce',true);
    reg.WriteString(nome,prg);
  finally
    reg.free;
  end;
end;


initialization
  WinVersionInfo.dwOSVersionInfoSize := SizeOf(WinVersionInfo);
  GetVersionOk:= GetVersionEx (WinVersionInfo);
  if GetVersionOk then
  with WinVersionInfo do
  begin
    WinMajVer:= dwMajorVersion;             // Major OS ver no
    WinMinVer:= dwMinorVersion;             // Minor OS ver no
    WinBuildNo:= dwBuildNumber and $0000FFFF;            // Build no
    WinMajVerStr   := IntToStr (dwMajorVersion);
    WinMinVerStr   := IntToStr (dwMinorVersion);
    WinBuildNoStr  := IntToStr (WinBuildNo); // low order word
    Windows3X:=False;
    Windows95:=False;
    Windows98:=False;
    WindowsNT:=False;
    Windows2000 := False;
    case dwPlatFormId of
      VER_PLATFORM_WIN32s:
      begin
        WinPlatFormStr := 'Win32s';
        Windows3X:=True;
      end;
      VER_PLATFORM_WIN32_WINDOWS:
      begin
        WinPlatFormStr := 'Windows 95';
        Windows95:=True;
        if (dwMajorVersion = 4) and (dwMinorVersion > 9) then
        begin
           WinPlatFormStr := 'Windows 98';
           Windows95:=False;
           Windows98:=True;
        end;
      end;
      VER_PLATFORM_WIN32_NT:
      begin
        WinPlatFormStr := 'Windows NT';
        WindowsNT := dwMajorVersion = 4;
        Windows2000 := dwMajorVersion = 5 ;
        if Windows2000 and (dwMinorVersion = 1) then
        begin
          WindowsXP := True;
          Windows2000 := False;
        end;
      end;
    end;
    WinCSDVerStr   := StrPas (szCSDVersion);
  end;
  if Windows95 or Windows98 or WindowsNT then
  begin
    WinDir:=GetStringInReg(HKEY_LOCAL_MACHINE,WinSetupKey,'WinDir');
    WinSysDir:=GetStringInReg(HKEY_LOCAL_MACHINE,WinSetupKey,'SysDir');
    sWinStartMenuProgramsDir:=GetStringInReg(HKEY_LOCAL_MACHINE,ShellFoldersKey,'Programs');
    sWinProgramsDir:=GetStringInReg(HKEY_LOCAL_MACHINE,'\Software\Microsoft\Windows\CurrentVersion','ProgramFilesDir');

    sWinDektopDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'Desktop');
    sWinStartMenuDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'Start Menu');

    sWinSendToDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'SendTo');;
    sWinStartupDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'Startup');
    sWinNetHoodDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'NetHood');
    sWinAppDataDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'AppData');
    sWinFontsDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'Fonts');
    sWinPersonalDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'Personal');
  end
  else
  begin
    WinDir:=GetStringInReg(HKEY_LOCAL_MACHINE,'\SOFTWARE\Microsoft\Windows NT\CurrentVersion','PathName');
    WinSysDir:=GetStringInReg(HKEY_LOCAL_MACHINE,'\SOFTWARE\Microsoft\Windows NT\CurrentVersion','SystemRoot');
    sWinProgramsDir:=GetStringInReg(HKEY_LOCAL_MACHINE,'\Software\Microsoft\Windows\CurrentVersion','ProgramFilesDir');

    sWinDektopDir:=GetStringInReg(HKEY_LOCAL_MACHINE,ShellFoldersKey,'Common Desktop');
    sWinStartMenuDir:=GetStringInReg(HKEY_LOCAL_MACHINE,ShellFoldersKey,'Common Start Menu');
    sWinStartMenuProgramsDir:=GetStringInReg(HKEY_LOCAL_MACHINE,ShellFoldersKey,'Common Programs');

    sWinSendToDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'SendTo');
    sWinStartupDir:=GetStringInReg(HKEY_CURRENT_USER,'\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders','Common Startup');
    sWinNetHoodDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'NetHood');
    sWinAppDataDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'AppData');
    sWinFontsDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'Fonts');
    sWinPersonalDir:=GetStringInReg(HKEY_CURRENT_USER,ShellFoldersKey,'Personal');
  end;

end.
