{
 * The contents of this file are subject to the InterBase Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.
 *
 * You may obtain a copy of the License at http://www.Inprise.com/IPL.html.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.  The Original Code was created by Inprise
 * Corporation and its predecessors.
 *
 * Portions created by Inprise Corporation are Copyright (C) Inprise
 * Corporation. All Rights Reserved.
 *
 * Contributor(s): Krzysztof Golko.
}

unit dlguPreferences;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TdlgPreferences = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    HelpBtn: TButton;
    GroupBox1: TGroupBox;
    cbxSQLDialect: TComboBox;
    Label1: TLabel;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure GetSettings;
    procedure UpdateSettings;
  public
    { Public declarations }
    class function ShowDialog: boolean;
  end;

var
  dlgPreferences: TdlgPreferences;

implementation

uses IBCGlobal;

{$R *.DFM}

class function TdlgPreferences.ShowDialog: boolean;
begin
  Result := dlgPreferences.ShowModal = mrOk;
end;

procedure TdlgPreferences.GetSettings;
begin
  cbxSqlDialect.ItemIndex := gAppSettings[DEFAULT_DIALECT].Setting - 1;
end;

procedure TdlgPreferences.UpdateSettings;
begin
  gAppSettings[DEFAULT_DIALECT].Setting := cbxSqlDialect.ItemIndex + 1;
end;

procedure TdlgPreferences.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(HelpContext);
end;

procedure TdlgPreferences.FormShow(Sender: TObject);
begin
  GetSettings;
end;

procedure TdlgPreferences.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if ModalResult = mrOk then
    UpdateSettings;
end;

end.
