{************************************************************************
  This Unit was modified to be interfaced in IBObjects
  by Lorenzo Mengoni - (Ancona, Italy)

  for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.

24.May.2005, Lorenzo:
- Added TJvComputerInfoEx

                                                                         }
unit dmuMain;

interface

uses
{$IFDEF LINUX}
  Types, QGraphics, QForms, QDialogs, QTypes,  QStdCtrls, QDBGrids, QControls,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, StdCtrls, ImgList,
{$ENDIF}
  SynEditHighlighter, SynHighlighterSQL, SysUtils, Classes,
  SynEditRegexSearch, SynEditMiscClasses, SynEditSearch,
  SynCompletionProposal, JvComponent, JvComputerInfoEx;

type
  TdmMain = class(TDataModule)
    SynSQLSyn1: TSynSQLSyn;
    imgToolBarsEnabled: TImageList;
    imgTreeview: TImageList;
    imgLargeView: TImageList;
    ImageList33: TImageList;
    ImageList1: TImageList;
    SynEditSearch: TSynEditSearch;
    SynEditRegexSearch: TSynEditRegexSearch;
    JvComputerInfoEx1: TJvComputerInfoEx;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadSyntaxFromPersistent;
    procedure SaveSyntaxToPersistent;
  end;

var
  dmMain: TdmMain;

implementation

uses
  IBOCGlobal,  IBOCPersistentTypes;

{$R *.DFM}

procedure TdmMain.LoadSyntaxFromPersistent;
var
  SyntaxSettings: TPersistentSettings;
  i: integer;
begin
  if Assigned(gPersistentInfo) then
  try
    SyntaxSettings := TPersistentSettings.Create(['Background', 'Foreground', 'Style']);
    try
      for i := 0 to SynSQLSyn1.AttrCount-1 do
      begin
        SyntaxSettings.ValueByName['Foreground'] := SynSQLSyn1.Attribute[i].Foreground;
        SyntaxSettings.ValueByName['Background'] := SynSQLSyn1.Attribute[i].Background;
        SyntaxSettings.ValueByName['Style'] := SynSQLSyn1.Attribute[i].IntegerStyle;

        gPersistentInfo.GetSectionSettings(['Syntax', SynSQLSyn1.Attribute[i].Name], SyntaxSettings);

        SynSQLSyn1.Attribute[i].Foreground := SyntaxSettings.ValueByName['Foreground'];
        SynSQLSyn1.Attribute[i].Background := SyntaxSettings.ValueByName['Background'];
        SynSQLSyn1.Attribute[i].IntegerStyle := SyntaxSettings.ValueByName['Style'];
      end;
    finally
      SyntaxSettings.Free;
    end;
  except
  end;
end;

procedure TdmMain.SaveSyntaxToPersistent;
var
  SyntaxSettings: TPersistentSettings;
  i: integer;
begin
  if Assigned(gPersistentInfo) then
  try
    SyntaxSettings := TPersistentSettings.Create(['Background', 'Foreground', 'Style']);
    try
      for i := 0 to SynSQLSyn1.AttrCount - 1 do
      begin
        SyntaxSettings.ValueByName['Foreground'] := SynSQLSyn1.Attribute[i].Foreground;
        SyntaxSettings.ValueByName['Background'] := SynSQLSyn1.Attribute[i].Background;
        SyntaxSettings.ValueByName['Style'] := SynSQLSyn1.Attribute[i].IntegerStyle;

        gPersistentInfo.StoreSectionSettings(['Syntax', SynSQLSyn1.Attribute[i].Name], SyntaxSettings);
      end;
    finally
      SyntaxSettings.Free;
    end;
  except
  end;
end;

end.

