{************************************************************************}
{  This Unit was modified to be interfaced in IBObjects
   by Lorenzo Mengoni - (Ancona, Italy)
   for suggestion and contributions email to lorenzo@mengoni.com
   }
{  This software is distributed under the License is distributed on      }
{    an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either              }
{    express or implied. See the ORIGINAL Copyright                      }
{
 * The contents of this file are subject to the InterBase Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.
 * 
 * You may obtain a copy of the License at http://www.Inprise.com/IPL.html.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.  The Original Code was created by Inprise
 * Corporation and its predecessors.
 * 
 * Portions created by Inprise Corporation are Copyright (C) Inprise
 * Corporation. All Rights Reserved.
 * 
 * Contributor(s): Krzysztof Golko.
}
unit frmuAbout;

interface

uses
{$IFDEF LINUX}
  Types, QForms, QControls, QStdCtrls, QExtCtrls, QGraphics,
{$ENDIF}
{$IFDEF MSWINDOWS}
  WinTypes, WinProcs, Forms, Controls, StdCtrls,
  Buttons, Graphics, ExtCtrls,
{$IFDEF useGraphicEx}
  GraphicEx,
{$ENDIF}
  jpeg,
{$IFDEF  _JvGIF_}
  JvGIF,
{$ENDIF}
  pngimage,

{$ENDIF}
  Classes, SysUtils, IBOConsoleForm, JvExControls, JvComponent,
  JvInstallLabel, JvgTransparentMemo, JclFileUtils, JvLinkLabel;

type
  TfrmAbout = class(TIBOConsoleForm)
    Label8: TLabel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel11: TPanel;
    JvgTransparentMemo1: TJvgTransparentMemo;
    VersionMemo: TJvgTransparentMemo;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button1KeyPress(Sender: TObject; var Key: Char);
  published
    Button1: TButton;
    lblCopyright: TLabel;
    lblOSVersion: TLabel;
    lblInterbaseLink: TLabel;
    lblBorlandLink: TLabel;
    Label2: TLabel;
    Image2: TImage;
    Panel2: TPanel;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel5: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure btnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HTTPLinkClick(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Label5Click(Sender: TObject);
    { Private declarations }
  private
  public
    { Public declarations }
  end;

procedure ShowAboutDialog(aProductName: string);

implementation

uses
{$IFDEF MSWINDOWS}
  ShellApi,
{$ENDIF}
  IBOCGlobal, zluUtility, dmuMain, JvComputerInfoEx, JclSysInfo;

{$IF Declared(Forms)}
{$R *.DFM}
{$IFEND}

{$IF Declared(QForms)}
{$R *.xfm}
{$IFEND}

const
  sNtProductType: array [TNtProductType] of string =
   ('Unknown', 'WorkStation', 'Server', 'Advanced Server',
    'Personal', 'Professional', 'Datacenter Server');

procedure ShowAboutDialog(aProductName: string);
var
  frmAbout: TfrmAbout;
  n:integer;
begin
  frmAbout := TfrmAbout.Create(Application.MainForm);
  with frmAbout do
  begin
    frmAbout.UseFont(gAppSettings[FONT_NAME],gAppSettings[FONT_CHARSET]);
  { Get OS Version Information / moved to  }
{$IFDEF LINUX}
    lblOSVersion.Caption := OSVerInfo;
{$ELSE}
    lblOSVersion.Caption := dmMain.JvComputerInfoEx1.OS.ProductName + ' ' +
                            sNtProductType[dmMain.JvComputerInfoEx1.OS.ProductType] + ' ' +
                            dmMain.JvComputerInfoEx1.OS.VersionCSDString;
{$ENDIF}
    { Get the version information for IBOConsole }
//    lblIBOConsoleVer.Caption := IBOConsoleVerInfo();
    with TJclFileVersionInfo.Create(Application.ExeName) do
    try
      Caption := 'About '+ProductName +' '+BinFileVersion;
      frmAbout.VersionMemo.Clear;
      for n:=0 to Items.Count-1 do
      if Items.Values[Items.Names[n]]<> '' then
        frmAbout.VersionMemo.Lines.Add(Items.Values[Items.Names[n]]);
    finally
      Free;
    end;
    ShowModal;
    Free;
  end;
end;

procedure TfrmAbout.btnOKClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmAbout.FormShow(Sender: TObject);
begin
  inherited;
end;

procedure TfrmAbout.HTTPLinkClick(Sender: TObject);
begin
{$IFDEF MSWINDOWS}
  ShellExecute(0, 'open', PChar((Sender as TLabel).Caption), '', '', SW_SHOWNORMAL);
{$ENDIF}
end;

procedure TfrmAbout.Label2Click(Sender: TObject);
begin
{$IFDEF MSWINDOWS}
  ShellExecute(0, 'open', PChar('http://www.mengoni.com'), '', '', SW_SHOWNORMAL);
{$ENDIF}
end;

procedure TfrmAbout.Image2Click(Sender: TObject);
begin
{$IFDEF MSWINDOWS}
  ShellExecute(0, 'open', PChar('http://www.ibobjects.com'), '', '', SW_SHOWNORMAL);
{$ENDIF}
end;

procedure TfrmAbout.Label5Click(Sender: TObject);
begin
{$IFDEF MSWINDOWS}
  ShellExecute(0, 'open', PChar('http://www.gimbal.com.au'), '', '', SW_SHOWNORMAL);
{$ENDIF}
end;

procedure TfrmAbout.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then begin
    ModalResult := mrOk;
  end;
end;

procedure TfrmAbout.Button1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then begin
    ModalResult := mrOk;
  end;
end;

end.



