{************************************************************************
  This Unit was modified to be interfaced in IBObjects
  by Lorenzo Mengoni - (Ancona, Italy)

  for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.

                                                                         }
{
 * The contents of this file are subject to the InterBase Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.
 * 
 * You may obtain a copy of the License at http://www.Inprise.com/IPL.html.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.  The Original Code was created by Inprise
 * Corporation and its predecessors.
 * 
 * Portions created by Inprise Corporation are Copyright (C) Inprise
 * Corporation. All Rights Reserved.
 * 
 * Contributor(s): Krzysztof Golko.
}

unit frmuAddTool;

interface

uses
{$IFDEF LINUX}
  QGraphics, QControls, QForms, QDialogs, QStdCtrls,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, StdCtrls,
{$ENDIF}
  SysUtils, Classes, IBOConsoleForm;

type
  TfrmAddTools = class(TIBOConsoleForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edtTitle: TEdit;
    edtProgram: TEdit;
    edtWorkingDir: TEdit;
    edtParams: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    btnBrowse: TButton;
    procedure btnBrowseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses IBOCGlobal;

{$IF Declared(Forms)}
{$R *.dfm}
{$IFEND}

{$IF Declared(QForms)}
{$R *.xfm}
{$IFEND}

procedure TfrmAddTools.btnBrowseClick(Sender: TObject);
var
  OpenDlg: TOpenDialog;
begin
  inherited;
  OpenDlg := TOpenDialog.Create (self);

  with OpenDlg do
  begin
{$IFDEF MSWINDOWS}
    DefaultExt := '.EXE';
    Filter := 'Program Files | *.EXE; *.BAT; *.COM;';
{$ENDIF}
    Options := Options + [ofPathMustExist, ofFileMustExist];
    if Execute then
    begin
      edtProgram.Text := FileName;
      if Length(edtTitle.Text) = 0 then
        edtTitle.Text := ExtractFileName(FileName);
    end;
    Free;
  end;
end;

end.
