{************************************************************************
  This Unit was modified to be interfaced in IBObjects
  by Lorenzo Mengoni - (Ancona, Italy)

  for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.

                                                                         }
{******************************************************************}
{ The contents of this file are used with permission, subject to   }
{ the Mozilla Public License Version 1.1 (the "License"); you may  }
{ not use this file except in compliance with the License. You may }
{ obtain a copy of the License at                                  }
{ http://www.mozilla.org/MPL/MPL-1.1.html                          }
{                                                                  }
{ Software distributed under the License is distributed on an      }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or   }
{ implied. See the License for the specific language governing     }
{ rights and limitations under the License.                        }
{                                                                  }
{******************************************************************} 
{20.August.2002
    Introduced new Ancestor TIBOConsoleEditor,
    I tryed inteface, but it make to duplicate all common code, so I preferred inheritance.

    Fixed Alter Domain

}
unit frmuEditorDomain;

interface

uses
{$IFDEF LINUX}
  QControls, QForms, QDialogs, QComCtrls, QStdCtrls, QMenus,
  Types, QTypes, QImgList, QExtCtrls,
  QStdActns, QActnList, SynEdit, SynEditPrint, IBCXDummies,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Messages, Controls, Forms, Dialogs, ComCtrls, StdCtrls, ClipBrd,
  Menus, ImgList, StdActns, ActnList, Graphics, Spin, ExtCtrls, Printers,
  Buttons, 
{$ENDIF}
  IBOConsoleForm, SysUtils, Classes, DB, IBOCGlobal,
  SynEdit, dmuNode;

type

  TfrmDomains = class(TIBOConsoleEditor)
    pgObjectEditor: TPageControl;
    tsMain: TTabSheet;
    edColumn: TEdit;
    Label1: TLabel;
    tsDefault: TTabSheet;
    tsConstraint: TTabSheet;
    Bevel1: TBevel;
    tsDDL: TTabSheet;
    Label3: TLabel;
    cmbDataType: TComboBox;
    nbType: TNotebook;
    Label4: TLabel;
    Label9: TLabel;
    cmbCharCharSet: TComboBox;
    Label14: TLabel;
    Label15: TLabel;
    edPrecision: TSpinEdit;
    edScale: TSpinEdit;
    Label18: TLabel;
    Label6: TLabel;
    Label11: TLabel;
    edSubType: TEdit;
    cmbBlobCharSet: TComboBox;
    edSegSize: TSpinEdit;
    chkColNotNull: TCheckBox;
    tsDescription: TTabSheet;
    pnlArray: TPanel;
    Label10: TLabel;
    lvArray: TListView;
    btnAddDimension: TButton;
    btnDeleteDimension: TButton;
    btnEditDimension: TButton;
    edDefault: TSynEdit;
    edConstraint: TSynEdit;
    Label2: TLabel;
    cmbCollate: TComboBox;
    Label5: TLabel;
    cmbBlobCollate: TComboBox;
    edDescription: TSynEdit;
    edDDL: TSynEdit;
    stsEditor: TStatusBar;
    ActionList1: TActionList;
    ActionCompile: TAction;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    edLength: TSpinEdit;
    ActionCancel: TAction;
    procedure cmbDataTypeChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure edColDefaultChange(Sender: TObject);
    procedure edColCheckChange(Sender: TObject);
    procedure pgObjectEditorChange(Sender: TObject);
    procedure btnAddDimensionClick(Sender: TObject);
    procedure btnDeleteDimensionClick(Sender: TObject);
    procedure btnEditDimensionClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure edColumnChange(Sender: TObject);
    procedure edLengthChange(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ActionCompileExecute(Sender: TObject);
    procedure ActionCompileUpdate(Sender: TObject);
    procedure edDefaultStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure edConstraintStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure edDescriptionStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure edDescriptionChange(Sender: TObject);
    procedure edColumnKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    FChangeDefault : Boolean;
    FChangeCheck : Boolean;
    FChangeName : Boolean;
    FChangeDataType : Boolean;
    FCompileText: String;
    fOldDefault:String;
    fOldCheck:String;

    function GetDataType(include_array_def:boolean=true) : String;
    function GetDefault : String;
    function GetNotNull : String;
    function GetCheck : String;
    function GetCollate: String;

    procedure SetCompileText(const Value: String);
    procedure GetDDL;
    procedure SetChangeCheck(const Value: Boolean);
    procedure SetChangeDataType(const Value: Boolean);
    procedure SetChangeDefault(const Value: Boolean);
    procedure SetChangeName(const Value: Boolean);
    function GetCharSet: String;
    property Change_Default : Boolean read FChangeDefault write SetChangeDefault;
    property Change_Check : Boolean read FChangeCheck write SetChangeCheck;
    property Change_Name : Boolean read FChangeName write SetChangeName;
    property Change_DataType : Boolean read FChangeDataType write SetChangeDataType;
  protected
    function CompileNewObject: boolean; override;
    function AlterObject: boolean; override;
    procedure DoLoadObject; override;
    procedure SignalNewObject; override;
    procedure SignalObjectModified; override;
    procedure SignalObjectNameChanged; override;
    procedure SetDataModule(const Value: TDmN); override;
  public
    { Public declarations }
    property CompileText:String read FCompileText write SetCompileText;
  end;

implementation

uses
  frmuArrayDialog, IBOAdminUtils, IBOExtract,
  dmuMain, frmuMain, frmuMessage, LMMessageDialog;

const
  TY_NONE              = -1;
  TY_SMALLINT          = 0;
  TY_INTEGER           = 1;
  TY_FLOAT             = 2;
  TY_DOUBLE_PRECISION  = 3;
  TY_DECIMAL           = 4;
  TY_NUMERIC           = 5;
  TY_DATE              = 6;
  TY_TIME              = 7;
  TY_TIMESTAMP         = 8;
  TY_CHAR              = 9;
  TY_VARCHAR           = 10;
  TY_BLOB              = 11;

{$R *.DFM}

  PG_DOMAIN            = 0;
  PG_DEFAULT           = 1;
  PG_CONSTRAINT        = 2;
  PG_DESC              = 3;
  PG_DDL               = 4;

procedure TfrmDomains.cmbDataTypeChange(Sender: TObject);
begin
  Change_DataType := True;
  if cmbDataType.ItemIndex = -1 then
  begin
    nbType.ActivePage := 'blank';
    pnlArray.Visible := True;
  end
  else
  begin
    case cmbDataType.ItemIndex of
      TY_DECIMAL :
        begin
          nbType.ActivePage := 'numeric';
          pnlArray.Visible := True;
        end;
      TY_NUMERIC :
        begin
          nbType.ActivePage := 'numeric';
          pnlArray.Visible := True;
        end;
      TY_CHAR :
        begin
          nbType.ActivePage := 'char';
          pnlArray.Visible := True;
        end;
      TY_VARCHAR :
        begin
          nbType.ActivePage := 'char';
          pnlArray.Visible := True;
        end;
      TY_BLOB :
        begin
          nbType.ActivePage := 'blob';
          pnlArray.Visible := False;
        end;
    else
      nbType.ActivePage := 'blank';
      pnlArray.Visible := True;
    end;
  end;
end;


function TfrmDomains.GetDataType(include_array_def:boolean=true) : String;
  procedure AddArrayDef;
    var
    Idx : Integer;
  begin
          Result := Result + ' [';
          for Idx := 0 to lvArray.Items.Count - 1 do
          begin
            Result := Result + lvArray.Items.Item[Idx].Caption + ':' + lvArray.Items.Item[Idx].SubItems[0] + ', ';
          end;
          Result := Trim(Result);
          if Result[Length(Result)] = ',' then
            Result := Copy(Result, 1, Length(Result) - 1);
          Result := Result + ']';
  end;

begin
  Result := cmbDataType.Text;

  case cmbDataType.ItemIndex of
    TY_NUMERIC, TY_DECIMAL :
      begin
        Result := Result + '(' + edPrecision.Text + ', ' + edScale.Text + ')';
        if lvArray.Items.Count > 0 then
          AddArrayDef;
      end;

    TY_CHAR, TY_VARCHAR :
      begin
        Result := Result + '(' + edLength.Text + ')';
        if lvArray.Items.Count > 0 then
          AddArrayDef;
      end;

    TY_BLOB :
      begin
        Result := Result + ' sub_type ' + edSubType.Text;
        Result := Result + ' segment size ' + IntToStr(edSegSize.Value);
        if not ((cmbBlobCharSet.Text = '') or (cmbBlobCharSet.Text = 'NONE')) then
          Result := Result + ' character set ' + cmbBlobCharSet.Text;
      end;
  else
    if include_array_def then 
    begin
      if lvArray.Items.Count > 0 then
        AddArrayDef;
    end;
  end;
end;


function TfrmDomains.GetDefault : String;
var
  Temp : String;
begin
  Temp := Trim(edDefault.Text);
  if Temp <> '' then
  begin
    if Pos('default', AnsiLowerCase(Temp)) = 0 then
      Temp := 'default ' + Temp;
    Result := ' ' + Temp
  end
  else
    Result := ' ';
end;

function TfrmDomains.GetNotNull : String;
begin
  if chkColNotNull.Checked then
    Result := ' not null'
  else
    Result := ' ';

end;

function TfrmDomains.GetCheck : String;
var
  Temp : String;
begin
  Temp := Trim(edConstraint.Text);
  if Temp <> '' then
  begin
    if Pos('check', AnsiLowerCase(Temp)) = 0 then
     Temp := 'check ('+ Temp+ ')';
    Result := ' ' + Temp;
  end  
  else
    Result := ' ';
end;

function TfrmDomains.GetCollate : String;
begin
  if (cmbCollate.Text <> '') and (UpperCase(cmbDataType.Text)<>'BLOB') then
    Result := ' collate ' + cmbCollate.Text
  else
    Result := ' ';
end;

function TfrmDomains.GetCharSet : String;
begin
  if (cmbCharCharSet.Text <> '') then
    Result := ' character set ' + cmbCharCharSet.Text
  else
    Result := ' ';
end;

procedure TfrmDomains.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  inherited;
end;

procedure TfrmDomains.FormCreate(Sender: TObject);
begin
  pgObjectEditor.ActivePage := tsMain;
  ImageIndex := NODE_DOMAINS_IMG;
  ObjectType := NODE_DOMAIN;
end;

procedure TfrmDomains.edColDefaultChange(Sender: TObject);
begin
  Change_Default := True;
end;

procedure TfrmDomains.edColCheckChange(Sender: TObject);
begin
  Change_Check := True;
end;

procedure TfrmDomains.GetDDL;
begin
  if Assigned(DataModule) then
  begin
    DataModule.IBOExtract.ExtractObject(eoDomain,ObjectName);
    edDDL.Lines.Clear;
    edDDL.Lines.Text := DataModule.IBOExtract.Items.Text;
    edDDL.Modified := False;
  end;
end;

procedure TfrmDomains.pgObjectEditorChange(Sender: TObject);
begin
  if pgObjectEditor.ActivePage = tsDDL then
  begin
    Self.Refresh;
    if not IsNewObject then
      GetDDL;
  end;
end;

procedure TfrmDomains.btnAddDimensionClick(Sender: TObject);
var
  frmArrayDialog: TfrmArrayDialog;

begin
  frmArrayDialog := TfrmArrayDialog.Create(Self);
  try
    if frmArrayDialog.ShowModal = mrOK then
    begin
      with lvArray.Items.Add do
      begin
        Caption := frmArrayDialog.edLBound.Text;
        SubItems.Add(frmArrayDialog.edUBound.Text);
      end;
      Change_DataType := True;
    end;
  finally
    frmArrayDialog.Free;
  end;
end;

procedure TfrmDomains.btnDeleteDimensionClick(Sender: TObject);
begin
  if lvArray.Selected <> nil then
  begin
    if LMMessageDlg(28, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      lvArray.Selected.Delete;
      Change_DataType := True;
    end;
  end;
end;

procedure TfrmDomains.btnEditDimensionClick(Sender: TObject);
var
  frmArrayDialog: TfrmArrayDialog;

begin
  if lvArray.Selected <> nil then
  begin
    frmArrayDialog := TfrmArrayDialog.Create(Self);
    try
      frmArrayDialog.edLBound.Value := StrToInt(lvArray.Selected.Caption);
      frmArrayDialog.edUBound.Value := StrToInt(lvArray.Selected.SubItems[0]);
      if frmArrayDialog.ShowModal = mrOK then
      begin
        with lvArray.Items.Add do
        begin
          lvArray.Selected.Caption := frmArrayDialog.edLBound.Text;
          lvArray.Selected.SubItems[0] := frmArrayDialog.edUBound.Text;
        end;
        Change_DataType := True;
      end;
    finally
      frmArrayDialog.Free;
    end;
  end;
end;

procedure TfrmDomains.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssCtrl]) and (Key = VK_TAB) then
    pgObjectEditor.SelectNextPage(True);
end;

procedure TfrmDomains.DoLoadObject;
var
  Idx : Integer;
  FSQLDialect:integer;
  Data:TDomainDef;
  x:TListItem;
begin
  edDescription.Text := Description;
  FSQLDialect := DataModule.Connection.SQLDialect;
  DataModule.GetDomainData3(ObjectName,Data);
  IsNewObject := False;
  cmbDataType.ItemIndex := cmbDataType.Items.IndexOf(Data.DataType);
  case cmbDataType.ItemIndex of
    TY_DECIMAL,
    TY_NUMERIC :
      begin
        edPrecision.Value := Data.Precision;
        edScale.Value := Data.Scale;
      end;
    TY_CHAR,
    TY_VARCHAR :
      begin
        edLength.Value := Data.CharLength;
        cmbCharCharSet.ItemIndex := cmbCharCharSet.Items.IndexOf(Data.CharCharSet);
        cmbCollate.ItemIndex := cmbCollate.Items.IndexOf(Data.CharCollate);
      end;
    TY_BLOB :
      begin
        edSubType.Text := Data.BlobSubType;
        edSegSize.Text := Data.BlobSegSize;
        cmbBlobCharSet.ItemIndex := cmbBlobCharSet.Items.IndexOf(Data.BlobCharSet);
        cmbBlobCollate.ItemIndex := cmbBlobCollate.Items.IndexOf(Data.BlobCollate);
      end;
  end;
  cmbDataTypeChange(cmbDataType);
  edDefault.Text := Data.Default;
  fOldDefault := Data.Default;
  edConstraint.Text := Data.Check;
  fOldCheck := Data.Check;

    for Idx := low(Data.ArrayDim) to High(Data.ArrayDim) do
    begin
      x := lvArray.Items.Add;
      x.Caption := IntToStr(Data.ArrayDim[idx].Lbound);
      X.SubItems.Add(IntToStr(Data.ArrayDim[idx].Ubound));
    end;

  if not FSQLDialect = 3 then
  begin
    btnAddDimension.Enabled := False;
    btnDeleteDimension.Enabled := False;
    btnEditDimension.Enabled := False;

    cmbCollate.Enabled := False;
    cmbCharCharSet.Enabled := False;
    cmbBlobCollate.Enabled := False;
    cmbBlobCharSet.Enabled := False;
  end;

  cmbCollate.Enabled := False;

  if Not FSQLDialect = 3 then
    edColumn.ReadOnly := True;

  edColumn.Text := ObjectName;
  Change_Default := False;
  Change_Check := False;
  Change_Name := False;
  Change_DataType := False;
end;

procedure TfrmDomains.SignalNewObject;
begin
  Caption := 'Domain - ' + ObjectName;
  edColumn.Text := ObjectName;
  fOldDefault:='';
  fOldCheck:='';
  ActiveControl := edColumn;
end;

procedure TfrmDomains.SignalObjectModified;
begin
  if ObjectModified then
    stsEditor.Panels[1].Text := '*'
  else
    stsEditor.Panels[1].Text := '';
end;

function TfrmDomains.AlterObject: boolean;
var emessage:String;
begin
  Refresh;
  FCompileText := 'ALTER DOMAIN '+QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName);
  if FChangeDefault then
  begin
    if edDefault.Text = '' then
    begin
      if fOldDefault<>'' then
        FCompileText := FCompileText+ ' DROP DEFAULT '
    end
    else
      FCompileText := FCompileText+ ' SET ' + GetDefault;
  end;
  if FChangeCheck then
  begin
    if edConstraint.Text = '' then
    begin
      if fOldCheck<>'' then
        FCompileText := FCompileText+ ' DROP CONSTRAINT '
    end
    else
      FCompileText := FCompileText+ ' ADD ' + GetCheck;
  end;
  if FChangeName or (NewName<>ObjectName)then
  begin
    FCompileText := FCompileText+ QuoteIdentifier(DataModule.Connection.SQLDialect,NewName);
  end;

  if FChangeDataType then
  begin
    //                                                 alter array don't work
    FCompileText := FCompileText + ' TYPE ' + GetDataType(false) + ' ' + GetCharSet;
    // collate is not allowed;
    // + ' ' + GetCollate;
  end;

  if DataModule.ExecuteDDL(FCompileText,emessage) then
  begin
    CompileErrors := '';
    DataModule.CommitDDL;
    ObjectName := edColumn.Text;
    Result := True;
  end
  else
  begin
    CompileErrors := emessage;
    DataModule.RollbackDDL;
    Result := False;
  end;

  if Result then
  begin
    Change_Default := False;
    Change_Check := False;
    Change_Name := False;
    Change_DataType := False;
  end;

end;

function TfrmDomains.CompileNewObject: boolean;
var emessage:String;
begin
  Refresh;

  FCompileText := 'CREATE DOMAIN ' +
                  QuoteIdentifier(DataModule.Connection.SQLDialect,NewName) + ' AS ' +
                  GetDataType +
                  GetCharSet +
                  GetDefault +
                  GetNotNull +
                  GetCheck +
                  GetCollate;

  if DataModule.ExecuteDDL(FCompileText,emessage) then
  begin
    CompileErrors := '';
    DataModule.CommitDDL;
    ObjectName := edColumn.Text;
    Result := True;
  end
  else
  begin
    CompileErrors := emessage;
    DataModule.RollbackDDL;
    Result := False;
  end;

  if not DataModule.Connection.SQLDialect = 3 then
    edColumn.ReadOnly := True;

  if Result then
  begin
    Change_Default := False;
    Change_Check := False;
    Change_Name := False;
    Change_DataType := False;
  end;
end;


procedure TfrmDomains.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := InternalCloseQuery;
end;

procedure TfrmDomains.edColumnChange(Sender: TObject);
begin
  Change_Name := True;
  NewName := edColumn.text;
end;

procedure TfrmDomains.edLengthChange(Sender: TObject);
begin
  Change_DataType := True;
end;

procedure TfrmDomains.SetCompileText(const Value: String);
begin
  FCompileText := Value;
end;

procedure TfrmDomains.BitBtn2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmDomains.SetDataModule(const Value: TDmN);
begin
  Inherited;
  if Assigned(DataModule) then
  begin
    stsEditor.Panels[2].Text := DataModule.Connection.DatabaseName;
    DataModule.GetCharSetNames(cmbBlobCharSet.Items);
    DataModule.GetCharSetNames(cmbCharCharSet.Items);
    DataModule.GetCollationNames(cmbBlobCollate.Items);
    DataModule.GetCollationNames(cmbCollate.Items);
  end
  else
  begin
    stsEditor.Panels[2].Text := '';
  end
end;

procedure TfrmDomains.SetChangeCheck(const Value: Boolean);
begin
  FChangeCheck := Value;
  if Value then ObjectModified := True;
end;

procedure TfrmDomains.SetChangeDataType(const Value: Boolean);
begin
  FChangeDataType := Value;
  if Value then ObjectModified := True;
end;

procedure TfrmDomains.SetChangeDefault(const Value: Boolean);
begin
  FChangeDefault := Value;
  if Value then ObjectModified := True;
end;

procedure TfrmDomains.SetChangeName(const Value: Boolean);
begin
  FChangeName := Value;
  if Value then ObjectModified := True;
end;

procedure TfrmDomains.ActionCompileExecute(Sender: TObject);
begin
  Compile;
end;

procedure TfrmDomains.ActionCompileUpdate(Sender: TObject);
begin
  ActionCompile.Enabled := ObjectModified;
end;

procedure TfrmDomains.edDefaultStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
  if pgObjectEditor.ActivePage = tsDefault then
    stsEditor.Panels[0].Text := Format('%d:%d',[edDefault.CaretY,edDefault.CaretX]);
end;

procedure TfrmDomains.edConstraintStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
  if pgObjectEditor.ActivePage = tsConstraint then
    stsEditor.Panels[0].Text := Format('%d:%d',[edConstraint.CaretY,edConstraint.CaretX]);
end;

procedure TfrmDomains.edDescriptionStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
  if pgObjectEditor.ActivePage = tsDescription then
    stsEditor.Panels[0].Text := Format('%d:%d',[edDescription.CaretY,edDescription.CaretX]);
end;

procedure TfrmDomains.edDescriptionChange(Sender: TObject);
begin
  EditDescription:= edDescription.Text;
end;

procedure TfrmDomains.edColumnKeyPress(Sender: TObject; var Key: Char);
begin
  if Assigned(Datamodule) then
    Key := CheckNameKey(Key,Datamodule.Connection.SQLDialect);
end;

procedure TfrmDomains.SignalObjectNameChanged;
begin
  inherited;
end;

end.
