{************************************************************************
{  This Unit was created to by Lorenzo Mengoni - (Ancona, Italy)
  by Lorenzo Mengoni - (Ancona, Italy)

  for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.

}
{******************************************************************}
{ The contents of this file are used with permission, subject to   }
{ the Mozilla Public License Version 1.1 (the "License"); you may  }
{ not use this file except in compliance with the License. You may }
{ obtain a copy of the License at                                  }
{ http://www.mozilla.org/MPL/MPL-1.1.html                          }
{                                                                  }
{ Software distributed under the License is distributed on an      }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or   }
{ implied. See the License for the specific language governing     }
{ rights and limitations under the License.                        }
{                                                                  }
{******************************************************************} 

unit frmuEditorStoredProcedure;

interface

uses
{$IFDEF LINUX}
  QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, 
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, Clipbrd, Buttons,
  StdCtrls, ExtCtrls, ComCtrls, Menus, Registry, ImgList,
{$ENDIF}
  SysUtils, Classes,  DB,  Grids, DBGrids,
  IB_Components, IB_Header,  Tabs, DBCtrls, ActnList,
  dmuNode, SynEdit, IBODataset, IB_TransactionBar, IBOConsoleForm,
  SynEditHighlighter, SynHighlighterSQL, DBClient, ToolWin, SynEditTypes;

type
  TfrmStoredProcedure = class(TIBOConsoleEditor)
    stsEditor: TStatusBar;
    dsResults: TDataSource;
    dlgOpen: TOpenDialog;
    pgObjectEditor: TPageControl;
    tsStoredProc: TTabSheet;
    tsDocoView: TTabSheet;
    qryStoredProc: TIBOQuery;
    qryResults: TIBOQuery;
    qryUtil: TIBOQuery;
    edEditor: TSynEdit;
    tsDependencies: TTabSheet;
    tsGrants: TTabSheet;
    tsDebuggerOutput: TTabSheet;
    cdsParameters: TClientDataSet;
    cdsParametersparam_name: TStringField;
    cdsParametersparam_type: TStringField;
    cdsParametersfield_type: TStringField;
    cdsParametersfield_length: TStringField;
    cdsParametersfield_scale: TStringField;
    cdsParametersmatch: TStringField;
    cdsParametersnull: TStringField;
    edErrors: TSynEdit;
    qComp: TIB_DSQL;
    edDescription: TSynEdit;
    Splitter1: TSplitter;
    tsExecution: TTabSheet;
    dsParameters: TDataSource;
    dbgValues: TDBGrid;
    grdResults: TDBGrid;
    Splitter2: TSplitter;
    ActionList1: TActionList;
    ActionExecute: TAction;
    ActionCompile: TAction;
    ActionCheckParams: TAction;
    Panel2: TPanel;
    rbDependent: TRadioButton;
    rbDependedOn: TRadioButton;
    pnlDependents: TPanel;
    tvDependents: TTreeView;
    pnlDependencies: TPanel;
    tvDependencies: TTreeView;
    lvPermissions: TListView;
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    ActionAddInputParam: TAction;
    ActionEditParam: TAction;
    ActionDeleteParam: TAction;
    PopupParamList: TPopupMenu;
    AddParam1: TMenuItem;
    EditParam1: TMenuItem;
    DeleteParam1: TMenuItem;
    Panel3: TPanel;
    edName: TEdit;
    Label2: TLabel;
    tsMetadata: TTabSheet;
    edMetadata: TSynEdit;
    dbgParameters: TDBGrid;
    Panel4: TPanel;
    Panel5: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    cdsParametersfeed_type: TStringField;
    Panel6: TPanel;
    Memo1: TMemo;
    Splitter3: TSplitter;
    cdsValues: TClientDataSet;
    cdsValuesparam_name: TStringField;
    cdsValuesparam_type: TStringField;
    cdsValuesparam_value: TStringField;
    cdsValuesfield_type: TStringField;
    cdsValuesfield_length: TStringField;
    cdsValuesfield_scale: TStringField;
    cdsValuesmatch: TStringField;
    cdsValuesnull: TStringField;
    cdsValuesfeed_type: TStringField;
    dsValues: TDataSource;
    cdsParametersPosition: TIntegerField;
    cdsValuesPosition: TIntegerField;
    ActionMoveUp: TAction;
    ActionMoveDown: TAction;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    ActionAddOutputParam: TAction;
    SpeedButton6: TSpeedButton;
    Panel7: TPanel;
    SpeedButton7: TSpeedButton;
    Panel8: TPanel;
    Panel9: TPanel;
    SpeedButton8: TSpeedButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure WindowListClick(Sender: TObject);
    procedure edEditorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pgObjectEditorChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure edEditorDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure edEditorDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure pgObjectEditorChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure edEditorChange(Sender: TObject);
    procedure cdsParametersnullValidate(Sender: TField);
    procedure cdsParametersnullChange(Sender: TField);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure edEditorStatusChange(Sender: TObject; Changes: TSynStatusChanges);
    procedure ActionCompileExecute(Sender: TObject);
    procedure edDescriptionStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure ActionExecuteExecute(Sender: TObject);
    procedure ActionCompileUpdate(Sender: TObject);
    procedure ActionExecuteUpdate(Sender: TObject);
    procedure rbDependentClick(Sender: TObject);
    procedure rbDependedOnClick(Sender: TObject);
    procedure ActionDeleteParamUpdate(Sender: TObject);
    procedure edNameChange(Sender: TObject);
    procedure edDescriptionChange(Sender: TObject);
    procedure edNameKeyPress(Sender: TObject; var Key: Char);
    procedure ActionAddInputParamExecute(Sender: TObject);
    procedure ActionEditParamExecute(Sender: TObject);
    procedure ActionDeleteParamExecute(Sender: TObject);
    procedure ActionEditParamUpdate(Sender: TObject);
    procedure ActionAddInputParamUpdate(Sender: TObject);
    procedure cdsParametersNewRecord(DataSet: TDataSet);
    procedure cdsParametersAfterPost(DataSet: TDataSet);
    procedure cdsValuesNewRecord(DataSet: TDataSet);
    procedure ActionMoveUpUpdate(Sender: TObject);
    procedure ActionMoveDownUpdate(Sender: TObject);
    procedure ActionMoveUpExecute(Sender: TObject);
    procedure ActionMoveDownExecute(Sender: TObject);
    procedure ActionAddOutputParamUpdate(Sender: TObject);
    procedure ActionAddOutputParamExecute(Sender: TObject);
  private
    { Private declarations }
    FErrors : Boolean;
    FSaveName : String;
    FAppendFlag : Boolean;
    FParameter_List : TStringList;
    FSource : TStringList;
    FHasParameters : Boolean;
    FNeedParameters : Boolean;
    fErrorLine:integer;
    FPreparingParametersTable: boolean;
    FCopingInputParams: boolean;
    FCharSet: TFontCharset;

    function NeedParameters : Boolean;
    function HasParameters : Boolean;
    function GetParameters(Force : Boolean; var Params : String) : Boolean;
    procedure PrepareSQLExecute;
    function PrepareParametersTable: Boolean;
    procedure SetCharSet(const Value: TFontCharset);
    procedure UpdatePanel1;
    procedure GetCompileParams(var ip, op: String);
    procedure AddError(msg:String); overload;
    procedure AddError(msg:TStrings); overload;
  protected
    procedure SetDataModule(const Value: TDmN); override;
    procedure SignalObjectModified; override;
    procedure SignalNewObject; override;
    function CompileNewObject:boolean; override;
    function AlterObject:boolean; override;
    procedure DoLoadObject; override;
    procedure DoExecute; // override;
    function CanChangeEncoding : Boolean; // override;
    procedure CopyInputParams;
  public
    { Public declarations }
    property CharSet:TFontCharset read FCharSet write SetCharSet;

  end;


implementation

uses
  Variants,

  frmuStoredProcParamWarn, IBOAdminUtils, IBOCGlobal,
  frmuMain, zluUtility, IBOExtract, dmuMain, frmuWindowList,
  frmuMessage, LMMessageDialog;

{$R *.DFM}


procedure TfrmStoredProcedure.WindowListClick(Sender: TObject);
begin
  if WindowState = wsMinimized then
    WindowState := wsNormal
  else
    BringToFront;
end;

procedure TfrmStoredProcedure.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
  OpenWindows.Remove(self);
end;

procedure TfrmStoredProcedure.FormCreate(Sender: TObject);
var n:integer;
begin
  ObjectType := NODE_PROCEDURE; 
  FPreparingParametersTable := False;
  FParameter_List := TStringList.Create;
  FSource := TStringList.Create;
  pgObjectEditor.ActivePage := tsStoredProc;
  FSaveName := '';
  edEditor.ClearAll;
  try
    dbgParameters.Columns[2].PickList.Clear;
    for n:=0 to 11 do
      dbgParameters.Columns[2].PickList.Add(sDataType[n]);
  except
  end;
end;

function TfrmStoredProcedure.NeedParameters : Boolean;
begin
  try
    qryUtil.BeginBusy(False);

    qryUtil.Close;
    qryUtil.SQL.Clear;
    qryUtil.SQL.Add('SELECT count(*) FROM RDB$PROCEDURE_PARAMETERS'+
                    ' WHERE RDB$PARAMETER_TYPE = 0 ' +
                    'and rdb$procedure_name = ' + AnsiQuotedStr(ObjectName, ''''));
    qryUtil.Open;
    if qryUtil.FieldByName('count').AsInteger > 0 then
      Result := True
    else
      Result := False;
    qryUtil.Close;
  finally
    qryUtil.EndBusy;
  end;
end;

function TfrmStoredProcedure.HasParameters : Boolean;
begin
  try
    qryUtil.BeginBusy(False);
    qryUtil.Close;
    qryUtil.SQL.Clear;
    qryUtil.SQL.Add('SELECT count(*) FROM RDB$PROCEDURE_PARAMETERS WHERE RDB$PARAMETER_TYPE = 1 ' +
                    'and rdb$procedure_name = ' + AnsiQuotedStr(ObjectName, ''''));
    qryUtil.Open;
    if qryUtil.FieldByName('count').AsInteger > 0 then
      Result := True
    else
      Result := False;
    qryUtil.Close;
  finally
    qryUtil.EndBusy;
  end;
end;



procedure TfrmStoredProcedure.edEditorKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  fErrorLine := -1;
end;

procedure TfrmStoredProcedure.pgObjectEditorChange(Sender: TObject);
begin
  if pgObjectEditor.ActivePage = tsStoredProc then
  begin
    if qryResults.Active then
      qryResults.Close;
    edEditor.SetFocus;
    edEditorStatusChange(Self,[]);
  end
  else
  if pgObjectEditor.ActivePage = tsDocoView then
  begin
    if qryResults.Active then
       qryResults.Close;
    edDescription.SetFocus;
    edDescriptionStatusChange(Self,[]);
  end
  else
  if pgObjectEditor.ActivePage = tsDependencies then
  begin
    if qryResults.Active then
      qryResults.Close;
    stsEditor.Panels[0].Text := '';
    rbDependent.Checked := true;
    DataModule.GetDependencies(tvDependencies,tvDependents,ObjectName,NODE_PROCEDURES);
  end
  else
  if pgObjectEditor.ActivePage = tsGrants then
  begin
    stsEditor.Panels[0].Text := '';
    Datamodule.GetPermissions(lvPermissions,ObjectName,NODE_PROCEDURES);
  end
  else
  if pgObjectEditor.ActivePage = tsExecution then
  begin
    stsEditor.Panels[0].Text := '';
  end;
end;

procedure TfrmStoredProcedure.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
    CanClose := InternalCloseQuery;
end;

procedure TfrmStoredProcedure.UpdatePanel1;
var s:String;
begin
  if edEditor.InsertMode then
    s := 'Insert'
  else
    s := 'Overwrite';
  if ObjectModified then
    s:= '* '+s;
  stsEditor.Panels[1].Text := s;
end;

procedure TfrmStoredProcedure.edEditorDragOver(Sender, Source: TObject;
  X, Y: Integer; State: TDragState; var Accept: Boolean);
var p:TDisplayCoord;
    pb:TBufferCoord;
begin
  SetFocus;
  UpdatePanel1;
  p := edEditor.PixelsToNearestRowColumn(X, Y);
  pb := edEditor.DisplayToBufferPos(p);
  edEditor.CaretXY := pb;
  Accept := True;
end;

procedure TfrmStoredProcedure.edEditorDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  Tmp : String;
var p:TDisplayCoord;
    pb:TBufferCoord;

begin
  Tmp:='';
  p := edEditor.PixelsToNearestRowColumn(X, Y);
  pb := edEditor.DisplayToBufferPos(p);
  edEditor.CaretXY := pb;
  edEditor.SelText := Tmp;
end;

procedure TfrmStoredProcedure.pgObjectEditorChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  if IsNewObject then
  begin
    LMMessageDlg(38, mtWarning, [mbOK], 0);
    AllowChange := False;
  end
  else
  begin
    if pgObjectEditor.ActivePage = tsStoredProc then
    begin

    end
    else
    if pgObjectEditor.ActivePage = tsExecution then
    begin
      if qryResults.IB_Transaction.InTransaction then
      begin
        LMMessageDlg(39, mtWarning, [mbOK], 0);
        AllowChange := False;
      end;
    end;
  end;
end;

procedure TfrmStoredProcedure.edEditorChange(Sender: TObject);
begin
  ObjectModified := True;
end;

procedure TfrmStoredProcedure.cdsParametersnullValidate(Sender: TField);
begin
  if not FPreparingParametersTable then
    if not ((AnsiUpperCase(Sender.AsString) = 'NULL') or (Sender.AsString = '')) then
      raise Exception.Create(GetPrompt(122));
end;

procedure TfrmStoredProcedure.cdsParametersnullChange(Sender: TField);
begin
  if not FPreparingParametersTable then
    raise EAbort.Create(GetPrompt(123));
end;

procedure TfrmStoredProcedure.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssCtrl]) and (Key = VK_TAB) then
    pgObjectEditor.SelectNextPage(true);
end;


function TfrmStoredProcedure.CanChangeEncoding: Boolean;
begin
  Result := False;
  if pgObjectEditor.ActivePage = tsStoredProc then
  begin
    Result := True;
  end;
  if pgObjectEditor.ActivePage = tsDocoView then
  begin
    Result := True;
  end;
end;

procedure TfrmStoredProcedure.DoExecute;

begin
  //compile first....
  if ObjectModified then
  begin
    if LMMessageDlg(40, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      ActionCompileExecute(Nil);
    end;
  end;

  if FErrors then
    Exit;

  try
    if cdsValues.State in dseditmodes then cdsValues.Post;
    qryResults.BeginBusy(False);
    Screen.Cursor := crHourGlass;
    stsEditor.Panels[2].Text := GetPrompt(41);
    stsEditor.Refresh;

    Caption := Format(GetPrompt(42),[ObjectName]);
    begin
      try
        qryResults.IB_Connection := DataModule.Connection;
        qryResults.IB_Transaction := DataModule.Transaction;
        PrepareSQLExecute;
        qryResults.ExecSQL;
        AddError(qryResults.SQL);
      except
        On E : Exception do
        begin
          AddError(E.Message);
          Refresh;
        end;
      end;
    end;
  finally
    qryResults.EndBusy;
    Screen.Cursor := crDefault;
    stsEditor.Panels[2].Text := DataModule.Connection.DatabaseName;
    stsEditor.Refresh;
    Caption := GetLangType(NODE_PROCEDURE)+' - ' + ObjectName;
  end;
end;

procedure TfrmStoredProcedure.FormDestroy(Sender: TObject);
begin
  FParameter_List.Free;
  FSource.Free;
  inherited;
end;

procedure TfrmStoredProcedure.edEditorStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
//  edEditorChange(Sender);
  if pgObjectEditor.ActivePage = tsStoredProc then
    stsEditor.Panels[0].Text := Format('%d:%d',[edEditor.CaretY,edEditor.CaretX]);
end;

procedure TfrmStoredProcedure.SetDataModule(const Value: TDmN);
begin
  inherited SetDataModule(Value);
  if Assigned(DataModule) then
  begin
    qComp.IB_Connection := DataModule.Connection;
    qryResults.IB_Connection := DataModule.Connection;
    qryStoredProc.IB_Connection := DataModule.Connection;
    qryUtil.IB_Connection := DataModule.Connection;
    qComp.IB_Transaction := DataModule.Transaction;
    qryResults.IB_Transaction := DataModule.Transaction;
    qryStoredProc.IB_Transaction := DataModule.Transaction;
    qryUtil.IB_Transaction := DataModule.Transaction;
  end
  else
  begin
    qComp.IB_Connection := Nil;
    qryResults.IB_Connection := Nil;
    qryStoredProc.IB_Connection := Nil;
    qryUtil.IB_Connection := Nil;
    qComp.IB_Transaction := Nil;
    qryResults.IB_Transaction := Nil;
    qryStoredProc.IB_Transaction := Nil;
    qryUtil.IB_Transaction := Nil;
  end;
  if Assigned(DataModule) then
  begin
    stsEditor.Panels[2].Text := DataModule.Connection.DatabaseName;
  end
  else
  begin
    stsEditor.Panels[2].Text := '';
  end
 
end;

procedure TfrmStoredProcedure.ActionCompileExecute(Sender: TObject);
begin
  FErrors := not Compile;
end;

function TfrmStoredProcedure.PrepareParametersTable: Boolean;
begin
  try
    qryUtil.BeginBusy(False);
    cdsParameters.Close;
    cdsParameters.CreateDataSet;
    if not cdsParameters.Active then cdsParameters.Open;
    qryUtil.Close;
    qryUtil.SQL.Clear;
    if DataModule.Connection.SQLDialect = 3 then
    begin
      qryUtil.SQL.Add('select a.rdb$parameter_name '+
                      ', b.rdb$field_type '+
                      ', b.rdb$field_length '+
                      ', b.rdb$field_scale '+
                      ', b.rdb$field_sub_type '+
                      ', b.rdb$field_precision '+
                      ', a.rdb$PARAMETER_TYPE '+
                      ', a.RDB$PARAMETER_NUMBER '+
                      'from rdb$procedure_parameters a, rdb$fields b '+
                      'where ' +
                      'a.rdb$field_source = b.rdb$field_name '+
                      //'and a.rdb$parameter_type = 0 '+
                      'and a.rdb$procedure_name = ' + AnsiQuotedStr(ObjectName, '''') +
                      ' order by rdb$parameter_number asc;');
    end
    else
    begin
      qryUtil.SQL.Add('select a.rdb$parameter_name '+
                      ', b.rdb$field_type '+
                      ', b.rdb$field_length '+
                      ', b.rdb$field_scale '+
                      ', a.rdb$PARAMETER_TYPE '+
                      ', a.RDB$PARAMETER_NUMBER '+
                      'from rdb$procedure_parameters a, rdb$fields b where ' +
                      'a.rdb$field_source = b.rdb$field_name '+
                      //'and a.rdb$parameter_type = 0 '+
                      'and a.rdb$procedure_name = '
                      + AnsiQuotedStr(ObjectName, '''') +
                      ' order by rdb$parameter_number asc;');
    end;
    qryUtil.Open;
    FAppendFlag := True;
    FPreparingParametersTable := True;
    While Not qryUtil.EOF do
    begin
      try
        cdsParameters.Append;
        cdsParametersPosition.Value :=  qryUtil.FieldByName('RDB$PARAMETER_NUMBER').AsInteger;
        case qryUtil.FieldByName('rdb$parameter_type').AsInteger of
        0: cdsParametersfeed_type.Value := 'Input';
        1: cdsParametersfeed_type.Value := 'Output';
        end;

        cdsParametersparam_name.AsString := qryUtil.FieldByName('rdb$parameter_name').AsString;

        if DataModule.Connection.SQLDialect = 3 then
        begin
          cdsParametersparam_type.AsString := ConvertFieldType(qryUtil.FieldByName('rdb$field_type').AsInteger,
                                                                               qryUtil.FieldByName('rdb$field_length').AsInteger,
                                                                               qryUtil.FieldByName('rdb$field_scale').AsInteger,
                                                                               qryUtil.FieldByName('rdb$field_sub_type').AsInteger,
                                                                               qryUtil.FieldByName('rdb$field_precision').AsInteger,
                                                                               Datamodule.Connection.SQLDialect);
        end
        else
        begin
          cdsParametersparam_type.AsString := ConvertFieldType(qryUtil.FieldByName('rdb$field_type').AsInteger,
                                                                               qryUtil.FieldByName('rdb$field_length').AsInteger,
                                                                               qryUtil.FieldByName('rdb$field_scale').AsInteger,
                                                                               -1,
                                                                               -1,
                                                                               Datamodule.Connection.SQLDialect);
        end;
        cdsParametersfield_type.AsString := qryUtil.FieldByName('rdb$field_type').AsString;
        cdsParametersfield_length.AsString := qryUtil.FieldByName('rdb$field_length').AsString;
        cdsParametersfield_scale.AsString := qryUtil.FieldByName('rdb$field_scale').AsString;
        cdsParametersmatch.AsString := 'T';

        cdsParameters.Post;
      except
        on e:Exception do
        begin
          cdsParameters.Cancel;
          LMMessageDlg(e.Message, mtError, [mbOk], 0);
        end;
      end;
      qryUtil.Next;
    end;
    qryUtil.Close;
    FPreparingParametersTable := False;
    Result := True;
  finally
    qryUtil.EndBusy;
  end;
end;

function TfrmStoredProcedure.GetParameters(Force : Boolean; var Params : String) : Boolean;
var v:String;
begin
  Params := '';
  try
    cdsValues.First;
    while Not cdsValues.EOF do
    begin
      if params <> '' then Params := Params + ','+CRLF;
      v := cdsValuesparam_value.AsString;
      if v = '' then v := 'NULL';
      Params := Params + AnsiQuotedStr(v, '''');
      cdsValues.Next;
    end;
    Result := True;
  finally
  end;
end;


procedure TfrmStoredProcedure.PrepareSQLExecute;
var Params:String;
begin
      qryResults.KeyLinksAutoDefine := False;
      qryResults.KeyLinks.Clear;
      qryResults.ReadOnly:=True;
      if NeedParameters then
      begin
        if HasParameters then
        begin
          if GetParameters(False, Params) then
            qryResults.SQL.Text:='select * from ' + QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName)+ '(' + Params + ');'
          else
            Exit;
        end
        else
        begin
          if GetParameters(False, Params) then
            qryResults.SQL.Text:='execute procedure ' + QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName) + '(' + Params + ');'
          else
            Exit;
        end;
      end
      else
      begin
        if HasParameters then
        begin
          qryResults.SQL.Text:='select * from ' + QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName) + ';';
        end
        else
          qryResults.SQL.Text:='execute procedure ' + QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName) + ';'
      end;
end;

procedure TfrmStoredProcedure.edDescriptionStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
  if pgObjectEditor.ActivePage = tsDocoView then
    stsEditor.Panels[0].Text := Format('%d:%d',[edDescription.CaretY,edDescription.CaretX]);
end;

procedure TfrmStoredProcedure.ActionExecuteExecute(Sender: TObject);
begin
  pgObjectEditor.ActivePage := tsExecution;
  DoExecute;
end;

procedure TfrmStoredProcedure.ActionCompileUpdate(Sender: TObject);
begin
  ActionCompile.Enabled := ObjectModified;
end;

procedure TfrmStoredProcedure.ActionExecuteUpdate(Sender: TObject);
begin
  ActionExecute.Enabled := (not ObjectModified) and (not IsNewObject);
end;

procedure TfrmStoredProcedure.SetCharSet(const Value: TFontCharset);
begin
  FCharSet := Value;
end;

procedure TfrmStoredProcedure.rbDependentClick(Sender: TObject);
begin
  pnlDependents.Visible := true;
  pnlDependencies.Visible := false;
end;

procedure TfrmStoredProcedure.rbDependedOnClick(Sender: TObject);
begin
  pnlDependents.Visible := false;
  pnlDependencies.Visible := true;
end;

procedure TfrmStoredProcedure.GetCompileParams(var ip,op:String);
begin
  ip:='';
  op:='';
  cdsParameters.First;
  while not cdsParameters.Eof do
  begin
    if cdsParametersfeed_type.AsString = 'Input' then
    begin
      if ip<>'' then ip := ip +', ';
      ip:=ip+QuoteIdentifier(Datamodule.Connection.SQLDialect,cdsParametersparam_name.AsString)+' '+cdsParametersparam_type.AsString;
    end
    else
    if cdsParametersfeed_type.AsString = 'Output' then
    begin
      if op<>'' then op := op +', ';
      op:=op+QuoteIdentifier(Datamodule.Connection.SQLDialect,cdsParametersparam_name.AsString)+' '+cdsParametersparam_type.AsString;
    end;
    cdsParameters.Next;
  end;
end;

function TfrmStoredProcedure.CompileNewObject: boolean;
var SqlText:TStringList;
    ip,op:String;
begin
  SqlText := TStringList.Create;
  try
    SqlText.Add('SET TERM ^;');
    SqlText.Add(Format('CREATE PROCEDURE %s',[QuoteIdentifier(Datamodule.Connection.SQLDialect,NewName)]));
    GetCompileParams(ip,op);
    if ip <> '' then
      SqlText.Add(Format('( %s )',[ip]));
    if op <> '' then
      SqlText.Add(Format('RETURNS ( %s )',[op]));
    SqlText.Add('as');
    SqlText.AddStrings(edEditor.Lines);
    Result := DataModule.ExecuteDDLScript(SqlText.Text,ip);
    CompileErrors := ip;
    if result then ObjectName := NewName;
  finally
    SqlText.Free;
  end;
end;


function TfrmStoredProcedure.AlterObject: boolean;
var SqlText:TStringList;
    ip,op:String;
begin
  SqlText := TStringList.Create;
  try
    SqlText.Add('SET TERM ^;');
    SqlText.Add(Format('ALTER PROCEDURE %s',[QuoteIdentifier(Datamodule.Connection.SQLDialect,NewName)]));
    GetCompileParams(ip,op);
    if ip <> '' then
      SqlText.Add(Format('( %s )',[ip]));
    if op <> '' then
      SqlText.Add(Format('RETURNS ( %s )',[op]));
    SqlText.Add('as');
    SqlText.AddStrings(edEditor.Lines);
    Result := DataModule.ExecuteDDLScript(SqlText.Text,ip);
    CompileErrors := ip;
    if result then ObjectName := NewName;
  finally
    SqlText.Free;
  end;
end;


procedure TfrmStoredProcedure.SignalNewObject;
begin
  inherited;
  edEditor.ClearAll;
  edEditor.Lines.Add('begin');
  edEditor.Lines.Add('end');
  UpdatePanel1;
end;

procedure TfrmStoredProcedure.SignalObjectModified;
begin
  inherited;
  edEditor.Modified := ObjectModified;
  UpdatePanel1;
end;

procedure TfrmStoredProcedure.DoLoadObject;
begin
  inherited;
  edName.Text := ObjectName;
  edName.ReadOnly := True;
  DataModule.GetProcedureInfo(FParameter_List, FSource, ObjectName);
  FSource.Clear;
  edEditor.ClearAll;
  edEditor.Lines.Text := DataModule.GetProcedureSource(ObjectName);
  edEditor.Modified := False;
  PrepareParametersTable;
  FHasParameters := HasParameters;
  FNeedParameters := NeedParameters;
  DataModule.IBOExtract.ExtractObject(eoProcedure,ObjectName);
  edMetadata.ClearAll;
  edMetadata.Lines.Text := DataModule.IBOExtract.Items.Text;
  CopyInputParams;
end;

procedure TfrmStoredProcedure.edNameChange(Sender: TObject);
begin
  NewName := edName.Text;
end;

procedure TfrmStoredProcedure.edDescriptionChange(Sender: TObject);
begin
  EditDescription := edDescription.Text;
end;

procedure TfrmStoredProcedure.edNameKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Assigned(Datamodule) then
    Key := CheckNameKey(Key,Datamodule.Connection.SQLDialect);
end;


procedure TfrmStoredProcedure.ActionEditParamExecute(Sender: TObject);
begin
  cdsParameters.Edit;
end;

procedure TfrmStoredProcedure.ActionDeleteParamExecute(Sender: TObject);
begin
  cdsParameters.Delete;
end;

procedure TfrmStoredProcedure.ActionDeleteParamUpdate(Sender: TObject);
begin
  ActionDeleteParam.Enabled := cdsParameters.RecordCount>0;
end;

procedure TfrmStoredProcedure.ActionEditParamUpdate(Sender: TObject);
begin
  ActionDeleteParam.Enabled := cdsParameters.RecordCount>0;
end;

procedure TfrmStoredProcedure.ActionAddInputParamUpdate(Sender: TObject);
begin
  ActionAddInputParam.Enabled := true;
end;

procedure TfrmStoredProcedure.AddError(msg: String);
var l:TStringList;
begin
  l := TStringList.Create;
  try
    l.Text := msg;
    AddError(l);
  finally
    l.Free;
  end;
end;

procedure TfrmStoredProcedure.AddError(msg:TStrings);
begin
  Memo1.Lines.AddStrings(msg);
end;

procedure TfrmStoredProcedure.cdsParametersNewRecord(DataSet: TDataSet);
begin
  cdsParametersmatch.AsString := 'N';
end;

procedure TfrmStoredProcedure.cdsParametersAfterPost(DataSet: TDataSet);
begin
  if not FPreparingParametersTable then ObjectModified := True;
end;

procedure TfrmStoredProcedure.CopyInputParams;
begin
  FCopingInputParams:=TRue;
  if not cdsValues.Active then cdsParameters.CreateDataSet;
  cdsValues.First;
  while not cdsValues.Eof do
  begin
    if not cdsParameters.Locate('param_name;feed_type',VarArrayOf([cdsValuesparam_name.AsString,'Input']),[]) then
      cdsValues.Delete
    else
      cdsValues.Next;
  end;

  cdsParameters.First;
  while not cdsParameters.Eof do
  begin
    if cdsParametersfeed_type.AsString = 'Input' then
    try
      if cdsValues.Locate('param_name',cdsParametersparam_name.AsString,[]) then
        cdsValues.Edit
      else
      begin
        cdsValues.Insert;
        cdsValuesparam_name.Value := cdsParametersparam_name.Value;
      end;
      cdsValuesPosition.Value := cdsParametersPosition.Value;
      cdsValuesparam_type.Value := cdsParametersparam_type.Value;
      cdsValuesfield_type.Value  := cdsParametersfield_type.Value;
      cdsValuesfield_length.Value  := cdsParametersfield_length.Value;
      cdsValuesfield_scale.Value  := cdsParametersfield_scale.Value;
      cdsValuesmatch.Value  := cdsParametersmatch.Value;
      cdsValuesnull.Value  := cdsParametersnull.Value;
      cdsValues.Post;
    except
      cdsValues.Cancel;
    end;
    cdsParameters.Next;
  end;
  FCopingInputParams:=False;
end;

procedure TfrmStoredProcedure.cdsValuesNewRecord(DataSet: TDataSet);
begin
  if not FCopingInputParams then Abort;
end;

procedure TfrmStoredProcedure.ActionMoveUpUpdate(Sender: TObject);
begin
  ActionMoveUp.Enabled := not cdsParameters.Bof;
end;

procedure TfrmStoredProcedure.ActionMoveDownUpdate(Sender: TObject);
begin
  ActionMoveDown.Enabled := not cdsParameters.Eof;
end;

procedure TfrmStoredProcedure.ActionMoveUpExecute(Sender: TObject);
var n,n1,f:String;
    p,p1:integer;
begin
  if not cdsParameters.Bof then
  begin
    n := cdsParametersparam_name.AsString;
    f := cdsParametersfeed_type.AsString;
    cdsParameters.Prior;
    begin
      cdsParameters.Next;
      exit;
    end;
    if cdsParametersfeed_type.AsString <> f then exit;
    n1 := cdsParametersparam_name.AsString;
    p1 := cdsParametersPosition.AsInteger;
    cdsParameters.Edit;
    cdsParametersPosition.AsInteger := p;
    cdsParameters.Post;
    if cdsParameters.Locate('param_name',n,[]) then
    begin
      cdsParameters.Edit;
      cdsParametersPosition.AsInteger := p1;
      cdsParameters.Post;
    end;
  end;
end;

procedure TfrmStoredProcedure.ActionMoveDownExecute(Sender: TObject);
var n,n1,f:String;
    p,p1:integer;
begin
  if not cdsParameters.Eof then
  begin
    n := cdsParametersparam_name.AsString;
    p := cdsParametersPosition.AsInteger;
    f := cdsParametersfeed_type.AsString;
    cdsParameters.Next;
    if cdsParametersfeed_type.AsString <> f then
    begin
      cdsParameters.Prior;
      exit;
    end;
    n1 := cdsParametersparam_name.AsString;
    p1 := cdsParametersPosition.AsInteger;
    cdsParameters.Edit;
    cdsParametersPosition.AsInteger := p;
    cdsParameters.Post;
    if cdsParameters.Locate('param_name',n,[]) then
    begin
      cdsParameters.Edit;
      cdsParametersPosition.AsInteger := p1;
      cdsParameters.Post;
    end;
  end;
end;

procedure TfrmStoredProcedure.ActionAddOutputParamUpdate(Sender: TObject);
begin
  ActionAddOutputParam.Enabled := true;
end;

procedure TfrmStoredProcedure.ActionAddOutputParamExecute(Sender: TObject);
var n:integer;
begin
  cdsParameters.Last;
  n:=cdsParametersPosition.AsInteger+1;
  cdsParameters.Append;
  cdsParametersPosition.Value := n;
  cdsParametersfeed_type.AsString := 'Output';
end;

procedure TfrmStoredProcedure.ActionAddInputParamExecute(Sender: TObject);
var n:integer;
begin
  cdsParameters.Last;
  while not cdsParameters.Bof and (cdsParametersfeed_type.AsString = 'Output') do
  begin
    cdsParameters.Prior;
  end;
  if cdsParametersfeed_type.AsString = 'Output' then
    n:=0
  else
    n:=cdsParametersPosition.AsInteger+1;
  cdsParameters.Insert;
  cdsParametersPosition.Value := n;
  cdsParametersfeed_type.AsString := 'Input';
end;

end.


