{************************************************************************}
{  This Unit was modified to be interfaced in IBObjects
   by Lorenzo Mengoni - (Ancona, Italy)
   for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.
   }
{
 * The contents of this file are subject to the InterBase Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.
 *
 * You may obtain a copy of the License at http://www.Inprise.com/IPL.html.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.  The Original Code was created by Inprise
 * Corporation and its predecessors.
 *
 * Portions created by Inprise Corporation are Copyright (C) Inprise
 * Corporation. All Rights Reserved.
 *
 * Contributor(s): Jeff Overcash, Krzysztof Golko.

10.August.2002, Lorenzo:
- Added Code for editing images in form view

13.August.2002, Lorenzo:
- Added Code for copy record
- Added edDescription and code for handling trigger description
- Added code for handling of index description

3.December.2003
- added new tab SQL Statements with Sql used exposed

}

unit frmuEditorTable;

interface

uses
{$IFDEF LINUX}
  QControls, QForms, QDialogs, QComCtrls, QStdCtrls, QMenus,
  Types, QTypes, QImgList, QExtCtrls,
  QStdActns, QActnList, SynEdit, SynEditPrint, IBCXDummies,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Messages, Controls, Forms, Dialogs, ComCtrls, StdCtrls,
  Menus, ImgList, StdActns, ActnList, Graphics, Spin, ToolWin,
  Buttons, Grids, DBGrids, ExtCtrls, DBCtrls,
{$ENDIF}
  frmuEditorConstraint, frmuLookUpFilterUpas,
  SysUtils, Classes, Db, IBDatabase, IBCustomDataset, SynEdit, Types,
  IBODataset, IB_Components, IB_TransactionBar, IBOExtract, dmuNode, Mask,
  ExtDlgs, Clipbrd, SynMemo, IBOConsoleForm,
{$IFDEF useGraphicEx}
  GraphicEx, JvDialogs
{$ELSE}
  jpeg,
{$IFDEF  _JvGIF_}
  JvGIF,
{$ENDIF}
  pngimage
{$ENDIF}
  ;

type
  TTableData = class
  public
    Columns,
    Indexes,
    Triggers,
    CheckConst,
    UniqueConst,
    RefConst: TStringList;
    SystemTable:boolean;
    constructor Create;
    destructor Destroy; override;
  end;

  TImgEditRec = record
    Image:TImage;
    Modified:boolean;
    CanView:boolean;
    TypeLabel:TLabel;
  end;

  TFilterDialogs=array of TFormLookUp;

  TfrmEditorTable = class(TIBOConsoleForm)
    StatusBar: TStatusBar;
    pgcProperties: TPageControl;
    tabProperties: TTabSheet;
    tabMetadata: TTabSheet;
    tabPermissions: TTabSheet;
    tabData: TTabSheet;
    dbgData: TDBGrid;
    tabDependencies: TTabSheet;
    dbgDataSource: TDataSource;
    TableActions: TActionList;
    ShowColumns: TAction;
    ShowTriggers: TAction;
    ShowCheckConstraints: TAction;
    ShowIndexes: TAction;
    ShowUniqueConstraints: TAction;
    ShowReferentialConstraints: TAction;
    lvTableObjects: TListView;
    SplitterWnd: TSplitter;
    Panel2: TPanel;
    rbDependent: TRadioButton;
    rbDependedOn: TRadioButton;
    pnlDependents: TPanel;
    tvDependents: TTreeView;
    pnlDependencies: TPanel;
    tvDependencies: TTreeView;
    lvPermissions: TListView;
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    IBOTable: TIBOQuery;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    Panel6: TPanel;
    cbExtractData: TCheckBox;
    reMetaData: TSynEdit;
    reTriggerSource: TSynEdit;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditUndo1: TEditUndo;
    pmRichEdit: TPopupMenu;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Selectall1: TMenuItem;
    N3: TMenuItem;
    Undo1: TMenuItem;
    IB_TransactionBar1: TIB_TransactionBar;
    pmObj: TPopupMenu;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Drop1: TMenuItem;
    ActionNewObject: TAction;
    ActionEditObject: TAction;
    ActionDropObject: TAction;
    tabDescription: TTabSheet;
    edDescription: TSynEdit;
    Panel5: TPanel;
    sbCols: TSpeedButton;
    tbTriggers: TSpeedButton;
    tbChkConst: TSpeedButton;
    tbIndexes: TSpeedButton;
    tbUnique: TSpeedButton;
    tbRef: TSpeedButton;
    Panel7: TPanel;
    NewPrimaryKey1: TMenuItem;
    PopupPermissions: TPopupMenu;
    ActionGrantSelect: TAction;
    ActionGrantDelete: TAction;
    ActionGrantInsert: TAction;
    ActionGrantUpdate: TAction;
    ActionGrantReference: TAction;
    ActionGrantExecute: TAction;
    Delete1: TMenuItem;
    Insert1: TMenuItem;
    Update1: TMenuItem;
    Select1: TMenuItem;
    Update2: TMenuItem;
    ActionGrantAll: TAction;
    ActionRevokeAll: TAction;
    GrantAll1: TMenuItem;
    RevokeAll1: TMenuItem;
    SpeedButton1: TSpeedButton;
    ActionOpenTable: TAction;
    SpeedButton2: TSpeedButton;
    ActionTableFilter: TAction;
    ScrollBoxFilter: TScrollBox;
    ScrollBoxData: TScrollBox;
    SpeedButton3: TSpeedButton;
    ActionTableFormView: TAction;
    ActionEmptyTable: TAction;
    SpeedButton4: TSpeedButton;
    ActionTableClearFilter: TAction;
    Panel8: TPanel;
    pmImages: TPopupMenu;
    Savetofile1: TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    Loadfromfile1: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    Cut2: TMenuItem;
    ActionCopyRecord: TAction;
    SpeedButton5: TSpeedButton;
    PanelTriggerSource: TPanel;
    Splitter1: TSplitter;
    edTriggerDesc: TSynMemo;
    tabSQLStatements: TTabSheet;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    SynEditSelect: TSynEdit;
    SynEditInsert: TSynEdit;
    SynEditUpdate: TSynEdit;
    SynEditDelete: TSynEdit;
    SaveDialog1: TSaveDialog;
    PopupMenu1: TPopupMenu;
    MenuItem2: TMenuItem;
    procedure pgcPropertiesChange(Sender: TObject);
    procedure dbgDataCellClick(Column: TColumn);
    procedure dbgDataDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure dbgDataEditButtonClick(Sender: TObject);
    procedure ShowColumnsExecute(Sender: TObject);
    procedure ShowTriggersExecute(Sender: TObject);
    procedure ShowCheckConstraintsExecute(Sender: TObject);
    procedure ShowIndexesExecute(Sender: TObject);
    procedure ShowUniqueConstraintsExecute(Sender: TObject);
    procedure ShowReferentialConstraintsExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure rbDependentClick(Sender: TObject);
    procedure rbDependedOnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbExtractDataClick(Sender: TObject);
    procedure IBOTableAfterOpen(DataSet: TDataSet);
    procedure dbgDataTitleClick(Column: TColumn);
    procedure IBOTablePostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure IBOTableDeleteError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure IBOTableEditError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure ActionEditObjectExecute(Sender: TObject);
    procedure ActionNewObjectExecute(Sender: TObject);
    procedure ActionDropObjectExecute(Sender: TObject);
    procedure ActionEditObjectUpdate(Sender: TObject);
    procedure ActionDropObjectUpdate(Sender: TObject);
    procedure pgcPropertiesChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure IBOTableBeforeClose(DataSet: TDataSet);
    procedure NewPrimaryKey1Click(Sender: TObject);
    procedure NewUniqueKey1Click(Sender: TObject);
    procedure lvPermissionsEditing(Sender: TObject; Item: TListItem;
      var AllowEdit: Boolean);
    procedure ActionGrantSelectExecute(Sender: TObject);
    procedure ActionGrantSelectUpdate(Sender: TObject);
    procedure ActionGrantDeleteUpdate(Sender: TObject);
    procedure ActionGrantInsertUpdate(Sender: TObject);
    procedure ActionGrantUpdateUpdate(Sender: TObject);
    procedure ActionGrantReferenceUpdate(Sender: TObject);
    procedure ActionGrantExecuteUpdate(Sender: TObject);
    procedure ActionGrantDeleteExecute(Sender: TObject);
    procedure ActionGrantInsertExecute(Sender: TObject);
    procedure ActionGrantUpdateExecute(Sender: TObject);
    procedure ActionGrantReferenceExecute(Sender: TObject);
    procedure ActionGrantExecuteExecute(Sender: TObject);
    procedure ActionRevokeAllUpdate(Sender: TObject);
    procedure ActionGrantAllUpdate(Sender: TObject);
    procedure ActionGrantAllExecute(Sender: TObject);
    procedure ActionRevokeAllExecute(Sender: TObject);
    procedure ActionOpenTableExecute(Sender: TObject);
    procedure IBOTableAfterClose(DataSet: TDataSet);
    procedure ActionTableFilterExecute(Sender: TObject);
    procedure ActionTableFormViewExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ActionEmptyTableExecute(Sender: TObject);
    procedure ActionEmptyTableUpdate(Sender: TObject);
    procedure ActionTableClearFilterUpdate(Sender: TObject);
    procedure ActionTableClearFilterExecute(Sender: TObject);
    procedure dbgDataSourceUpdateData(Sender: TObject);
    procedure dbgDataSourceDataChange(Sender: TObject; Field: TField);
    procedure Savetofile1Click(Sender: TObject);
    procedure Loadfromfile1Click(Sender: TObject);
    procedure Copy2Click(Sender: TObject);
    procedure Paste2Click(Sender: TObject);
    procedure Cut2Click(Sender: TObject);
    procedure IBOTableAfterPost(DataSet: TDataSet);
    procedure dbgDataSourceStateChange(Sender: TObject);
    procedure ActionCopyRecordUpdate(Sender: TObject);
    procedure ActionCopyRecordExecute(Sender: TObject);
    procedure dbgDataMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MenuItem2Click(Sender: TObject);
  private
    FTableOrder: String;
    FFormView: boolean;
    procedure SetTableOrder(const Value: String);
    procedure CreateFilterControls;
    procedure CreateFilterEdit(FieldIndex: integer; TopLeftPoint: TPoint; first:boolean);
    procedure FilterEditOnChange(Sender: TObject);
    procedure DestroyFilterControls;
    procedure FilterEditOnEnter(Sender: TObject);
    procedure FilterEditOnExit(Sender: TObject);
    procedure ApplyTableFilter;
    function GetFilterExpression(FieldIndex: integer): String;
    function GetFilterOperator(FieldIndex: integer): String;
    procedure SetFormView(const Value: boolean);
    procedure SetViewComponent;
    procedure CreateEditControls;
    procedure CreateEditingEdit(FieldIndex: integer; var TopLeftPoint: TPoint);
    procedure DestroyEditControls;
    procedure ClearFilterFields;
    procedure DropDownSpeedButtonOnClick(Sender: TObject);
    function FindFilterEdit(idx: integer): TMaskEdit;
    function FindFilterCombo(idx: integer): TComboBox;
    procedure LoadEditImages;
    procedure SetImageModified(Sender: TImage);
//    procedure LoadTriggerDescription(aTriggerName: String);
    procedure SaveTriggerDescription(aTriggerName: String);
    procedure TriggerSourceChanging(Sender: TObject; Item: TListItem;
      Change: TItemChange; var AllowChange: Boolean);
    procedure ShowTriggerSource(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure IndexDescriptionChanging(Sender: TObject; Item: TListItem;
      Change: TItemChange; var AllowChange: Boolean);
    procedure ShowIndexDescription(Sender: TObject; Item: TListItem;
      Change: TItemChange);
//    procedure LoadIndexDescription(aIndexName: String);
    procedure SaveIndexDescription(aIndexName: String);
    procedure UnloadEditImages;
    procedure ReloadTableData;
  private
    { Private declarations }
    { For displaying Object Information }
    FTableData : TTableData;
    FMetadataRefreshList:boolean;
    FRefreshList:boolean;

    FObjType: Integer;
    FShowSystem: boolean;
    FObjName: String;
    FDataModule: TDmN;
    fStart:boolean;
    GridColSize:TIntegerDynArray;
    fError:String;
    fFilterModified:Boolean;
    fLookUps:TFilterDialogs;
    fImages:array of TImgEditRec;
    fLabelsWidth:integer;
    fGridField:TField;

    procedure GetDependencies (const ObjName: String; const ObjType: Integer);
    procedure GetPermissions (const ObjName: String; const ObjType: Integer);
    procedure GetTableProperties;
    procedure FillList(const ListObject: TListView; const StringList: TStringList);
    procedure NewField(TableName: String);
    procedure NewIndex(TableName: String);
    procedure NewConstraint(TableName: String; aType:TConstraintType);
    procedure SetDataModule(const Value: TDmN);
    procedure DoExtractMetadata(lObjName: String);
    procedure LoadDescription;
    procedure SaveDescription;
    procedure EditField;
    procedure DropField;
    procedure GetColumnsProperties;
    procedure GetTriggersProperties;
    procedure GetConstraintsProperties;
    procedure GetIndexesProperties;
    procedure GetUniqueConstraintsProperties;
    procedure GetReferentialConstraintsProperties;
    procedure EditIndex;
    procedure DropConstraint;
    procedure DropIndex;
    procedure DropSubObject(ObjectTypeName, DropSQL: String);
    procedure EditConstraint;
    procedure NewTrigger(TableName: String);
    procedure DropTrigger;
    procedure EditTrigger;
    procedure AddUserName(un: String);
    procedure ExecuteActionGrant(op_type: integer; user: String);
    procedure SetUpTable;
    property TableOrder:String read FTableOrder write SetTableOrder;
  public
    { Public declarations }
    procedure Update; override;
    procedure InitDlg(ObjName: String; const Showsystem, Refetch: boolean);
    procedure Refetch;
    property DataModule:TDmN read FDataModule write SetDataModule;
    property ObjectName:string read FObjName;
    property ObjectType:Integer read FObjType;
    property FormView:boolean read FFormView write SetFormView;
    procedure SignalObjectRefresh(const aDataModule: TDmN; const aObjType: integer; const aObjName:String='');
  end;


implementation

uses
  frmuMessage, frmuDisplayBlob, frmuDispMemo, dmuMain, zluUtility, IBOAdminUtils,
  IBOCGlobal, frmuWindowList, IBOCPersistent, frmuEditorField, frmuMain,
  frmuEditorDomain, frmuEditorIndex, LMIBOQueryStatement, frmuEditorTrigger,
  LMMessageDialog;

{$R *.DFM}

const
  TAB_DOMAIN = 0;
  TAB_TABLE = 1;
  TAB_PROCEDURE = 2;
  TAB_TRIGGER = 3;
  TAB_EXCEPTION = 4;
  TAB_FILTER = 5;
  TAB_FUNCTION = 6;
  TAB_GENERATOR = 7;
  TAB_ROLE = 8;
  TAB_VIEW = 9;

  USR_COL = 0;
  SEL_COL = 1;
  DEL_COL = 2;
  INS_COL = 3;
  UPD_COL = 4;
  REF_COL = 5;
  EXE_COL = 6;
  MEM_COL = 7;
  GRANT_COL = 8;

  DESCRIPTION_ROW = 0;

  COLUMN_LIST = 0;
  TRIGGER_LIST = 1;
  CHECK_CONST_LIST = 2;
  INDEX_LIST = 3;
  UNIQUE_CONST_LIST = 4;
  REF_CONST_LIST = 5;


{ frmEditorTable }

// kris Kylix
procedure TfrmEditorTable.Update;
begin
  Refetch;
end;

procedure TfrmEditorTable.InitDlg(ObjName: String;
                                 const Showsystem, Refetch: boolean);
var
  lRefetch: boolean;

begin
  FObjType := NODE_TABLES;
  if not (ShowSystem = FShowSystem) then
    { All lists need to be refetched }
    lRefetch := true
  else
    lRefetch := Refetch;
  FShowSystem := ShowSystem;
  FObjName := ObjName;
  Caption := Format(GetLangType('Table')+' - %s', [ObjName]);
  reMetadata.Lines.Clear;
  { Set up the array to hold object data }
//  StatusBar.Panels[1].Text := NODE_ARRAY[FObjType];

  tabData.tabVisible := false;
  tabPermissions.tabVisible := false;
  tabProperties.TabVisible := true;

  FRefreshList := lRefetch;
  FMetadataRefreshList := lRefetch;

  pgcProperties.ActivePageIndex := 0;
  tabData.tabVisible := true;
  tabPermissions.TabVisible := true;
  pgcPropertiesChange(pgcProperties);
end;


procedure TfrmEditorTable.DoExtractMetadata(lObjName: String);
var
  lExtractTypes : TExtractTypes;
  lObjectType : TExtractObjectTypes;
begin
      { Only refetch if there is nothing there or something caused a refresh }
      if (reMetadata.Lines.Count = 0) or FMetadataRefreshList = true then
      begin
        FMetadataRefreshList := false;
        Screen.Cursor := crHourGlass;
        lExtractTypes := [];
        try
            DataModule.IBOExtract.ShowSystem := FShowSystem;
            lObjectType := eoTable;
            if cbExtractData.Checked then
              lExtractTypes := [etTrigger, etDomain, etIndex, etForeign, etData]
            else
              lExtractTypes := [etTrigger, etDomain, etIndex, etForeign];
            DataModule.IBOExtract.ExtractObject(lObjectType, lObjName, lExtractTypes);
            reMetadata.Text := DataModule.IBOExtract.Items.Text;
{$IFNDEF NOT_YET_IN_KYLIX}
            reMetadata.Perform(EM_SCROLLCARET, 0, 0);
{$ENDiF}
        finally
          Screen.Cursor := crDefault;
        end;
      end;
end;

procedure TfrmEditorTable.SetUpTable;
var st:TSqlStatements;
begin
  st:=TSqlStatements.Create;
  try
    st.PrepareIBOQuery(IBOTable,ObjectName);
    SynEditSelect.Lines.Assign(IBOTable.SQL);
    SynEditInsert.Lines.Assign(IBOTable.InsertSQL);
    SynEditUpdate.Lines.Assign(IBOTable.EditSQL);
    SynEditDelete.Lines.Assign(IBOTable.DeleteSQL);
    //IBOTable.Active := true;
    DestroyFilterControls;
    DestroyEditControls;
  finally
    st.Free;
  end;
end;


procedure TfrmEditorTable.pgcPropertiesChange(Sender: TObject);
begin
    if pgcProperties.ActivePage = tabMetadata then
    begin
      DoExtractMetadata(ObjectName);
    end;

    if pgcProperties.ActivePage = tabData then
    begin
      if not IBOTable.Active or FRefreshList then
        SetUpTable;
    end;

    if pgcProperties.ActivePage = tabPermissions then
      GetPermissions (ObjectName, FObjType);

    if pgcProperties.ActivePage = tabDependencies then
      GetDependencies (ObjectName, FObjType);

    if pgcProperties.ActivePage = tabDescription then
      LoadDescription;

    if pgcProperties.ActivePage = tabProperties then
      GetTableProperties;
end;

procedure TfrmEditorTable.dbgDataCellClick(Column: TColumn);
begin
  if Assigned(Column) then
    if Assigned(Column.Field) then
      if Column.Field.DataType in [ftMemo, ftBlob] then
        Column.ButtonStyle := cbsEllipsis;
end;

procedure TfrmEditorTable.dbgDataDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
  with Sender as TDBGrid do
  begin
    if Column.Field = nil then
    begin
      with Canvas do
      begin
        font.color := clBlue;
        TextRect(Rect, Rect.Left, Rect.top, NULL_STR);
      end
    end
    else
    begin
      if Column.Field.IsNull then
      begin
        with Canvas do
        begin
          font.color := clBlue;
          TextRect(Rect, Rect.Left, Rect.top, NULL_STR);
        end;
      end;
    end;
  end;
end;

procedure TfrmEditorTable.dbgDataEditButtonClick(Sender: TObject);
var
  FieldObj: TField;
begin
  if dbgData.SelectedField is tBlobField then
  begin
    FieldObj := dbgData.SelectedField;
    case FieldObj.DataType of
      ftBlob:
        IBCDisplayBlob(Self, TBlobField(FieldObj));
      ftMemo:
        IBCDisplayMemo(Self,FieldObj);
      else
        LMMessageDlg(FieldObj.DisplayName + ' is unknown', mtError, [mbOk], 0);
    end;
  end;
end;

procedure TfrmEditorTable.GetDependencies(const ObjName: String;
  const ObjType: Integer);
begin
  rbDependent.Checked := true;
  DataModule.GetDependencies(tvDependencies,tvDependents,ObjName,ObjType);
end;

function ItemPresent(List:TListView; un:String):integer;
var n:integer;
begin
  Result := -1;
  for n:=0 to List.Items.Count -1 do
    if List.Items[n].Caption = un then
    begin
      result := n;
      break;
    end;
end;

procedure TfrmEditorTable.AddUserName(un:String);
var
  idx:integer;
begin
  idx := ItemPresent(lvPermissions,un);
  if idx < 0 then
  with lvPermissions.Items.Add do
  begin
    Caption := un;
    ImageIndex := 25;
    SubItems.Add('');
    SubItems.Add('');
    SubItems.Add('');

    SubItems.Add('');
    SubItems.Add('');
    SubItems.Add('');

    SubItems.Add('');

    SubItemImages[0] := IMG_WHITE;
    SubItemImages[1] := IMG_WHITE;
    SubItemImages[2] := IMG_WHITE;
    SubItemImages[3] := IMG_WHITE;
    SubItemImages[4] := IMG_WHITE;
    SubItemImages[5] := IMG_WHITE;
    SubItemImages[6] := IMG_WHITE;
  end;
end;

procedure TfrmEditorTable.GetPermissions(const ObjName: String; const ObjType: Integer);
var
  n:integer;
begin
  Screen.Cursor := crHourGlass;
  Datamodule.GetPermissions(lvPermissions,ObjName,ObjType);
  for n:=0 to DataModule.ServerNode.UserList.Count-1 do
     AddUserName(DataModule.ServerNode.UserList[n]);
  Screen.Cursor := crDefault;
end;

procedure TfrmEditorTable.ShowColumnsExecute(Sender: TObject);
begin
  sbCols.Down := true;
  PanelTriggerSource.Visible := false;
  reTriggerSource.ReadOnly := True;
  lvTableObjects.Align := alClient;
  lvTableObjects.OnChange := nil;
  lvTableObjects.OnChanging := nil;
  SplitterWnd.Visible := false;
  NewPrimaryKey1.Visible := false;
  New1.Visible := True;
  GetColumnsProperties;
end;

procedure TfrmEditorTable.GetColumnsProperties;
begin
  if (FTableData.Columns.Count <= 0) or FRefreshList = true then
  begin
    if FRefreshList then SetUpTable;
    FRefreshList := false;
    FTableData.Columns.Clear;
    DataModule.GetColumnList(FTableData.Columns, FObjName);
  end;
  FillList(lvTableObjects, FTableData.Columns);
end;

procedure TfrmEditorTable.ShowTriggersExecute(Sender: TObject);
begin
  tbTriggers.Down := true;
  try
    reTriggerSource.Lines.Clear;
    PanelTriggerSource.Visible := true;
    edTriggerDesc.Visible := True;
    Splitter1.Visible := True;
    reTriggerSource.ReadOnly := True;
  except
  end;
  try
    lvTableObjects.Align := alTop;
    lvTableObjects.Anchors := [akLeft, akRight, akTop, akBottom];
    lvTableObjects.Height := lvTableObjects.Parent.Height div 2;
  except
  end;
  SplitterWnd.Visible := true;
  SplitterWnd.Top := lvTableObjects.Height + lvTableObjects.Top;
  NewPrimaryKey1.Visible := false;
  New1.Visible := True;
  GetTriggersProperties;
end;

procedure TfrmEditorTable.SaveTriggerDescription(aTriggerName:String);
begin
  if Assigned(Datamodule) then
  begin
    DataModule.ObjectDescriptionUpdate(NODE_TRIGGER,aTriggerName,edTriggerDesc.Text);
    edTriggerDesc.Modified := False;
    frmMain.ObjectListRefresh(DataModule, NODE_TRIGGER);
  end;
end;
{
procedure TfrmEditorTable.LoadTriggerDescription(aTriggerName:String);
begin
  if Assigned(Datamodule) then
  begin
    edTriggerDesc.Text := DataModule.GetObjectDescription(NODE_TRIGGER,aTriggerName);
    edTriggerDesc.Modified := False;
  end;
end;
}

procedure TfrmEditorTable.GetTriggersProperties;
begin
  if (FTableData.Triggers.Count <= 0) or FRefreshList = true then
  begin
    FRefreshList := false;
    FTableData.Triggers.Clear;
    DataModule.GetTriggerList(FTableData.Triggers, FObjName);
  end;

  FillList (lvTableObjects, FTableData.Triggers);
  reTriggerSource.Lines.Clear;
  lvTableObjects.OnChange := ShowTriggerSource;
  lvTableObjects.OnChanging := TriggerSourceChanging;
  lvTableObjects.Selected := lvTableObjects.TopItem;
end;

procedure TfrmEditorTable.GetConstraintsProperties;
begin
  if (FTableData.CheckConst.Count <= 0) or FRefreshList = true then
  begin
    FRefreshList := false;
    FTableData.CheckConst.Clear;
    DataModule.GetCheckConstList(FTableData.CheckConst,  FObjName);
  end;
  FillList (lvTableObjects, FTableData.CheckConst);
  reTriggerSource.Lines.Clear;
  lvTableObjects.OnChange := ShowTriggerSource;
  lvTableObjects.Selected := lvTableObjects.TopItem;
  lvTableObjects.OnChanging := Nil;
end;

procedure TfrmEditorTable.GetIndexesProperties;
begin
  if (FTableData.Indexes.Count <= 0) or FRefreshList = true then
  begin
    FRefreshList := false;
    FTableData.Indexes.Clear;
    DataModule.GetIndexList(FTableData.Indexes,  FObjName);
  end;

  FillList (lvTableObjects, FTableData.Indexes);
  reTriggerSource.Lines.Clear;
  lvTableObjects.Selected := lvTableObjects.TopItem;
end;

procedure TfrmEditorTable.GetUniqueConstraintsProperties;
begin
  if (FTableData.UniqueConst.Count <= 0) or FRefreshList = true then
  begin
    FRefreshList := false;
    FTableData.UniqueConst.Clear;
    DataModule.GetConstList(FTableData.UniqueConst, FObjName);
  end;
  FillList (lvTableObjects, FTableData.UniqueConst);
end;

procedure TfrmEditorTable.GetReferentialConstraintsProperties;
begin
  if (FTableData.RefConst.Count <= 0) or FRefreshList = true then
  begin
    FRefreshList := false;
    FTableData.RefConst.Clear;
    DataModule.GetReferentialConstList(FTableData.RefConst, FObjName);
  end;
  FillList (lvTableObjects, FTableData.RefConst);
end;

procedure TfrmEditorTable.GetTableProperties;
begin
  FTableData.SystemTable := DataModule.IsSystemTable(FObjName);
  if sbCols.Down then  GetColumnsProperties;
  if tbTriggers.Down then GetTriggersProperties;
  if tbChkConst.Down then GetConstraintsProperties;
  if tbIndexes.Down then GetIndexesProperties;
  if tbUnique.Down then GetUniqueConstraintsProperties;
  if tbRef.Down then GetReferentialConstraintsProperties;
end;

procedure TfrmEditorTable.FillList(const ListObject: TListView; const StringList: TStringList);
var
  loListItem: TListItem;
  loListColumn: TListColumn;
  lsCurrLine: string;
  i,n,mw,l: integer;
  WasVisible: boolean;
begin
  // to prevent delay
  WasVisible := ListObject.Visible;
  ListObject.Visible := FALSE;
  try

    ListObject.Items.BeginUpdate;
    ListObject.Items.Clear;

    ListObject.Columns.Clear;

{$IFNDEF NOT_YET_IN_KYLIX}
    ListObject.AllocBy := StringList.Count;
{$ENDIF}

    { The column Headers are stored in element 0 }
    lsCurrLine := StringList.Strings[0];
    while Length(lsCurrLine) > 0 do
    begin
      loListColumn := ListObject.Columns.Add;
      loListColumn.Caption := GetNextField(lsCurrLine, DEL);
{$IFDEF MSWINDOWS}
      loListColumn.Width := ColumnTextWidth;
      loListColumn.AutoSize := true;
{$ENDIF}
{$IFDEF LINUX}
      loListColumn.AutoSize := true;
{$ENDIF}
    end;

    for i := 1  to StringList.Count - 1 do
    begin
      lsCurrLine := StringList.Strings[i];
      loListItem := ListObject.Items.Add;
      loListItem.Caption := GetNextField(lsCurrLine, DEL);

      while Length(lsCurrLine) > 0 do
      begin
        loListItem.SubItems.Add(GetNextField(lsCurrLine, DEL));
      end;
    end;

{$IFDEF MSWINDOWS}
    for i:=0 to ListObject.Columns.Count -1 do
    try
      mw := 0;
      for n:= 0 to ListObject.Items.Count -1 do
      begin
        if i=0 then
          l := Length(ListObject.Items[n].Caption)
        else
        begin
          if i <= ListObject.Items[n].SubItems.Count then
            l := Length(ListObject.Items[n].SubItems[i-1])
          else
            l:=0;
        end;
        if l>mw then mw := l;
      end;
      l := Length(ListObject.Columns[i].Caption);
      if l<mw then
        ListObject.Columns[i].Width := ColumnTextWidth
      else
        ListObject.Columns[i].Width := ColumnHeaderWidth;
    except
    end;
{$ENDIF}

    ListObject.Items.EndUpdate;
    if ListObject.Items.Count > 0 then
      ListObject.Items[0].Selected := true;
  finally
    ListObject.Visible := WasVisible;
  end;
end;

procedure TfrmEditorTable.TriggerSourceChanging(Sender: TObject;
  Item: TListItem; Change: TItemChange; var AllowChange: Boolean);
begin
  if edTriggerDesc.Modified then
  begin
    SaveTriggerDescription(Item.Caption);
  end;
end;

procedure TfrmEditorTable.ShowTriggerSource(Sender: TObject;
  Item: TListItem; Change: TItemChange);
var
  lLine: String;
begin
  if (lvTableObjects.Items.Count > 0) and
     (Item.SubItems.Count > 0) then
  begin
    reTriggerSource.Lines.BeginUpdate;
    reTriggerSource.Lines.Clear;
    lLine := Item.SubItems.Strings[Item.SubItems.Count-2];
    reTriggerSource.Lines.Text := lLine;
    reTriggerSource.Lines.EndUpdate;

    edTriggerDesc.Lines.BeginUpdate;
    edTriggerDesc.Lines.Clear;
    lLine := Item.SubItems.Strings[Item.SubItems.Count-1];
    if lLine <> NULL_FLAG then
      edTriggerDesc.Lines.Text := lLine;
    edTriggerDesc.Lines.EndUpdate;
  end;
end;

procedure TfrmEditorTable.IndexDescriptionChanging(Sender: TObject;
  Item: TListItem; Change: TItemChange; var AllowChange: Boolean);
begin
  if reTriggerSource.Modified then
  begin
    SaveIndexDescription(Item.Caption);
    Item.SubItems.Strings[Item.SubItems.Count-1] := reTriggerSource.Lines.Text;
  end;
end;

procedure TfrmEditorTable.SaveIndexDescription(aIndexName:String);
begin
  if Assigned(Datamodule) then
  begin
    DataModule.ObjectDescriptionUpdate(NODE_INDEX,aIndexName,reTriggerSource.Text);
    reTriggerSource.Modified := False;
    frmMain.ObjectListRefresh(DataModule, NODE_TRIGGER);
  end;
end;

procedure TfrmEditorTable.ShowIndexDescription(Sender: TObject;
  Item: TListItem; Change: TItemChange);
var
  lLine: String;
begin
  if (lvTableObjects.Items.Count > 0) and
     (Item.SubItems.Count > 0) then
  begin
    reTriggerSource.Lines.BeginUpdate;
    reTriggerSource.Lines.Clear;
    lLine := Item.SubItems.Strings[Item.SubItems.Count-1];
    if lLine <> NULL_FLAG then
      reTriggerSource.Lines.Text := lLine;
    reTriggerSource.Lines.EndUpdate;
  end;
end;


procedure TfrmEditorTable.ShowCheckConstraintsExecute(Sender: TObject);
begin
  tbChkConst.Down := true;
  try
    PanelTriggerSource.Visible := true;
    reTriggersource.Lines.Clear;
  except
  end;
  try
    lvTableObjects.Align := alTop;
    lvTableObjects.Anchors := [akLeft, akRight, akTop, akBottom];
    lvTableObjects.Height := lvTableObjects.Parent.Height div 2;
  except
  end;
  try
    SplitterWnd.Visible := true;
    SplitterWnd.Top := lvTableObjects.Height + lvTableObjects.Top;
  except
  end;
  NewPrimaryKey1.Visible := false;
  New1.Visible := True;
  GetConstraintsProperties;
end;

procedure TfrmEditorTable.ShowIndexesExecute(Sender: TObject);
begin
  tbIndexes.Down := true;
  PanelTriggerSource.Visible := True;
  reTriggerSource.ReadOnly := False;
  edTriggerDesc.Visible := False;
  Splitter1.Visible := False;
  try
    lvTableObjects.Align := alTop;
    lvTableObjects.Anchors := [akLeft, akRight, akTop, akBottom];
    lvTableObjects.Height := lvTableObjects.Parent.Height div 2;
  except
  end;
  lvTableObjects.OnChange := ShowIndexDescription;
  lvTableObjects.OnChanging := IndexDescriptionChanging;
  SplitterWnd.Visible := false;
  NewPrimaryKey1.Visible := false;
  New1.Visible := True;
  GetIndexesProperties;
end;

procedure TfrmEditorTable.ShowUniqueConstraintsExecute(Sender: TObject);
begin
  tbUnique.Down := true;
  PanelTriggerSource.Visible := false;
  reTriggerSource.ReadOnly := True;
  lvTableObjects.Align := alClient;
  lvTableObjects.OnChange := nil;
  lvTableObjects.OnChanging := nil;
  SplitterWnd.Visible := false;
  NewPrimaryKey1.Visible := True;
  New1.Visible := False;
  GetUniqueConstraintsProperties;
  if lvTableObjects.Items.Count = 0 then
  begin
    NewPrimaryKey1.Enabled := True;
  end
  else
  begin
    NewPrimaryKey1.Enabled := False;
  end;
end;

procedure TfrmEditorTable.ShowReferentialConstraintsExecute(
  Sender: TObject);
begin
  tbRef.Down := true;
  PanelTriggerSource.Visible := false;
  reTriggerSource.ReadOnly := True;
  lvTableObjects.Align := alClient;
  lvTableObjects.OnChange := nil;
  lvTableObjects.OnChanging := nil;
  SplitterWnd.Visible := false;
  NewPrimaryKey1.Visible := false;
  New1.Visible := True;
  GetReferentialConstraintsProperties;
end;

procedure TfrmEditorTable.FormShow(Sender: TObject);
begin
  if fStart then
  begin
    fStart:=False;
    ShowColumnsExecute(nil);
  end;
end;

procedure TfrmEditorTable.rbDependentClick(Sender: TObject);
begin
  pnlDependents.Visible := true;
  pnlDependencies.Visible := false;
end;

procedure TfrmEditorTable.rbDependedOnClick(Sender: TObject);
begin
  pnlDependents.Visible := false;
  pnlDependencies.Visible := true;
end;

procedure TfrmEditorTable.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  OpenWindows.Remove(Self);
  Action := caFree;
end;

procedure TfrmEditorTable.Refetch;
begin
  FRefreshList := true;
  FMetadataRefreshList := True;
  try
    pgcPropertiesChange(pgcProperties);
  except
  end;
end;

procedure TfrmEditorTable.SetDataModule(const Value: TDmN);
begin
  fDataModule := Value;
  if Assigned(FDataModule) then
  begin
    IBOTable.IB_Connection := DataModule.Connection;
    IBOTable.IB_Transaction := DataModule.Transaction;
    IB_TransactionBar1.IB_Transaction := DataModule.Transaction;
    StatusBar.Panels[2].Text := DataModule.Connection.DatabaseName;
  end
  else
  begin
    IBOTable.IB_Connection := Nil;
    IBOTable.IB_Transaction := Nil;
    IB_TransactionBar1.IB_Transaction := Nil;
    StatusBar.Panels[2].Text := '';
  end;

end;

{ TTableData }

constructor TTableData.Create;
begin
  inherited Create;
  Columns := TStringList.Create;
  Indexes := TStringList.Create;
  Triggers := TStringList.Create;
  CheckConst := TStringList.Create;
  UniqueConst := TStringList.Create;
  RefConst := TStringList.Create;
end;

destructor TTableData.Destroy;
begin
  Columns.Free;
  Indexes.Free;
  Triggers.Free;
  CheckConst.Free;
  UniqueConst.Free;
  RefConst.Free;
  inherited Destroy;
end;

procedure TfrmEditorTable.cbExtractDataClick(Sender: TObject);
begin
  FMetadataRefreshList := True;
  DoExtractMetadata(ObjectName);
end;

procedure TfrmEditorTable.IBOTableAfterOpen(DataSet: TDataSet);
var n:integer;
begin
  for n:= Low(GridColSize) to High(GridColSize) do
  begin
    if n in [0..dbgData.Columns.Count-1] then
      dbgData.Columns[n].Width := GridColSize[n];
  end;
  Beautify(IBOTable);
  ActionOpenTable.Caption := GetLangText('Close');
  if ScrollBoxData.Visible then LoadEditImages;
end;

procedure TfrmEditorTable.dbgDataTitleClick(Column: TColumn);
begin
  if Assigned(Column) then
  begin
    TableOrder := QuoteIdentifier(DataModule.Connection.SQLDialect,Column.FieldName);
  end
  else
    TableOrder := '';
end;

procedure TfrmEditorTable.IBOTablePostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  Action := daAbort;
  LMMessageDlg(e.message, mtError, [mbOk], 0);
end;

procedure TfrmEditorTable.IBOTableDeleteError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  Action := daAbort;
  LMMessageDlg(e.message, mtError, [mbOk], 0);

end;

procedure TfrmEditorTable.IBOTableEditError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  Action := daAbort;
  LMMessageDlg(e.message, mtError, [mbOk], 0);
end;

procedure TfrmEditorTable.NewIndex(TableName : String);
var
  F : TfrmEditorIndex;

begin
  F := TfrmEditorIndex.Create(Application);
  try
    F.DataModule := DataModule;
    F.TableName := ObjectName;
    F.NewObject;
    if F.ShowModal = mrOK then
    begin
      Refetch;
    end;
  finally
    F.Free;
  end;
end;

procedure TfrmEditorTable.NewConstraint(TableName : String; aType:TConstraintType);
var
  F : TfrmEditorConstraint;
begin
  F := TfrmEditorConstraint.Create(Application);
  try
    F.NewConstraint(DataModule,TableName,aType);
    if F.ShowModal = mrOK then
    begin
      Refetch;
    end;
  finally
    F.Free;
  end;
end;

procedure TfrmEditorTable.EditIndex;
var f:TfrmEditorIndex;
begin
  if Assigned(lvTableObjects.Selected) then
  begin
    f:=TfrmEditorIndex.Create(Application);
    try
      f.DataModule := DataModule;
      f.TableName := ObjectName;
      f.ObjectName := lvTableObjects.Selected.Caption;
      if f.ShowModal = mrOk then
      begin
        Refetch;
      end;
    finally
      f.Release;
    end;
  end;
end;

procedure TfrmEditorTable.EditField;
var f:TfrmEditorField;
begin
  if Assigned(lvTableObjects.Selected) then
  begin
    f:=TfrmEditorField.Create(Application);
    try
      f.DataModule := DataModule;
      f.TableName := ObjectName;
      f.ObjectName := lvTableObjects.Selected.Caption;
      if f.ShowModal = mrOk then
      begin
        Refetch;
      end;
    finally
      f.Release;
    end;
  end;
end;

procedure TfrmEditorTable.DropSubObject(ObjectTypeName,DropSQL:String);
var
    error:String;
begin
  if Assigned(lvTableObjects.Selected) then
  if LMMessageDlg(43,[ObjectTypeName,lvTableObjects.Selected.Caption], mtConfirmation, [mbYes, mbNo], 0) = mrYes
  then
  begin
    IBOTable.Close;
    if DataModule.ExecuteDDL(Format(DropSQL,[
              Quoteidentifier(DataModule.Connection.SQLDialect,ObjectName),
              Quoteidentifier(DataModule.Connection.SQLDialect,lvTableObjects.Selected.Caption)
              ]),error) then
    begin
      DataModule.CommitDDL;
      Refetch;
    end
    else
    begin
      DisplayMsg(ERR_DDL_EXECUTION,error);
      DataModule.RollbackDDL;
    end;
  end;
end;

procedure TfrmEditorTable.DropField;
begin
  DropSubObject('Field','alter table %s drop %s');
end;

procedure TfrmEditorTable.DropTrigger;
begin
  DropSubObject('Trigger','/* %s */ drop trigger %s');
end;

procedure TfrmEditorTable.DropConstraint;
begin
  DropSubObject('Constraint','alter table %s drop CONSTRAINT %s');
end;

procedure TfrmEditorTable.DropIndex;
begin
  DropSubObject('Index','/* %s */ drop INDEX %s');
end;

procedure TfrmEditorTable.EditConstraint;
var
  F : TfrmEditorConstraint;
begin
  if Assigned(lvTableObjects.Selected) then
  begin
    F := TfrmEditorConstraint.Create(Application);
    try
      F.DataModule := FDataModule;
      F.TableName := ObjectName;
      F.LoadConstraint(lvTableObjects.Selected.Caption);
      if F.ShowModal = mrOK then
      begin
        Refetch;
      end;
    finally
      F.Free;
    end;
  end;
end;

procedure TfrmEditorTable.NewField(TableName : String);
var
  F : TfrmEditorField;
begin
  F := TfrmEditorField.Create(Application);
  try
    f.DataModule := DataModule;
    f.NewField(TableName);
    if F.ShowModal = mrOK then
    begin
      FMetadataRefreshList := True;
      Refetch;
    end;
  finally
    F.Free;
  end;
end;

procedure TfrmEditorTable.NewTrigger(TableName : String);
var
  F : TfrmEditorTrigger;
begin
  Application.CreateForm(TfrmEditorTrigger,f);
  F.DataModule := DataModule;
  F.TableName := ObjectName;
  F.NewObject;
  F.Show;
end;

procedure TfrmEditorTable.EditTrigger;
var
  F : TfrmEditorTrigger;
begin
  if Assigned(lvTableObjects.Selected) then
  begin
    f:=TfrmEditorTrigger(OpenWindows.FindWindow(DataModule,NODE_TRIGGERS,lvTableObjects.Selected.Caption));
    if not Assigned(f) then
    begin
      f:=TfrmEditorTrigger.Create(Application);
      F.DataModule := DataModule;
      F.TableName := ObjectName;
      f.ObjectName := lvTableObjects.Selected.Caption;
    end;
    f.Show;
  end;
end;

procedure TfrmEditorTable.ActionEditObjectExecute(Sender: TObject);
begin
  if sbCols.Down then EditField
  else
  if tbTriggers.Down then EditTrigger
  else
  if tbIndexes.Down then EditIndex
  else
  if tbUnique.Down then EditConstraint
  else
  if tbChkConst.Down then EditConstraint
  else
  if tbRef.Down then EditConstraint;
end;

procedure TfrmEditorTable.ActionNewObjectExecute(Sender: TObject);
begin
  if sbCols.Down then NewField(FObjName)
  else
  if tbTriggers.Down then NewTRigger(fObjname)
  else
  if tbIndexes.Down then NewIndex(FObjName)
  else
  if tbUnique.Down then NewConstraint(FObjName,ctUnique)
  else
  if tbChkConst.Down then NewConstraint(FObjName,ctCheck)
  else
  if tbRef.Down then NewConstraint(FObjName, ctFK);
end;

procedure TfrmEditorTable.ActionDropObjectExecute(Sender: TObject);
begin
  if sbCols.Down then DropField
  else
  if tbTriggers.Down then DropTrigger
  else
  if tbIndexes.Down then DropIndex
  else
  if tbUnique.Down then DropConstraint
  else
  if tbChkConst.Down then DropConstraint
  else
  if tbRef.Down then DropConstraint;
  ReloadTableData;
end;

procedure TfrmEditorTable.ActionEditObjectUpdate(Sender: TObject);
begin
  ActionEditObject.Enabled := Assigned(lvTableObjects.Selected);
end;

procedure TfrmEditorTable.ActionDropObjectUpdate(Sender: TObject);
begin
  ActionDropObject.Enabled := Assigned(lvTableObjects.Selected);
end;

procedure TfrmEditorTable.pgcPropertiesChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
    if pgcProperties.ActivePage = tabDescription then
    begin
      if edDescription.Modified then
      begin
        if LMMessageDlg(30, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          SaveDescription;
      end;
    end
end;

procedure TfrmEditorTable.SaveDescription;
begin
  if Assigned(Datamodule) then
  begin
    DataModule.ObjectDescriptionUpdate(FObjType,FObjName,edDescription.Text);
    edDescription.Modified := False;
    frmMain.ObjectListRefresh(DataModule, FObjType);
  end;
end;

procedure TfrmEditorTable.LoadDescription;
begin
  if Assigned(Datamodule) then
  begin
    edDescription.Text := DataModule.GetObjectDescription(FObjType,FObjName);
    edDescription.Modified := False;
  end;
end;

procedure TfrmEditorTable.FormCreate(Sender: TObject);
begin
  setLength(GridColSize,0);
  FTableData := TTableData.Create;
  fStart:=True;
end;

procedure TfrmEditorTable.FormDestroy(Sender: TObject);
begin
  try
    setLength(GridColSize,0);
    FreeAndNil(FTableData);
  except
  end;
end;

procedure TfrmEditorTable.IBOTableBeforeClose(DataSet: TDataSet);
var n:integer;
begin
  setLength(GridColSize,dbgData.Columns.Count);
  for n:= 0 to dbgData.Columns.Count-1 do
  begin
    GridColSize[n] := dbgData.Columns[n].Width;
  end;
end;

procedure TfrmEditorTable.NewPrimaryKey1Click(Sender: TObject);
begin
  NewConstraint(FObjName,ctPK);
end;

procedure TfrmEditorTable.NewUniqueKey1Click(Sender: TObject);
begin
  NewConstraint(FObjName,ctUnique);
end;

procedure TfrmEditorTable.lvPermissionsEditing(Sender: TObject;
  Item: TListItem; var AllowEdit: Boolean);
begin
  AllowEdit :=  Item.Caption <> '';
end;

procedure TfrmEditorTable.ActionGrantSelectUpdate(Sender: TObject);
begin
  ActionGrantSelect.Enabled := Assigned(lvPermissions.Selected);
end;

procedure TfrmEditorTable.ActionGrantDeleteUpdate(Sender: TObject);
begin
  ActionGrantDelete.Enabled := Assigned(lvPermissions.Selected);
end;

procedure TfrmEditorTable.ActionGrantInsertUpdate(Sender: TObject);
begin
  ActionGrantInsert.Enabled := Assigned(lvPermissions.Selected);
end;

procedure TfrmEditorTable.ActionGrantUpdateUpdate(Sender: TObject);
begin
  ActionGrantUpdate.Enabled := Assigned(lvPermissions.Selected);
end;

procedure TfrmEditorTable.ActionGrantReferenceUpdate(Sender: TObject);
begin
  ActionGrantReference.Enabled := Assigned(lvPermissions.Selected);
end;

procedure TfrmEditorTable.ActionGrantExecuteUpdate(Sender: TObject);
begin
  ActionGrantExecute.Enabled := Assigned(lvPermissions.Selected);
end;

procedure TfrmEditorTable.ActionRevokeAllUpdate(Sender: TObject);
begin
  ActionRevokeAll.Enabled := Assigned(lvPermissions.Selected);
end;

procedure TfrmEditorTable.ActionGrantAllUpdate(Sender: TObject);
begin
  ActionGrantAll.Enabled := Assigned(lvPermissions.Selected);
end;


const
  n_select    = 0;
  n_delete    = 1;
  n_insert    = 2;
  n_update    = 3;
  n_reference = 4;
  n_execute   = 5;
  n_all       = 6;


  MapOpType:array[n_select..n_all] of String = (
  'select',
  'delete',
  'insert',
  'update',
  'all',
  'execute',
  'all');

procedure TfrmEditorTable.ExecuteActionGrant(op_type:integer; user:String);
var n:integer;
begin
  if lvPermissions.Selected.SubItems[op_type]= '' then
  begin
    if op_type = n_reference then
    DataModule.ExecuteDDL('grant '+MapOpType[op_type]+' on '+
                          QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName)+
                          ' to '+ lvPermissions.Selected.Caption + ' WITH GRANT OPTION',fError)
    else
    DataModule.ExecuteDDL('grant '+MapOpType[op_type]+' on '+
                          QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName)+
                          ' to '+ lvPermissions.Selected.Caption,fError);
    if fError <> '' then
       DisplayMsg(ERR_GET_EXCEPTIONS, fError)
    else
    begin
       lvPermissions.Selected.SubItems[op_type]:= GetLangText('Y');
       if op_type = n_reference then
         for n:= n_select to n_reference do
         begin
           lvPermissions.Selected.SubItems[n]:=  GetLangText('Y');
           if lvPermissions.Selected.SubItems[n] =  GetLangText('Y') then
             lvPermissions.Selected.SubItemImages[n] := IMG_GRANT_OPT
           else
             lvPermissions.Selected.SubItemImages[n] := IMG_WHITE;
         end;
    end;
  end
  else
  begin
    if op_type = n_reference then
    DataModule.ExecuteDDL('revoke GRANT OPTION FOR '+MapOpType[op_type]+' on '+
                          QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName)+
                          ' from '+ lvPermissions.Selected.Caption,fError)
    else
    DataModule.ExecuteDDL('revoke '+MapOpType[op_type]+' on '+
                          QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName)+
                          ' from '+ lvPermissions.Selected.Caption,fError);
    if fError <> '' then
       DisplayMsg(ERR_GET_EXCEPTIONS, fError)
    else
    begin
       lvPermissions.Selected.SubItems[op_type]:= '';
       lvPermissions.Selected.SubItemImages[op_type] := IMG_WHITE;
       if op_type = n_reference then
         for n:= n_select to n_reference do
         begin
           if lvPermissions.Selected.SubItems[n] =  GetLangText('Y') then
             lvPermissions.Selected.SubItemImages[n] := IMG_GRANT_OPT
           else
             lvPermissions.Selected.SubItemImages[n] := IMG_WHITE;
         end;
    end;
  end;
  if fError = '' then
    DataModule.DDLTransaction.CommitRetaining;
end;


procedure TfrmEditorTable.ActionGrantSelectExecute(Sender: TObject);
begin
  ExecuteActionGrant(n_select,lvPermissions.Selected.Caption);
end;

procedure TfrmEditorTable.ActionGrantDeleteExecute(Sender: TObject);
begin
  ExecuteActionGrant(n_delete,lvPermissions.Selected.Caption);
end;

procedure TfrmEditorTable.ActionGrantInsertExecute(Sender: TObject);
begin
  ExecuteActionGrant(n_insert,lvPermissions.Selected.Caption);
end;

procedure TfrmEditorTable.ActionGrantUpdateExecute(Sender: TObject);
begin
  ExecuteActionGrant(n_update,lvPermissions.Selected.Caption);
end;

procedure TfrmEditorTable.ActionGrantReferenceExecute(Sender: TObject);
begin
  ExecuteActionGrant(n_reference,lvPermissions.Selected.Caption);
end;

procedure TfrmEditorTable.ActionGrantExecuteExecute(Sender: TObject);
begin
  ExecuteActionGrant(n_execute,lvPermissions.Selected.Caption);
end;

procedure TfrmEditorTable.ActionGrantAllExecute(Sender: TObject);
begin
  DataModule.ExecuteDDL('grant all on '+QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName)+
             ' to '+ lvPermissions.Selected.Caption,fError);
  if fError <> '' then DisplayMsg(ERR_GET_EXCEPTIONS, fError)
  else
  begin
    lvPermissions.Selected.SubItems[n_select   ]:= GetLangText('Y');
    lvPermissions.Selected.SubItems[n_delete   ]:= GetLangText('Y');
    lvPermissions.Selected.SubItems[n_insert   ]:= GetLangText('Y');
    lvPermissions.Selected.SubItems[n_update   ]:= GetLangText('Y');
    DataModule.DDLTransaction.CommitRetaining;
  end;
end;

procedure TfrmEditorTable.ActionRevokeAllExecute(Sender: TObject);
begin
  DataModule.ExecuteDDL('revoke all on '+QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName)+
             ' from '+ lvPermissions.Selected.Caption,fError);
  if fError <> '' then DisplayMsg(ERR_GET_EXCEPTIONS, fError)
  else
  begin
    lvPermissions.Selected.SubItems[n_select   ]:= '';
    lvPermissions.Selected.SubItems[n_delete   ]:= '';
    lvPermissions.Selected.SubItems[n_insert   ]:= '';
    lvPermissions.Selected.SubItems[n_update   ]:= '';
    lvPermissions.Selected.SubItemImages[n_select   ] := IMG_WHITE;
    lvPermissions.Selected.SubItemImages[n_delete   ] := IMG_WHITE;
    lvPermissions.Selected.SubItemImages[n_insert   ] := IMG_WHITE;
    lvPermissions.Selected.SubItemImages[n_update   ] := IMG_WHITE;
    DataModule.DDLTransaction.CommitRetaining;
  end;
end;

procedure TfrmEditorTable.ActionOpenTableExecute(Sender: TObject);
begin
  if IBOTable.Active then
    IBOTable.Close
  else
  begin
    if IBOTable.Sql.Text <> '' then
      IBOTable.Open;
  end;
end;

procedure TfrmEditorTable.IBOTableAfterClose(DataSet: TDataSet);
begin
  ActionOpenTable.Caption := GetLangText('Open');
  UnloadEditImages;
end;

procedure TfrmEditorTable.SetTableOrder(const Value: String);
var oact:boolean;
begin
  FTableOrder := Value;
  oact:=IBOTable.Active;
  if FTableOrder='' then
  begin
    IBOTable.SqlOrder.Clear;
  end
  else
  begin
    IBOTable.SqlOrder.Clear;
    IBOTable.SqlOrder.Add('order by '+FTableOrder);
  end;
  if oact then
    IBOTable.Open;
end;

function TfrmEditorTable.GetFilterExpression(FieldIndex:integer):String;
var
  fMaskEdit   : TMaskEdit  ;
  fComboBox   : TComboBox  ;
  fCheckBox   : TCheckBox  ;
  n:integer;
  fField:TField;
  value:String;
begin
  fField := IBOTable.Fields[FieldIndex];
  fMaskEdit  := nil;
  fComboBox  := nil;
  fCheckBox  := nil;
  Result := '';
  for n:=0 to ScrollBoxFilter.ComponentCount-1 do
    if (TControl(ScrollBoxFilter.Components[n]).Tag = FieldIndex) then
    begin
      if (ScrollBoxFilter.Components[n] is TMaskEdit  ) then fMaskEdit  := TMaskEdit  (ScrollBoxFilter.Components[n]);
      if (ScrollBoxFilter.Components[n] is TComboBox  ) then fComboBox  := TComboBox  (ScrollBoxFilter.Components[n]);
      if (ScrollBoxFilter.Components[n] is TCheckBox  ) then fCheckBox  := TCheckBox  (ScrollBoxFilter.Components[n]);
    end;
  if Assigned(fComboBox) then
  begin
    if pos('null',fComboBox.Text)>0 then
    begin
      Result := QuoteIdentifier(DataModule.Connection.SQLDialect,fField.FieldName)+ ' ' +
                fComboBox.Text;
    end
    else
    if fMaskEdit.Text <> '' then
    begin
      if Assigned(fCheckBox) and fCheckBox.Checked then
        Result := 'upper('+QuoteIdentifier(DataModule.Connection.SQLDialect,fField.FieldName)+ ') '
      else
        Result := QuoteIdentifier(DataModule.Connection.SQLDialect,fField.FieldName)+ ' ';
      value := fMaskEdit.Text;
      if (Uppercase(value) = 'NULL') or (value = '''''') then
        Result := Result + fComboBox.Text + ' '+ value
      else
      begin
        if (fComboBox.Text = 'in') or (fComboBox.Text='not in') then
          Result := Result + fComboBox.Text + ' ('+value+')'
        else
          Result := Result + fComboBox.Text + ' '+ QuotedStr(value);
      end;
    end;
  end;
end;

function TfrmEditorTable.GetFilterOperator(FieldIndex:integer):String;
var
  fRadioGroup : TRadioGroup;
  n:integer;
begin
  fRadioGroup:= nil;
  Result :='';
  for n:=0 to ScrollBoxFilter.ComponentCount-1 do
    if (TControl(ScrollBoxFilter.Components[n]).Tag = FieldIndex) then
    begin
      if (ScrollBoxFilter.Components[n] is TRadioGroup) then fRadioGroup:= TRadioGroup(ScrollBoxFilter.Components[n]);
    end;
  if Assigned(fRadioGroup) then
    case fRadioGroup.ItemIndex of
      0: Result := 'and';
      1: Result := 'or';
    end;
end;

procedure TfrmEditorTable.ApplyTableFilter;
var tfilter:String;
    ffilter:string;
    n:integer;
begin
  tfilter := '';
  for n:=0 to IBOTable.FieldCount-1 do
  if not IBOTable.Fields[n].IsBlob then
  begin
    ffilter := GetFilterExpression(n);
    if ffilter<>'' then
    begin
      if tfilter<>'' then
      begin
        tfilter := tfilter + ' '+GetFilterOperator(n);
      end;
      tfilter := tfilter + ' '+ffilter;
    end;
  end;
  IBOTable.Close;
  IBOTable.SQLWhere.Clear;
  if tfilter <> '' then
   IBOTable.SQLWhere.Text := 'where '+tfilter;
  IBOTable.Open;
end;

procedure TfrmEditorTable.ActionTableFilterExecute(Sender: TObject);
begin
  if ScrollBoxFilter.Visible then
  begin
    ApplyTableFilter;
    SetViewComponent;
    ScrollBoxFilter.Visible := False;
    ActionTableFilter.Caption := GetLangText('Filter');
  end
  else
  begin
    if ScrollBoxFilter.ComponentCount=0 then
      CreateFilterControls;
    ScrollBoxFilter.Visible := True;
    dbgData.Visible := False;
    ScrollBoxData.Visible := False;
    ActionTableFilter.Caption := GetLangText('Apply');
  end;
end;

procedure TfrmEditorTable.FilterEditOnEnter(Sender: TObject);
begin
  if Sender is  TDBMemo      then  TDBMemo    (Sender).Color := clYellow else
  if Sender is  TDbEdit      then  TDbEdit    (Sender).Color := clYellow else
  if Sender is  TMaskEdit    then  TMaskEdit  (Sender).Color := clYellow else
  if Sender is  TLabel       then  TLabel     (Sender).Color := clYellow else
  if Sender is  TRadioGroup  then  TRadioGroup(Sender).Color := clSilver else
  if Sender is  TComboBox    then  TComboBox  (Sender).Color := clYellow else
  if Sender is  TCheckBox    then  TCheckBox  (Sender).Color := clSilver;
end;

procedure TfrmEditorTable.FilterEditOnExit(Sender: TObject);
begin
  if Sender is  TDBMemo      then  TDBMemo    (Sender).Color := clWindow else
  if Sender is  TDbEdit      then  TDbEdit    (Sender).Color := clWindow else
  if Sender is  TMaskEdit    then  TMaskEdit  (Sender).Color := clWindow else
  if Sender is  TLabel       then  TLabel     (Sender).Color := clWindow else
  if Sender is  TRadioGroup  then  TRadioGroup(Sender).Color := clBtnFace else
  if Sender is  TComboBox    then  TComboBox  (Sender).Color := clWindow else
  if Sender is  TCheckBox    then  TCheckBox  (Sender).Color := clBtnFace;
end;

procedure TfrmEditorTable.FilterEditOnChange(Sender: TObject);
var
  fMaskEdit: TMaskEdit;
  fComboBox: TComboBox;
  fCheckBox: TCheckBox;
  fldIdx, n:integer;
begin
  if Sender is TCheckBox then
  begin
    fCheckBox := TCheckBox(Sender);
    fldIdx := fCheckBox.Tag;
    for n:=0 to ScrollBoxFilter.ComponentCount-1 do
    if (ScrollBoxFilter.Components[n] is TMaskEdit) and
       (TControl(ScrollBoxFilter.Components[n]).Tag = fldIdx)
    then
    begin
      fMaskEdit:=TMaskEdit(ScrollBoxFilter.Components[n]);
      if fCheckBox.Checked then
        fMaskEdit.CharCase := ecUpperCase
      else
        fMaskEdit.CharCase := ecNormal;
    end;
  end
  else
  if Sender is TComboBox then
  begin
    fComboBox := TComboBox(Sender);
    fldIdx := fComboBox.Tag;
    for n:=0 to ScrollBoxFilter.ComponentCount-1 do
    if (ScrollBoxFilter.Components[n] is TMaskEdit) and
       (TControl(ScrollBoxFilter.Components[n]).Tag = fldIdx)
    then
    begin
      fMaskEdit:=TMaskEdit(ScrollBoxFilter.Components[n]);
      fMaskEdit.Enabled := pos('null',fComboBox.Text)=0;
      if not fMaskEdit.Enabled then
        fMaskEdit.Color := clBtnFace
      else
        fMaskEdit.Color := clWindow;
    end;
  end;
  fFilterModified := True;
end;

function TfrmEditorTable.FindFilterEdit(idx:integer):TMaskEdit;
var
  fMaskEdit   : TMaskEdit  ;
  n:integer;
begin
  result := Nil;
  for n:=0 to ScrollBoxFilter.ComponentCount-1 do
    if (ScrollBoxFilter.Components[n] is TMaskEdit  ) then
    begin
      fMaskEdit  := TMaskEdit(ScrollBoxFilter.Components[n]);
      if fMaskEdit.Tag = idx then
      begin
        result := fMaskEdit;
        break;
      end;
    end;
end;

function TfrmEditorTable.FindFilterCombo(idx:integer):TComboBox;
var
  fComboBox   : TComboBox  ;
  n:integer;
begin
  result := Nil;
  for n:=0 to ScrollBoxFilter.ComponentCount-1 do
    if (ScrollBoxFilter.Components[n] is TComboBox  ) then
    begin
      fComboBox  := TComboBox(ScrollBoxFilter.Components[n]);
      if fComboBox.Tag = idx then
      begin
        result := fComboBox;
        break;
      end;
    end;
end;

const Spacing = 4;
      EditsGap = 8;
      TotalHeight = 33;
      ControlsHeight = 21;
      MaskEditWidth = 225;
      RadioGroupWidth = 105;
      LabelWidth = 110;
      ComboBoxWidth = 75;
      CheckBoxWidth = 140; //113;


procedure TfrmEditorTable.DropDownSpeedButtonOnClick(Sender: TObject);
var fIdx:integer;
    pt:TPoint;
    fcbox:TComboBox;
begin
  fIdx := (Sender as TSpeedButton).Tag;
  if not Assigned(fLookUps[fIdx]) then
  begin
    fLookUps[fIdx] := TFormLookUp.CreateLookup(Application,DataModule,ObjectName,IBOTable.Fields[fidx].FieldName);
    pt.X := (Sender as TSpeedButton).Left-MaskEditWidth-Spacing;
    pt.y := (Sender as TSpeedButton).Top+(Sender as TSpeedButton).Height;
    pt:=ScrollBoxFilter.ClientToScreen(pt);
    fLookUps[fIdx].Left := pt.X;
    fLookUps[fIdx].Top := pt.Y;
  end;
  if fLookUps[fIdx].ShowModal = mrOk then
  begin
    FindFilterEdit(fIdx).Text := fLookUps[fIdx].Sql;
    if fLookUps[fIdx].MultipleValues then
    begin
      fcbox := FindFilterCombo(fIdx);
      if (fcbox.Text <> 'in') and (fcbox.Text <> 'not in') then
        fcbox.Text := 'in';
    end;
  end;
end;


procedure TfrmEditorTable.CreateFilterEdit(FieldIndex:integer; TopLeftPoint:TPoint; first:boolean);
var
  fMaskEdit: TMaskEdit;
  fLabel: TLabel;
  fRadioGroup: TRadioGroup;
  fComboBox: TComboBox;
  fCheckBox: TCheckBox;
begin
  if not first then
  begin
    fRadioGroup:= TRadioGroup.Create(ScrollBoxFilter);
    fRadioGroup.Parent := ScrollBoxFilter;
    fRadioGroup.Top := TopLeftPoint.Y;
    fRadioGroup.Left := TopLeftPoint.X;
    fRadioGroup.Width := RadioGroupWidth;
    fRadioGroup.Height := TotalHeight;
    fRadioGroup.Caption := GetLangText('Operator');
    fRadioGroup.Columns := 2;
    //don't change order
    fRadioGroup.Items.add(GetLangText('And'));
    fRadioGroup.Items.add(GetLangText('Or'));
    //don't change order
    fRadioGroup.ItemIndex := 0;
    fRadioGroup.Tag := FieldIndex;
    fRadioGroup.OnClick := FilterEditOnChange;
    fRadioGroup.OnEnter := FilterEditOnEnter;
    fRadioGroup.OnExit := FilterEditOnExit;
    TopLeftPoint.X := TopLeftPoint.X + Spacing + fRadioGroup.Width;
  end
  else
  begin
    with TSpeedButton.Create(ScrollBoxFilter) do
    begin
      Parent := ScrollBoxFilter;
      Top := TopLeftPoint.Y+EditsGap;
      Left := TopLeftPoint.X;
      Width := RadioGroupWidth;
      Height := ControlsHeight;
      Flat := True;
      Action := ActionTableClearFilter;
    end;
    TopLeftPoint.X := TopLeftPoint.X + Spacing + RadioGroupWidth;
  end;

  fLabel:= TLabel.Create(ScrollBoxFilter);
  fLabel.Parent := ScrollBoxFilter;
  fLabel.AutoSize := False;
  fLabel.Layout := tlCenter;
  fLabel.Top := TopLeftPoint.Y+EditsGap;
  fLabel.Left := TopLeftPoint.X;
  fLabel.Width := fLabelsWidth;
  fLabel.Height := ControlsHeight;
  fLabel.Caption := IBOTable.Fields[FieldIndex].DisplayName;
  TopLeftPoint.X := TopLeftPoint.X + Spacing + fLabel.Width;

  fComboBox:= TComboBox.Create(ScrollBoxFilter);
  fComboBox.Parent := ScrollBoxFilter;
  fComboBox.Top := TopLeftPoint.Y+EditsGap;
  fComboBox.Left := TopLeftPoint.X;
  fComboBox.Width := ComboBoxWidth;
  fComboBox.Height := ControlsHeight;
  //do not localize
  fComboBox.Text := '=';
  fComboBox.Items.add('=');
  if IBOTable.Fields[FieldIndex].DataType = ftString then
  begin
    fComboBox.Items.add('like');
    fComboBox.Items.add('not like');
  end;
  fComboBox.Items.add('<>');
  fComboBox.Items.add('>=');
  fComboBox.Items.add('<=');
  fComboBox.Items.add('is null');
  fComboBox.Items.add('is not null');
  fComboBox.Items.add('in');
  fComboBox.Items.add('not in');
  //do not localize
  fComboBox.Tag := FieldIndex;
  fComboBox.OnChange := FilterEditOnChange;
  fComboBox.OnCloseUp := FilterEditOnChange;
  fComboBox.OnEnter := FilterEditOnEnter;
  fComboBox.OnExit := FilterEditOnExit;
  TopLeftPoint.X := TopLeftPoint.X + Spacing + fComboBox.Width;

  fMaskEdit:= TMaskEdit.Create(ScrollBoxFilter);
  fMaskEdit.Parent := ScrollBoxFilter;
  fMaskEdit.Top := TopLeftPoint.Y+EditsGap;
  fMaskEdit.Left := TopLeftPoint.X;
  fMaskEdit.Width := MaskEditWidth;
  fMaskEdit.Height := ControlsHeight;
  fMaskEdit.Tag := FieldIndex;
  fMaskEdit.OnChange := FilterEditOnChange;
  fMaskEdit.OnEnter := FilterEditOnEnter;
  fMaskEdit.OnExit := FilterEditOnExit;

  with TSpeedButton.Create(ScrollBoxFilter) do
  begin
    OnClick := DropDownSpeedButtonOnClick;
    Tag := FieldIndex;
    Parent := ScrollBoxFilter;
    Top := TopLeftPoint.Y+EditsGap;
    Left := TopLeftPoint.X+fMaskEdit.Width+1;
    Width := ControlsHeight;
    Height := ControlsHeight;
    Flat := True;
    Caption := '...';
  end;

  TopLeftPoint.X := TopLeftPoint.X + Spacing + fMaskEdit.Width + ControlsHeight;

  if IBOTable.Fields[FieldIndex].DataType = ftString then
  begin
    fCheckBox:= TCheckBox.Create(ScrollBoxFilter);
    fCheckBox.Parent := ScrollBoxFilter;
    fCheckBox.Top := TopLeftPoint.Y+EditsGap;
    fCheckBox.Left := TopLeftPoint.X;
    fCheckBox.Width := CheckBoxWidth;
    fCheckBox.Height := ControlsHeight;
    fCheckBox.Caption := GetLangText('Case Insensitive');
    fCheckBox.Tag := FieldIndex;
    fCheckBox.OnClick := FilterEditOnChange;
    fCheckBox.OnEnter := FilterEditOnEnter;
    fCheckBox.OnExit := FilterEditOnExit;
    TopLeftPoint.X := TopLeftPoint.X + Spacing + fCheckBox.Width;
  end;
end;

procedure TfrmEditorTable.DestroyFilterControls;
var
  n:integer;
begin
  n:=ScrollBoxFilter.ComponentCount+2;
  while (ScrollBoxFilter.ComponentCount>0) and (n>0) do
  try
    try
      ScrollBoxFilter.Components[0].Free;
    finally
      dec(n);
    end;
  except
  end;
  for n:=low(fLookUps) to High(fLookUps) do
  try
    if Assigned(fLookUps[n]) then
      fLookUps[n].Release;
  except
  end;
end;

procedure TfrmEditorTable.CreateFilterControls;
var TopLeftPoint:TPoint;
    n,maxw:integer;
    first:boolean;
    fLabel:TLabel;
begin
  TopLeftPoint.X := Spacing;
  TopLeftPoint.Y := 0;
  fLabel:= TLabel.Create(ScrollBoxData);
  try
    fLabel.Parent := ScrollBoxData;
    fLabel.AutoSize := true;
    fLabel.Layout := tlCenter;
    fLabel.Top := 0;
    fLabel.Left := 0;
    maxw:=20;
    for n:=0 to IBOTable.FieldCount-1 do
    if not IBOTable.Fields[n].IsBlob then
    begin
      fLabel.Caption := IBOTable.Fields[n].DisplayName;
      if maxw<fLabel.Width then
        maxw:=fLabel.Width;
    end;
  finally
    fLabel.Free;
  end;
  fLabelsWidth:=maxw;

  first := true;
  for n:=0 to IBOTable.FieldCount-1 do
  if not IBOTable.Fields[n].IsBlob then
  begin
    CreateFilterEdit(IBOTable.Fields[n].Index,TopLeftPoint,first);
    first := False;
    TopLeftPoint.Y := TopLeftPoint.Y + Spacing + TotalHeight;
  end;
  SetLength(fLookUps,IBOTable.FieldCount);
  fFilterModified := False;
end;

procedure TfrmEditorTable.SetViewComponent;
begin
  if not IBOTable.Active then IBOTable.Open;
  if FormView and (ScrollBoxData.ComponentCount = 0) then
  begin
    CreateEditControls;
  end;
  if FormView then LoadEditImages;
  ScrollBoxData.Visible := FormView;
  dbgData.Visible := not FormView;
end;

procedure TfrmEditorTable.ActionTableFormViewExecute(Sender: TObject);
begin
  FormView := not FormView;
  if not ScrollBoxFilter.Visible then SetViewComponent;
end;

procedure TfrmEditorTable.SetFormView(const Value: boolean);
begin
  FFormView := Value;
  if not FFormView then
    ActionTableFormView.Caption := GetLangText('Form View')
  else
    ActionTableFormView.Caption := GetLangText('Grid View');
end;

const
  EditLabelWidth = 150;
  DBMemoWidth = 320;
  DBMemoHeight = DBMemoWidth * 3 div 4;

procedure TfrmEditorTable.CreateEditingEdit(FieldIndex:integer; var TopLeftPoint:TPoint);
var
  fDBEdit: TDbEdit;
  fDBMemo: TDBMemo;
  fImage: TImage;
  fLabel: TLabel;
  X,Y:integer;
begin
  X := TopLeftPoint.X;
  Y := TopLeftPoint.Y;

  fLabel:= TLabel.Create(ScrollBoxData);
  fLabel.Parent := ScrollBoxData;
  fLabel.AutoSize := False;
  fLabel.Layout := tlCenter;
  fLabel.Top := Y;
  fLabel.Left := X;
  fLabel.Width := fLabelsWidth;
  fLabel.Height := ControlsHeight;
  fLabel.Caption := IBOTable.Fields[FieldIndex].DisplayName;
  X := X + Spacing + fLabel.Width;

  if IBOTable.Fields[FieldIndex].IsBlob then
  begin
    if IBOTable.Fields[FieldIndex] is TMemoField then
    begin
      fDBMemo:= TDBMemo.Create(ScrollBoxData);
      fDBMemo.Parent := ScrollBoxData;
      fDBMemo.Top := Y;
      fDBMemo.Left := X;
      fDBMemo.Width := ScrollBoxData.ClientWidth - fDBMemo.Left - Spacing;
      fDBMemo.Anchors := fDBMemo.Anchors + [akRight];
      fDBMemo.Height := DBMemoHeight;
      fDBMemo.Tag := FieldIndex;
      fDBMemo.OnEnter := FilterEditOnEnter;
      fDBMemo.OnExit := FilterEditOnExit;
      fDBMemo.DataSource := dbgDataSource;
      fDBMemo.DataField := IBOTable.Fields[FieldIndex].FieldName;
      Y := Y + fDBMemo.Height + Spacing;
    end
    else
    if not FTableData.SystemTable then 
    begin
      fImage:= TImage.Create(ScrollBoxData);
      fImage.Parent := ScrollBoxData;
      fImage.Top := Y;
      fImage.Left := X;
      fImage.Width := ScrollBoxData.ClientWidth - fImage.Left - Spacing;
      fImage.Anchors := fImage.Anchors + [akRight];
      fImage.Height := DBMemoHeight;
      fImage.Tag := FieldIndex;
      fImage.PopupMenu := pmImages;
      fImage.Proportional := True;
      fImage.Center := True;
      fImage.Stretch := True;

      fLabel:= TLabel.Create(ScrollBoxData);
      fLabel.Parent := ScrollBoxData;
      fLabel.AutoSize := true;
      fLabel.Layout := tlCenter;
      fLabel.Top := Y+DBMemoHeight+Spacing;
      fLabel.Left := X;
      fLabel.Caption := '...';
      Y := Y + fImage.Height + Spacing + ControlsHeight+ Spacing;
      SetLength(fImages,Length(fImages)+1);
      fImages[High(fImages)].Image := fImage;
      fImages[High(fImages)].Modified := False;
      fImages[High(fImages)].TypeLabel := fLabel;
    end;
  end
  else
  begin
    fDBEdit:= TDbEdit.Create(ScrollBoxData);
    fDBEdit.Parent := ScrollBoxData;
    fDBEdit.Top := Y;
    fDBEdit.Left := X;
    fDBEdit.Width := MaskEditWidth;
    fDBEdit.Height := ControlsHeight;
    fDBEdit.Tag := FieldIndex;
    fDBEdit.OnEnter := FilterEditOnEnter;
    fDBEdit.OnExit := FilterEditOnExit;
    fDBEdit.DataSource := dbgDataSource;
    fDBEdit.DataField := IBOTable.Fields[FieldIndex].FieldName;
    Y := Y + fDBEdit.Height + Spacing;
  end;
  
  TopLeftPoint.Y := Y;
end;

procedure TfrmEditorTable.CreateEditControls;
var TopLeftPoint:TPoint;
    n:integer;
    fLabel:TLabel;
    maxw:integer;
begin
  TopLeftPoint.X := Spacing;
  TopLeftPoint.Y := Spacing;
  fLabel:= TLabel.Create(ScrollBoxData);
  try
    fLabel.Parent := ScrollBoxData;
    fLabel.AutoSize := true;
    fLabel.Layout := tlCenter;
    fLabel.Top := 0;
    fLabel.Left := 0;
    maxw:=20;
    for n:=0 to IBOTable.FieldCount-1 do
    begin
      fLabel.Caption := IBOTable.Fields[n].DisplayName;
      if maxw<fLabel.Width then
        maxw:=fLabel.Width;
    end;
  finally
    fLabel.Free;
  end;
  fLabelsWidth:=maxw;

  for n:=0 to IBOTable.FieldCount-1 do
  begin
    CreateEditingEdit(IBOTable.Fields[n].Index,TopLeftPoint);
  end;
end;

procedure TfrmEditorTable.DestroyEditControls;
var
  n:integer;
begin
  n:=ScrollBoxData.ComponentCount+2;
  while (ScrollBoxData.ComponentCount>0) and (n>0) do
  try
    try
      ScrollBoxData.Components[0].Free;
    finally
      dec(n);
    end;
  except
  end;
  SetLength(fImages,0);
end;

procedure TfrmEditorTable.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if edDescription.Modified then
  begin
    case LMMessageDlg(30, mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
      mrYes: SaveDescription;
      mrCancel : CanClose:=False;
    end;
  end;
end;

procedure TfrmEditorTable.ActionEmptyTableExecute(Sender: TObject);
var Error:string;
begin
  case LMMessageDlg(44,[ObjectName], mtConfirmation, [mbYes, mbNo], 0) of
    mrYes:
    begin
      DataModule.ExecuteSql(
        format('delete from %s %s ',
               [QuoteIdentifier(DataModule.Connection.SQLDialect,ObjectName),
                IBOTable.SQLWhere.Text]),
        Error);
      if Error<>'' then DisplayMsg(ERR_ISQL_ERROR,Error);
      if IBOTable.Active then IBOTable.Refresh;
    end;
  end;
end;

procedure TfrmEditorTable.ActionEmptyTableUpdate(Sender: TObject);
begin
  ActionEmptyTable.Enabled := not IBOTable.IsEmpty;
end;

procedure TfrmEditorTable.ActionTableClearFilterUpdate(Sender: TObject);
begin
  ActionTableClearFilter.Enabled := fFilterModified;
end;

procedure TfrmEditorTable.ActionTableClearFilterExecute(Sender: TObject);
begin
  ClearFilterFields;
end;

procedure TfrmEditorTable.ClearFilterFields;
var
  fMaskEdit   : TMaskEdit  ;
  fComboBox   : TComboBox  ;
  fCheckBox   : TCheckBox  ;
  fRadioGroup : TRadioGroup;
  n:integer;
begin
  for n:=0 to ScrollBoxFilter.ComponentCount-1 do
  begin
    if (ScrollBoxFilter.Components[n] is TMaskEdit  ) then
    begin
      fMaskEdit  := TMaskEdit  (ScrollBoxFilter.Components[n]);
      fMaskEdit.Clear;
    end
    else
    if (ScrollBoxFilter.Components[n] is TComboBox  ) then
    begin
      fComboBox  := TComboBox  (ScrollBoxFilter.Components[n]);
      fComboBox.ItemIndex := 0;
      fComboBox.Text := '=';
    end
    else
    if (ScrollBoxFilter.Components[n] is TCheckBox  ) then
    begin
      fCheckBox  := TCheckBox  (ScrollBoxFilter.Components[n]);
      fCheckBox.Checked := False
    end
    else
    if (ScrollBoxFilter.Components[n] is TRadioGroup) then
    begin
      fRadioGroup  := TRadioGroup (ScrollBoxFilter.Components[n]);
      fRadioGroup.ItemIndex := 0;
    end;
  end;
  fFilterModified := False;
end;


procedure TfrmEditorTable.dbgDataSourceUpdateData(Sender: TObject);
var n:integer;
    emessage:String;
begin
  for n := low(FImages) to High(FImages) do
  if FImages[n].Modified then
  begin
    WriteImageToField(FImages[n].Image,IBOTable.Fields[FImages[n].Image.tag],emessage);
    //FImages[n].Modified := False;
    if emessage<>'' then
      DisplayMsg ( ERR_BAD_FORMAT, emessage);
  end;
end;

procedure TfrmEditorTable.LoadEditImages;
var n:integer;
    emessage:String;
begin
  for n := low(FImages) to High(FImages) do
  if not FImages[n].Modified and FImages[n].CanView then
  begin
    try
      FImages[n].CanView:=true;
      try
        LoadImageFromField(FImages[n].Image,IBOTable.Fields[FImages[n].Image.tag],emessage);
      except
        FImages[n].CanView:=False;
      end;
      fImages[n].TypeLabel.Caption := '...';
      if Assigned(FImages[n].Image) then
      if Assigned(FImages[n].Image.Picture) then
      begin
        fImages[n].TypeLabel.Caption := GraphicType(FImages[n].Image.Picture.Graphic) +
            format(' %d x %d',[
            FImages[n].Image.Picture.Graphic.Width,
            FImages[n].Image.Picture.Graphic.Height]);
      end;
    finally
      FImages[n].Modified := False;
    end;
  end;
end;


procedure TfrmEditorTable.UnloadEditImages;
var n:integer;
begin
  for n := low(FImages) to High(FImages) do
  try
    FImages[n].Image.Picture.Graphic := Nil;
    FImages[n].Modified := False;
    FImages[n].CanView := True;
  except
  end;
end;


procedure TfrmEditorTable.dbgDataSourceDataChange(Sender: TObject;
  Field: TField);
begin
  LoadEditImages;
  fGridField := nil;
end;

procedure TfrmEditorTable.SetImageModified(Sender:TImage);
var n:integer;
begin
  if Assigned(Sender) then
    for n := low(FImages) to High(FImages) do
      if FImages[n].Image = Sender then
      begin
        FImages[n].Modified := true;
        break;
      end;
end;

function GetImage(Sender:TObject):TImage;
begin
  Result := nil;
  if Sender is TMenuItem then
    if TMenuItem(Sender).GetParentMenu is TPopupMenu then
      if TPopupMenu(TMenuItem(Sender).GetParentMenu).PopupComponent is TImage then
        Result := TImage(TPopupMenu(TMenuItem(Sender).GetParentMenu).PopupComponent);
end;

procedure TfrmEditorTable.Savetofile1Click(Sender: TObject);
var x:TImage;
begin
  x:=GetImage(Sender);
  if assigned(x) then
    if assigned(x.Picture.Graphic) then
    begin
      SavePictureDialog1.Filter := GraphicFilter(x.Picture.Graphic);
      SavePictureDialog1.DefaultExt := GraphicExt(x.Picture.Graphic);
      if SavePictureDialog1.Execute then
        x.Picture.SaveToFile(SavePictureDialog1.FileName);
    end;
end;

procedure TfrmEditorTable.Loadfromfile1Click(Sender: TObject);
var x:TImage;
begin
  x:=GetImage(Sender);
  if assigned(x) then
    if OpenPictureDialog1.Execute then
    begin
      x.Picture.LoadFromFile(OpenPictureDialog1.FileName);
      SetImageModified(x);
      if not (IBOTable.State in dseditmodes) then IBOTable.Edit;
    end;
end;

procedure TfrmEditorTable.Copy2Click(Sender: TObject);
var x:TImage;
begin
  x:=GetImage(Sender);
  if assigned(x) then
    if x.Picture.Graphic <> nil then
    begin
      Clipboard.Assign(x.Picture);
      x.Refresh;
    end;
end;

procedure TfrmEditorTable.Paste2Click(Sender: TObject);
var x:TImage;
begin
  x:=GetImage(Sender);
  if assigned(x) then
    if x.Picture.Graphic <> nil then
    begin
      x.Picture.Graphic := GraphicFromClipboard;
      SetImageModified(x);
      x.Refresh;
      if not (IBOTable.State in dseditmodes) then IBOTable.Edit;
    end;
end;

procedure TfrmEditorTable.Cut2Click(Sender: TObject);
var x:TImage;
begin
  x:=GetImage(Sender);
  if assigned(x) then
    if x.Picture.Graphic <> nil then
    begin
      Clipboard.Assign(x.Picture);
      x.Picture.Graphic := nil;
      x.Refresh;
      if not (IBOTable.State in dseditmodes) then
      begin
        IBOTable.Edit;
        IBOTable.Fields[x.tag].Clear;
      end;
    end;
end;

procedure TfrmEditorTable.IBOTableAfterPost(DataSet: TDataSet);
begin
  if pgcProperties.ActivePage = tabData then
    if ScrollBoxData.Visible then
      LoadEditImages;
end;

procedure TfrmEditorTable.dbgDataSourceStateChange(Sender: TObject);
var n:integer;
begin
  if not (dbgDataSource.State in dseditmodes) then
    if pgcProperties.ActivePage = tabData then
      if ScrollBoxData.Visible then
        for n := low(FImages) to High(FImages) do
          FImages[n].Modified := False;
end;

procedure TfrmEditorTable.ActionCopyRecordUpdate(Sender: TObject);
begin
  ActionCopyRecord.Enabled := IBOTable.Active and not IBOTable.IsEmpty;
end;

procedure TfrmEditorTable.ActionCopyRecordExecute(Sender: TObject);
var buffer:array of Variant;
    n:integer;
    err:String;
begin
  if IBOTable.State in dsEditModes then
  begin
    try
      IBOTable.Post;
    except
      on e:exception do
      begin
        LMMessageDlg(e.Message,mtError,[mbOk],0);
        exit;
      end;
    end;
  end;

  SetLength(buffer,IBOTable.FieldCount);
  try
    for n:= 0 to IBOTable.FieldCount-1 do
    begin
      buffer[n] := IBOTable.Fields[n].Value;
    end;
    try
      err:='';
      IBOTable.Append;
      for n:= 0 to IBOTable.FieldCount-1 do
      try
        IBOTable.Fields[n].Value :=  buffer[n];
      except
        on e:exception do
        begin
          err:=err+#13+e.Message;
        end;
      end;
      if err<>'' then
        LMMessageDlg(err,mtError,[mbOk],0);
    except
      on e:exception do
      begin
        LMMessageDlg(e.Message,mtError,[mbOk],0);
        exit;
      end;
    end;
  finally
    SetLength(buffer,0);
  end;
end;

procedure TfrmEditorTable.SignalObjectRefresh(const aDataModule: TDmN;
  const aObjType: integer; const aObjName: String);
begin
  if aDataModule = FDataModule then
  begin
    if (aObjType in [NODE_TABLES,NODE_TABLE]) and (aObjName = ObjectName) then
      ReloadTableData;
  end;
end;


procedure TfrmEditorTable.ReloadTableData;
begin
  FTableData.SystemTable := DataModule.IsSystemTable(fobjname);
  FTableData.Columns.Clear;
  DataModule.GetColumnList(FTableData.Columns,FObjName);
  FTableData.Triggers.Clear;
  DataModule.GetTriggerList(FTableData.Triggers,FObjName);
  FTableData.CheckConst.Clear;
  DataModule.GetCheckConstList(FTableData.CheckConst,FObjName);
  FTableData.Indexes.Clear;
  DataModule.GetIndexList(FTableData.Indexes,FObjName);
  FTableData.UniqueConst.Clear;
  DataModule.GetConstList(FTableData.UniqueConst,FObjName);
  FTableData.RefConst.Clear;
  DataModule.GetReferentialConstList(FTableData.RefConst,FObjName);
  FRefreshList := false;
  GetTableProperties;
end;

type
  TCrackG=class(TCustomGrid)
  end;

procedure TfrmEditorTable.dbgDataMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var r: TRect;
begin
  if Button = mbRight then
  begin
    if Assigned(dbgData.SelectedField) and dbgData.SelectedField.IsBlob then
    begin
      fGridField := dbgData.SelectedField;
      R := TCrackG(dbgData).CellRect(TCrackG(dbgData).Col,TCrackG(dbgData).Row);
      r.TopLeft:=dbgData.ClientToScreen(r.TopLeft);
      r.BottomRight:=dbgData.ClientToScreen(r.BottomRight);
      PopupMenu1.Popup(r.Left,r.Bottom);
    end
    else
      fGridField := Nil;
  end;
end;

procedure SaveToFile(const Field:TField; const FileName: string);
var
  BlobStream: TStream;
  FileStream: TStream;
begin
  FileStream := TFileStream.Create(FileName, fmCreate);
  BlobStream := Field.DataSet.CreateBlobStream(Field, bmRead);
  try
    FileStream.CopyFrom(BlobStream, 0);
  finally
    FileStream.Free;
    BlobStream.Free
  end;
end;

procedure TfrmEditorTable.MenuItem2Click(Sender: TObject);
begin
  if Assigned(fGridField) and SaveDialog1.Execute then
     SaveToFile(fGridField,SaveDialog1.FileName);
end;

end.
