{************************************************************************
  This Unit was modified to be interfaced in IBObjects
  by Lorenzo Mengoni - (Ancona, Italy)

  for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.

                                                                         }
{
08.08.2002, Kalwa:
- BUGFIX: lvObjectsDblClick() did not test for NIL-item in
  lvObjects.Selected if NODE_TABLE was active.

13.August.2002, Lorenzo:
- Adjusted display of description in FillObjectList

21.August.2002, Lorenzo:
- Modified ObjectRefreshList to handle a single Object refresh

23.August.2002, Lorenzo:
- Modified Events for handling the name of the object involved hooked directly to mainform

11.June.2003, Lorenzo:
- Fixed Metadata extraction of Numeric(x,x) sql type
- Modified Generators Handling, now in a single view like IB_SQL

6.December.2003, Lorenzo:
- disabled server access on gds32.dll not present
}

unit frmuMain;
interface
uses
{$IFDEF LINUX}
  Types, Libc, QForms, IBCXDummies, QStdActns, QActnList, QMenus, QTypes,
  QComCtrls, QControls, QExtCtrls, QDialogs,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Forms, Controls, Menus, Dialogs, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, ImgList, ToolWin, Grids, DBGrids, DBCtrls,
  Messages, RichEdit, DB, 
  ActnList, StdActns,
{$ENDIF}
  IB_Components, IB_Session, dmuNode, IBOConsoleForm, IB_Constants,
  IBODataset, IBOExtract, IBOCPersistent, IBOCPersistentIniFile,
  wisql, zluibcClasses, IBOServices, Classes, SysUtils, IB_TransactionBar,
  FrameGeneratorsU;

type
  TEventObjectNotify = procedure (const DataModule: TDmN; const ObjType: integer; const ObjName: String) of object;

type
  TfrmMain = class(TIBOConsoleForm)
    stbMain: TStatusBar;
    MainMenu1: TMainMenu;
    Console1: TMenuItem;
    View1: TMenuItem;
    Server1: TMenuItem;
    Database1: TMenuItem;
    ToolMenu: TMenuItem;
    Help1: TMenuItem;
    Exit2: TMenuItem;
    SystemData2: TMenuItem;
    Large2: TMenuItem;
    Small2: TMenuItem;
    List2: TMenuItem;
    Details1: TMenuItem;
    Register3: TMenuItem;
    UnRegister2: TMenuItem;
    Login2: TMenuItem;
    ServerProperties2: TMenuItem;
    DiagnoseConnection2: TMenuItem;
    UserSecurity2: TMenuItem;
    ServerProperties3: TMenuItem;
    Register4: TMenuItem;
    Unregister3: TMenuItem;
    Connect2: TMenuItem;
    ConnectAs2: TMenuItem; 
    Disconnect2: TMenuItem; 
    CreateDatabase1: TMenuItem;
    DropDatabase1: TMenuItem; 
    ViewMetadata2: TMenuItem; 
    Properties4: TMenuItem; 
    BackupRestore1: TMenuItem; 
    Backup2: TMenuItem;
    Restore2: TMenuItem; 
    EditBackupAlias1: TMenuItem;
    TransactionRecovery2: TMenuItem; 
    Shutdown2: TMenuItem;
    DatabaseRestart2: TMenuItem; 
    DatabaseStatistics2: TMenuItem;
    Sweep2: TMenuItem; 
    Validation2: TMenuItem;
    InteractiveSQL2: TMenuItem;
    Configure1: TMenuItem; 
    Contents2: TMenuItem; 
    TopicSearch1: TMenuItem;
    RemoveAlias2: TMenuItem;
    About2: TMenuItem; 
    N18: TMenuItem; 
    N19: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem; 
    N22: TMenuItem; 
    N23: TMenuItem;
    N24: TMenuItem; 
    N25: TMenuItem; 
    tvMain: TTreeView; 
    ServerLogout: TAction; 
    ServerSecurity: TAction; 
    DatabaseDisconnect: TAction;
    DatabaseProperties: TAction; 
    DatabaseSweep: TAction;
    DatabaseRecoverTrans: TAction; 
    DatabaseStatistics: TAction; 
    DatabaseMetadata: TAction;
    DatabaseShutdown: TAction; 
    DatabaseRestart: TAction; 
    DatabaseDrop: TAction;
    ServerLogin: TAction;
    DatabaseRegister: TAction;
    DatabaseUnregister: TAction; 
    DatabaseConnect: TAction; 
    DatabaseConnectAs: TAction; 
    DatabaseCreate: TAction; 
    ExtToolsLaunchISQL: TAction; 
    ExtToolsConfigure: TAction; 
    DatabaseBackup: TAction; 
    DatabaseRestore: TAction; 
    BackupRestoreModifyAlias: TAction; 
    ExtToolDropDown: TAction; 
    pmDatabaseActions: TPopupMenu;
    Connect1: TMenuItem; 
    ConnectAs1: TMenuItem;
    CreateDatabase2: TMenuItem;
    Register1: TMenuItem;
    N1: TMenuItem;
    pmDatabaseConnectedActions: TPopupMenu; 
    Disconnect1: TMenuItem; 
    Properties1: TMenuItem;
    Sweep1: TMenuItem;
    TransactionRecovery1: TMenuItem;
    DatabaseStatistics3: TMenuItem; 
    ViewMetadata1: TMenuItem; 
    Maintenance1: TMenuItem; 
    BackupRestore2: TMenuItem;
    EditBackupAlias3: TMenuItem; 
    RemoveAlias3: TMenuItem; 
    Backup1: TMenuItem;
    Restore1: TMenuItem;
    pmServer: TPopupMenu; 
    Logout1: TMenuItem; 
    Login1: TMenuItem;
    DiagnoseConnection1: TMenuItem;
    AddCertificate3: TMenuItem; 
    Register2: TMenuItem; 
    UserSecurity1: TMenuItem; 
    UnRegister1: TMenuItem; 
    ViewLogfile1: TMenuItem; 
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem; 
    N5: TMenuItem; 
    pmBackupRestore: TPopupMenu; 
    EditBackupAlias4: TMenuItem; 
    Backup3: TMenuItem; 
    Restore3: TMenuItem; 
    N6: TMenuItem;
    ServerProperties: TAction; 
    pmDatabases: TPopupMenu; 
    Register5: TMenuItem;
    CreateDatabase3: TMenuItem; 
    N7: TMenuItem; 
    ViewServerLog: TAction;
    UserAdd: TAction; 
    UserModify: TAction;
    UserDelete: TAction; 
    pmUsers: TPopupMenu; 
    actMain: TActionList; 
    ConsoleExit: TAction; 
    ViewList: TAction;
    ViewReport: TAction;
    ViewIcon: TAction; 
    ViewSmallIcon: TAction;
    ViewProperties: TAction; 
    ViewSystem: TAction; 
    HelpContents: THelpContents;
    HelpOnHelp: THelpOnHelp;
    HelpTopicSearch: THelpTopicSearch; 
    HelpAbout: TAction; 
    EditCopy: TEditCopy; 
    EditCut: TEditCut;
    EditPaste: TEditPaste; 
    EditSelectAll: TEditSelectAll;
    EditUndo: TEditUndo; 
    ServerRegister: TAction; 
    ServerUnregister: TAction; 
    ServerConnection: TAction; 
    N8: TMenuItem;
    BackupRestoreRemoveAlias: TAction;
    DeleteAlias1: TMenuItem; 
    N9: TMenuItem; 
    N01: TMenuItem; 
    Shutdown3: TMenuItem; 
    DatabaseRestart1: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem; 
    N13: TMenuItem; 
    DeleteAlias2: TMenuItem; 
    N14: TMenuItem; 
    EditPopup: TPopupMenu;
    Cut1: TMenuItem; 
    Copy1: TMenuItem; 
    Paste1: TMenuItem; 
    N15: TMenuItem;
    SelectAll1: TMenuItem; 
    DatabaseValidate: TAction; 
    N17: TMenuItem; 
    Validation1: TMenuItem;
    Unregister4: TMenuItem; 
    splVertical: TSplitter; 
    N27: TMenuItem; 
    Properties2: TMenuItem; 
    ServerActionProps: TAction; 
    DatabaseActionsProperties: TAction; 
    pmDBObjects: TPopupMenu;
    ObjectDescription: TAction;
    ObjectCreate: TAction;
    ObjectModify: TAction; 
    ObjectDelete: TAction; 
    ObjectExtract: TAction; 
    EditFont: TAction; 
    WindowList: TAction;
    ObjectProperties: TAction; 
    Properties5: TMenuItem;
    Maintenance2: TMenuItem;
    N16: TMenuItem; 
    N10: TMenuItem; 
    ViewLogfile2: TMenuItem;
    actDatabaseBackup: TAction;
    DBCRestore: TAction;
    lvObjects: TListView; 
    AddUser1: TMenuItem; 
    ModifyUser1: TMenuItem; 
    DeleteUser1: TMenuItem;
    DatabaseUsers: TAction; 
    DiagnoseConnection3: TMenuItem; 
    ConnectedUsers1: TMenuItem; 
    N26: TMenuItem;
    N28: TMenuItem;
    ObjectRefresh: TAction; 
    Refresh1: TMenuItem; 
    ConnectAs3: TMenuItem; 
    pmWindows: TPopupMenu;
    Test1: TMenuItem;
    HighlightOptions: TAction; 
    ToolBar2: TToolBar; 
    ToolButton1: TToolButton; 
    ToolButton5: TToolButton; 
    ToolButton8: TToolButton;
    ToolButton9: TToolButton; 
    ToolButton10: TToolButton; 
    ToolButton6: TToolButton; 
    ToolButton41: TToolButton;
    ToolButton2: TToolButton;
    pmTablesNode: TPopupMenu;
    NewTable1: TMenuItem;
    New1: TMenuItem;
    Drop1: TMenuItem;
    IB_TransactionBarDDL: TIB_TransactionBar;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    IB_TransactionBarDefault: TIB_TransactionBar;
    Windows1: TMenuItem;
    DatabaseWindows: TAction;
    DatabaseWindows1: TMenuItem;
    ActionOptions: TAction;
    Options1: TMenuItem;
    N30: TMenuItem;
    Refresh2: TMenuItem;
    Refresh3: TMenuItem;
    FrameGenerators1: TFrameGenerators;
    actHighlightOptions: TAction;
    HighlightOptions2: TMenuItem;
    ActionQueryBuilder: TAction;
    procedure FormClose(Sender: TObject; var Action: TCloseAction); 
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject); 
    procedure lvObjectsChange(Sender: TObject; Item: TListItem; Change: TItemChange); 
    procedure lvObjectsDblClick(Sender: TObject); 
    procedure tvMainChange(Sender: TObject; Node: TTreeNode); 
    procedure tvMainDblClick(Sender: TObject); 
    procedure tvMainDeletion(Sender: TObject; Node: TTreeNode); 
    procedure tvMainExpanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean); 
    procedure mmiHeContentsClick(Sender: TObject); 
    procedure mmiHeOverviewClick(Sender: TObject); 
    procedure mmiHeUsingHelpClick(Sender: TObject);
    procedure tvMainKeyPress(Sender: TObject; var Key: Char); 
    procedure tvMainMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject); 
    procedure lvActionsDblClick(Sender: TObject); 
    procedure lvObjectsKeyDown(Sender: TObject; var Key: Word; 
      Shift: TShiftState); 
    procedure ConsoleExitExecute(Sender: TObject); 
    procedure DatabaseShutdownExecute(Sender: TObject); 
    procedure DatabaseRegisterExecute(Sender: TObject); 
    procedure DatabaseUnregisterExecute(Sender: TObject); 
    procedure DatabaseConnectExecute(Sender: TObject); 
    procedure DatabaseConnectAsExecute(Sender: TObject); 
    procedure DatabaseDisconnectExecute(Sender: TObject);
    procedure ToolsStatisticsExecute(Sender: TObject);
    procedure ToolsSweepExecute(Sender: TObject);
    procedure ToolsSQLExecute(Sender: TObject); 
    procedure ServerViewLogExecute(Sender: TObject);
    procedure DatabaseRestartExecute(Sender: TObject); 
    procedure ToolsTransRecoverExecute(Sender: TObject); 
    procedure DatabaseCreateExecute(Sender: TObject); 
    procedure DatabaseDropExecute(Sender: TObject); 
    procedure ToolsValidationExecute(Sender: TObject);
    procedure DatabasePropertiesExecute(Sender: TObject);
    procedure DatabaseRestoreExecute(Sender: TObject);
    procedure HelpAboutExecute(Sender: TObject); 
    procedure BackupRestoreModifyAliasExecute(Sender: TObject); 
    procedure ServerDiagConnectionExecute(Sender: TObject); 
    procedure ServerLoginExecute(Sender: TObject); 
    procedure ServerLogoutExecute(Sender: TObject);
    procedure ServerPropertiesExecute(Sender: TObject); 
    procedure ServerRegisterExecute(Sender: TObject);
    procedure ServerUnregisterExecute(Sender: TObject);
    procedure ServerSecurityExecute(Sender: TObject); 
    procedure ViewSystemDataExecute(Sender: TObject); 
    procedure DatabaseBackupExecute(Sender: TObject); 
    procedure DatabaseMetadataExecute(Sender: TObject); 
    procedure ViewListExecute(Sender: TObject); 
    procedure ViewListUpdate(Sender: TObject);
    procedure ViewReportExecute(Sender: TObject); 
    procedure ViewReportUpdate(Sender: TObject); 
    procedure ViewIconExecute(Sender: TObject); 
    procedure ViewIconUpdate(Sender: TObject); 
    procedure ViewSmallIconExecute(Sender: TObject); 
    procedure ViewSmallIconUpdate(Sender: TObject);
    procedure DatabaseConnectedActionsUpdate(Sender: TObject);
    procedure ServerActionsUpdate(Sender: TObject);
    procedure ServerConnectedUpdate(Sender: TObject); 
    procedure DatabaseRegisterUpdate(Sender: TObject); 
    procedure DatabaseActionsUpdate(Sender: TObject);
    procedure ExtToolsConfigureExecute(Sender: TObject); 
    procedure ExtToolDropDownExecute(Sender: TObject); 
    procedure ExtToolLaunchExecute(Sender: TObject); 
    procedure BackupRestoreUpdate(Sender: TObject);
    procedure DatabaseCreateUpdate(Sender: TObject); 
    procedure listViewEnter(Sender: TObject); 
    procedure frmMainDestroy(Sender: TObject); 
    procedure BackupRestoreRemoveAliasExecute(Sender: TObject); 
    procedure BackupRestoreAliasUpdate(Sender: TObject); 
    procedure DatabasePropertiesUpdate(Sender: TObject);
    procedure DatabaseValidateUpdate(Sender: TObject); 
    procedure ObjectDescriptionUpdate(Sender: TObject);
    procedure ObjectExtractExecute(Sender: TObject);
    procedure ObjectDeleteUpdate(Sender: TObject);
    procedure ObjectDeleteExecute(Sender: TObject); 
    procedure ViewSystemUpdate(Sender: TObject); 
    procedure FormShow(Sender: TObject); 
    procedure lvObjectsContextPopup(Sender: TObject; MousePos: TPoint; 
      var Handled: Boolean); 
    procedure tvMainCollapsing(Sender: TObject; Node: TTreeNode; 
      var AllowCollapse: Boolean); 
    procedure ServerPropertiesUpdate(Sender: TObject); 
    procedure UserDeleteUpdate(Sender: TObject); 
    procedure UserAddExecute(Sender: TObject);
    procedure UserModifyExecute(Sender: TObject);
    procedure UserModifyUpdate(Sender: TObject); 
    procedure UserDeleteExecute(Sender: TObject); 
    procedure ServerUsersExecute(Sender: TObject); 
    procedure ObjectModifyUpdate(Sender: TObject); 
    procedure DatabaseShutdownUpdate(Sender: TObject);
    procedure ObjectRefreshExecute(Sender: TObject);
    procedure ToolsSQLExecute1(Sender: TObject); 
    procedure WindowListUpdate(Sender: TObject); 
    procedure pmWindowsPopup(Sender: TObject); 
    procedure WindowMenuOnClick(Sender: TObject);
    procedure ExtToolsLaunchISQLUpdate(Sender: TObject);
    procedure ObjectCreateExecute(Sender: TObject);
    procedure ObjectCreateUpdate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure WindowListExecute(Sender: TObject);
    procedure DatabaseWindowsUpdate(Sender: TObject);
    procedure DatabaseWindowsExecute(Sender: TObject);
    procedure ActionOptionsExecute(Sender: TObject);
    procedure lvObjectsEditing(Sender: TObject; Item: TListItem;
      var AllowEdit: Boolean);
    procedure actHighlightOptionsExecute(Sender: TObject);
    procedure actHighlightOptionsUpdate(Sender: TObject);
    procedure ActionQueryBuilderUpdate(Sender: TObject);

  private
    { Private declarations } 
    FErrorState: boolean; 
    FCurrSelServer: TibcServerNode;
    F_CurrSelDatabase: TibcDatabaseNode;
    FCurrSelTreeNode: TibcTreeNode;
    FPrevSelTreeNode: TibcTreeNode;
    FRefetch,
    FViewSystemData: Boolean;
    FToolMenuIdx: integer;
    FLastActions: string;
    FNilDatabase: TIB_Connection;

    function DoDBDisconnect(SelDatabaseNode: TibcDatabaseNode): boolean;
    function GetBackupFiles(const SelServerNode: TibcServerNode): integer; 
    function GetDatabases(const SelServerNode: TibcServerNode): integer; 
    function GetDDLScript: integer; 
    function GetDBObjects(const SelDatabaseNode: TibcDatabaseNode; const SelTreeNode: TibcTreeNode; const ObjType: integer): integer; 
    function GetServers: integer; 
    function GetUsers(const SelServerNode: TibcServerNode; const SelTreeNode: TibcTreeNode): integer;
 
    function RegisterBackupFile(const SelServerNode: TibcServerNode; 
      const SourceDBAlias,BackupAlias: string; 
      BackupFiles: TStringList): boolean;

    // kris start 
    procedure AddServerNode(const ServerNodeName: string; ServerProps: TibcServerProps; Password: string = ''); 
    function RegisterServer(const ServerAlias: string; ServerProps: TibcServerProps): boolean;
    function UnRegisterServer(const ServerAlias: String): boolean; 

    procedure AddDatabaseNode(const SelServerNode: TibcServerNode; const DatabaseNodeName: string; 
      const dbProps: TibcDatabaseProps; const Password: string; NewDatabase: TIB_Connection); 
    function RegisterDatabase(const ServerAlias, DatabaseAlias: string; dbProps: TibcDatabaseProps): boolean; 
    function UnregisterDatabase(const ServerAlias, DatabaseAlias: string): boolean; 
    // kris end 
    function IsDBRegistered(const DBFile : String; var ExistingDBAlias : String) : Boolean; 
    procedure DeleteNode(const Node: TTreeNode; const ChildNodesOnly: boolean); 
    function DoServerLogin(const SilentLogin: boolean): boolean; 
    procedure FillObjectList(const CurrSelNode: TibcTreeNode); 
    procedure InitTreeView; 
    procedure ReadPersistentInfo; 
    procedure SavePersistentInfo;
    procedure AddTreeRootNode(const ObjType: Integer; const Parent: TTreeNode);
    procedure FillActionList(const Action: String); 
    procedure AutoSizelvColumns;
 
    { WISQL Event Methods } 
    procedure EventDatabaseCreate(var Database: TIB_Connection); 
    procedure EventDatabaseDrop;
    procedure NewTable;
    procedure NewDomain;
    procedure NewException;
    procedure NewProcedure;
    procedure NewFunction;
    procedure NewView;
    procedure NewRole;
    procedure NewFilter;
    procedure SetMainIcon(f: TForm);
    procedure SetObjectIcon(f: TForm);
    procedure SetErrorState(const Value:boolean);
    procedure SetCurrSelDatabase(const Value: TibcDatabaseNode);
    procedure OnStartProc(Sender: TObject);

  public
    { Public declarations }
    constructor Create(aOwner:TComponent); override;
    procedure EventObjectNew(const DataModule: TDmN; const ObjType: integer; const ObjName:String);
    procedure EventObjectDrop(const DataModule: TDmN; const ObjType: integer; const ObjName:String);
    procedure EventObjectRefresh(const DataModule: TDmN; const ObjType: integer; const ObjName:String='');
    procedure RefreshUsers(const ServerNode: TibcServerNode);
    function DoDatabaseCreate: boolean;
    procedure CheckUserList(ServerNode: TibcServerNode);
    procedure ObjectListRefresh(const DataModule: TDmN; const ObjType: integer; const ObjectName:String='');
    procedure RenameTreeNode(SelTreeNode: TibcTreeNode; NewNodeName: string);
    procedure DisplayWindow(Sender: TObject);
    function DoDBConnect(const SelServerNode: TibcServerNode; 
      SelDatabaseNode: TibcDatabaseNode; 
      const SilentLogin: boolean; refresh:boolean): boolean; 
    { WISQL hooks for main form objects } 
    function CreateDatabase(Sender: TObject): boolean; 
    function ConnectAsDatabase(Sender: TObject): boolean; 
    procedure ShowWindows(DataModule:TDmN = Nil);
    property CurrSelServer: TibcServerNode read FCurrSelServer write FCurrSelServer;
    property CurrSelDatabase: TibcDatabaseNode read F_CurrSelDatabase write SetCurrSelDatabase;
    property ErrorState: boolean read FErrorState write SetErrorState;
  end;

var 
  frmMain: TfrmMain;
 
implementation 
{$IF Declared(Forms)}
{$R *.DFM}
{$IFEND}
{$IF Declared(QForms)}
{$R *.xfm}
{$IFEND}
uses
{$IFDEF LINUX}
  Qt, QGraphics,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Graphics, CommCtrl, 
{$ENDIF}
{$IFNDEF NOT_YET_IN_KYLIX}
  frmuModifyServerAlias,
{$ENDIF}
  frmuUser, frmuDBConnections, frmuServerProperties, frmEditorOptionsU,
  frmuAbout, IBOCGlobal, frmuDBRegister, frmuServerRegister, dmuMain, 
  frmuDBConnect, frmuServerLogin, zluUtility, frmuMessage, frmuCommDiag, 
  frmuDBBackup, frmuDBRestore, frmuDBValidation, frmuDBStatistics, frmuDBTransactions, 
  zluContextHelp, zluSQL, frmuDisplayBlob, frmuTools,
  frmuWindowList, IB_Header, frmuDBCreate, frmuTextViewer, IBOAdminUtils,
  frmuDBProperties, frmuDBShutdown, frmuBackupAliasProperties, frmuEditorField,
  frmuEditorDomain,
  frmuEditorException, frmuEditorStoredProcedure, frmuEditorUDF,
  frmuEditorFilter, frmuEditorView, frmuEditorRole, frmuEditorTable,
  frmuIBOConsoleOptions, IBOCPersistentTypes,
  IBOCPersistentWinReg, IniFiles, LMMessageDialog, frmuDBFind;
const
  ACTIONS = 0; 
  OBJECTS = 1; 
  STATIC = 2; 
  SYSDBA_ONLY = 999; 
 
{$IFDEF MSWINDOWS} 
var 
  { To detect multiple instances, we will replace the window proc with our 
    own and create our own message }
  OldWindowProc: Pointer; 
  IBOConsole_msg: DWORD;
 
function IBOConsoleWindowProc(WindowHandle : hWnd;
                             TheMessage   : LongInt; 
                             ParamW       : LongInt; 
                             ParamL       : LongInt) : LongInt stdcall; 
begin 
  if TheMessage = LongInt(IBOConsole_msg)  then
  begin 
    SendMessage(Application.handle, WM_SYSCOMMAND, SC_RESTORE, 0); 
    SetForegroundWindow(Application.Handle); 
    Result := 0;
    exit; 
  end; 
  {Call the original winproc} 
  Result := CallWindowProc(OldWindowProc, 
                           WindowHandle, 
                           TheMessage, 
                           ParamW, 
                           ParamL);
end; 
{$ENDIF} 
 
{$IFDEF MSWINDOWS} 
function GetNodeHandle(Node: TTreeNode): HTreeItem; 
begin 
  Result := Node.ItemId; 
end;
{$ENDIF} 
{$IFDEF LINUX} 
function GetNodeHandle(Node: TTreeNode): QListViewItemH; 
begin 
  Result := Node.Handle; 
end; 
{$ENDIF} 
 
 
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction); 
begin 
  gApplShutdown := true;
  SavePersistentInfo;
  // kris kylix
//  FWindowList.Free; 
  FreeAndNil(OpenWindows); 
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  conffile:String;
  langId:string;
  langFile:string;
{$IFDEF MSWINDOWS}
  tmpInfo,s: TibcPersistentInfo;
{$ENDIF}
begin
  OnStart := OnStartProc;
{$IFDEF MSWINDOWS}
  {First, setup a handler for detecting multiple instances }
  IBOConsole_msg := RegisterWindowMessage('ibo_console_mtx');
  {Set window proc to IBOConsoleWindowProc. Save the old one}
  ImageIndex := NODE_PROGRAM_ICON_IMG;
{$ENDIF}

  FErrorState := false;
  FNilDatabase := nil;
  stbMain.Height := 19;
  tvMain.Width := Width div 3;

  gApplShutdown := false;
  gExternalApps := nil;
  FCurrSelServer := nil;
  F_CurrSelDatabase := nil;
  FCurrSelTreeNode := nil;
  FPrevSelTreeNode := nil;
  try
{$IFDEF MSWINDOWS}
    SetLength(gWinTempPath, MAX_PATH);
    GetTempPath(MAX_PATH,PChar(gWinTempPath));
{$ENDIF}
    // creation of FWindowList moved before creation FTableData
    // kris Kylix
    OpenWindows := TIBOCWindowList.Create(Self);
    // this might raise an exception eg when gds32.dll not available
    FLastActions := '';
    FRefetch := false;
    InitTreeView;
{$IFDEF MSWINDOWS}
//    conffile := GetEnvironmentVariable('USERPROFILE');
//    if conffile = '' then conffile := GetEnvironmentVariable('HOMEPATH');
//    if conffile = '' then conffile := ExtractFilePath(Application.ExeName);
    conffile := dmMain.JvComputerInfoEx1.Folders.Profile+'\.iboconsole';
    ForceDirectories(conffile);
    conffile := conffile+'\'+lowercase(ExtractFileName(ChangeFileExt(Application.ExeName,'.ini')));
    if not FileExists(conffile) then
    begin
      gPersistentInfo := TIBOCWinRegPersistentInfo.Create;
      tmpInfo := TibcIniPersistentInfo.Create(conffile);
      try
        ReadPersistentInfo;
        tmpInfo.assign(gPersistentInfo);
        s:= gPersistentInfo;
        gPersistentInfo := tmpInfo;
        tmpInfo := s;
        SavePersistentInfo;
      finally
        tmpInfo.Free;
      end;
    end
    else
    begin
      gPersistentInfo := TibcIniPersistentInfo.Create(conffile);
      ReadPersistentInfo;
    end;
{$ENDIF}
{$IFDEF LINUX}
    conffile := GetEnv('HOME') + '/.iboconsole/iboconsole.conf';
    PersistentInfo := TibcIniPersistentInfo.Create(conffile);
    ReadPersistentInfo;
{$ENDIF}
    langId:= gAppSettings[GUI_LANGUAGE];
    if langId<>'en' then
    begin
      langFile := ChangeFileExt(Application.ExeName,'.lang.'+langId);
      if FileExists(langFile) then
        gGUILanguageFile := TIniFile.Create(langFile);
    end;
    UseFont(gAppSettings[FONT_NAME],gAppSettings[FONT_CHARSET]);
    tvMain.Selected := tvMain.Items[0];
    tvMainChange(nil, nil);
    FToolMenuIdx := ToolMenu.Count;
    FrameGenerators1.ParentResize;


  except
    gApplShutdown := true;
    raise;
  end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  try
    FreeAndNil(gPersistentInfo);
  except
  end;
  try
    if Assigned(gExternalApps) then
      gExternalApps.Free;
  except
  end;
end; 
 
{**************************************************************** 
* 
*  l v O b j e c t L i s t C h a n g e ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input:  Sender - The object that initiated the event 
*          Item - The list item that just changed 
*          Change - The type of change that just occurred 
* 
*  Return: None 
* 
*  Description: This procedure enables/disables controls based on the 
*               the selected treenode 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
procedure TfrmMain.lvObjectsChange(Sender: TObject; Item: TListItem; Change: TItemChange); 
var 
  lTreeNode: TTreeNode; 
begin 
  if Assigned(lvObjects.Selected) then
  begin 
    case FCurrSelTreeNode.NodeType of 
      NODE_SERVERS: 
      begin 
        if Assigned(lvObjects.Selected.Data) then 
        begin 
          if TObject(lvObjects.Selected.Data) is TTreeNode then 
          begin 
            lTreeNode := tvMain.Items.GetNode(GetNodeHandle(TTreeNode(lvObjects.Selected.Data))); 
            FCurrSelServer := TibcServerNode(lTreeNode.Data); 
          end; 
        end;
      end; 
 
      NODE_DATABASES: 
      begin 
        if Assigned(lvObjects.Selected.Data) then 
        begin 
          if TObject(lvObjects.Selected.Data) is TTreeNode then 
          begin 
            lTreeNode := tvMain.Items.GetNode(GetNodeHandle(TTreeNode(lvObjects.Selected.Data))); 
            FCurrSelServer := TibcServerNode(lTreeNode.Parent.Parent.Data); 
            CurrSelDatabase := TibcDatabaseNode(lTreeNode.Data);
          end; 
        end; 
      end; 
 
      NODE_BACKUP_ALIASES:
      begin
        if Assigned(lvObjects.Selected.Data) then 
        begin 
          if TObject(lvObjects.Selected.Data) is TTreeNode then 
          begin 
            lTreeNode := tvMain.Items.GetNode(GetNodeHandle(TTreeNode(lvObjects.Selected.Data))); 
            FCurrSelServer := TibcServerNode(lTreeNode.Parent.Parent.Data); 
            FCurrSelTreeNode := TibcTreeNode(lTreeNode.Data);
          end; 
        end
      end;
    end;
  end
end;
 
{**************************************************************** 
* 
*  l v O b j e c t L i s t D b l C l i c k ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input:  Sender - The object that initiated the event 
* 
*  Return: None 
* 
*  Description: This procedure determines what action takes place 
*               during a double click depending on the type of the 
*               selected treenode 
*
*****************************************************************
* Revisions:  Lorenzo Mengoni 2001-12-30
*
*****************************************************************}
procedure TfrmMain.lvObjectsDblClick(Sender: TObject);
var
  fd:TfrmDomains;
  fe:TfrmExceptions;
  fs:TfrmStoredProcedure;
  fu:TfrmUDFEditor;
  fo:TfrmEditorTable;
  ff:TFrmEditorFilter;
  fv:TfrmViewEditor;
  fr:TfrmRole;
begin
  if (Sender is TListView) and ((Sender as TListView).Tag = ACTIONS) then
    lvActionsDblClick(Sender)
  else
  begin
    case FCurrSelTreeNode.NodeType of
      NODE_USERS:
      begin
        if Assigned(FCurrSelServer) then
        begin
          if lvObjects.SelCount > 0 then
            frmuUser.UserInfo(FCurrSelServer,lvObjects.Selected.Caption)
          else
            frmuUser.UserInfo(FCurrSelServer,'');
        end;
      end;

      NODE_DOMAINS:
      if Assigned(lvObjects.Selected) then
      begin
        fd := OpenWindows.FindWindow(CurrSelDatabase.DataModule,
                                     NODE_DOMAINS,
                                     lvObjects.Selected.Caption) as TfrmDomains;
        if not Assigned(fd) then
        begin
          fd:=TfrmDomains.Create(Application);
          fd.DataModule := CurrSelDatabase.DataModule;
          fd.ObjectName := lvObjects.Selected.Caption;
          SetObjectIcon(fd);
          OpenWindows.Add(fd.Caption,fd);
        end;
        fd.Show;
      end;

      NODE_EXCEPTIONS:
      if Assigned(lvObjects.Selected) then
      begin
        fe := OpenWindows.FindWindow(CurrSelDatabase.DataModule,
                                     NODE_EXCEPTIONS,
                                     lvObjects.Selected.Caption) as TfrmExceptions;
        if not Assigned(fe) then
        begin
           fe:=TfrmExceptions.Create(Application);
           fe.DataModule := CurrSelDatabase.DataModule;
           fe.ObjectName := lvObjects.Selected.Caption;
           SetObjectIcon(fe);
           OpenWindows.Add(fe.Caption,fe);
        end;
        fe.Show;
      end;

      NODE_PROCEDURES:
      if Assigned(lvObjects.Selected) then
      begin
        fs := OpenWindows.FindWindow(CurrSelDatabase.DataModule,
                                     NODE_PROCEDURES,
                                     lvObjects.Selected.Caption) as TfrmStoredProcedure;
        if not Assigned(fs) then
        begin
          fs:=TfrmStoredProcedure.Create(Application);
          fs.DataModule := CurrSelDatabase.DataModule;
          fs.ObjectName := lvObjects.Selected.Caption;
          SetObjectIcon(fs);
          OpenWindows.Add(fs.Caption,fs);
        end;
        fs.Show;
      end;

      NODE_FUNCTIONS:
      if Assigned(lvObjects.Selected) then
      begin
        fu := OpenWindows.FindWindow(CurrSelDatabase.DataModule,
                                     NODE_FUNCTIONS,
                                     lvObjects.Selected.Caption) as TfrmUDFEditor;
        if not Assigned(fu) then
        begin
          fu:=TfrmUDFEditor.Create(Application);
          fu.DataModule := CurrSelDatabase.DataModule;
          fu.ObjectName := lvObjects.Selected.Caption;
          SetObjectIcon(fu);
          OpenWindows.Add(fu.Caption,fu);
        end;
        fu.Show;
      end;

      NODE_BLOB_FILTERS:
      if Assigned(lvObjects.Selected) then
      begin
        ff := OpenWindows.FindWindow(CurrSelDatabase.DataModule,
                                     NODE_BLOB_FILTERS,
                                     lvObjects.Selected.Caption) as TFrmEditorFilter;
        if not Assigned(ff) then
        begin
          ff:=TFrmEditorFilter.Create(Application);
          ff.DataModule := CurrSelDatabase.DataModule;
          ff.ObjectName := lvObjects.Selected.Caption;
          SetObjectIcon(ff);
          OpenWindows.Add(ff.Caption,ff);
        end;
        ff.Show;
      end;

      NODE_VIEWS:
      if Assigned(lvObjects.Selected) then
      begin
        fv := OpenWindows.FindWindow(CurrSelDatabase.DataModule,
                                     NODE_VIEWS,
                                     lvObjects.Selected.Caption) as TfrmViewEditor;
        if not Assigned(fv) then
        begin
          fv:=TfrmViewEditor.Create(Application);
          fv.DataModule := CurrSelDatabase.DataModule;
          fv.ObjectName := lvObjects.Selected.Caption;
          SetObjectIcon(fv);
          OpenWindows.Add(fv.Caption,fv);
        end;
        fv.Show;
      end;

      NODE_ROLES:
      if Assigned(lvObjects.Selected) then
      begin
        fr := OpenWindows.FindWindow(CurrSelDatabase.DataModule,
                                     NODE_ROLES,
                                     lvObjects.Selected.Caption) as TfrmRole;
        if not Assigned(fr) then
        begin
          fr:=TfrmRole.Create(Application);
          fr.DataModule := CurrSelDatabase.DataModule;
          fr.ObjectName := lvObjects.Selected.Caption;
          SetObjectIcon(fr);
          OpenWindows.Add(fr.Caption,fr);
        end;
        fr.Show;
      end;

      NODE_TABLES:
      if Assigned(lvObjects.Selected) then
       begin
        fo := OpenWindows.FindWindow(CurrSelDatabase.DataModule,
                                     FCurrSelTreeNode.NodeType,
                                     lvObjects.Selected.Caption) as TfrmEditorTable;
        if not Assigned(fo) then
        begin
          fo := TfrmEditorTable.Create(Application);
          fo.DataModule := CurrSelDatabase.DataModule;
          fo.InitDlg(lvObjects.Selected.Caption,
                     FViewSystemData,
                     FRefetch);
          SetObjectIcon(fo);
          OpenWindows.Add(fo.Caption,fo);
        end;
        fo.Show;
      end;
    end;
  end;
end;

function FindItem(ListView: TListView; aCaption:String): TListItem;
var n:integer;
begin
  Result := nil;
  for n := 0 to ListView.Items.Count-1 do
  if ListView.Items[n].Caption = aCaption then
  begin
    Result := ListView.Items[n];
    Break;
  end;
end;

function ReplaceCrLf(const Text:String):String;
begin
  Result:=Text;
  Result := StringReplace(Result,CRLF,' ',[rfReplaceAll]);
  Result := StringReplace(Result,#10,' ',[rfReplaceAll]);
end;

{****************************************************************
*
*  t v M a i n C h a n g e ( )
*
****************************************************************
*  Author: The Client Server Factory Inc.
*  Date:   March 1, 1999
*
*  Input:  Sender - The object that initiated the event
*
*  Return: None
*
*  Description: This procedure controls what actions can take place when
*               the user selectes a treenode
*
*****************************************************************
* Revisions:
*
*****************************************************************}
procedure TfrmMain.tvMainChange(Sender: TObject; Node: TTreeNode);
var
  bProps: TibcBackupProps;
  procedure AssignProps;
  begin
    FCurrSelServer := TibcServerNode(tvMain.Selected.Parent.Parent.Parent.Data);
    CurrSelDatabase := TibcDatabaseNode(tvMain.Selected.Parent.Data);
    // 'if' added to work around spurious OnChange event in early CLX
    if CurrSelDatabase.DataModule.Connection.Connected then
    begin
      stbMain.Panels[1].Text := Format('%s: %s',[GetLangText('Database'),CurrSelDatabase.NodeName]);
      if (FCurrSelTreeNode.ObjectList.Count = 0) or
         (FCurrSelTreeNode.ShowSystem <> FViewSystemData) then
      begin
        GetDBObjects(CurrSelDatabase, FCurrSelTreeNode, FCurrSelTreeNode.NodeType);
        FCurrSelTreeNode.ShowSystem := FViewSystemData;
      end;
      FillObjectList (FCurrSelTreeNode);
      lvObjects.PopupMenu := pmDBObjects;
    end;
  end;

  procedure AssignPropsGenerators;
  begin
    FCurrSelServer := TibcServerNode(tvMain.Selected.Parent.Parent.Parent.Data);
    CurrSelDatabase := TibcDatabaseNode(tvMain.Selected.Parent.Data);
    // 'if' added to work around spurious OnChange event in early CLX
    if CurrSelDatabase.DataModule.Connection.Connected then
    begin
      stbMain.Panels[1].Text := Format('%s: %s',[GetLangText('Database'),CurrSelDatabase.NodeName]);
      FCurrSelTreeNode.ShowSystem := FViewSystemData;
      lvObjects.PopupMenu := pmDBObjects;
    end;
  end;


var Item : TListItem;
    bItemSelected:boolean;
    ItemCaption:String;
begin
  Item := lvObjects.Selected;
  bItemSelected := Assigned(Item);
  if bItemSelected then
    ItemCaption := Item.Caption;
  stbMain.Panels[0].Text := '';
  stbMain.Panels[1].Text := '';
  stbMain.Panels[2].Text := '';
  stbMain.Panels[3].Text := '';
  try
    // kris alfa 2 added check if Data assigned
    if Assigned(tvMain.Selected) and Assigned(tvMain.Selected.Data) then
    // kris afla 2 end
    begin
      tvMain.PopupMenu := nil;
      lvObjects.PopupMenu := nil;
      FCurrSelTreeNode := TibcTreeNode(tvMain.Selected.Data);

      if (not Assigned(FPrevSelTreeNode)) and (Assigned(FCurrSelTreeNode)) then
        FPrevSelTreeNode := FCurrSelTreeNode;

      case FCurrSelTreeNode.NodeType of
        NODE_LOGS:
        begin
          FillActionList('Log');
        end;

        NODE_SERVERS:
        begin
          // kris afla 2 start
          // to disable LanuchISQL action
          FCurrSelServer := nil;
          // kris alfa 2 end
          GetServers;
          FillObjectList(FCurrSelTreeNode);
          tvMain.PopupMenu := pmServer;
        end;

        NODE_SERVER:
        begin
          FCurrSelServer := TibcServerNode(tvMain.Selected.Data);
          tvMain.PopupMenu := pmServer;
          if FCurrSelServer.Server.Active then
            FillActionList('Server Connected')
          else
            FillActionList('Server');
        end;

        NODE_DATABASES:
        begin
          FCurrSelServer := TibcServerNode(tvMain.Selected.Parent.Data);
          if tvMain.Selected.HasChildren then
            CurrSelDatabase := TibcDatabaseNode((tvMain.Selected.GetFirstChild).Data)
          else
            CurrSelDatabase := nil;
          GetDatabases(FCurrSelServer);
          FillObjectList(FCurrSelTreeNode);
          tvMain.PopupMenu := pmDatabases;
        end;

        NODE_BACKUP_ALIASES:
        begin
          FCurrSelServer := TibcServerNode(tvMain.Selected.Parent.Data);
          GetBackupFiles(FCurrSelServer);
          FillObjectList(FCurrSelTreeNode);
          lvObjects.PopupMenu := pmBackupRestore;
          tvMain.PopupMenu := pmBackupRestore;
        end;

        NODE_USERS:
        begin
          FCurrSelServer := TibcServerNode(tvMain.Selected.Parent.Data);
          GetUsers(FCurrSelServer,FCurrSelTreeNode);
          FillObjectList(FCurrSelTreeNode);
          lvObjects.PopupMenu := pmUsers;
        end;

        NODE_BACKUP_ALIAS:
        begin
          FCurrSelServer := TibcServerNode(tvMain.Selected.Parent.Parent.Data);
          gPersistentInfo.GetBackupAliasProps(FCurrSelServer.NodeName, FCurrSelTreeNode.NodeName, bProps);
            TibcBackupAliasNode(FCurrSelTreeNode).SourceDBServer := bProps.ServerAlias;
            TibcBackupAliasNode(FCurrSelTreeNode).SourceDBAlias := bProps.DatabaseAlias;
            TibcBackupAliasNode(FCurrSelTreeNode).BackupFiles.Text := bProps.BackupFiles;

              TibcBackupAliasNode(FCurrSelTreeNode).Created := bProps.Created;
              TibcBackupAliasNode(FCurrSelTreeNode).LastAccessed := bProps.Accessed;

          FillActionList ('Backup');
          tvMain.popupMenu := pmBackupRestore;
        end;

        NODE_DATABASE:
        begin
          FCurrSelServer := TibcServerNode(tvMain.Selected.Parent.Parent.Data);
          CurrSelDatabase := TibcDatabaseNode(tvMain.Selected.Data);
          stbMain.Panels[1].Text := Format('%s: %s',[GetLangText('Database'),CurrSelDatabase.NodeName]);

          { Force refresh for the object viewer }
          FRefetch := true;

          if (Assigned(CurrSelDatabase.DataModule.Connection)) and
             (CurrSelDatabase.DataModule.Connection.Connected) then
          begin
            FillActionList ('Database Connected');
            tvMain.PopupMenu := pmDatabaseConnectedActions;
            IB_TransactionBarDefault.IB_Transaction := CurrSelDatabase.DataModule.Transaction;
            IB_TransactionBarDDL.IB_Transaction := CurrSelDatabase.DataModule.DDLTransaction;
          end
          else
          begin
            FillACtionList ('Database');
            tvMain.PopupMenu := pmDatabaseActions;
            IB_TransactionBarDefault.IB_Transaction := CurrSelDatabase.DataModule.Transaction;
            IB_TransactionBarDDL.IB_Transaction := CurrSelDatabase.DataModule.DDLTransaction;
          end;
        end;

        NODE_FUNCTIONS,
        NODE_EXCEPTIONS,
        NODE_DOMAINS,
        NODE_PROCEDURES,
        NODE_TABLES,
        NODE_VIEWS,
        NODE_BLOB_FILTERS,
        NODE_ROLES:
        begin
          tvMain.PopupMenu := pmTablesNode;
          AssignProps;
        end;
        NODE_GENERATORS:
        begin
          if (Assigned(CurrSelDatabase.DataModule.Connection)) and
             (CurrSelDatabase.DataModule.Connection.Connected) then
          begin
            AssignPropsGenerators;
            FrameGenerators1.DataModule := CurrSelDatabase.DataModule;
            FrameGenerators1.LoadObjects;
            FrameGenerators1.ParentResize;
          end;
        end;
      end;
      FrameGenerators1.Visible := FCurrSelTreeNode.NodeType=NODE_GENERATORS;
      lvObjects.Visible := FCurrSelTreeNode.NodeType<>NODE_GENERATORS;
    end;


  finally
    if Assigned(FCurrSelServer) and (FCurrSelTreeNode.NodeType <> NODE_SERVERS) then
    begin
      stbMain.Panels[0].Text := Format('%s: %s',[GetLangText('Server'),FCurrSelServer.NodeName]);
      if FCurrSelServer.Server.Active then
        stbMain.Panels[2].Text := Format('%s: %s',[GetLangText('User'),FCurrSelServer.Username]);
    end;
    if Assigned(FCurrSelTreeNode) then
      FPrevSelTreeNode := FCurrSelTreeNode;

    if Assigned(CurrSelDatabase) and Assigned(CurrSelDatabase.DataModule) then
    begin
      IB_TransactionBarDefault.IB_Transaction := CurrSelDatabase.DataModule.Transaction;
      IB_TransactionBarDDL.IB_Transaction := CurrSelDatabase.DataModule.DDLTransaction;
    end
    else
    begin
      IB_TransactionBarDefault.IB_Transaction := Nil;
      IB_TransactionBarDDL.IB_Transaction := Nil;
    end;
    if bItemSelected then
       lvObjects.Selected := FindItem(lvObjects,ItemCaption);
    Application.ProcessMessages;
  end;

end;

{****************************************************************
*
*  t v M a i n D b l C l i c k ( )
*
****************************************************************
*  Author: The Client Server Factory Inc.
*  Date:   March 1, 1999
*
*  Input:  Sender - The object that initiated the event
*
*  Return: None
*
*  Description: This procedure performs an action depending on
*               which treenode received the double-click.
*
*****************************************************************
* Revisions:
*
*****************************************************************}
procedure TfrmMain.tvMainDblClick(Sender: TObject);
begin
  if not Assigned (FCurrSelTreeNode) then
    exit;

  if not fCheckGDS32Ok then
  begin
    MessageDlg(fCheckGDS32Msg, mtError, [mbOK], 0);
    exit;
  end;

  case FCurrSelTreeNode.NodeType of
    NODE_SERVERS:
      ServerRegisterExecute(Self); 
 
    NODE_SERVER: 
      if (Assigned(FCurrSelServer)) and (not FCurrSelServer.Server.Active) and 
        (FCurrSelServer.Version > 5) then 
        DoServerLogin(false); 
 
    NODE_DATABASE: 
      if Assigned(FCurrSelServer) and
         Assigned(CurrSelDatabase) and
         (not Assigned(CurrSelDatabase.DataModule.Connection) or
          not (CurrSelDatabase.DataModule.Connection.Connected)) then
        DoDBConnect(FCurrSelServer,CurrSelDatabase,true,true);
 
    NODE_BACKUP_ALIAS: 
      DatabaseRestoreExecute(self); 
  end; 
end; 
 
procedure TfrmMain.tvMainDeletion(Sender: TObject; Node: TTreeNode); 
var
  lTmpTreeNode: TibcTreeNode; 
begin 
  if Assigned(Node.Data) then 
  begin 
    lTmpTreeNode := TibcTreeNode(Node.Data); 
    lTmpTreeNode.Free; 
  end 
end; 
 
procedure TfrmMain.tvMainExpanding(Sender: TObject; Node: TTreeNode; 
  var AllowExpansion: Boolean); 
begin 
  if (Assigned(Node.Data)) and (TibcTreeNode(Node.Data) is TibcServerNode) then 
  begin 
    if TibcServerNode(Node.Data).Server.Active or (FCurrSelServer.Version < 6) then 
      AllowExpansion := true 
    else 
      AllowExpansion := false; 
  end 
end; 
 
 
function TfrmMain.DoDBConnect(const SelServerNode: TibcServerNode; 
  SelDatabaseNode: TibcDatabaseNode; 
  const SilentLogin: boolean; Refresh:boolean): boolean; 
var 
  lDatabaseNode: TTreeNode; 
  dbProps: TIbcDatabaseProps; 
begin 
  Result := true; 
  if Assigned(SelServerNode) and Assigned(SelDatabaseNode) then 
  begin 
    if IBCDBConnect(SelDatabaseNode,SelServerNode,SilentLogin) then 
    begin 
      lDatabaseNode := tvMain.Items.GetNode(SelDatabaseNode.NodeID); 
 
      if Refresh then
      begin 
        if not lDatabaseNode.HasChildren then 
        begin 
          lDatabaseNode.ImageIndex := NODE_DATABASES_CONNECTED_IMG; 
          lDatabaseNode.SelectedIndex := NODE_DATABASES_CONNECTED_IMG; 
 
          AddTreeRootNode (NODE_DOMAINS, lDatabaseNode); 
          AddTreeRootNode (NODE_TABLES, lDatabaseNode); 
          AddTreeRootNode (NODE_VIEWS, lDatabaseNode); 
          AddTreeRootNode (NODE_PROCEDURES, lDatabaseNode); 
          AddTreeRootNode (NODE_FUNCTIONS, lDatabaseNode); 
          AddTreeRootNode (NODE_GENERATORS, lDatabaseNode); 
          AddTreeRootNode (NODE_EXCEPTIONS, lDatabaseNode); 
          AddTreeRootNode (NODE_BLOB_FILTERS, lDatabaseNode); 
          AddTreeRootNode (NODE_ROLES, lDatabaseNode); 
        end; 
 
        try 
          if gPersistentInfo.DatabaseAliasExists(SelServerNode.NodeName, SelDatabaseNode.NodeName) then 
          begin 
            gPersistentInfo.GetDatabaseProps(SelServerNode.NodeName, SelDatabaseNode.NodeName, dbProps); 
            dbProps.Username := SelDatabaseNode.Username; 
            dbProps.Role := SelDatabaseNode.Role; 
            dbProps.CaseSensitiveRole := SelDatabaseNode.CaseSensitiveRole; 
            dbProps.CharacterSet := SelDatabaseNode.CharacterSet; 
            dbProps.Accessed := Now; 
            gPersistentInfo.StoreDatabaseProps(SelServerNode.Nodename, SelDatabaseNode.NodeName, dbProps); 
          end 
        except 
          on E:Exception do 
          // kris start 
          //  Application.HandleException(E); 
            DisplayMsg(WAR_PERSISTENT_UPDATE, E.Message); 
          // kris end 
        end; 
      end; 
      tvMainChange(nil,nil);
 
      if Assigned(lDatabaseNode) then 
        lDatabaseNode.Expand (false); 
    end 
    else 
      result := false; 
  end; 
end; 
 
{**************************************************************** 
* 
*  D o D B D i s c o n n e c t ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input:  SelDatabaseNode - The selected database 
* 
*  Return: None 
* 
*  Description: This procedure disconnects the specified database 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
function TfrmMain.DoDBDisconnect(SelDatabaseNode: TibcDatabaseNode): boolean;
begin 
  if not Assigned(SelDatabaseNode) then 
    result := false
  else
  try
    if SelDatabaseNode.DataModule.Connection.Connected then
    if OpenWindows.CanCloseAll(SelDatabaseNode.DataModule) then
    begin
      SelDatabaseNode.DataModule.Connection.Disconnect;
      OpenWindows.CloseAll(SelDatabaseNode.DataModule);
      OpenWindows.UpdateAll;
    end;
    result := SelDatabaseNode.DataModule.Connection.Connected = False;
    Application.ProcessMessages;
  except
    on E:EIB_ISCError do
    begin 
      DisplayMsg(ERR_DB_DISCONNECT,E.Message); 
      result := false; 
    end; 
  end; 
end; 
 
{**************************************************************** 
* 
*  G e t B a c k u p F i l e s ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input: SelServerNode - The selected server 
*         SelTreeNode - The selected tree node 
* 
*  Return: integer - Indicates the success/failure of the operation 
* 
*  Description: This precedure retrieves a list of Backup aliases for the 
*               selected server from the treeview structure 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
function TfrmMain.GetBackupFiles(const SelServerNode: TibcServerNode): integer; 
var 
  lObjectList: TStringList;
  lCurrParentNode, lCurrChildNode: TTreeNode; 
begin 
  lObjectList := TStringList.Create; 
  try 
    Screen.Cursor := crHourGlass; 
    lObjectList.AddObject(GetLangText('Name'),nil);
    lCurrParentNode := tvMain.Items.GetNode(SelServerNode.BackupFilesID); 
    lCurrChildNode := lCurrParentNode.GetFirstChild; 
    while lCurrChildNode <> nil do 
    begin 
      lObjectList.AddObject(lCurrChildNode.Text, lCurrChildNode); 
      lCurrChildNode := lCurrParentNode.GetNextChild(lCurrChildNode); 
    end; 
    TibcTreeNode(lCurrParentNode.Data).ObjectList.Assign(lObjectList); 
    result := SUCCESS; 
  finally 
    lObjectList.Free; 
    Screen.Cursor := crDefault; 
  end; 
end; 
 
// This procedure determines the type of the selected 
// treenode and calls the appropriate function in order to 
// retrieve the DDL script for the object(s). 
function TfrmMain.GetDDLScript: integer; 
var 
  lSQLScript: TStringList; 
  IBExtract : TIBOExtract;
begin 
  Result := 0; 
  if (not Assigned(CurrSelDatabase)) and (not Assigned (FCurrSelTreeNode)) then
    Exit; 
  lSQLScript := nil; 
  try 
    lSQLScript := TStringList.Create; 
    lSQLScript.Text := ''; 
    Screen.Cursor := crHourGlass;
 
    IBExtract := TIBOExtract.Create(self);
    with IBExtract do 
    begin 
      Database := CurrSelDatabase.DataModule.Connection;
      ShowSystem := FViewsystemData; 
      ExtractObject(eoDatabase); 
      lSqlScript.Text := Items.Text; 
      Free; 
    end; 
    IBCShowStrings(lSQLScript, 'Database Metadata', false); 
  finally 
    Screen.Cursor := crDefault; 
    lSQLScript.Free; 
  end; 
end; 
 
 
 
{**************************************************************** 
* 
*  G e t D a t a b a s e s ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input: SelServerNode - The selected server 
* 
*  Return: integer - Indicates the success/failure of the operation 
* 
*  Description: This procedure retrieves a list of databases for the 
*               specified server from the treeview structure 
* 
***************************************************************** 
* Revisions: 
*
*****************************************************************} 
function TfrmMain.GetDatabases(const SelServerNode: TibcServerNode): integer; 
var 
  lObjectList: TStringList; 
  lCurrParentNode,lCurrChildNode: TTreeNode; 
  lDBNode: TibcDatabaseNode; 
begin 
  lObjectList := TStringList.Create; 
  try
    Screen.Cursor := crHourGlass;
    lObjectList.AddObject(Format('%s%s%s',[GetLangText('Name'),DEL,GetLangText('Path')]),nil);
    lCurrParentNode := tvMain.Items.GetNode(SelServerNode.DatabasesID);
    lCurrChildNode := lCurrParentNode.GetFirstChild;
    while lCurrChildNode <> nil do
    begin
      lDbNode := TibcDatabaseNode(lCurrChildNode.Data);
      //Lorenzo: prevent case of malformed alias with no dbfiles
      if lDBNode.DatabaseFiles.Count > 0 then
        lObjectList.AddObject(Format('%s%s%s',[lCurrChildNode.Text,DEL ,lDBNode.DatabaseFiles[0]]),lCurrChildNode)
      else
        lObjectList.AddObject(Format('%s%s%s',[lCurrChildNode.Text,DEL ,'']),lCurrChildNode);
      lCurrChildNode := lCurrParentNode.GetNextChild(lCurrChildNode);
    end; 
    TibcTreeNode(lCurrParentNode.Data).ObjectList.Assign(lObjectList); 
    result := SUCCESS; 
  finally 
    lObjectList.Free; 
    Screen.Cursor := crDefault; 
  end; 
end; 
 
{**************************************************************** 
* 
*  G e t S e r v e r s ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input: None 
*
*  Return: Returns a status code indicating the success/failure of 
*          the operation. 
* 
*  Description: Get's a list of registered servers 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
function TfrmMain.GetServers: integer; 
var 
  lObjectList: TStringList; 
  lCurrChildNode: TTreeNode; 
  lNode: TibcServerNode; 
  Str, LastAccess: String; 
  Connections: integer; 
 
begin 
  lObjectList := TStringList.Create; 
  try 
    Screen.Cursor := crHourGlass;
    lObjectList.AddObject(Format(GetLangText('Name')+'%s'+GetLangText('Description')+'%s'+GetLangText('Last Accessed')+'%s'+GetLangText('Connections'),[DEL,DEL, DEL]),nil);
    lCurrChildNode := tvMain.Items[0].GetFirstChild; 
    while lCurrChildNode <> nil do 
    begin 
      lNode := TibcServerNode(lCurrChildNode.Data); 
      Connections := 0; 
      if lNode.Server.Active then 
      begin 
        lNode.Server.FetchDatabaseInfo; 
        Connections := lNode.Server.DatabaseInfo.NoOfAttachments; 
      end; 
      LastAccess := DateTimeToStr(lNode.LastAccessed); 
      Str := Format('%s%s%s%s%s%s%d',[lCurrChildNode.Text,DEL,lNode.Description,DEL,LastAccess,DEL, Connections]); 
      lObjectList.AddObject(Str,lCurrChildNode); 
      lCurrChildNode := tvMain.Items[0].GetNextChild(lCurrChildNode); 
    end;
    TibcServerNode(tvMain.Items[0].Data).ObjectList.Assign(lObjectList); 
    result := SUCCESS; 
  finally 
    lObjectList.Free; 
    Screen.Cursor := crDefault; 
  end; 
end; 
 
{**************************************************************** 
* 
*  G e t U s e r s ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input: 
* 
*  Return: None 
* 
*  Description: 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
function TfrmMain.GetUsers(const SelServerNode: TibcServerNode; const SelTreeNode: TibcTreeNode): integer;
var 
  lObjectList: TStringList;
begin
  result := FAILURE;
  lObjectList := TStringList.Create;
  try
    try
      Application.ProcessMessages;
      Screen.Cursor := crHourGlass;
      SelServerNode.GetUsersList(lObjectList);
      SelTreeNode.ObjectList.Assign(lObjectList);
      result := SUCCESS;
    except
    end;
  finally
    lObjectList.Free;
    Screen.Cursor := crDefault;
  end;
end;
 
{**************************************************************** 
* 
*  R e g i s t e r B a c k u p F i l e ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input: 
* 
*  Return: None 
* 
*  Description: 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
function TfrmMain.RegisterBackupFile(const SelServerNode: TibcServerNode; const SourceDBAlias, 
  BackupAlias: string; BackupFiles: TStringList): boolean; 
var 
  lBackupAliasNode: TTreeNode; 
  bkProps: TibcBackupProps; 
begin 
  try 
    tvMain.Items.BeginUpdate; 
    lBackupAliasNode := tvMain.Items.AddChild(tvMain.Items.GetNode(SelServerNode.BackupFilesID), '');
    lBackupAliasNode.Data := TibcBackupAliasNode.Create(tvMain, GetNodeHandle(lBackupAliasNode), 
      BackupAlias, Now, Now, NODE_BACKUP_ALIAS); 
    lBackupAliasNode.Text := BackupAlias; 
    lBackupAliasNode.SelectedIndex := NODE_BACKUP_ALIAS_IMG; 
    lBackupAliasNode.ImageIndex := NODE_BACKUP_ALIAS_IMG; 
    TibcBackupAliasNode(lBackupAliasNode.Data).SourceDBServer := SelServerNode.NodeName; 
    TibcBackupAliasNode(lBackupAliasNode.Data).SourceDBAlias := SourceDBAlias; 
    TibcBackupAliasNode(lBackupAliasNode.Data).BackupFiles.Assign(BackupFiles); 
    TibcBackupAliasNode(lBackupAliasNode.Data).Created := Now; 
    TibcBackupAliasNode(lBackupAliasNode.Data).LastAccessed := Now; 
 
    bkProps.ServerAlias := SelServerNode.NodeName; 
    bkProps.DatabaseAlias := SourceDBAlias; 
    bkProps.BackupFiles := BackupFiles.Text; 
    bkProps.Created := TibcBackupAliasNode(lBackupAliasNode.Data).Created; 
    bkProps.Accessed := TibcBackupAliasNode(lBackupAliasNode.Data).LastAccessed; 
 
    gPersistentInfo.StoreBackupAliasProps(SelServerNode.NodeName, BackupAlias, bkProps); 
  finally 
    tvMain.Items.EndUpdate; 
    tvMainChange(nil,nil); 
    GetBackupFiles(FCurrSelServer); 
    result := true; 
  end; 
end; 
 
procedure TfrmMain.AddDatabaseNode(const SelServerNode: TibcServerNode; const DatabaseNodeName: string; 
      const dbProps: TibcDatabaseProps; const Password: string; NewDatabase: TIB_Connection); 
var 
  lDatabaseNode, lCurrNode: TTreeNode;
begin 
  try 
    tvMain.Items.BeginUpdate; 
    lDatabaseNode := tvMain.Items.AddChild(tvMain.Items.GetNode(SelServerNode.DatabasesID), '');
    lDatabaseNode.Data := TibcDatabaseNode.Create(tvMain,
                                                  GetNodeHandle(lDatabaseNode),
                                                  DatabaseNodeName,
                                                  NODE_DATABASE,
                                                  dbProps,
                                                  Password);
    lDatabaseNode.Text := TibcDatabaseNode(lDatabaseNode.Data).NodeName;
    TibcDatabaseNode(lDatabaseNode.Data).DataModule.ServerNode := SelServerNode;
    CurrSelDatabase := TibcDatabaseNode(lDatabaseNode.Data);
 
    lDatabaseNode.SelectedIndex := NODE_DATABASES_DISCONNECTED_IMG; 
    lDatabaseNode.ImageIndex := NODE_DATABASES_DISCONNECTED_IMG; 
    lCurrNode := tvMain.Items.GetNode(SelServerNode.DatabasesID); 
    lCurrNode.Expand(false); 
    tvMain.Selected := lDatabaseNode; 
  finally 
    tvMain.Items.EndUpdate; 
    tvMainChange(nil,nil); 
    GetDatabases(FCurrSelServer); 
  end; 
end; 
 
function TfrmMain.RegisterDatabase(const ServerAlias, DatabaseAlias: string; dbProps: TibcDatabaseProps): boolean; 
begin 
//  if SaveAlias then 
  begin 
    try 
      gPersistentInfo.StoreDatabaseProps(Serveralias, DatabaseAlias, dbProps); 
      Result := true; 
    except 
      Result := false; 
    end; 
  end; 
 
end; 
 
// kris start 
function TfrmMain.UnregisterDatabase(const ServerAlias, DatabaseAlias: string): boolean; 
begin 
  try 
    gPersistentInfo.DeleteDatabaseAlias(FCurrSelServer.NodeName, CurrSelDatabase.NodeName);
    Result := true; 
  except 
    on E:Exception do 
    begin 
      DisplayMsg(ERR_DATABASE_UNREGISTER, E.Message); 
      Result := false; 
    end; 
  end; 
end; 
 
{ 
  //at a trasition to more consistent design 
} 
function TfrmMain.RegisterServer(const ServerAlias: string; ServerProps: TibcServerProps): boolean; 
{function TfrmMain.RegisterServer(const ServerName,ServerAlias,UserName, 
                                 Password, Description: string; 
                                 Protocol: TProtocol; SaveAlias: boolean; 
                                 LastAccess: TDateTime): boolean; } 
begin 
  try 
    gPersistentInfo.StoreServerProps(ServerAlias, ServerProps); 
    Result := true; 
  except 
    on E:Exception do 
    begin 
      DisplayMsg(ERR_SERVER_REGISTER, E.Message); 
      Result := false; 
    end; 
  end; 
end; 
 
 
procedure TfrmMain.AddServerNode(const ServerNodeName: string; ServerProps: TibcServerProps; Password: string = ''); 
var 
  lServerNode: TTreeNode; 
begin 
  try 
    tvMain.Items.BeginUpdate; 
    lServerNode := tvMain.Items.AddChild(tvMain.Items[0], ServerNodeName); 
    if ServerProps.Protocol = cpLocal then
      lServerNode.MoveTo(tvMain.Items[0],naAddChildFirst); 
{    lServerNode.Data := TibcServerNode.Create(tvMain, lServerNode.ItemId, ServerAlias, 
                         ServerProps.ServerName, ServerProps.UserName, Password, 
                         ServerProps.Description, ServerProps.Protocol, 
                         ServerProps.Accessed, NODE_SERVER); } 
    lServerNode.Data := TibcServerNode.Create(tvMain, GetNodeHandle(lServerNode), ServerNodeName, NODE_SERVER, 
                         ServerProps, Password); 
 
    lServerNode.SelectedIndex := 1; 
    lServerNode.ImageIndex := 1; 
    tvMain.Items[0].Expand(false); 
 
    FCurrSelServer := TibcServerNode(lServerNode.Data); 
    tvMain.Selected := lServerNode; 
  finally 
    tvMain.Items.EndUpdate; 
    tvMainChange(nil,nil); 
    GetServers; 
  end; 
end; 
 
// kris end 
 
{**************************************************************** 
* 
*  D e l e t e N o d e ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input: 
* 
*  Return: None 
* 
*  Description: 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
procedure TfrmMain.DeleteNode(const Node: TTreeNode; const ChildNodesOnly: boolean); 
begin 
  if Assigned (Node) then 
  begin 
    { Any connected nodes are deleted in the destructor for 
      TIBCDatabaseNode } 
    Node.DeleteChildren; 
    if not ChildNodesOnly then 
      Node.Delete; 
    tvMain.Refresh; 
    Application.ProcessMessages; 
  end; 
end; 
 
{**************************************************************** 
* 
*  D o S e r v e r L o g i n ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input: SilentLogin - Indicates wheather or not to prompt the 
*         user for login information. 
* 
*  Return: None 
* 
*  Description: This procedure makes a call to the server login function 
*               and refreshes the treeview depending on the success/failure 
*               of the login 
*****************************************************************} 
function TfrmMain.DoServerLogin(const SilentLogin: boolean): boolean; 
var 
  lServerNode,lCurrNode: TTreeNode; 
  lDatabases,lBackupAliases,lBackupFiles,lDatabaseFiles: TStringList; 
  i: integer; 
  sProps: TibcServerProps;
  dbProps: TibcDatabaseProps; 
  bkProps: TibcBackupProps; 
begin 
  lDatabases := nil; 
  lBackupAliases := nil; 
  lBackupFiles := nil; 
  lDatabaseFiles := nil; 
  result := false; 
 
  if Assigned(FCurrSelServer) then 
  begin 
    try 
      if IBCServerLogin(FCurrSelServer,SilentLogin) then
      begin 
        result := true; 
        try 
          lDatabases := TStringList.Create;
          lBackupAliases := TStringList.Create; 
          lBackupFiles := TStringList.Create; 
          lDatabaseFiles := TStringList.Create;
 
          lServerNode := tvMain.Items.GetNode(FCurrSelServer.NodeID); 
          lServerNode.SelectedIndex := NODE_SERVERS_ACTIVE_IMG; 
          lServerNode.ImageIndex := NODE_SERVERS_ACTIVE_IMG; 
          lServerNode.Expand(true); 
 
          if FCurrSelServer.Version < 6 then 
          begin 
            DisplayMsg(ERR_SERVER_LOGIN, Format(getprompt(74),[FCurrSelServer.NodeName]));
          end; 
 
          if not lServerNode.HasChildren then 
          begin 
            lCurrNode := tvMain.Items.AddChild(lServerNode, GetLangType(NODE_DATABASES));
            lCurrNode.Data := TibcTreeNode.Create(tvMain, GetNodeHandle(lCurrNode),'',NODE_DATABASES);
            TibcServerNode(lServerNode.Data).DatabasesID := GetNodeHandle(lCurrNode); 
 
            lCurrNode.ImageIndex := NODE_DATABASES_IMG; 
            lCurrNode.SelectedIndex := NODE_DATABASES_IMG; 
 
            lCurrNode := tvMain.Items.AddChild(lServerNode, GetLangType(NODE_BACKUP_ALIASES));
            lCurrNode.Data := TibcTreeNode.Create(tvMain, GetNodeHandle(lCurrNode),'',NODE_BACKUP_ALIASES);
            TibcServerNode(lServerNode.Data).BackupFilesID := GetNodeHandle(lCurrNode); 

            lCurrNode.ImageIndex := NODE_BACKUP_ALIASES_IMG; 
            lCurrNode.SelectedIndex := NODE_BACKUP_ALIASES_IMG; 
 
            lCurrNode := tvMain.Items.AddChild(lServerNode, GetLangType(NODE_LOGS));
            lCurrNode.Data := TibcTreeNode.Create(tvMain, GetNodeHandle(lCurrNode), '',NODE_LOGS); 
            lCurrNode.ImageIndex := NODE_LOGS_IMG; 
            lCurrNode.SelectedIndex := NODE_LOGS_IMG; 
 
            lCurrNode := tvMain.Items.AddChild(lServerNode, GetLangType(NODE_USERS));
            lCurrNode.Data := TibcTreeNode.Create(tvMain, GetNodeHandle(lCurrNode), '',NODE_USERS); 
            lCurrNode.ImageIndex := NODE_USERS_IMG; 
            lCurrNode.SelectedIndex := NODE_USERS_IMG; 
          end; 
 
          tvMain.Refresh; 
          FCurrSelServer.LastAccessed := Now; 
 
          gPersistentInfo.GetServerProps(FCurrSelServer.NodeName, sProps); 
          sProps.UserName := FCurrSelServer.UserName; 
          sProps.Accessed := Now; 
          gPersistentInfo.StoreServerProps(FCurrSelServer.NodeName, sProps); // new line 
 
          gPersistentInfo.GetDatabaseAliases(FCurrSelServer.NodeName, lDatabases); 
          for i := 0 to lDatabases.Count - 1 do 
          begin 
            gPersistentInfo.GetDatabaseProps(FCurrSelServer.NodeName, lDatabases[i], dbProps); 
            AddDatabaseNode(FCurrSelServer, lDatabases[i], dbProps, '', FNilDatabase);
          end; 

          gPersistentInfo.GetBackupAliases(FCurrSelServer.NodeName, lBackupAliases); 
          for i := 0 to (lBackupAliases.Count - 1) do 
          begin 
            gPersistentInfo.GetBackupAliasProps(FCurrSelServer.NodeName, lBackupAliases[i], bkProps); 
            lBackupFiles.Text := bkProps.BackupFiles; 
            RegisterBackupFile(FCurrSelServer, bkProps.DatabaseAlias, lBackupAliases[i], lBackupFiles); 
          end; 
        finally 
          lDatabases.Free; 
          lBackupFiles.Free; 
          lBackupAliases.Free; 
          lDatabaseFiles.Free; 
        end; 
      end; 
    finally 
      tvMainChange(nil,nil); 
    end; 
  end; 
end; 
 
{**************************************************************** 
* 
*  F i l l O b j e c t L i s t ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input:
* 
*  Return: None 
* 
*  Description: 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
procedure TfrmMain.FillObjectList(const CurrSelNode: TibcTreeNode);
var 
  loListItem: TListItem; 
  loListColumn: TListColumn; 
  lsCurrLine: string;
  i: integer;
 
begin 
  if not Assigned(CurrSelNode.ObjectList) or
     (CurrSelNode.NodeType in [NODE_SERVER, NODE_DATABASE, NODE_TABLE]) then 
    exit; 

  case CurrSelNode.NodeType of
    NODE_SERVERS,
    NODE_DATABASES,
    NODE_USERS,
    NODE_BACKUP_ALIASES:
     lvObjects.Tag := STATIC;
    else
     lvObjects.Tag := OBJECTS;
  end; 
 
  FLastActions := ''; 
{$IFDEF MSWINDOWS} 
  lvObjects.SmallImages := dmMain.imgTreeView; 
  lvObjects.StateImages := dmMain.imgTreeView;
  lvObjects.LargeImages := dmMain.imgTreeView;
{$ENDIF} 
{$IFDEF LINUX} 
//  lvObjects.StateImages := dmMain.imgTreeView; 
//  lvObjects.Images := dmMain.imgTreeView; 
{$ENDIF} 
 
  if (CurrSelNode.ObjectList.Count = 0) then 
  begin 
    lvObjects.Items.BeginUpdate; 
    lvObjects.Items.Clear; 
 
    lvObjects.Columns.BeginUpdate; 
    lvObjects.Columns.Clear; 

    lvObjects.Items.EndUpdate; 
    lvObjects.Columns.EndUpdate; 
  end
  else 
  begin 
    Screen.Cursor := crHourglass; 
 
    lvObjects.Items.BeginUpdate;
    lvObjects.Items.Clear; 
 
    lvObjects.Columns.BeginUpdate; 
    lvObjects.Columns.Clear;
 
    if (FCurrSelTreeNode.ShowSystem <> FViewSystemData) and 
       (lvObjects.Tag = OBJECTS) then 
    begin 
      GetDBObjects(CurrSelDatabase,FCurrSelTreeNode, FCurrSelTreeNode.NodeType);
      FillObjectList (FCurrSelTreeNode); 
    end; 
 
{$IFNDEF NOT_YET_IN_KYLIX} 
    lvObjects.AllocBy := CurrSelNode.ObjectList.Count; 
{$ENDIF} 
 
    lsCurrLine := CurrSelNode.ObjectList.Strings[0]; 
    while Length(lsCurrLine) > 0 do 
    begin 
      loListColumn := lvObjects.Columns.Add; 
      loListColumn.Caption := GetNextField(lsCurrLine, DEL);
    end; 
 
    for i := 1  to CurrSelNode.ObjectList.Count - 1 do 
    begin 
      lsCurrLine := CurrSelNode.ObjectList.Strings[i]; 
      loListItem := lvObjects.Items.Add; 
      loListItem.Caption := GetNextField(lsCurrLine, DEL); 
 
      if Assigned(CurrSelNode.ObjectList.Objects[i]) then 
      begin 
        loListItem.Data := CurrSelNode.ObjectList.Objects[i]; 
      end; 

      case CurrSelNode.NodeType of 
        NODE_SERVERS: 
        begin 
          if Assigned(CurrSelNode.ObjectList.Objects[i]) then 
          begin
            if TibcServerNode(TTreeNode(CurrSelNode.ObjectList.Objects[i]).Data).Server.Active then
              loListItem.ImageIndex := NODE_SERVERS_ACTIVE_IMG
            else
              loListItem.ImageIndex := NODE_SERVERS_INACTIVE_IMG;
          end;
        end;

        NODE_DATABASES:
        begin
          if Assigned(CurrSelNode.ObjectList.Objects[i]) then
          begin
          if TibcDatabaseNode(TTreeNode(CurrSelNode.ObjectList.Objects[i]).Data).DataModule.Connection.Connected then
            loListItem.ImageIndex := NODE_DATABASES_CONNECTED_IMG
          else
            loListItem.ImageIndex := NODE_DATABASES_DISCONNECTED_IMG;
          end;
        end;

        NODE_BACKUP_ALIASES: loListItem.ImageIndex := NODE_BACKUP_ALIASES_IMG;
        NODE_USERS: loListItem.ImageIndex := NODE_USER_IMG;

        NODE_DOMAINS: loListItem.ImageIndex := NODE_DOMAINS_IMG;
        NODE_TABLES: loListItem.ImageIndex := NODE_TABLES_IMG;
        NODE_VIEWS: loListItem.ImageIndex := NODE_VIEWS_IMG;
        NODE_PROCEDURES: loListItem.ImageIndex := NODE_PROCEDURES_IMG;
        NODE_FUNCTIONS: loListItem.ImageIndex := NODE_FUNCTIONS_IMG;
        NODE_GENERATORS: loListItem.ImageIndex := NODE_GENERATORS_IMG;
        NODE_EXCEPTIONS: loListItem.ImageIndex := NODE_EXCEPTIONS_IMG;
        NODE_BLOB_FILTERS: loListItem.ImageIndex := NODE_BLOB_FILTERS_IMG;
        NODE_ROLES: loListItem.ImageIndex := NODE_ROLES_IMG;
        NODE_COLUMNS: loListItem.ImageIndex := NODE_COLUMNS_IMG;
        NODE_INDEXES: loListItem.ImageIndex := NODE_INDEXES_IMG;
        NODE_REFERENTIAL_CONSTRAINTS: loListItem.ImageIndex := NODE_REFERENTIAL_CONSTRAINTS_IMG;
        NODE_UNIQUE_CONSTRAINTS: loListItem.ImageIndex := NODE_UNIQUE_CONSTRAINTS_IMG;
        NODE_CHECK_CONSTRAINTS: loListItem.ImageIndex := NODE_CHECK_CONSTRAINTS_IMG;
        NODE_TRIGGERS: loListItem.ImageIndex := NODE_TRIGGERS_IMG;
      end; 
 
      while Length(lsCurrLine) > 0 do 
      begin
        //replace crlf for display in listview
        loListItem.SubItems.Add(ReplaceCrLf(GetNextField(lsCurrLine, DEL)));
      end;
    end; 
    AutoSizelvColumns; // should it be outside EndUpdate? 
    lvObjects.Columns.EndUpdate; 
    lvObjects.Items.EndUpdate; 
 
    Application.ProcessMessages; 
    Screen.Cursor := crDefault;
    stbMain.Panels[3].Text := Format('%d %s',[lvObjects.Items.Count,GetLangText('objects listed')]);
  end;
end; 
 
{**************************************************************** 
* 
*  I n i t T r e e V i e w ( ) 
* 
**************************************************************** 
*  Author: The Client Server Factory Inc. 
*  Date:   March 1, 1999 
* 
*  Input: 
* 
*  Return: None 
* 
*  Description: 
* 
***************************************************************** 
* Revisions: 
* 
*****************************************************************} 
procedure TfrmMain.InitTreeView; 
var 
  lCurrNode: TTreeNode; 
begin 
  lCurrNode := tvMain.Items.GetFirstNode; 
  lCurrNode.Data := TibcTreeNode.Create(tvMain, GetNodeHandle(lCurrNode),'',NODE_SERVERS); 
  lCurrNode.ImageIndex :=  0; 
  lCurrNode.SelectedIndex := 0; 
end; 
 
procedure TfrmMain.ReadPersistentInfo;
var 
  ServerProps: TibcServerProps; 
  lServers: TStringList; 
  i: integer; 
  iProtocol: integer; 
  lResult: boolean; 
  lRecover: boolean; 
  lMessage: String;
 
  function ReadServerInfo(AnAlias: string): boolean; 
  begin 
    lRecover := false; 
    try 
      gPersistentInfo.GetServerProps(lServers.Strings[i], ServerProps); 
      Result := true; 
    except 
      on E:Exception do 
      begin 
        Result := false; 
        lMessage := E.Message; 
        DisplayMsg(ERR_SERVER_ALIAS, lMessage); 
      end; 
    end; 
  end; 
{$IFNDEF NOT_YET_IN_KYLIX}
  function RecoverServerAlias(ANAlias: string): boolean; 
  begin 
    Result := true; 
    lRecover := true; 
    iProtocol := integer(ServerProps.Protocol); 
    while DisplayModifyAlias(lServers.Strings[i], ServerProps.ServerName, ServerProps.UserName, 
                                     iProtocol, lMessage) <> mrOk do 
    begin 
      case LMMessageDlg(69, [AnAlias], mtConfirmation, mbYesNoCancel, 0) of 
        mrYes: 
          if UnRegisterServer(lServers.Strings[i]) then 
          begin 
            Result := false; 
            Break; 
          end; 
        mrCancel: 
          begin 
            Result := false; 
            Break; 
          end; 
      end; 
    end; 
    if Result then 
      ServerProps.Protocol := TIB_Protocol(iProtocol);
  end; 
{$ENDIF} 
begin 
  lServers := TStringList.Create;
  try 
    { Read Option Settings } 
    gPersistentInfo.GetSettings(gAppSettings);

    case gAppSettings[VIEW_STYLE] of
      0: ViewIcon.OnExecute(self); 
      1: ViewSmallIcon.OnExecute(self); 
      2: ViewList.OnExecute(self); 
      3: ViewReport.OnExecute(self); 
    end; 
    FViewSystemData := gAppSettings[SYSTEM_DATA]; 
    // kris start 
{$IFDEF LINUX} 
    dmMain.LoadSyntaxFromPersistent; 
{$ENDIF} 
    // kris end 
 
    { Read external apps settings } 
    gExternalApps := TStringList.Create;
    gPersistentInfo.GetExternalApps(gExternalApps); 
 
    { Read the servers } 
    gPersistentInfo.GetServerAliases(lServers); 
      for i := 0 to lServers.Count - 1 do 
      begin 
        lResult := ReadServerInfo(lServers.Strings[i]); 
{$IFNDEF NOT_YET_IN_KYLIX} 
        if not lResult then 
          lResult := RecoverServerAlias(lServers.Strings[i]); 
{$ENDIF} 
        if lResult then 
        // kris start 
          AddServerNode(lServers.Strings[i], ServerProps, '');
      end; {for} 
    finally 
      lServers.Free; 
    end;

end; 
 
procedure TfrmMain.SavePersistentInfo; 
begin 
  if Assigned(gPersistentInfo) then 
  try 
    gPersistentInfo.StoreFormSettings(Self, 0, 'MainState'); // kris 
    gPersistentInfo.StoreSettings(gAppSettings); 
    // kris start 
{$IFDEF LINUX} 
    dmMain.SaveSyntaxToPersistent; 
{$ENDIF} 
    // kris end 
    gPersistentInfo.Update; 
  except 
    on E:Exception do 
      DisplayMsg(WAR_PERSISTENT_UPDATE, E.Message); 
  end; 
end; 
 
procedure TfrmMain.RenameTreeNode(SelTreeNode: TibcTreeNode; NewNodeName: string); 
var 
  lSelTreeNode: TTreeNode; 
  idx: Integer; 
begin 
  lSelTreeNode := tvMain.Items.GetNode(SelTreeNode.NodeID); 
  if SelTreeNode is TIBCServerNode then 
  begin 
    with TibcTreeNode(frmMain.tvMain.Items[0].Data).ObjectList do
    begin 
      for idx := 0 to Count - 1 do 
        if Pos(lSelTreeNode.Text, Strings[Idx]) = 1 then 
        begin 
          Strings[idx] := newNodeName; 
          break; 
        end; 
    end; 
  end; 
  lSelTreeNode.Text := NewNodeName; 
  tvMain.Refresh; 
end; 
 
procedure TfrmMain.mmiHeContentsClick(Sender: TObject); 
begin 
  Application.HelpCommand(HELP_FINDER,0);
end;

procedure TfrmMain.mmiHeOverviewClick(Sender: TObject);
begin
  Application.HelpCommand(GENERAL_OVERVIEW,0);
end;

procedure TfrmMain.mmiHeUsingHelpClick(Sender: TObject); 
begin 
  Application.HelpCommand(HELP_HELPONHELP,0);
end;

procedure TfrmMain.tvMainKeyPress(Sender: TObject; var Key: Char); 
{$IFDEF LINUX} 
const 
  VK_RETURN = 13; 
{$ENDIF} 
begin 
  if Ord(Key) = VK_RETURN then
  begin 
    Key := '0'; 
    case FCurrSelTreeNode.NodeType of
      NODE_SERVER : 
        if (not FCurrSelServer.Server.Active) and (not FCurrSelServer.Version < 6) then 
          tvMainDblClick(nil); 
 
      NODE_DATABASE : 
        if (not CurrSelDatabase.DataModule.Connection.Connected) then
           tvMainDblClick(nil); 
 
      NODE_SERVERS, NODE_BACKUP_ALIASES, NODE_DATABASES : 
        tvMainDblClick(nil); 
 
      NODE_BACKUP_ALIAS, NODE_USERS : 
        tvMainDblClick(nil); 
    end;  // of case nodetype of 
  end; 
end; 
 
procedure TfrmMain.tvMainMouseDown(Sender: TObject; Button: TMouseButton; 
  Shift: TShiftState; X, Y: Integer); 
begin 
  if Button = mbRight then 
  begin 
    tvMain.Selected := tvMain.GetNodeAt(X,Y); 
  end; 
end; 
 
procedure TfrmMain.FormResize(Sender: TObject); 
begin 
  splVertical.Left := tvMain.Width; 
  splVertical.Width := 3;
  FrameGenerators1.ParentResize;
end;

function TfrmMain.IsDBRegistered(const DBFile : String; var ExistingDBAlias : String) : Boolean;
var
  lDatabases: TStringList;
  i: Integer;
  dbProps: TibcDatabaseProps;
begin
  Result := false;
  lDatabases := TStringList.Create;
  try
    gPersistentInfo.GetDatabaseAliases(FCurrSelServer.ServerName, lDatabases);
    for i := 0 to lDatabases.Count - 1 do
    begin
      gPersistentInfo.GetDatabaseProps(FCurrSelServer.ServerName, lDatabases[i], dbProps);
      if dbProps.DatabaseFiles = DBFile then
      begin 
        ExistingDBAlias := lDatabases.Strings[i]; 
        Result := true; 
        Break; 
      end; 
    end; 
  finally 
    lDatabases.Free; 
  end; 
  if result then 
    if LMMessageDlg(Format('This database is already registered with the following alias: %s.%s'+ 
      'Are you sure you want to register this database again?', 
      [ExistingDBAlias, CRLF]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      result := false 
    else 
      result := true; 
end; 
 
// kris start 
function TfrmMain.UnRegisterServer(const ServerAlias: String): boolean; 
begin 
  try 
    gPersistentInfo.DeleteServerAlias(ServerAlias); 
    result := true; 
  except 
 
    Result := false; 
  end; 
end; 
// kris end 
 
procedure TfrmMain.AddTreeRootNode(const ObjType: Integer; const Parent: TTreeNode); 
var 
  lCurrNode: TTreeNode; 
 
begin 
  lCurrNode := tvMain.Items.AddChild(Parent, GetLangType(Objtype));
  lCurrNode.Data := TibcTreeNode.Create(tvMain, GetNodeHandle(lCurrNode),'',ObjType); 
 
  case ObjType of 
    NODE_DOMAINS: 
    begin 
      lCurrNode.ImageIndex := NODE_DOMAINS_IMG; 
      lCurrNode.SelectedIndex := NODE_DOMAINS_IMG; 
      TibcDatabaseNode(Parent.Data).DomainsID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_TABLES: 
    begin 
      lCurrNode.ImageIndex := NODE_TABLES_IMG; 
      lCurrNode.SelectedIndex := NODE_TABLES_IMG; 
      TibcDatabaseNode(Parent.Data).TablesID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_PROCEDURES: 
    begin 
      lCurrNode.ImageIndex := NODE_PROCEDURES_IMG; 
      lCurrNode.SelectedIndex := NODE_PROCEDURES_IMG; 
      TibcDatabaseNode(Parent.Data).ProceduresID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_VIEWS: 
    begin 
      lCurrNode.ImageIndex := NODE_VIEWS_IMG; 
      lCurrNode.SelectedIndex := NODE_VIEWS_IMG; 
      TibcDatabaseNode(Parent.Data).ViewsID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_TRIGGERS: 
    begin 
      lCurrNode.ImageIndex := NODE_TRIGGERS_IMG; 
      lCurrNode.SelectedIndex := NODE_TRIGGERS_IMG; 
      TibcDatabaseNode(Parent.Data).TriggersID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_EXCEPTIONS: 
    begin 
      lCurrNode.ImageIndex := NODE_EXCEPTIONS_IMG; 
      lCurrNode.SelectedIndex := NODE_EXCEPTIONS_IMG; 
      TibcDatabaseNode(Parent.Data).ExceptionsID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_BLOB_FILTERS: 
    begin 
      lCurrNode.ImageIndex := NODE_BLOB_FILTERS_IMG; 
      lCurrNode.SelectedIndex := NODE_BLOB_FILTERS_IMG; 
      TibcDatabaseNode(Parent.Data).FiltersID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_GENERATORS: 
    begin 
      lCurrNode.ImageIndex := NODE_GENERATORS_IMG; 
      lCurrNode.SelectedIndex := NODE_GENERATORS_IMG;
      TibcDatabaseNode(Parent.Data).GeneratorsID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_ROLES: 
    begin 
      lCurrNode.ImageIndex := NODE_ROLES_IMG; 
      lCurrNode.SelectedIndex := NODE_ROLES_IMG; 
      TibcDatabaseNode(Parent.Data).RolesID := GetNodeHandle(lCurrNode); 
    end; 
    NODE_FUNCTIONS: 
    begin 
      lCurrNode.ImageIndex := NODE_FUNCTIONS_IMG; 
      lCurrNode.SelectedIndex := NODE_FUNCTIONS_IMG; 
      TibcDatabaseNode(Parent.Data).FunctionsID := GetNodeHandle(lCurrNode); 
    end; 
  end; 
end; 
 
procedure TfrmMain.lvActionsDblClick(Sender: TObject); 
begin 
  with Sender as TListView do 
  begin 
    if Assigned (Selected) and Assigned (Selected.Data) then 
      TAction(Selected.Data).OnExecute(Sender); 
  end; 
end; 
 
procedure TfrmMain.lvObjectsKeyDown(Sender: TObject; var Key: Word; 
  Shift: TShiftState); 
{$IFDEF LINUX} 
const 
  VK_RETURN = KEY_RETURN; 
{$ENDIF} 
var 
 pt: TPoint; 
begin 
{$IFNDEF NOT_YET_IN_KYLIX} 
  if (Sender as TListView).Tag in [ACTIONS, OBJECTS] then 
    if (Key = VK_RETURN) then 
    begin 
       if (ssAlt in Shift) and Assigned (lvObjects.PopupMenu) then 
       begin 
         pt := ClientToScreen(lvObjects.Selected.GetPosition); 
         lvObjects.PopupMenu.Popup(pt.X, pt.Y); 
       end 
       else 
         lvObjectsDblClick(Sender); 
    end; 
{$ENDIF} 
end; 
 
procedure TfrmMain.ConsoleExitExecute(Sender: TObject); 
begin 
  Close; 
end; 
 
procedure TfrmMain.DatabaseShutdownExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase)) then
    frmuDBShutDown.DoDBShutdown(FCurrSelServer,CurrSelDatabase);
end;
 
procedure TfrmMain.DatabaseRegisterExecute(Sender: TObject); 
var 
  lDBAlias, lPassword: string; 
  lExistingAlias : String; 
  lDatabaseFiles : TStringList; 
  lSaveAlias : boolean; 
  dbProps: TibcDatabaseProps; 
begin 
  if not Assigned(FCurrSelServer) then 
    Exit; 
 
  lDatabaseFiles := TStringList.Create; 
  try 
    tvMain.Items.BeginUpdate; 
    if IBCRegisterDBDlg(lDBAlias, lPassword, dbProps, FCurrSelServer, lSaveAlias) then
    begin 
      lExistingAlias := ''; 
      // Actually it should be checked also for non-persistent aliases ??? 
      if gPersistentInfo.DatabaseAliasExists(FCurrSelServer.Nodename, lDBAlias) then 
      begin 
      //  else { database is registered } 
        DisplayMsg(WAR_DUPLICATE_DB_ALIAS,''); 
        Exit;  // ??? No endUpdate ??? 
      end; 
 
//      lDataBaseFiles.Text := dbProps.DatabaseFiles; 
      if not IsDBRegistered(dbProps.DatabaseFiles, lExistingAlias) then 
      begin 
        RegisterDatabase(FCurrSelServer.NodeName, lDBAlias, dbProps); 
        AddDatabaseNode(FCurrSelServer, lDBAlias, dbProps, lPassword, FNilDatabase); 
        if (dbProps.UserName <> '') and (lPassword <> '') then 
        begin 
          if not DoDBConnect(FCurrSelServer,CurrSelDatabase,true,true) then
          begin 
            if lSaveAlias then 
              gPersistentInfo.DeleteDatabaseAlias(FCurrSelServer.NodeName, CurrSelDatabase.NodeName);
            DeleteNode(tvMain.Items.GetNode(CurrSelDatabase.NodeID),false);
            CurrSelDatabase := nil;
            tvMainChange(nil,nil); 
            GetDatabases(FCurrSelServer); 
          end; 
        end; 
      end; 
    end; 
  finally 
    lDatabaseFiles.Free; 
    tvMain.Items.EndUpdate; 
  end; 
end; 
 
procedure TfrmMain.DatabaseUnregisterExecute(Sender: TObject); 
begin 
  if LMMessageDlg(11, mtConfirmation, [mbYes, mbNo], 0) = mrYes then 
  begin 
    if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase)) then
    begin 
      if CurrSelDatabase.DataModule.Connection.Connected then
        if not DoDBDisconnect(CurrSelDatabase) then
        begin 
          DisplayMsg(ERR_DB_DISCONNECT, 'Database registration not removed.'); 
          Exit; 
        end; 
        // kris start db 
        UnregisterDatabase(FCurrSelServer.NodeName, CurrSelDatabase.NodeName);
        // kris end 
        DeleteNode(tvMain.Items.GetNode(CurrSelDatabase.NodeID),false);
        CurrSelDatabase := nil;
        tvMainChange(nil,nil); 
        GetDatabases(FCurrSelServer); 
    end; 
  end; 
end; 
 
procedure TfrmMain.DatabaseConnectExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase))
    and (not CurrSelDatabase.DataModule.Connection.Connected) then
    DoDBConnect(FCurrSelServer,CurrSelDatabase,true,true);
end; 
 
procedure TfrmMain.DatabaseConnectAsExecute(Sender: TObject); 
begin 
  if Assigned(FCurrSelServer) and Assigned(CurrSelDatabase) then
  begin 
    if not CurrSelDatabase.DataModule.Connection.Connected then
      DoDBConnect(FCurrSelServer,CurrSelDatabase,false,true);
  end;
end;

procedure TfrmMain.DatabaseDisconnectExecute(Sender: TObject); 
var 
  lCurrNode: TTreeNode; 
begin 
  if not Assigned(CurrSelDatabase) then
    exit;
  if LMMessageDlg(12, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    if DoDBDisconnect(CurrSelDatabase) then
    begin
      lCurrNode := tvMain.Items.GetNode(CurrSelDatabase.NodeID);
      lCurrNode.SelectedIndex := 2;
      lCurrNode.ImageIndex := 2;
      DeleteNode(lCurrNode, true);
      tvMainChange(nil,nil);
    end;
  end;
end; 
 
procedure TfrmMain.ToolsStatisticsExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase)) then
    frmuDBStatistics.DoDBStatistics(FCurrSelServer,CurrSelDatabase);
end; 
 
procedure TfrmMain.ToolsSweepExecute(Sender: TObject); 
var 
  lValidation: TIBOValidationService;  // validation object
  lOptions: TValidateOptions;         // validation options 
begin 
  // show message and verify action 
  if LMMessageDlg(13, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin 
    // if user presses the OK button and they wish to proceed 
    lValidation := Nil;                // initialize 
    try 
      lValidation := TIBOValidationService.Create(Self);
      try                              // attach to currently selected server 
        lValidation.LoginPrompt := false; 
        lValidation.ServerName := FCurrSelServer.Server.ServerName; 
        lValidation.Protocol := FCurrSelServer.Server.Protocol; 
        lValidation.Params.Assign(FCurrSelServer.Server.Params); 
        lValidation.Attach; 
      except                           // if an exception occurs 
        on E:EIB_ISCError do               // trap it and show error message 
        begin 
          DisplayMsg(ERR_SERVER_LOGIN, E.Message); 
          if (E.ERRCODE = isc_lost_db_connection) or 
             (E.ERRCODE = isc_unavailable) or 
             (E.ERRCODE = isc_network_error) then 
            ErrorState:= True; 
          Exit; 
        end; 
      end; 
 
      if lValidation.Active then       // if successfully attached to server 
      begin 
        Screen.Cursor := crHourGlass;  // change cursor to hourglass 
 
        // define database 
        lValidation.DatabaseName := CurrSelDatabase.DatabaseFiles.Strings[0];
 
        // clear option lists 
        lValidation.Options := []; 
        lOptions := []; 
 
        // specify SweepDB validation option 
        Include(lOptions, SweepDB); 
 
        lValidation.Options := lOptions; 
 
        // start service 
        try 
          lValidation.ServiceStart; 
          while (lValidation.IsServiceRunning) and (not gApplShutdown) do 
          begin 
            Application.ProcessMessages; 
            Screen.Cursor := crHourGlass; 
          end; 
 
          if lValidation.Active then 
            lValidation.Detach; 
        except 
          on E: EIB_ISCError do 
          begin 
            DisplayMsg(E.ERRCODE, E.Message); 
            if (E.ERRCODE = isc_lost_db_connection) or 
               (E.ERRCODE = isc_unavailable) or 
               (E.ERRCODE = isc_network_error) then 
              ErrorState:= True;
        end; 
      end; 
      end; 
    finally 
      if lValidation.Active then 
        lValidation.Detach; 
      lValidation.Free; 
      Screen.Cursor := crDefault; 
      DisplayMsg(INF_DATABASE_SWEEP, ''); 
    end; 
  end; 
end; 
 
procedure TfrmMain.ToolsSQLExecute(Sender: TObject); 
var 
  lCnt: integer; 
  str: string;
  f:TdlgWisql;
  Icon: TIcon;
begin
  f:= TdlgWisql.Create(Self);
  Icon := TIcon.Create;
  try
{$IFDEF MSWINDOWS}
    dmMain.imgTreeview.GetIcon(NODE_WISQL_IMG, Icon);
{$ENDIF}
    f.Icon := Icon;
  finally
    Icon.Free;
  end;
  if Assigned(CurrSelDatabase) and
     Assigned(CurrSelDatabase.DataModule.Connection) and
     Assigned(CurrSelDatabase.DataModule.Connection.DbHandle) and
     (CurrSelDatabase.DataModule.Connection.Connected)
  then
  begin
    f.DataModule := CurrSelDatabase.DataModule;
    f.Connect1Click(Sender);
  end;

  f.ServerList.Clear;
  for lCnt := 1 to TibcServerNode(tvMain.Items[0].Data).ObjectList.Count - 1 do
  begin
    str := TibcServerNode(tvMain.Items[0].Data).ObjectList.Strings[lCnt];
    f.ServerList.Append(GetNextField(Str, DEL));
  end;
  if Assigned(FCurrSelServer) and (FCurrSelServer.Server.Active) then
    f.ServerIndex := f.ServerList.IndexOf(FCurrSelServer.NodeName)
  else
    f.ServerIndex := -1;

  if Assigned (FCurrSelServer) and (FCurrSelServer.server.Active) then
  begin
    f.OnCreateDatabase := EventDatabaseCreate;
  end;
  f.ShowDialog;

end;

procedure TfrmMain.ServerViewLogExecute(Sender: TObject);
var
  ibcLogSvc: TIBOLogService;

begin
  ibcLogSvc := TIBOLogService.create(self);
  Screen.Cursor := crHourGlass;
  try 
    ibcLogSvc.ServerName := FCurrSelServer.Servername; 
    ibcLogSvc.Protocol := FCurrSelServer.Server.Protocol; 
    ibcLogSvc.Params := FCurrSelServer.Server.Params; 
    ibcLogSvc.LoginPrompt := false; 
    try 
      ibcLogSvc.Attach; 
      ibcLogSvc.ServiceStart; 
      IBCShowServiceInfo(ibcLogSvc, 'Server Log'); 
      ibcLogSvc.Detach; 
      Screen.Cursor := crDefault; 
    except 
      on E: EIB_ISCError do 
      begin 
        DisplayMsg(E.ERRCODE, E.Message); 
        if (E.ERRCODE = isc_lost_db_connection) or 
           (E.ERRCODE = isc_unavailable) or 
           (E.ERRCODE = isc_network_error) then 
          ErrorState:= True; 
    end; 
    end; 
  finally 
    ibcLogSvc.Free; 
    Screen.Cursor := crDefault; 
  end; 
end; 
 
procedure TfrmMain.DatabaseRestartExecute(Sender: TObject);
var 
  lConfig: TIBOConfigService;
begin 
  lConfig:=Nil;                        // initilialize variables 
  try                                  // create ConfigService object 
    lConfig:=TIBOConfigService.Create(Nil);
    Screen.Cursor := crHourGlass; 
    try                                // specify server information 
      lConfig.LoginPrompt:=false;      // and Attempt to login 
      lConfig.ServerName:=FCurrSelServer.ServerName; 
      lConfig.Protocol:=FCurrSelServer.Server.Protocol; 
      lConfig.DatabaseName:=CurrSelDatabase.DatabaseFiles.Strings[0];
      lConfig.Params.Assign(FCurrSelServer.Server.Params);
      lConfig.Attach; 
    except                             // if an error occurs 
      on E:EIB_ISCError do                 // trap it and show 
      begin                            // error message 
        DisplayMsg(ERR_SERVER_LOGIN, E.Message); 
        if (E.ERRCODE = isc_lost_db_connection) or 
           (E.ERRCODE = isc_unavailable) or 
           (E.ERRCODE = isc_network_error) then 
          ErrorState:= True; 
        Exit; 
      end; 
    end; 
 
    if lConfig.Active then             // if ConfigService is active 
    begin                              // set the database name 
      lConfig.DatabaseName:=CurrSelDatabase.DatabaseFiles.Strings[0];
 
      // bring database back online 
      lConfig.BringDatabaseOnline; 
 
      // wait while processing 
      while (lConfig.IsServiceRunning) and (not gApplShutdown) do 
      begin 
        Application.ProcessMessages; 
        Screen.Cursor := crHourGlass; 
      end; 
 
      // if ConfigService is no longer active then detach 
      if lConfig.Active then 
        lConfig.Detach; 
    end; 
 
    DisplayMsg(INF_DATABASE_RESTARTED, ''); 

  finally 
    Screen.Cursor := crDefault; 
    // deallocate memory 
    lConfig.Free; 
  end; 
end; 
 
procedure TfrmMain.ToolsTransRecoverExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase)) then
    frmuDBTransactions.DoDBTransactions(FCurrSelServer,CurrSelDatabase);
end; 

function TfrmMain.DoDatabaseCreate:boolean;
var 
  DatabaseAlias: string; 
  dbProps: TibcDatabaseProps;
begin
  Result := False;
  if not Assigned(FCurrSelServer) then
    Exit;
  try
    if IBCDBCreateDlg(FCurrSelServer, DatabaseAlias, dbProps) = SUCCESS then
    begin
      if DatabaseAlias <> '' then
      begin
        RegisterDatabase(FCurrSelServer.NodeName, DatabaseAlias, dbProps);
        AddDatabaseNode(FCurrSelServer, DatabaseAlias, dbProps, '', FNilDatabase);
        if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase))
          and (not CurrSelDatabase.DataModule.Connection.Connected) then
          DoDBConnect(FCurrSelServer,CurrSelDatabase,true,true);
        Result := True;
      end;
    end;
  finally
  end; 
end; 


procedure TfrmMain.DatabaseCreateExecute(Sender: TObject);
begin
  if not Assigned(FCurrSelServer) then
    Exit;
  try
    DoDatabaseCreate;
  finally
  end;
end; 
 
procedure TfrmMain.DatabaseDropExecute(Sender: TObject); 
var 
  lOriginalState : Boolean; 
begin 
  if LMMessageDlg(14, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin 
    lOriginalState := CurrSelDatabase.DataModule.Connection.Connected; 
 
    // disconnect from database 
    CurrSelDatabase.DataModule.Connection.Connected := false; 
 
    // check if the database is open 
    if not CurrSelDatabase.DataModule.Connection.Connected then
    begin 
      // if the databsae is not open then connect to it using the username 
      // and password used to connected to the server 
      CurrSelDatabase.DataModule.Connection.LoginPrompt:=false;
      CurrSelDatabase.DataModule.Connection.Username := FCurrSelServer.UserName;
      CurrSelDatabase.DataModule.Connection.Password := FCurrSelServer.Password; 
      CurrSelDatabase.DataModule.Connection.Connected:=true; 
    end; 
 
    try 
    // drop the databsae 
    CurrSelDatabase.DataModule.Connection.DropDatabase; 
 
    // remove from treeview and un-register from the persistent storage 
    if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase)) then 
    begin 
      gPersistentInfo.DeleteDatabaseAlias(FCurrSelServer.NodeName, CurrSelDatabase.NodeName); 
      DeleteNode(tvMain.Items.GetNode(CurrSelDatabase.NodeID),false); 
      tvMainChange(nil,nil); 
      GetDatabases(FCurrSelServer); 
    end; 
    except 
      on E : EIB_ISCError do 
      begin 
        DisplayMsg(ERR_DROP_DATABASE, E.Message); 
        CurrSelDatabase.DataModule.Connection.Connected := lOriginalState; 
      end; 
    end; 
  end; 
end; 

procedure TfrmMain.ToolsValidationExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase)) then 
    frmuDBValidation.DoDBValidation(FCurrSelServer,CurrSelDatabase); 
end; 
 
procedure TfrmMain.DatabasePropertiesExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase)) then
    frmuDBProperties.EditDBProperties(FCurrSelServer,CurrSelDatabase); 
 
  GetDatabases(FCurrSelServer); 
end; 
 
procedure TfrmMain.DatabaseRestoreExecute(Sender: TObject); 
var 
  bckupAlias: TibcBackupAliasNode; 
  bkProps: TibcBackupProps; 
begin 
  if Assigned(FCurrSelServer) and Assigned(FCurrSelTreeNode) then 
    try 
      if IBCDBRestoreDlg(FCurrSelServer, FCurrSelTreeNode) = SUCCESS then 
        if FCurrSelTreeNode is TibcBackupAliasNode then 
        begin 
          bckupAlias := TibcBackupAliasNode(FCurrSelTreeNode); 
          gPersistentInfo.GetBackupAliasProps(FCurrSelServer.NodeName, FCurrSelTreeNode.NodeName, bkProps); 
          bkProps.Accessed := Now; 
          bkProps.DatabaseAlias := bckupAlias.SourceDBAlias; 
          bkProps.ServerAlias := bckupAlias.SourceDBServer; 
          gPersistentInfo.StoreBackupAliasProps(FCurrSelServer.NodeName, FCurrSelTreeNode.NodeName, bkProps); 
        end; 
    except 
      on EIBCCriticalError do 
        ErrorState:= True;
    end; 
end; 
 
procedure TfrmMain.HelpAboutExecute(Sender: TObject); 
begin 
  frmuAbout.ShowAboutDialog('IBOConsole'); 
end; 
 
procedure TfrmMain.BackupRestoreModifyAliasExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelTreeNode)) and (FCurrSelTreeNode is TibcBackupAliasNode) then
    frmuBackupAliasProperties.EditBackupAliasProperties(FCurrSelServer,TibcBackupAliasNode(FCurrSelTreeNode)); 
  GetBackupFiles(FCurrSelServer);
end; 
 
procedure TfrmMain.ServerDiagConnectionExecute(Sender: TObject); 
begin 
  frmuCommDiag.DoDiagnostics(FCurrSelServer); 
end; 
 
procedure TfrmMain.ServerLoginExecute(Sender: TObject); 
begin 
  DoServerLogin(false); 
end; 
 
procedure TfrmMain.ServerLogoutExecute(Sender: TObject); 
var 
  lCurrNode     : TTreeNode; 
  lDatabaseNode : TibcDatabaseNode; 
  i             : integer; 
begin 
  if FErrorState or (LMMessageDlg(15, mtConfirmation, [mbYes, mbNo], 0) = mrYes) then 
  begin 
    if Assigned (CurrSelDatabase) then 
    begin 
      DoDBDisConnect(CurrSelDatabase); 
      CurrSelDatabase := nil; 
    end; 
 
    if Assigned(FCurrSelServer) then 
    begin
      try 
        if FCurrSelServer.Version > 5 then 
          FCurrSelServer.Server.Detach; 
 
        FCurrSelServer.Version := 6;
        if not FCurrSelServer.Server.Active then 
        begin 
          lCurrNode := tvMain.Items.GetNode(FCurrSelServer.DatabasesID); 
          for i := lCurrNode.Count - 1 downto 0  do 
          begin 
            lDatabaseNode := TibcDatabaseNode(lCurrNode.Item[i].Data); 
            DoDBDisconnect(lDatabaseNode); 
            DeleteNode(lCurrNode.Item[i], true); 
            lCurrNode.Item[i].SelectedIndex := 2; 
            lCurrNode.Item[i].ImageIndex := 2; 
          end; 
          lCurrNode := tvMain.Items.GetNode(FCurrSelServer.NodeID); 
          DeleteNode(lCurrNode, true);
          lCurrNode.SelectedIndex := 1; 
          lCurrNode.ImageIndex := 1; 
          lCurrNode.Collapse(true); 
        end; 
        tvMain.Refresh; 
        tvMainChange(nil,nil); 
      except 
        DisplayMsg(ERR_SERVER_SERVICE, 'This server may be shutdown or disconnected.'); 
 
        if not FCurrSelServer.Server.Active then 
        begin 
          tvMain.Items.BeginUpdate;
          lCurrNode := tvMain.Items.GetNode(FCurrSelServer.DatabasesID); 
          if Assigned (lCurrNode) then 
          begin 
          for i := lCurrNode.Count - 1 downto 0  do 
          begin 
            lDatabaseNode := TibcDatabaseNode(lCurrNode.Item[i].Data); 
            DoDBDisconnect(lDatabaseNode); 
            DeleteNode(lCurrNode.Item[i], true); 
            lCurrNode.Item[i].SelectedIndex := 2; 
            lCurrNode.Item[i].ImageIndex := 2; 
          end;
          end; 
          lCurrNode := tvMain.Items.GetNode(FCurrSelServer.NodeID); 
          DeleteNode(lCurrNode, true); 
          lCurrNode.SelectedIndex := 1; 
          lCurrNode.ImageIndex := 1; 
          lCurrNode.Collapse(true); 
        end; 
        tvMain.Refresh; 
        tvMainChange(nil,nil); 
        tvMain.Items.EndUpdate;         
      end;  // of try except 
    end;  // of if assigned 
  end;  // of confirmation 
end; 
 
procedure TfrmMain.ServerPropertiesExecute(Sender: TObject); 
begin 
  if Assigned(FCurrSelServer) then 
    frmuServerProperties.EditServerProperties(FCurrSelServer);
end; 
 
procedure TfrmMain.ServerRegisterExecute(Sender: TObject); 
var 
  lServerName,lServerAlias,lUserName,lPassword, lDescription: string;
  lSaveAlias: boolean; 
  lProtocol: TIB_Protocol;
  ServerProps: TIbcServerProps; 
begin 
 
  if IBCRegisterServerDlg(lServerName,lServerAlias,lUserName,lPassword, lDescription, lProtocol, REGISTER_SERVER, lSaveAlias) = SUCCESS then
  begin 
    if gPersistentInfo.ServerAliasExists(lServeralias) then 
    begin 
      DisplayMsg(WAR_SERVER_REGISTERED, lServerAlias); 
      Exit; 
    end; 
 
    ServerProps.ServerName := lServerName; 
    ServerProps.UserName := lUserName; 
    ServerProps.Description := lDescription; 
    ServerProps.Protocol := lProtocol; 
    ServerProps.Created := Now; 
    ServerProps.Accessed := ServerProps.Created;
    // 
    //  if lSaveAlias then // RegisterServer only if lSaveAlias 
    // 
    if RegisterServer(lServerAlias, ServerProps) then 
    begin 
      AddServerNode(lServerAlias, ServerProps, lPassword); 
      if (lUserName <> '') and (lPassword <> '') then 
      begin 
        try 
          DoServerLogin(true); 
        except 
          on E: Exception do 
          begin 
            // kris start 
            gPersistentInfo.DeleteServerAlias(FCurrSelServer.NodeName); 
            tvMain.Items.BeginUpdate; 
            lvObjects.Items.BeginUpdate; 
            DeleteNode(tvMain.Items.GetNode(FCurrSelServer.NodeID),false); 
            FCurrSelServer := nil; 
            tvMainChange(nil,nil); 
            GetServers; 
            tvMain.Selected := tvMain.TopItem; 
            lvObjects.Items.EndUpdate;
            tvMain.Items.EndUpdate; 
            DisplayMsg (ERR_SERVER_LOGIN, E.Message); 
          end; 
        end; 
      end;
    end; 
  end;
end; 
 
procedure TfrmMain.ServerUnregisterExecute(Sender: TObject); 
begin 
  if Assigned(FCurrSelServer) and 
    (LMMessageDlg(69, [FCurrSelServer.Nodename], mtConfirmation, [mbYes, mbNo], 0) = mrYes) then 
  begin 
    if UnRegisterServer(FCurrSelServer.Nodename) then 
    begin 
      DeleteNode(tvMain.Items.GetNode(FCurrSelServer.NodeID),false); 
      FCurrSelServer := nil; 
      tvMainChange(nil,nil); 
      GetServers(); 
      tvMain.Selected := tvMain.TopItem; 
    end; 
  end; 
end; 
 
procedure TfrmMain.ServerSecurityExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (Assigned(FCurrSelTreeNode) and 
    (FCurrSelTreeNode.NodeType = NODE_USERS)) then 
  begin 
    if lvObjects.SelCount > 0 then 
      frmuUser.UserInfo(FCurrSelServer,lvObjects.Selected.Caption) 
    else 
      frmuUser.UserInfo(FCurrSelServer,''); 
  end
  else
    frmuUser.UserInfo(FCurrSelServer,''); 
end; 
 
procedure TfrmMain.ViewSystemDataExecute(Sender: TObject); 
begin 
  FViewSystemData := not (Sender as TAction).Checked; 
  gAppSettings[SYSTEM_DATA] := FViewSystemData; 
  FCurrSelTreeNode.ShowSystem := FViewSystemData; 
  if lvObjects.Tag = OBJECTS then 
  begin 
    lvObjects.Items.BeginUpdate; 
    lvObjects.Items.Clear; 
    GetDBObjects(CurrSelDatabase,FCurrSelTreeNode, FCurrSelTreeNode.NodeType); 
    FillObjectList (FCurrSelTreeNode); 
    lvObjects.Items.EndUpdate;
  end; 
end; 
 
procedure TfrmMain.DatabaseBackupExecute(Sender: TObject); 
var 
  lSourceDBAlias,lBackupAlias: string; 
  lBackupFiles: TStringList; 
  lBackupAliasNode: TibcBackupAliasNode; 
  bkProps: TibcBackupProps; 
begin 
  lBackupFiles := TStringList.Create;
  try 
    if Assigned(FCurrSelServer) then 
    begin 
      if Assigned(FCurrSelTreeNode) and (FcurrSelTreeNode.NodeType = NODE_BACKUP_ALIAS) then
      begin 
        lBackupAliasNode := TibcBackupAliasNode(FCurrSelTreeNode); 
        lSourceDBAlias := lBackupAliasNode.SourceDBAlias; 
        lBackupAlias := FCurrSelTreeNode.NodeName; 
        lBackupFiles.Text := lBackupAliaSNode.BackupFiles.Text;
      end; 
 
      if Assigned (FCurrSelTreeNode) and (FCurrSelTreeNode.NodeType = NODE_DATABASE) then 
        lSourceDBAlias := FCurrSelTreeNode.NodeName; 
 
      try 
        if IBCDBBackupDlg(lSourceDBAlias, lBackupAlias, 
          lBackupFiles, FCurrSelServer, CurrSelDatabase) = SUCCESS then 
        begin 
          if not gPersistentInfo.BackupAliasExists(FCurrSelServer.Nodename,lBackupAlias) then 
          begin 
            RegisterBackupFile(FCurrSelServer,lSourceDBAlias,lBackupAlias, lBackupFiles); 
          end 
          else 
          begin 
            gPersistentInfo.GetBackupAliasProps(FCurrSelServer.NodeName, lBackupAlias, bkProps); 
            bkProps.BackupFiles := lBackupFiles.Text; 
            gPersistentInfo.StoreBackupAliasProps(FCurrSelServer.NodeName, lBackupAlias, bkProps); 
          end; 
        end; 
      except 
        on EIBCCriticalError do 
          ErrorState:= True;
      end; 
    end;
  finally 
    lBackupFiles.Free;
  end 
end; 
 
procedure TfrmMain.DatabaseMetadataExecute(Sender: TObject); 
begin 
  GetDDLScript; 
end; 
 
procedure TfrmMain.ViewListExecute(Sender: TObject);
begin 
  lvObjects.ViewStyle := vsList; 
  // kris - I know Begin and EndUpdate should be inside 
  // AutoSize..., but I was trying to minmise changes 
  lvObjects.Columns.BeginUpdate; 
  AutoSizelvColumns; 
  lvObjects.Columns.EndUpdate; 
end; 
 
procedure TfrmMain.ViewListUpdate(Sender: TObject); 
begin 
  (Sender as TAction).Checked := (lvObjects.ViewStyle = vsList); 
end; 
 
procedure TfrmMain.ViewReportExecute(Sender: TObject); 
begin 
  lvObjects.ViewStyle := vsReport; 
  lvObjects.Columns.BeginUpdate; 
  AutoSizelvColumns;
  lvObjects.Columns.EndUpdate; 
end; 
 
procedure TfrmMain.ViewReportUpdate(Sender: TObject); 
begin 
  (Sender as TAction).Checked := (lvObjects.ViewStyle = vsReport); 
end; 
 
procedure TfrmMain.ViewIconExecute(Sender: TObject); 
begin 
{$IFNDEF NOT_YET_IN_KYLIX} 
  lvObjects.ViewStyle := vsIcon; 
{$ENDIF} 
end; 
 
procedure TfrmMain.ViewIconUpdate(Sender: TObject); 
begin
{$IFNDEF NOT_YET_IN_KYLIX} 
  (Sender as TAction).Checked := (lvObjects.ViewStyle = vsIcon);
{$ENDIF} 
end; 
 
procedure TfrmMain.ViewSmallIconExecute(Sender: TObject); 
begin 
{$IFNDEF NOT_YET_IN_KYLIX}
  lvObjects.ViewStyle := vsSmallIcon;
{$ENDIF}
end;

procedure TfrmMain.ViewSmallIconUpdate(Sender: TObject);
begin
{$IFNDEF NOT_YET_IN_KYLIX}
  (Sender as TAction).Checked := (lvObjects.ViewStyle = vsSmallIcon);
{$ENDIF}
end;

procedure TfrmMain.FillActionList(const Action: String);
var
  lCnt: Integer;
  ListItem: TListItem;
  LColumn: TListColumn;
begin
  lvObjects.Tag := ACTIONS;

  if FLastActions <> Action then
  begin
    FLastActions := Action;
    lvObjects.Items.BeginUpdate;
    lvObjects.Items.Clear;

    lvObjects.Columns.BeginUpdate;
    lvObjects.Columns.Clear;

    lColumn := lvObjects.Columns.Add;
    lColumn.Caption := GetLangText('Action');

    lColumn := lvObjects.Columns.Add;
    lColumn.Caption := GetLangText('Description');

    lvObjects.Columns.EndUpdate;
{ TODO: Do not show icons since not all objects have them }

{$IFDEF MSWINDOWS}
  lvObjects.SmallImages := dmMain.imgToolBarsEnabled;
  lvObjects.StateImages := dmMain.imgToolBarsEnabled;
  lvObjects.LargeImages := dmMain.imgToolBarsEnabled;

//'Server Connected'

{$ENDIF}
{$IFDEF LINUX}
    lvObjects.Images := nil;
{$ENDIF}
    with actMain do
    begin
      for lCnt := 0 to ActionCount - 1 do
      begin 
        with Actions[lCnt] as TAction do 
        begin 
          if Category = Action then 
          begin 
            if Tag <> 1 then 
            begin 
              if (Tag = SYSDBA_ONLY) and 
                 (UpperCase(FCurrSelServer.UserName) <> 'SYSDBA')
              then 
                continue; 
              ListItem := lvObjects.Items.Add; 
              ListItem.Caption := StripMenuChars(Caption); 
              ListItem.ImageIndex := ImageIndex; 
              ListItem.SubItems.Add (Hint); 
              ListItem.Data := TAction(Actions[lCnt]); 
            end;
          end;
        end; 
      end; 
    end; 
    lvObjects.Items.EndUpdate; 
 
    lvObjects.Columns.BeginUpdate; 
    AutoSizelvColumns; 
    lvObjects.Columns.EndUpdate; 
  end; 
end; 
 
procedure TfrmMain.DatabaseConnectedActionsUpdate(Sender: TObject); 
begin 
  if Assigned(CurrSelDatabase) and 
     Assigned (CurrSelDatabase.DataModule.Connection) and 
     Assigned (CurrSelDatabase.DataModule.Connection.dbHandle) then
    (Sender as TAction).Enabled := CurrSelDatabase.DataModule.Connection.Connected 
  else 
    (Sender as TAction).Enabled := false; 
end; 
 
procedure TfrmMain.ServerActionsUpdate(Sender: TObject); 
begin 
  if Assigned(FCurrSelServer) and Assigned (FCurrSelServer.Server) then 
    if FCurrSelTreeNode.NodeType  = NODE_SERVERS then 
      (Sender as TAction).Enabled := false 
    else 
      (Sender as TAction).Enabled := not FCurrSelServer.Server.Active 
  else 
    (Sender as TAction).Enabled := true;
end; 
 
procedure TfrmMain.ServerConnectedUpdate(Sender: TObject); 
begin 
  if Assigned(FCurrSelServer) and Assigned (FCurrSelServer.Server) then
    if FCurrSelTreeNode.NodeType  = NODE_SERVERS then 
      (Sender as TAction).Enabled := false 
    else 
      (Sender as TAction).Enabled := FCurrSelServer.Server.Active 
  else 
    (Sender as TAction).Enabled := false; 
end; 
 
procedure TfrmMain.DatabaseRegisterUpdate(Sender: TObject); 
begin 
  if Assigned(CurrSelDatabase) and 
     Assigned (CurrSelDatabase.DataModule.Connection) and
     Assigned (CurrSelDatabase.DataModule.Connection.dbHandle) then
    (Sender as TAction).Enabled := not CurrSelDatabase.DataModule.Connection.Connected 
  else 
    (Sender as TAction).Enabled := false; 
end; 
 
procedure TfrmMain.EventDatabaseDrop; 
begin 
  // remove from treeview and un-register from the persistent storage 
  try 
    if (Assigned(FCurrSelServer)) and (Assigned(CurrSelDatabase)) then 
    begin 
      gPersistentInfo.DeleteDatabaseAlias(FCurrSelServer.NodeName, CurrSelDatabase.NodeName);
      DeleteNode(tvMain.Items.GetNode(CurrSelDatabase.NodeID),false); 
      tvMainChange(nil,nil); 
      GetDatabases(FCurrSelServer); 
    end; 
  except 
    on E : EIB_ISCError do 
    begin 
      DisplayMsg(ERR_DROP_DATABASE, E.Message); 
    end; 
  end; 
end;
 
procedure TfrmMain.EventDatabaseCreate(var Database: TIB_Connection); 
var 
  Alias: string; 
  Password:  string; 
  lCnt: integer; 
  dbProps: TibcDatabaseProps; 
begin 
  if Assigned(FCurrSelServer) and (FCurrSelServer.Server.Active) then 
  begin 
    alias := ExtractFileName(Database.DatabaseName);
 
    { Check to make sure that we are not overwriting an alias } 
    lCnt := 0; 
    // kris start 
//  while AliasExists(Alias) do 
    while gPersistentInfo.DatabaseAliasExists(FCurrSelServer.ServerName, Alias) do
    // kris end 
    begin 
      Inc(lCnt); 
      Alias := Format('%s_%d',[Alias, lCnt]); 
    end; 

    dbProps.DatabaseFiles := Database.DatabaseName; 
    dbProps.username := Database.Username;
    password := Database.password;
    dbProps.role := Database.SQLRole;
 
    if FCurrSelServer.Server.Protocol = cpLocal then 
      if ExtractFilePath(Database.DatabaseName) = '' then 
        Database.DatabaseName := ExtractFilePath(Application.ExeName)+Database.Databasename; 
 
    RegisterDatabase(FCurrSelServer.NodeName, alias, dbProps); 
    AddDatabaseNode(FCurrSelServer, alias, dbProps, password, Database);
    GetDatabases(FCurrSelServer);
    FillObjectList(FCurrSelTreeNode); 
    DoDBConnect(FCurrSelServer, CurrSelDatabase, true, true); 
  end; 
end; 

procedure TfrmMain.DatabaseActionsUpdate(Sender: TObject); 
begin
  if Assigned (FCurrSelTreeNode) and (FCurrSelTreeNode.NodeType = NODE_DATABASE) then 
  begin 
    if Assigned (FCurrSelServer) and Assigned (FCurrSelServer.server) then 
      (Sender as TAction).Enabled := FCurrSelServer.Server.Active and 
         (not CurrSelDatabase.DataModule.Connection.Connected) 
    else 
      (Sender as TAction).Enabled := false; 
    end 
  else 
    (Sender as TAction).Enabled := false; 
end; 
 
procedure TfrmMain.ExtToolsConfigureExecute(Sender: TObject);
var 
  dlgTools: TfrmTools; 
begin 
  dlgTools := TfrmTools.Create(Self);
{$ifdef initlangfile} WriteAllCaptionAndText('',dlgTools,gTransIniFile); {$endif}
  dlgTools.ShowModal;
  dlgTools.Free;
end; 
 
procedure TfrmMain.ExtToolDropDownExecute(Sender: TObject); 
var 
  MenuItem: TMenuItem;
  lCnt, x : integer; 
begin 
  { Clear out all external tool options } 
  lCnt := ToolMenu.Count;
  for x := lCnt - 1 downto FToolMenuIdx do 
  begin 
     MenuItem := ToolMenu.Items[x]; 
     MenuItem.Free; 
  end; 
 
  if gExternalApps.Count > 0 then 
  begin 
    { Add a separator } 
{$IF Declared(Menus)} 
    ToolMenu.NewBottomLine; 
{$IFEND} 
{$IF Declared(QMenus)} 
    ToolMenu.InsertNewLineAfter(ToolMenu.Items[FToolMenuIdx - 1]); 
{$IFEND} 
    for lCnt := 0 to gExternalApps.Count - 1 do 
    begin 
      MenuItem := ToolMenu.Find(gExternalApps.Strings[lCnt]); 
      if not Assigned(MenuItem) then 
      begin 
        MenuItem := TMenuItem.Create(Self);
        MenuItem.OnClick := ExtToolLaunchExecute; 
        MenuItem.Caption := gExternalApps.Strings[lCnt]; 
        MenuItem.Tag := lCnt; 
        ToolMenu.Add(MenuItem); 
      end; 
    end; 
  end; 
end; 
 
procedure TfrmMain.ExtToolLaunchExecute(Sender: TObject); 
var
  lPos: integer; 
  retval: boolean; 
  lTitle, sPath, 
  sWorkDir, 
  cmdLine, 
  lparams: string; 
{$IFDEF LINUX} 
  RetCode: integer; 
{$ENDIF} 
{$IFDEF MSWINDOWS} 
  StartupInfo: TStartupInfo; 
  ProcessInfo: TProcessInformation; 
{$ENDIF} 
  buf: array[byte] of char; 
  pcWorkDir: PChar;
begin 
  with (Sender as TMenuItem) do 
  begin 
    lPos := Tag;
    gPersistentInfo.GetExternalApp(lPos, lTitle, sPath, sWorkDir, lParams); 
    cmdLine := sPath + ' ' + lParams; 
    try 
{$IFDEF MSWINDOWS} 
      if sWorkDir <> '' then 
        pcWorkDir := PChar(sWorkDir) 
      else 
        pcWorkDir := nil; 
      FillChar(StartupInfo, sizeof(StartupInfo), 0); 
      StartupInfo.cb := sizeof(StartupInfo); 
      retval := CreateProcess(nil, PChar(CmdLine), nil, nil, false, 
         NORMAL_PRIORITY_CLASS, nil, pcWorkDir, StartupInfo, ProcessInfo); 
 
      if not retval then 
      begin 
        FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil, GetLastError, 
                LOCALE_USER_DEFAULT, Buf, sizeof(Buf), nil);
        raise Exception.Create(Buf+CRLF+'Command: '+cmdLine); 
      end; 
{$ENDIF} 
{$IFDEF LINUX} 
//    cmdLine := 'konsole -e ' + cmdLine; 
    RetCode := Libc.System(PChar(cmdLine)); 
    // ?? to be fixed later 
    if (RetCode = -1) and (RetCode = 127) then 
      raise Exception.Create('error code -1'); 
//    RetCode := Libc.Execv(PChar(sPath), nil); 
{$ENDIF} 
    except 
      on E: Exception do
      begin 
        DisplayMsg(ERR_EXT_TOOL_ERROR, E.Message); 
      end; 
    end; 
  end; 
end; 
 
procedure TfrmMain.BackupRestoreUpdate(Sender: TObject); 
begin 
  if Assigned (CurrSelDatabase) and 
     Assigned (CurrSelDatabase.DataModule.Connection) and 
     Assigned (CurrSelDatabase.DataModule.Connection.dbHandle) then 
    (Sender as TAction).Enabled := CurrSelDatabase.DataModule.Connection.Connected
  else 
    (Sender as TAction).Enabled := false; 
end; 
 
procedure TfrmMain.DatabaseCreateUpdate(Sender: TObject); 
begin 
  if Assigned (FCurrSelServer) and Assigned (FCurrSelServer.server) then 
    (Sender as TAction).Enabled := FCurrSelServer.Server.Active 
  else 
    (Sender as TAction).Enabled := false;
end; 
 
function TfrmMain.GetDBObjects(const SelDatabaseNode: TibcDatabaseNode;
  const SelTreeNode: TibcTreeNode; const ObjType: integer): integer; 
var 
  lObjectList: TStringList; 
  retval: integer;
begin 
  result := FAILURE; 
  lObjectList := nil; 
  lObjectList := TStringList.Create; 
  try 
    Screen.Cursor := crHourGlass;
    case FCurrSelTreeNode.NodeType of
      NODE_DOMAINS: retval := SelDatabaseNode.DataModule.GetDomainList(lObjectList, FViewSystemData);
      NODE_TABLES: retval := SelDatabaseNode.DataModule.GetTableList(lObjectList,  FViewSystemData);
      NODE_VIEWS: retval := SelDatabaseNode.DataModule.GetViewList(lObjectList, FViewSystemData);
      NODE_PROCEDURES: retval := SelDatabaseNode.DataModule.GetProcedureList(lObjectList,  FViewSystemData);
      NODE_FUNCTIONS: retval := SelDatabaseNode.DataModule.GetFunctionList(lObjectList,  FViewSystemData);
      NODE_GENERATORS: retval := SelDatabaseNode.DataModule.GetGeneratorList(lObjectList, FViewSystemData);
      NODE_EXCEPTIONS: retval := SelDatabaseNode.DataModule.GetExceptionList(lObjectList,  FViewSystemData);
      NODE_BLOB_FILTERS: retval := SelDatabaseNode.DataModule.GetBlobFilterList(lObjectList,  FViewSystemData);
      NODE_ROLES: retval := SelDatabaseNode.DataModule.GetRoleList(lObjectList );
      else
        retval := FAILURE; 
    end; 
    if  retval = SUCCESS then 
    begin 
      SelTreeNode.ObjectList.Assign(lObjectList); 
      result := SUCCESS; 
    end 
    else 
      selTreeNode.ObjectList.Clear; 
  finally 
    lObjectList.Free; 
    Screen.Cursor := crDefault;
  end;
end; 
 
procedure TfrmMain.listViewEnter(Sender: TObject); 
begin 
  if (Sender is TListView) then 
  begin 
    with (Sender as TListView) do 
    begin 
      if not Assigned (Selected) then 
        Selected := TopItem; 
    end; 
  end; 
end; 
 
 
procedure TfrmMain.frmMainDestroy(Sender: TObject); 
begin 
//  SetWindowLong(frmMain.Handle, GWL_WNDPROC, LongInt(OldWindowProc)); 
  inherited; 
end; 
 
procedure TfrmMain.BackupRestoreRemoveAliasExecute(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (FCurrSelTreeNode is TibcBackupAliasNode) then 
  begin 
    if LMMessageDlg(70,[AnsiUppercase(FCurrSelTreeNode.NodeName)], mtConfirmation, [mbYes, mbNo], 0) = mrYes then 
    begin 
      gPersistentInfo.DeleteBackupAlias(FCurrSelServer.NodeName, FCurrSelTreeNode.NodeName); 
      DeleteNode(tvMain.Items.GetNode(FCurrSelTreeNode.NodeID),false);
      tvMainChange(nil,nil); 
    end; 
  end; 
end; 

procedure TfrmMain.BackupRestoreAliasUpdate(Sender: TObject); 
begin 
  if (Assigned(FCurrSelServer)) and (FCurrSelTreeNode is TibcBackupAliasNode) then 
    (Sender as TAction).Enabled := true 
  else 
    (Sender as TAction).Enabled := false;   
end; 
 
procedure TfrmMain.DatabasePropertiesUpdate(Sender: TObject); 
begin 
  (Sender as TAction).Enabled := Assigned(CurrSelDatabase); 
end;
 
procedure TfrmMain.DatabaseValidateUpdate(Sender: TObject); 
begin 
  if Assigned (CurrSelDatabase) and 
     Assigned (CurrSelDatabase.DataModule.Connection) and 
     not Assigned (CurrSelDatabase.DataModule.Connection.dbHandle) then 
    (Sender as TAction).Enabled := not CurrSelDatabase.DataModule.Connection.connected 
  else 
    (Sender as TAction).Enabled := false; 
end; 
 
procedure TfrmMain.DisplayWindow(Sender: TObject); 
begin
{$IFNDEF NOT_YET_IN_KYLIX} 
  with (Sender as TMenuItem) do 
    ShowWindow(Tag, sW_RESTORE); 
{$ENDIF} 
end; 
 
procedure TfrmMain.ObjectDescriptionUpdate(Sender: TObject); 
begin
  if Assigned(FCurrSelTreeNode) then 
    if FCurrSelTreeNode.NodeType in [NODE_ROLES, NODE_GENERATORS] then 
      (Sender as TAction).Enabled := false
    else 
      (Sender as TAction).Enabled := true 
  else 
    (Sender as TAction).Enabled := false; 
end; 
 
procedure TfrmMain.ObjectExtractExecute(Sender: TObject); 
var
  IBExtract: TIBOExtract;
  ObjectType : TExtractObjectTypes;
  ObjectName : String;
  ExtractTypes : TExtractTypes;
begin
  if Assigned(lvObjects.Selected) then
  begin
    IBExtract := TIBOExtract.Create (self);
    Screen.Cursor := crHourGlass;
    try
      with IBExtract do
      begin
        Database := CurrSelDatabase.DataModule.Connection;
        ShowSystem := FViewSystemData;
        ObjectName := lvObjects.Selected.Caption;
        ExtractTypes := [];
        case FCurrSelTreeNode.NodeType of
          NODE_DOMAINS:
            ObjectType := eoDomain;
          NODE_TABLES:
          begin
            ObjectType := eoTable;
            ExtractTypes := [etDomain, etTrigger, etForeign, etIndex];
          end;
          NODE_VIEWS:
          begin
            ObjectType := eoView;
            ExtractTypes := [etTrigger];
          end;
          NODE_PROCEDURES:
            ObjectType := eoProcedure;
          NODE_FUNCTIONS:
            ObjectType := eoFunction;
          NODE_GENERATORS:
            ObjectType := eoGenerator;
          NODE_EXCEPTIONS:
            ObjectType := eoException;
          NODE_BLOB_FILTERS:
            ObjectType := eoBLOBFilter;
          NODE_ROLES:
            ObjectType := eoRole;
          else
            ObjectType := eoDatabase;
        end;
        ExtractObject(ObjectType, ObjectName, ExtractTypes);
        IBCShowStrings(Items, Format('%s %s',[GetLangText('Metadata for'),ObjectName]), false);
      end;
    finally
      Screen.Cursor := crDefault;
      IBExtract.Free;
    end;
  end;
end;

procedure TfrmMain.ObjectDeleteUpdate(Sender: TObject);
begin
  { Do not allow System Metadata to be dropped!}
  if Assigned(lvObjects.Selected) then
  begin 
    if Pos('RDB$', lvObjects.Selected.Caption) <> 0 then 
      (Sender as TAction).Enabled := false 
    else
      (Sender as TAction).Enabled := true; 
  end;
end; 

procedure TfrmMain.ObjectDeleteExecute(Sender: TObject);
var
  error:String;
begin
  if Assigned (lvObjects.Selected) then
  begin
    if CurrSelDatabase.DataModule.DropObject(FCurrSelTreeNode.NodeType,lvObjects.Selected.Caption, error) then
    begin
      if Assigned (lvObjects.Selected) then
        lvObjects.Selected.Delete
    end;
  end;
end;

procedure TfrmMain.ViewSystemUpdate(Sender: TObject);
begin
  (Sender as TAction).Checked := gAppSettings[SYSTEM_DATA];
end;

function TfrmMain.ConnectAsDatabase(Sender: Tobject): boolean;
begin
  try
    result := true;
    DatabaseConnectAsExecute(Sender);
    with Sender as TdlgWisql do
    begin
      OnDropDatabase := EventDatabaseDrop;
      (Sender as TdlgWisql).DataModule := CurrSelDatabase.DataModule;
    end;
  except
    result := false; 
  end; 
end;
 
function TfrmMain.CreateDatabase(Sender: TObject): boolean; 
begin 
  try 
    result := true;
    DatabaseCreateExecute (Sender);
    if Assigned(CurrSelDatabase) then
    begin
      if Sender is TdlgWisql then
      with TdlgWisql(Sender) do
      begin
        //Database := CurrSelDatabase.DataModule.Connection;
        OnDropDatabase := EventDatabaseDrop;
        Caption := GetLangText('Interactive SQL')+' - '+ExtractFileName(CurrSelDatabase.DataModule.Connection.DatabaseName);
      end; 
    end 
    else 
      result := false; 
  except 
    result := false; 
  end;
end; 
 
procedure TfrmMain.ShowWindows(DataModule:TDmN);
begin
  OpenWindows.Show(DataModule);
end; 
 
procedure TfrmMain.FormShow(Sender: TObject);
begin
  if not gApplShutdown then
  begin
    Caption := 'IBOConsole';
    OpenWindows.Add(Caption, Self);
  end 
  else 
    Close;
end; 
 
procedure TfrmMain.lvObjectsContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin 
  if not Assigned (lvObjects.Selected) then
  begin
    case lvObjects.Tag of
      ACTIONS: Handled := true;
      OBJECTS:
      begin
        MousePos := lvObjects.ClientToScreen(MousePos);
        pmTablesNode.Popup(MousePos.X,MousePos.Y);
        Handled := true;
      end;
      STATIC : if not Assigned(lvObjects.PopupMenu) then Handled := true;
      else     Handled := true;
    end;
  end
  else
  begin
    case lvObjects.Tag of
      ACTIONS:
        Handled := true;
      OBJECTS, STATIC:
        if not Assigned(lvObjects.PopupMenu) then
          Handled := true;
      else
        Handled := true;
    end;
  end;
end; 
 
procedure TfrmMain.tvMainCollapsing(Sender: TObject; Node: TTreeNode; 
  var AllowCollapse: Boolean); 
begin 
  if Node.GetPrev = nil then 
    AllowCollapse := false; 
end;
 
procedure TfrmMain.ServerPropertiesUpdate(Sender: TObject); 
begin 
  if FCurrSelTreeNode.NodeType  = NODE_SERVERS then 
    (Sender as TAction).Enabled := false 
  else 
    (Sender as TAction).Enabled := true; 
end; 
 
procedure TfrmMain.UserDeleteUpdate(Sender: TObject); 
begin 
  if Assigned(lvObjects.Selected) then
    (Sender as TAction).Enabled := not (lvObjects.Selected.Caption = 'SYSDBA') 
  else 
    (Sender as TAction).Enabled := false;
end; 
 
procedure TfrmMain.UserAddExecute(Sender: TObject); 
begin 
  if Assigned(FCurrSelServer) then 
  begin 
    frmuUser.UserInfo(FCurrSelServer,'', true); 
    tvMainChange(nil, nil); 
  end; 
end;
 
procedure TfrmMain.UserModifyExecute(Sender: TObject); 
begin 
  if Assigned(FCurrSelServer) then 
  begin
    frmuUser.UserInfo(FCurrSelServer,lvObjects.Selected.Caption); 
    tvMainChange(nil, nil); 
  end; 
end; 
 
procedure TfrmMain.UserModifyUpdate(Sender: TObject); 
begin 
  (Sender as TAction).Enabled := Assigned(lvObjects.Selected); 
end; 
 
procedure TfrmMain.UserDeleteExecute(Sender: TObject); 
var 
  SecurityService: TIBOSecurityService;
begin 
  if Assigned (lvObjects.Selected) then 
  begin 
    if LMMessageDlg(71, [lvObjects.Selected.Caption], mtConfirmation, [mbYes, mbNo], 0) = mrYes then 
    begin 
      try 
        SecurityService := TIBOSecurityService.Create(self);
        with SecurityService do 
        begin 
          Screen.Cursor := crHourGlass; 
          LoginPrompt := false; 
          ServerName := FCurrSelServer.Server.ServerName; 
          Protocol := FCurrSelServer.Server.Protocol; 
          Params.Assign(FCurrSelServer.Server.Params); 
          Attach;
          UserName := lvObjects.Selected.Caption;
          DeleteUser;
          while (IsServiceRunning) do 
            Application.ProcessMessages; 
          Detach; 
          Free; 
        end; 
      except 
        on E: EIB_ISCError do
        begin 
            DisplayMsg(E.ERRCODE, E.Message); 
          if (E.ERRCODE = isc_lost_db_connection) or 
             (E.ERRCODE = isc_unavailable) or 
             (E.ERRCODE = isc_network_error) then 
            ErrorState:= True; 
          exit; 
      end; 
    end; 
    end; 
    RefreshUsers(fCurrSelServer);
    tvMainChange(nil, nil);
  end; 
end; 
 
procedure TfrmMain.ServerUsersExecute(Sender: TObject); 
begin 
  if Assigned(FCurrSelServer) and Assigned(CurrSelDatabase) then 
    frmuDBConnections.ViewDBConnections (FCurrSelServer, CurrSelDatabase.DataModule.Connection); 
end;
 
procedure TfrmMain.ObjectModifyUpdate(Sender: TObject); 
begin
  (Sender as TAction).Enabled := (FCurrSelTreeNode.NodeType in [NODE_DOMAINS, 
        NODE_TABLES, NODE_PROCEDURES, NODE_EXCEPTIONS]); 
end; 

procedure TfrmMain.SetErrorState(const Value:boolean);
begin
  FErrorState := Value;
  if Value then
     ServerLogoutExecute(nil);
end;

procedure TfrmMain.DatabaseShutdownUpdate(Sender: TObject);
begin
  if Assigned(CurrSelDatabase) and
     Assigned (CurrSelDatabase.DataModule.Connection) and
     Assigned (CurrSelDatabase.DataModule.Connection.dbHandle) then
    if UpperCase(FCurrSelServer.UserName) = 'SYSDBA' then
      (Sender as TAction).Enabled := CurrSelDatabase.DataModule.Connection.Connected
    else 
      (Sender as TAction).Enabled := false 
  else 
    (Sender as TAction).Enabled := false; 
end; 
 
procedure TfrmMain.ToolsSQLExecute1(Sender: TObject);
var 
  lCnt: integer;
  str: string; 
begin 
  with TdlgWisql.Create(Self) do 
  begin 
    new_connection:=false;
      if Assigned(CurrSelDatabase) and
         Assigned(CurrSelDatabase.DataModule.Connection) and
         Assigned(CurrSelDatabase.DataModule.Connection.dbHandle) and
         (CurrSelDatabase.DataModule.Connection.Connected) then begin
         Newconnection1Click(Sender);
      end;
      ServerList.Clear;
      for lCnt := 1 to TibcServerNode(tvMain.Items[0].Data).ObjectList.Count - 1 do begin
        str := TibcServerNode(tvMain.Items[0].Data).ObjectList.Strings[lCnt];
        ServerList.Append(GetNextField(Str, DEL));
      end;
      if Assigned(FCurrSelServer) and (FCurrSelServer.Server.Active) then
        ServerIndex := ServerList.IndexOf(FCurrSelServer.NodeName)
      else
        ServerIndex := -1;

      if Assigned (FCurrSelServer) and (FCurrSelServer.server.Active) then
      begin
        OnCreateDatabase := EventDatabaseCreate;
      end;
      ShowDialog;
  end;
end;

procedure TfrmMain.pmWindowsPopup(Sender: TObject);
var 
  lCnt : Integer; 
  menu : TMenuItem; 
begin 
  pmWindows.Items.Clear; 
  // kis Kylix
  for lCnt := 0 to OpenWindows.Count - 1 do
  begin
    menu := TMenuItem.Create(pmWindows);
    menu.ImageIndex := OpenWindows.ImageIndex(lCnt);
    menu.OnClick := WindowMenuOnClick;
    menu.Caption := OpenWindows[lCnt].Caption;
    menu.Tag := Integer(OpenWindows[lCnt]); 
    pmWindows.Items.Add(menu);
  end;
end; 
 
procedure TfrmMain.WindowMenuOnClick(Sender: TObject); 
begin 
  TForm(TMenuItem(Sender).Tag).BringToFront; 
end; 
 
procedure TfrmMain.AutoSizelvColumns; 
var
  i: integer;
begin
  for i := 0 to lvObjects.Columns.Count -1 do
  begin
{$IF Declared(ComCtrls)}
    lvObjects.Columns[i].Width := ColumnHeaderWidth;
{$IFEND}
{$IF Declared(QComCtrls)}
    lvObjects.Columns[i].AutoSize := true;
{$IFEND}
  end;
end;


// kris alfa 2 start
procedure TfrmMain.ExtToolsLaunchISQLUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := Assigned(FCurrSelServer);
end;
// kris alfa 2 end

procedure TfrmMain.NewTable;
var
  F : TfrmEditorField;
begin
  F := TfrmEditorField.Create(Application);
  try
    f.DataModule := CurrSelDatabase.DataModule;
    f.NewTable;
    if F.ShowModal = mrOK then
    begin
    end;
  finally
    F.Free;
  end;
end;

procedure TfrmMain.SetMainIcon(f:TForm);
var
  lIcon : TIcon;
begin
{$IFDEF MSWINDOWS}
  if Assigned(tvMain.Selected) then
  begin
    lIcon := TIcon.Create;
    try
      tvMain.Images.GetIcon(tvMain.Selected.ImageIndex, lIcon);
      f.Icon := lIcon;
    finally
      lIcon.Free;
    end;
  end;
{$ENDIF}
end;

procedure TfrmMain.SetObjectIcon(f:TForm);
var
  lIcon : TIcon;
begin
{$IFDEF MSWINDOWS}
  if Assigned(lvObjects.Selected) then
  begin
    lIcon := TIcon.Create;
    try
      lvObjects.SmallImages.GetIcon(lvObjects.Selected.ImageIndex, lIcon);
      f.Icon := lIcon;
    finally
      lIcon.Free;
    end;
  end;
{$ENDIF}
end;


procedure TfrmMain.NewDomain;
var fd:TfrmDomains;
begin
  fd:=TfrmDomains.Create(Application);
  fd.DataModule := CurrSelDatabase.DataModule;
  fd.NewObject;
  fd.Show;
end;

procedure TfrmMain.NewException;
var fe:TfrmExceptions;
begin
  fe:=TfrmExceptions.Create(Application);
  fe.DataModule := CurrSelDatabase.DataModule;
  fe.NewObject;
  fe.Show;
end;

procedure TfrmMain.NewProcedure;
var fs:TfrmStoredProcedure;
begin
  fs:=TfrmStoredProcedure.Create(Application);
  fs.DataModule := CurrSelDatabase.DataModule;
  fs.NewObject;
  fs.Show;
end;

procedure TfrmMain.NewFunction;
var fu:TfrmUDFEditor;
begin
  fu:=TfrmUDFEditor.Create(Application);
  SetMainIcon(fu);
  fu.DataModule := CurrSelDatabase.DataModule;
  fu.NewUDF;
  OpenWindows.Add(fu.Caption,fu);
  fu.Show;
end;

procedure TfrmMain.NewView;
var fv:TfrmViewEditor;
begin
  fv:=TfrmViewEditor.Create(Application);
  fv.DataModule := CurrSelDatabase.DataModule;
  fv.NewObject;
  fv.Show;
end;

procedure TfrmMain.NewFilter;
var fe:TFrmEditorFilter;
begin
  fe:=TFrmEditorFilter.Create(Application);
  SetMainIcon(fe);
  fe.DataModule := CurrSelDatabase.DataModule;
  fe.NewFilter;
  OpenWindows.Add(fe.Caption,fe);
  fe.Show;
end;

procedure TfrmMain.NewRole;
var fr:TfrmRole;
begin
  fr:=TfrmRole.Create(Application);
  fr.DataModule := CurrSelDatabase.DataModule;
  fr.NewObject;
  fr.Show;
end;

procedure TfrmMain.ObjectCreateExecute(Sender: TObject);
begin
    case FCurrSelTreeNode.NodeType of
      NODE_DOMAINS: NewDomain;
      NODE_TABLES: NewTable;
      NODE_VIEWS: NewView;
      NODE_PROCEDURES: NewProcedure;
      NODE_FUNCTIONS: NewFunction;
      NODE_EXCEPTIONS: NewException;
      NODE_BLOB_FILTERS: NewFilter;
      NODE_ROLES: NewRole;
    end;
end;

procedure TfrmMain.ObjectCreateUpdate(Sender: TObject);
begin
  ObjectCreate.Enabled := Assigned(CurrSelDatabase);
end;

procedure TfrmMain.CheckUserList(ServerNode: TibcServerNode);
begin
  if FCurrSelServer = ServerNode then
  if FCurrSelTreeNode.NodeType = NODE_USERS then
  begin
    if Assigned (FCurrSelTreeNode) then
      FCurrSeltreeNode.ObjectList.Clear;
    tvMainChange(nil, nil);
  end;
end;


procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := OpenWindows.CanClose;
end;

procedure TfrmMain.WindowListUpdate(Sender: TObject);
begin
  // kris Kylix
  TAction(Sender).Enabled := Assigned(OpenWindows) and (OpenWindows.Count > 1);
end;

procedure TfrmMain.WindowListExecute(Sender: TObject);
begin
  ShowWindows;
end;

procedure TfrmMain.DatabaseWindowsUpdate(Sender: TObject);
begin
  DatabaseWindows.Enabled := Assigned(CurrSelDatabase) and
                             Assigned(CurrSelDatabase.DataModule) and
                             OpenWindows.HasForms(CurrSelDatabase.DataModule);
end;

procedure TfrmMain.DatabaseWindowsExecute(Sender: TObject);
begin
  if Assigned(CurrSelDatabase) and Assigned(CurrSelDatabase.DataModule) then
  begin
    ShowWindows(CurrSelDatabase.DataModule);
  end;
end;

procedure TfrmMain.ActionOptionsExecute(Sender: TObject);
var
  origDDL : boolean;
  origforce_uppercase_identifier : boolean;
  optsDlg: TfrmOptions;
  n:integer;
  extra:word;
  origlangId:string;
  langFile:string;

begin
  optsDlg := TfrmOptions.Create (self);
  gPersistentInfo.GetFormSettings(optsDlg,extra,'OptionsState');
  origDDL := gAppSettings[AUTO_COMMIT_DDL];
  origFORCE_UPPERCASE_IDENTIFIER := gAppSettings[FORCE_UPPERCASE_IDENTIFIER];
  origlangId := gAppSettings[GUI_LANGUAGE];

  OptsDlg.ShowModal;
  OptsDlg.Free;
  if origDDL<>gAppSettings[AUTO_COMMIT_DDL] then
  begin
    for n:=0 to Application.ComponentCount-1 do
    if Application.Components[n] is TDmN then
    try
      TDmN(Application.Components[n]).AutoDDL := gAppSettings[AUTO_COMMIT_DDL];
    except
    end;
  end;
  if origforce_uppercase_identifier<>gAppSettings[FORCE_UPPERCASE_IDENTIFIER] then
  begin
    for n:=0 to Application.ComponentCount-1 do
    if Application.Components[n] is TIBOConsoleEditor then
    try
      TIBOConsoleEditor(Application.Components[n]).uppercase_identifier := gAppSettings[FORCE_UPPERCASE_IDENTIFIER];
    except
    end;
  end;
  if origlangId<>gAppSettings[GUI_LANGUAGE] then
  begin
    if gAppSettings[GUI_LANGUAGE]<>'en' then
    begin
      langFile := ChangeFileExt(Application.ExeName,'.lang.'+gAppSettings[GUI_LANGUAGE]);
      if FileExists(langFile) then
      begin
        if Assigned(gGUILanguageFile) then FreeAndNil(gGUILanguageFile);
        gGUILanguageFile := TIniFile.Create(langFile);
        GetAllCaptionAndText('',Self,gGUILanguageFile);
      end
      else
      begin
        DisplayMsg (ERR_FOPEN, langFile);
      end;
    end
    else
      if Assigned(gGUILanguageFile) then FreeAndNil(gGUILanguageFile);
  end;
end;

procedure TfrmMain.ObjectListRefresh(const DataModule: TDmN;
  const ObjType: integer; const ObjectName:String='');
var x:TListItem;
  procedure RebuildList;
  begin
    if Assigned (FCurrSelTreeNode) then
      FCurrSeltreeNode.ObjectList.Clear;
    tvMainChange(nil, nil);
  end;
begin
  OpenWindows.RefreshObject(DataModule,ObjType,ObjectName);
  if CurrSelDatabase.DataModule = DataModule then
  if FCurrSelTreeNode.NodeType = ObjType then
  begin
    if ObjectName = '' then
      RebuildList
    else
    begin
      X:=FindItem(lvObjects,ObjectName);
      if Assigned(x) then
      begin
        if X.SubItems.Count < 1 then
          X.SubItems.Add(ReplaceCrLf(CurrSelDatabase.DataModule.GetObjectDescription(ObjType,ObjectName)))
        else
          X.SubItems[0] := ReplaceCrLf(CurrSelDatabase.DataModule.GetObjectDescription(ObjType,ObjectName));
      end
      else
        RebuildList;
    end;
  end;
end;

procedure TfrmMain.EventObjectRefresh(const DataModule: TDmN; const ObjType: integer; const ObjName:String='');
begin
  if ObjType = NODE_UNK then
  begin
    if CurrSelDatabase.DataModule = DataModule then
    begin
      case FcurrSelTreeNode.NodeType of
        NODE_DOMAINS:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_DOMAIN);
        NODE_TABLES:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_TABLE);
        NODE_VIEWS:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_VIEW);
        NODE_PROCEDURES:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_PROCEDURE);
        NODE_FUNCTIONS:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_FUNCTION);
        NODE_GENERATORS:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_GENERATOR);
        NODE_EXCEPTIONS:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_EXCEPTION);
        NODE_BLOB_FILTERS:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_BLOB_FILTER);
        NODE_ROLES:
          GetDBObjects (CurrSelDatabase, FCurrSelTreeNode, NODE_ROLE);
      end;
      FillObjectList (FCurrSelTreeNode);
      FRefetch := true;
      OpenWindows.UpdateAll(DataModule);
    end;
  end
  else
    ObjectListRefresh (DataModule, ObjType, ObjName);
end;

procedure TfrmMain.EventObjectDrop(const DataModule: TDmN;
  const ObjType: integer; const ObjName: String);
var x:TListItem;
begin
  if CurrSelDatabase.DataModule = DataModule then
  if NodeMatch(FCurrSelTreeNode.NodeType,ObjType) then
  begin
    if ObjName <> '' then
    begin
      X:=FindItem(lvObjects,ObjName);
      if Assigned(x) then
      begin
        lvObjects.Items.Delete(x.Index);
      end;
    end;
  end;
end;

procedure TfrmMain.EventObjectNew(const DataModule: TDmN;
  const ObjType: integer; const ObjName: String);
var x:TListItem;
begin
  if CurrSelDatabase.DataModule = DataModule then
  if NodeMatch(FCurrSelTreeNode.NodeType,ObjType) then
  begin
    if ObjName <> '' then
    begin
      X:=FindItem(lvObjects,ObjName);
      if not Assigned(x) then
      begin
        GetDBObjects(CurrSelDatabase, FCurrSelTreeNode, FCurrSelTreeNode.NodeType);
        FCurrSelTreeNode.ShowSystem := FViewSystemData;
        FillObjectList (FCurrSelTreeNode);
      end;
    end;
  end;
end;

procedure TfrmMain.ObjectRefreshExecute(Sender: TObject);
begin
  if Assigned (FCurrSelTreeNode) then
    FCurrSeltreeNode.ObjectList.Clear;
  tvMainChange(nil, nil);
end;


procedure TfrmMain.lvObjectsEditing(Sender: TObject; Item: TListItem;
  var AllowEdit: Boolean);
begin
  AllowEdit := FCurrSelTreeNode.NodeType = NODE_GENERATORS;
end;

procedure TfrmMain.RefreshUsers(const ServerNode: TibcServerNode);
begin
  if assigned(ServerNode) then
  begin
    ServerNode.Reload;
    if ServerNode = tvMain.Selected.Data then
      tvMain.OnChange(tvMain,tvMain.Selected);
  end;
end;

procedure TfrmMain.SetCurrSelDatabase(const Value: TibcDatabaseNode);
begin
  if f_CurrSelDatabase <> Value then
  begin
    FrameGenerators1.DataModule := nil;
//    if FrameGenerators1.Visible then
  end;
  f_CurrSelDatabase := Value;
end;

procedure TfrmMain.actHighlightOptionsExecute(Sender: TObject);
var
  EditorOptions: TfrmEditorOptions;
  i:integer;
begin
  EditorOptions := TfrmEditorOptions.Create(self);
  try
    EditorOptions.SynSQLSyn1.Assign(dmMain.SynSQLSyn1);
    EditorOptions.FormId := 'HighlightOptionsState';
    if EditorOptions.ShowModal = mrOK then
    begin
      dmMain.SynSQLSyn1.Assign(EditorOptions.SynSQLSyn1);
      gAppSettings[SYNTAX_FONT_NAME] := EditorOptions.SynEditor.Font.Name;
      gAppSettings[SYNTAX_FONT_CHARSET] := EditorOptions.SynEditor.Font.CharSet;
      for I := 0 to Screen.CustomFormCount-1 do
      begin
        if Screen.CustomForms[I] is TIBOConsoleForm then
          TIBOConsoleForm(Screen.CustomForms[I]).UseSyntaxFont(gAppSettings[SYNTAX_FONT_NAME],gAppSettings[SYNTAX_FONT_CHARSET] );
        try
          SetAllSyntaxFontsNameCharset(Screen.CustomForms[I],gAppSettings[SYNTAX_FONT_NAME],gAppSettings[SYNTAX_FONT_CHARSET] );
        except
        end;
      end;
    end;
  finally
    EditorOptions.Release;
  end;
end;

procedure TfrmMain.actHighlightOptionsUpdate(Sender: TObject);
begin
  actHighlightOptions.Enabled := true;
end;

constructor TfrmMain.Create(aOwner: TComponent);
begin
  inherited;
  FormId := 'MainState';
  Application.HelpFile := ExtractFilePath(Application.ExeName)+CONTEXT_HELP_FILE;
end;

procedure TfrmMain.OnStartProc(Sender: TObject);
begin

end;

procedure TfrmMain.ActionQueryBuilderUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := Assigned(FCurrSelServer) and Assigned(F_CurrSelDatabase);
end;

end.
