{******************************************************************}
{  This Unit was created to by Lorenzo Mengoni - (Ancona, Italy)
   for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.
}
{******************************************************************}
{ The contents of this file are used with permission, subject to   }
{ the Mozilla Public License Version 1.1 (the "License"); you may  }
{ not use this file except in compliance with the License. You may }
{ obtain a copy of the License at                                  }
{ http://www.mozilla.org/MPL/MPL-1.1.html                          }
{                                                                  }
{ Software distributed under the License is distributed on an      }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or   }
{ implied. See the License for the specific language governing     }
{ rights and limitations under the License.                        }
{                                                                  }
{******************************************************************} 

unit frmuUDFInputParam;

interface

uses
{$IFDEF LINUX}
  QControls, QForms, QDialogs, QComCtrls, QStdCtrls, QMenus,
  Types, QTypes, QImgList, QExtCtrls,
  QStdActns, QActnList, SynEdit, SynEditPrint, IBCXDummies,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Messages, Controls, Forms, Dialogs, ComCtrls, StdCtrls,
  Menus, ImgList, StdActns, ActnList, Graphics, Spin,
{$ENDIF}
  SysUtils, Classes, IBOConsoleForm;

type
  TfrmUDFAddInput = class(TIBOConsoleForm)
    btnOK: TButton;
    btnCancel: TButton;
    btnHelp: TButton;
    edParameter: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    cmbRtnType: TComboBox;
    procedure btnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses LMMessageDialog;

{$R *.DFM}

procedure TfrmUDFAddInput.btnOKClick(Sender: TObject);
begin
  if edParameter.Text = '' then
  begin
    LMMessageDlg(55, mtError, [mbOK], 0);
    Exit;
  end;

  ModalResult := mrOK;
end;

procedure TfrmUDFAddInput.FormCreate(Sender: TObject);
begin
//  HelpContext := IDH_UDF_Input_Parameters_Dialog;
  cmbRtnType.ItemIndex := 1;
end;

procedure TfrmUDFAddInput.btnHelpClick(Sender: TObject);
begin
//  Application.HelpCommand(HELP_CONTEXT, IDH_UDF_Input_Parameters_Dialog);
end;

end.
