{************************************************************************
  This Unit was modified to be interfaced in IBObjects
  by Lorenzo Mengoni - (Ancona, Italy)

  for suggestion and contributions email to lorenzo@mengoni.com

  This software is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied.
  If you live or are intended to use this software in countries
  where this is not applicable ("AS IS" basis), DO NOT USE IT.
}
{
 * The contents of this file are subject to the InterBase Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.
 *
 * You may obtain a copy of the License at http://www.Inprise.com/IPL.html.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.  The Original Code was created by Inprise
 * Corporation and its predecessors.
 *
 * Portions created by Inprise Corporation are Copyright (C) Inprise
 * Corporation. All Rights Reserved.
 *
 * Contributor(s): Jeff Overcash, Krzysztof Golko, Sergey Gavrilev.

08.08.2002, Kalwa:
- CHG: Replaced TscExcelExport with TExcelExport. This component is created
  on runtime.
- NEW: Added TSaveDialog "dlgSaveXLS" to select a filename.

10.August.2002, Lorenzo:
- Merged Code from Akim for excel export whit a new routine for csv and
  the original for txt in SaveOutput procedure
- Suppressed the commit and rollback buttons, we have IB_TransactionBars

23.August.2002, Lorenzo:
- Modified Events for handling the name of the object involved hooked directly to mainform

24.November.2003, Lorenzo:
- Added new feature, tables and fields listing like in IBWSQL and IBObjects components.

4.December.2003, Lorenzo:
- Fixed Save Output Bug
- modified xml file layout in Save output, all data are declared as CDATA.
- added statistics and sql query to xml file output.

26.December.2003, Lorenzo:
- Fixed SQL Union Bug: trapped exception generated by TIBOQuery.RecordCount that does not handle correctly

24.November.2004, Lorenzo:
- Added new feature, QueryBuilder functions.
- Added Memo for sql errors and removed the code of DisplayMsg function for SQL errors
- Added OQBuilderDialog1
- Added OQBEngineIBO1
- Added pgcInput with TabQueryBuilder and TabSQLInput
- Added TabColumns in pgcOutput
- Added IOQBForm inheritance to TdlgWisql
- modified QueryExecute and QueryPrepare Actions

New behavior:
when Querybuilder is active the run and prepare query actions let the OQBEngineIBO1
produce the sql statement and put it in reSqlInput and then new sql is treated as usual

when reSqlInput is active all is the same as in old version

15.January.2005 , Lorenzo:
- Added properties
   fCreateDatabaseParsed:boolean;
   fOwnedDataModule:boolean;
- Added function
   ParseDBCreate
- fixed create database behaviour
   modified QueryExecuteUpdate to get enabled when createdatabase is present on script
   when found a new datamodule is created and used to create the real database.
   when form is destroied or Datamodule is reassigned the new created is destroied


}

unit wisql;

interface

uses
{$IFDEF LINUX}
  Types, QGraphics, QForms, QDialogs, IBCXDummies, QStdActns, QActnList, QMenus,
  QTypes, QComCtrls, QExtCtrls, QStdCtrls, QDBGrids, QGrids, QControls,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, Menus, ComCtrls, ToolWin,
  ExtCtrls, StdCtrls, Grids, DBGrids, ImgList, StdActns, ActnList,
{$ENDIF}
  SysUtils, Classes, IBOConsoleForm, SynEditTypes,
  Db, zluibcClasses, IB_COmponents, IBODataset, IB_Schema,
  zluSQL, MemoLists, SynEditPrint, SynEdit, XLSExport, IB_Session, IB_Process,
  IB_DataScan, IB_Export, dmuNode, IB_TransactionBar, Buttons, QBuilder,
  OQBEibo, SynCompletionProposal;

type
  TCreateDBEvent = procedure (var Database: TIB_Connection) of Object;
  TConnectDBEvent = procedure (const Server: String;
                               const Database: TIB_Connection) of Object;
  TServerConnectEvent = procedure (const ServerName: String) of Object;
  TDisconnectDBEvent = procedure (const Database: TDmN) of Object;
  TUpdateObjectEvent = procedure (const DataModule: TDmN;
                                  const ObjectType: integer;
                                  const ObJectName:String) of Object;
  TDropDBEvent = procedure of Object;

  TdlgWisql = class(TIBOConsoleDatabaseForm, IOQBForm)
    pgcOutput: TPageControl;
    TabData: TTabSheet;
    dbgSQLResults: TDBGrid;
    TabResults: TTabSheet;
    splISQLHorizontal: TSplitter;
    GridSource: TDataSource;
    pmClientDialect: TPopupMenu;
    Dialect1: TMenuItem;
    Dialect2: TMenuItem;
    Dialect3: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    QueryLoadScript1: TMenuItem;
    QueryNext1: TMenuItem;
    QueryPrevious1: TMenuItem;
    QueryPrevious2: TMenuItem;
    QuerySaveScript1: TMenuItem;
    SaveOutput1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Database1: TMenuItem;
    Disconnect1: TMenuItem;
    Create1: TMenuItem;
    Drop1: TMenuItem;
    N5: TMenuItem;
    Connect1: TMenuItem;
    pnlEnterSQL: TPanel;
    stbISQL: TStatusBar;
    Print1: TMenuItem;
    Close1: TMenuItem;
    DialectAction1: TAction;
    DialectAction2: TAction;
    DialectAction3: TAction;
    QueryPrevious: TAction;
    QueryNext: TAction;
    QueryExecute: TAction;
    QueryLoadScript: TAction;
    QuerySaveScript: TAction;
    QuerySaveOutput: TAction;
    pmLastFiles: TPopupMenu;
    EditOptions: TAction;
    FileClose: TAction;
    QueryPrepare: TAction;
    EditFind: TAction;
    sbData: TStatusBar;
    EditFont: TAction;
    Help1: TMenuItem;
    SQLReference1: TMenuItem;
    N6: TMenuItem;
    Options1: TMenuItem;
    N8: TMenuItem;
    mnuEdit1: TMenuItem;
    Undo2: TMenuItem;
    N9: TMenuItem;
    mnuEdCopy1: TMenuItem;
    Cut2: TMenuItem;
    Paste2: TMenuItem;
    SelectAll2: TMenuItem;
    mnuEdN1: TMenuItem;
    mnuEdFind1: TMenuItem;
    Font2: TMenuItem;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditUndo1: TEditUndo;
    lblFileName: TLabel;
    TabStats: TTabSheet;
    lvStats: TListView;
    Prepare1: TMenuItem;
    DatabaseConnectAs: TAction;
    DatabaseDisconnect: TAction;
    DatabaseCreate: TAction;
    DatabaseDrop: TAction;
    pmRichEdit: TPopupMenu;
    Paste1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Undo1: TMenuItem;
    Selectall1: TMenuItem;
    N3: TMenuItem;
    FontDialog1: TFontDialog;
    FindDialog1: TFindDialog;
    actWisql: TActionList;
    mnuPrev: TPopupMenu;
    mnuNext: TPopupMenu;
    Newconnection1: TMenuItem;
    reSqlInput: TSynEdit;
    reSqlOutput: TMemo;
    Print: TAction;
    PrintDialog: TPrintDialog;
    SynEditPrint: TSynEditPrint;
    grdProcedures: TStringGrid;
    SaveSQLHistory: TAction;
    LoadSQLHistory: TAction;
    dlgHistorySave: TSaveDialog;
    dlgSaveSQL: TSaveDialog;
    dlgLoadSQL: TOpenDialog;
    dlgHistoryLoad: TOpenDialog;
    SaveSQLHistory1: TMenuItem;
    LoadSQLHistory1: TMenuItem;
    QueryFetchAll: TAction;
    QueryFetchAll1: TMenuItem;
    EditRedo: TAction;
    Redo1: TMenuItem;
    IB_TransactionBarDefault: TIB_TransactionBar;
    IB_TransactionBarDDL: TIB_TransactionBar;
    dlgSaveOutPut: TSaveDialog;
    tsParameters: TTabSheet;
    ScrollBoxParams: TScrollBox;
    PanelTopButtons: TPanel;
    SpeedButtonQueryPrevious: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButtonQueryNext: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButtonQueryExecute: TSpeedButton;
    SpeedButtonQueryPrepare: TSpeedButton;
    SpeedButtonQueryFetchAll: TSpeedButton;
    SpeedButtonQueryLoadScript: TSpeedButton;
    SpeedButtonQuerySaveScript: TSpeedButton;
    SpeedButtonEditFind: TSpeedButton;
    SpeedButtonWindowList: TSpeedButton;
    SpeedButtonPrint: TSpeedButton;
    SpeedButtonQuerySaveOutput: TSpeedButton;
    PanelLeft: TPanel;
    PanelRight: TPanel;
    Splitter1: TSplitter;
    ListBoxTables: TListBox;
    ListBoxFields: TListBox;
    PanelAddTable: TPanel;
    ButtonAddTable: TButton;
    ButtonAddField: TButton;
    Splitter3: TSplitter;
    Panel2: TPanel;
    Panel3: TPanel;
    PanelAddField: TPanel;
    aAddTable: TAction;
    aAddField: TAction;
    CheckBoxUseAlias: TCheckBox;
    ActionQueryBuilder: TAction;
    QueryBuilder1: TMenuItem;
    N4: TMenuItem;
    TabSQLErrors: TTabSheet;
    MemoSQLErrors: TMemo;
    OQBuilderDialog1: TOQBuilderDialog;
    OQBEngineIBO1: TOQBEngineIBO;
    pgcInput: TPageControl;
    TabSQLInput: TTabSheet;
    TabQueryBuilder: TTabSheet;
    TabColumns: TTabSheet;
    QBSaveDialog1: TSaveDialog;
    QBOpenDialog1: TOpenDialog;
    SynCompletionProposal1: TSynCompletionProposal;
    procedure QueryExecuteExecute(Sender: TObject);
    procedure QueryLoadScriptExecute(Sender: TObject);
    procedure QuerySaveScriptExecute(Sender: TObject);
    procedure QueryPreviousExecute(Sender: TObject);
    procedure QueryNextExecute(Sender: TObject);
    procedure QuerySaveOutputExecute(Sender: TObject);
    procedure DialectChange(Sender: TObject);
    procedure DialectUpdate(Sender: TObject);
    procedure reSqlInputKeyPress(Sender: TObject; var Key: Char);
    procedure cbServersChange(Sender: TObject);
    procedure EditOptionsExecute(Sender: TObject);
    procedure EditFindExecute(Sender: TObject);
    procedure QueryPrepareExecute(Sender: TObject);
    procedure dbgSQLResultsCellClick(Column: TColumn);
    procedure dbgSQLResultsDrawColumnCell(Sender: TObject;
      const Rect: TRect; DataCol: Integer; Column: TColumn;
      State: TGridDrawState);
    procedure dbgSQLResultsEditButtonClick(Sender: TObject);
    procedure SQLReference1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FileCloseExecute(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Drop1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure Create1Click(Sender: TObject);
    procedure QueryPreviousUpdate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure QuerySaveOutputUpdate(Sender: TObject);
    procedure DatabaseDisconnectUpdate(Sender: TObject);
    procedure DatabaseConnectAsUpdate(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure mnuPrevPopup(Sender: TObject);
    procedure NavMenuClick(Sender: TObject);
    procedure mnuNextPopup(Sender: TObject);
    procedure Newconnection1Click(Sender: TObject);
    procedure reSqlInputStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure EditFontExecute(Sender: TObject);
    procedure EditFindUpdate(Sender: TObject);
    procedure SaveSQLHistoryExecute(Sender: TObject);
    procedure LoadSQLHistoryExecute(Sender: TObject);
    procedure QueryFetchAllUpdate(Sender: TObject);
    procedure QueryFetchAllExecute(Sender: TObject);
    procedure EditCopy1Execute(Sender: TObject);
    procedure EditCut1Execute(Sender: TObject);
    procedure EditPaste1Execute(Sender: TObject);
    procedure EditSelectAll1Execute(Sender: TObject);
    procedure EditUndo1Execute(Sender: TObject);
    procedure EditCopy1Update(Sender: TObject);
    procedure EditCut1Update(Sender: TObject);
    procedure EditPaste1Update(Sender: TObject);
    procedure EditUndo1Update(Sender: TObject);
    procedure EditRedoExecute(Sender: TObject);
    procedure EditRedoUpdate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DatabaseCreateUpdate(Sender: TObject);
    procedure dlgSaveOutputTypeChange(Sender: TObject);
    procedure reSqlInputChange(Sender: TObject);
    procedure QueryExecuteUpdate(Sender: TObject);
    procedure QuerySaveScriptUpdate(Sender: TObject);
    procedure QueryPrepareUpdate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure aAddTableUpdate(Sender: TObject);
    procedure aAddTableExecute(Sender: TObject);
    procedure ListBoxTablesClick(Sender: TObject);
    procedure aAddFieldUpdate(Sender: TObject);
    procedure aAddFieldExecute(Sender: TObject);
    procedure PanelLeftResize(Sender: TObject);
    procedure ListBoxTablesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBoxFieldsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TabQueryBuilderShow(Sender: TObject);
    procedure QueryLoadScriptHint(var HintStr: String;
      var CanShow: Boolean);
    procedure QuerySaveScriptHint(var HintStr: String;
      var CanShow: Boolean);
    procedure pgcInputChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FQryDataSet: TIBOQuery;

    FOnCreateDB: TCreateDBEvent;
    FOnConnectDB: TConnectDBEvent;
    FOnServerConnect: TServerConnectEvent;
    FOnDropDatabase: TDropDBEvent;
    FServerList: TStringList;
    FServerIndex,
    FCurrSQLDialect: integer;
    FConnected: boolean;
    FAutoDDL: boolean;
    FQueryBuffer: TMemoList;
    fpgcOutputHeight:integer;
    fISQLObj: TIBOSqlObj;
    fLabelsWidth:integer;
    fTablesloaded:Boolean;
    fCreateDatabaseParsed:boolean;
    fOwnedDataModule:boolean;
    procedure UpdateConnectStatus(const Connected: boolean);
    procedure UpdateOutputWindow (const Data: String);
    procedure ProcessISQLEvent (const ISQLEvent: TSQLEvent; const SubEvent: TSQLSubEvent;
                                const Data: Variant; const DataModule: TDmN; const ObjectName:String);
    procedure SetAutoDDL(const Value: boolean);
    procedure SetClientDialect(const Value: integer);
    procedure ShowStatistics(const Stats: TStringList);
    procedure CheckDisconnect(Sender: TIB_Connection);
    procedure SaveOutput;
    procedure DB_KEYGetText(Sender: TField; var Text: String; DisplayText: Boolean);
    procedure SaveOutputText(aFileName: String);
    procedure SaveOutputCSV(aFileName: String);
    procedure SaveOutputToExcel(aFileName: String);
    procedure SaveOutputHTML(aFileName: String);
    procedure SaveOutputXML(aFileName: String);
    procedure CreateParamEditControls;
    procedure CreateParamEdit(ParamIndex: integer;
      var TopLeftPoint: TPoint);
    function GetParamEditValue(n: integer): string;
    procedure DestroyParamControls;
    procedure ParamEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ResetISQLObj;
    procedure UpdateListTables;
    procedure ClearQBuilder;
    function ParseDBCreate: boolean;
  protected
    procedure SetDataModule(const Value: TDmN); override;
    function GetExtra:Word; override;
    procedure SetExtra(const Value:Word); override;
    procedure DoOnStart; override;
  public
    { Public declarations }
    New_connection:boolean;
    procedure CreateParams(var Params: TCreateParams); override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ShowDialog;
    function CheckTransactionStatus(const Closing: boolean): integer;
    function ConnectAsDatabase(Sender: Tobject): boolean;
    function CreateDatabase(Sender: TObject): boolean;
  published
    property OnCreateDatabase: TCreateDBEvent read FOnCreateDB write FOnCreateDB;
    property OnConnectDatabase: TConnectDBEvent read FOnConnectDB write FOnConnectDB;
    property OnDropDatabase: TDropDBEvent read FOnDropDatabase write FOnDropDatabase;
    property OnServerConnect: TServerConnectEvent read FOnServerConnect write FOnServerConnect;
    property ServerList: TStringList read FServerList write FServerList;
    property ServerIndex: integer read FServerIndex write FServerIndex;
    property AutoDDL: boolean read FAutoDDL write SetAutoDDL;
    property Dialect: integer read FCurrSQLDialect write SetClientDialect;
  protected
    fQBArea : TOQBArea;
    fQBGrid : TOQBGrid;
    fQBModified : boolean;
    function GetQBGrid:TOQBGrid;
    function GetQBArea:TOQBArea;
    function GetQBTables:TListBox;
    procedure SetPagesHeight(const Value:Integer);
    function GetPagesHeight:Integer;
    function GetQBTablesWidth:Integer;
    procedure SetQBTablesWidth(const Value:Integer);
    procedure SetQBOptions(const Value: TOQBOptions);
    function GetQBButtons:TOQBbuttons;
    procedure SetQBButtons(const Value: TOQBbuttons);
    function GetQBOptions: TOQBOptions;
    function GetQBDialog:TOQBuilderDialog;
    procedure SetQBDialog(const Value: TOQBuilderDialog);
    property QBTables:TListBox read GetQBTables;
    property QBArea:TOQBArea read GetQBArea;
    property QBGrid:TOQBGrid read GetQBGrid;
    function GetQBModified: boolean;
    procedure SetQBModified(const Value: boolean);
    procedure SetFormScreenPosition(const aTop, aLeft, aHeight, aWidth:Integer; aWindowState:TWindowState);
  end;

implementation

uses
{$IFDEF MSWINDOWS}
  Printers, 
{$ENDIF}
  frmEditorOptionsU,
  frmuMessage, IBOCGlobal, frmuSQLOptions, frmuDisplayBlob,
  frmuDispMemo, zluContextHelp, zluUtility, frmuMain, IBSQL,
  Math, IBOCPersistent, dmuMain, frmuWindowList, LMMessageDialog, TypInfo
  , StrUtils ;

const
  OBJECTNAME = '\ISQL';

{$IF Declared(Forms)}
{$R *.DFM}
{$IFEND}
{$IF Declared(QForms)}
{$R *.xfm}
{$IFEND}

procedure TdlgWisql.QuerySaveOutputExecute(Sender: TObject);
begin
  SaveOutput;
end;

procedure TdlgWisql.QueryNextExecute(Sender: TObject);
var
  iQry: TStrings;
begin
  iQry := FQueryBuffer.GetNext;
  if Assigned(iQry) then
    reSQLInput.Lines := iQry
  else
    reSQLInput.lines.Clear;
  reSQLInput.Modified := FALSE;
  ResetISQLObj;
end;

procedure TdlgWisql.QueryPreviousExecute(Sender: TObject);
var
  iQry: TStrings;
begin
  iQry := FQueryBuffer.GetPrev;
  if Assigned(iQry) then
    reSQLInput.Lines := iQry
  else
    reSQLInput.Lines.Clear;
  reSQLInput.Modified := FALSE;
  ResetISQLObj;
end;

procedure TdlgWisql.QuerySaveScriptExecute(Sender: TObject);
begin
  begin
    if pgcInput.ActivePage = TabQueryBuilder then
    begin
      if QBSaveDialog1.Execute then
        OQBuilderDialog1.SaveModel(QBSaveDialog1.FileName);
    end
    else
    if dlgSaveSQL.Execute then
    begin
      if FileExists(dlgSaveSQL.FileName) then
        if LMMessageDlg(0, [dlgSaveSQL.FileName],mtConfirmation, mbYesNoCancel, 0) <> mrYes then Exit;
      reSQLInput.Lines.SaveToFile(dlgSaveSQL.FileName);
      reSQLInput.Modified := false;
    end;
  end;
end;

procedure TdlgWisql.QueryLoadScriptExecute(Sender: TObject);
begin
  try
    Screen.Cursor := crHourGlass;
    if pgcInput.ActivePage = TabQueryBuilder then
    begin
      if QBOpenDialog1.Execute then
      begin
        QBArea.ClearAll;
        QBGrid.ColCount := 2;
        OQBuilderDialog1.OpenModel(QBOpenDialog1.FileName);
        fQBModified := False;
      end;
    end
    else
    begin
      if dlgLoadSQL.Execute then
      try
          reSQLInput.Lines.LoadFromFile(dlgLoadSQL.FileName);
          reSQLInput.Modified := TRUE;
          reSQLInput.SetFocus;
      except
        on E:Exception do
        begin
          LMMessageDlg(E.Message + #10#13 + Format(getPrompt(1),[dlgLoadSQL.FileName]), mtError, [mbOK], 0);
          Exit;
        end;
      end;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

function TdlgWisql.GetParamEditValue(n:integer):string;
var
  i : Integer;
begin
  result := '';
  for i:=0 to ScrollBoxParams.ComponentCount-1 do
    if ScrollBoxParams.Components[i] is TEdit then
    with TEdit(ScrollBoxParams.Components[i]) do
    begin
      if Tag = n then
      begin
        result := Text;
        break;
      end;
    end;
end;

procedure TdlgWisql.QueryExecuteExecute(Sender: TObject);
var
  i : Integer;
  lErrors:boolean;
begin
  if pgcInput.ActivePage = TabQueryBuilder then
  begin
    OQBEngineIBO1.DoSql;
    reSqlInput.Lines.Text := OQBEngineIBO1.GeneratedSQL;
  end;

  if Assigned(fISQLObj)
     and (fISQLObj.HasParams)
     and fISQLObj.WaitForParams
  then
  begin
    for i := 0 to High(fISQLObj.Params) do
    begin
      fISQLObj.Params[i].Value := GetParamEditValue(i);
    end;
    fISQLObj.DoISQLWithParams;
    pgcOutput.ActivePage := TabData;
    exit;
  end;

  fCreateDatabaseParsed := ParseDBCreate;

  if fCreateDatabaseParsed then
  begin
    DataModule := nil;
    DataModule := TDmn.Create(Self);
    DataModule.DatabaseNode := nil;
    DataModule.ServerNode := frmMain.CurrSelServer;
    fOwnedDataModule := True;
  end;

  if Assigned (FQryDataSet) then
  begin
    GridSource.DataSet := nil;
    FQryDataSet.Free;
  end;

  FQryDataSet := TIBOQuery.Create(self);

  if Assigned (DataModule) then
  begin
    FQryDataset.IB_Connection := DataModule.Connection;
    FQryDataset.IB_Transaction := DataModule.Transaction;
  end
  else
  begin
    exit;
  end;

  reSQLOutput.Clear;
  fISQLObj := nil;
  lErrors := False;
  try
    lvStats.Items.BeginUpdate;
    lvStats.Items.Clear;
    lvStats.Items.EndUpdate;

    fISQLObj := TIBOSqlObj.Create (Self);
    Screen.Cursor := crSQLWait;
    try
        fISQLObj.AutoDDL := FAutoDDL;
        fISQLObj.Query := reSQLInput.Lines;
        fISQLObj.DataModule := DataModule;
        fISQLObj.DataSet := FQryDataSet;
        fISQLObj.OnDataOutput := UpdateOutputWindow;
        fISQLObj.OnISQLEvent := ProcessISQLEvent;
        pgcOutput.ActivePage := TabData;
        fISQLObj.Statistics := true;
        Cursor := crSQLWait;
        lvStats.Items.BeginUpdate;
        lvStats.Items.Clear;
        lvStats.Items.EndUpdate;
        fISQLObj.DoIsql;
        Cursor := crDefault;
        if reSQLInput.Modified then
        begin
          FQueryBuffer.Add(reSqlInput.Lines);
          reSQLInput.Modified := false;
        end;
        if gAppSettings[CLEAR_INPUT]
           and not fISQLObj.WaitForParams
           and (pgcInput.ActivePage <> TabQueryBuilder) 
        then
        begin
          reSQLInput.Lines.Clear;
          FQueryBuffer.MovePast;
        end;
        MemoSQLErrors.Clear;
    except on
      E: EIsqlException do
      begin
        Cursor := crDefault;
        pgcOutput.ActivePage := TabSQLErrors;
        MemoSQLErrors.Lines.Text := e.Message;
        lErrors := True;
      end;
    end;
  finally
    if FQryDataset.StatementType = stExecProcedure then
    begin
      dbgSQLResults.Visible := false;
      grdProcedures.Visible := true;
      grdProcedures.RowCount := 2;
      grdProcedures.ColCount := FQryDataset.FieldCount;
      for i := 0 to FQryDataset.FieldCount - 1 do
        grdProcedures.Cells[i, 0] := FQryDataset.Fields[i].Name;

      for i := 0 to FQryDataset.FieldCount - 1 do
        grdProcedures.Cells[i, grdProcedures.RowCount - 1] :=
           FQryDataset.Fields[i].AsString;
    end
    else
    begin
      dbgSQLResults.Visible := true;
      grdProcedures.Visible := false;
      for i := 0 to FQryDataset.FieldCount - 1 do
        if  FQryDataset.Fields[i].FieldName = 'DB_KEY' then
          FQryDataset.Fields[i].OnGetText := DB_KEYGetText;
      GridSource.DataSet := FQryDataset;
    end;
    ShowStatistics (fISQLObj.StatisticsList);
    if not lErrors then
      if (fISQLObj.HasParams and fISQLObj.WaitForParams) then
      begin
        CreateParamEditControls;
        tsParameters.TabVisible := true;
        pgcOutput.ActivePage := tsParameters;
      end
      else
      begin
        tsParameters.TabVisible := false;
        pgcOutput.ActivePage := TabData;
        FreeAndNil(fISQLObj);
      end
    else
      FreeAndNil(fISQLObj);
    Screen.Cursor := crDefault;
  end;
end;

procedure TdlgWisql.UpdateOutputWindow(const Data: String);
begin
  reSqLOutput.Lines.Add (Data);
end;

procedure TdlgWisql.DialectChange(Sender: TObject);
var
  tmpdialect: integer;

begin
  if Assigned (DataModule) then
  begin
    tmpdialect := TAction(Sender).Tag;
    with DataModule.Connection do begin
      try
        if tmpdialect <> SQLDialect then
          DisplayMsg (WAR_DIALECT_MISMATCH, Format(GetPrompt(64),[SQLDialect, tmpdialect]));
        SQLDialect := TAction(Sender).tag;
      except on E: Exception do
         DisplayMsg (ERR_INV_DIALECT, Format('%s'+CRLF+GetPrompt(65),[E.Message, tmpdialect]));
      end;
    end;
  end;
  Dialect := TAction(Sender).Tag;
end;

procedure TdlgWisql.DialectUpdate(Sender: TObject);
begin
   with Sender as TAction do
     Checked := (FCurrSQLDialect = Tag)
end;

procedure TdlgWisql.ShowDialog;
begin
  reSQLInput.Lines.Clear;
  reSQLOutput.Lines.Clear;

  OpenWindows.UpdateWindowList(Caption, TObject(Self), true);
  if Assigned (DataModule) then
  begin
    DataModule.Connection.BeforeDisconnect := CheckDisconnect;
    if not DataModule.Connection.Connected then
    begin
      DataModule.Connection.Connected := true;
    end;
    FConnected := false;
    UpdateConnectStatus(true);
    Dialect := DataModule.Connection.SQLDialect;
  end
  else
    UpdateConnectStatus(false);

  FQueryBuffer.Clear;
  Show;
  OpenWindows.UpdateWindowList(Caption, TObject(Self));
end;

procedure TdlgWisql.reSqlInputKeyPress(Sender: TObject; var Key: Char);
begin
{$IFNDEF NOT_YET_IN_KYLIX}
  if (Key = #10) and (GetKeyState(VK_CONTROL) < 0) then
  begin
    Key := #0;
    QueryExecuteExecute(Sender);
  end;
{$ENDIF}
end;

procedure TdlgWisql.ProcessISQLEvent(const ISQLEvent: TSQLEvent;
  const SubEvent: TSQLSubEvent; const Data: Variant; const DataModule: TDmN;
  const ObjectName:String);
var
  objType: integer;

begin
  case ISQLEvent of
    evntISQL:
    begin
      case SUbEvent of
        seAutoDDL:
          AutoDDL := Data;
      end;
    end;
    evntDialect:
    begin
      case SubEvent of
        seDialect1:
          DialectChange(DialectAction1);
        seDialect2:
          DialectChange(DialectAction2);
        seDialect3:
          DialectChange(DialectAction3);
      end;
    end;
    evntConnect:
    begin
      if Assigned (OnConnectDatabase) and
        gAppSettings[UPDATE_ON_CONNECT] then
      begin
        { force a path before the database name if this is a local connection }
        if DataModule.Connection.Protocol = cpLocal then
          if ExtractFilePath(DataModule.Connection.DatabaseName) = '' then
            DataModule.Connection.DatabaseName := ExtractFilePath(Application.ExeName)+DataModule.Connection.Databasename;

      end;
      UpdateConnectStatus(true);
      FCurrSQLDialect := DataModule.Connection.SQLDialect;
      FConnected := true;
      fTablesloaded := False;
      UpdateListTables;
    end;

    evntCreate:
    begin
      if SubEvent = seDatabase then
      begin
        UpdateConnectStatus(true);
        if Assigned (OnCreateDatabase) and
           gAppSettings[UPDATE_ON_CREATE] then
        OnCreateDatabase (DataModule.Connection);

        FCurrSQLDialect := DataModule.Connection.SQLDialect;
        FConnected := true;
        UpdateConnectStatus(true);
      end
      else
      begin
        case SubEvent of
          seDomain: objType := NODE_DOMAIN;
          seTable: objType := NODE_TABLE;
          seView: objType := NODE_VIEW;
          seProcedure: objType := NODE_PROCEDURE;
          seFunction: objType := NODE_FUNCTION;
          seGenerator: objType := NODE_GENERATOR;
          seException: objType := NODE_EXCEPTION;
          seFilter: objType := NODE_BLOB_FILTER;
          seRole: objType := NODE_ROLE;
          else
            objType := NODE_UNK;
        end;
        frmMain.EventObjectNew(DataModule, ObjType, ObjectName);
      end;
    end;

    evntAlter:
    begin
        case SubEvent of
          seDomain: objType := NODE_DOMAIN;
          seTable: objType := NODE_TABLE;
          seView: objType := NODE_VIEW;
          seProcedure: objType := NODE_PROCEDURE;
          seFunction: objType := NODE_FUNCTION;
          seGenerator: objType := NODE_GENERATOR;
          seException: objType := NODE_EXCEPTION;
          seFilter: objType := NODE_BLOB_FILTER;
          seRole: objType := NODE_ROLE;
          else
            objType := NODE_UNK;
        end;
        frmMain.EventObjectRefresh(DataModule, objType, ObjectName);
    end;

    evntDrop:
    begin
      if SubEvent = seDatabase then
      begin
       if Assigned(OnDropDatabase) then
         OnDropDatabase;
       UpdateConnectStatus(false);
      end
      else
      begin
        case SubEvent of
          seDomain: objType := NODE_DOMAIN;
          seTable: objType := NODE_TABLE;
          seView: objType := NODE_VIEW;
          seProcedure: objType := NODE_PROCEDURE;
          seFunction: objType := NODE_FUNCTION;
          seGenerator: objType := NODE_GENERATOR;
          seException: objType := NODE_EXCEPTION;
          seFilter: objType := NODE_BLOB_FILTER;
          seRole: objType := NODE_ROLE;
          else
            objType := NODE_UNK;
        end;
        frmMain.EventObjectDrop(DataModule, ObjType, ObjectName);
      end;
    end;

    evntTransaction:
    begin
      frmMain.EventObjectNew(DataModule, NODE_UNK, '');
    end;
  end;
end;

constructor TdlgWisql.Create(AOwner: TComponent);
begin
  inherited;

  fQBArea := nil;
  fQBGrid := nil;

  fpgcOutputHeight := 0;
  fISQLObj := Nil;
  ImageIndex := NODE_WISQL_IMG;
  FormId := 'SQLState';
  FServerList := TStringList.Create;
  FConnected := false;
  Dialect := gAppSettings[DEFAULT_DIALECT];
  AutoDDL := gAppSettings[AUTO_COMMIT_DDL];

  { On create, the input window is always 1/2 of the window }
  pgcOutput.Height := Self.ClientHeight div 2;

  FQueryBuffer := TMemoList.Create;

  fCreateDatabaseParsed:=False;

end;

destructor TdlgWisql.Destroy;
begin
  FServerList.Free;
  FQueryBuffer.Free;
  inherited;
end;

procedure TdlgWisql.cbServersChange(Sender: TObject);

begin
  Disconnect1Click(Sender);
  if Assigned(DataModule) and not Assigned(DataModule.Connection.dbHandle) then
    if Assigned (OnServerConnect) then
      OnServerConnect ((Sender as TComboBox).Text);
end;

procedure TdlgWisql.EditOptionsExecute(Sender: TObject);
var
  origDialect: integer;
  origDDL : boolean;
  optsDlg: TfrmSQLOptions;
begin
  optsDlg := TfrmSQLOptions.Create (self);
  origDialect := gAppSettings[DEFAULT_DIALECT];
  origDDL := gAppSettings[AUTO_COMMIT_DDL];
  OptsDlg.ShowModal;
  OptsDlg.Free;
  if OrigDDL <> gAppSettings[AUTO_COMMIT_DDL] then
    AutoDDL := gAppSettings[AUTO_COMMIT_DDL];

  if OrigDialect <> gAppSettings[DEFAULT_DIALECT] then
    Dialect := gAppSettings[DEFAULT_DIALECT];
end;

procedure TdlgWisql.EditFindExecute(Sender: TObject);
begin
  FindDialog1.Execute;
end;

procedure TdlgWisql.QueryPrepareExecute(Sender: TObject);
begin
  if not Assigned(DataModule) then exit;
  try
    if pgcInput.ActivePage = TabQueryBuilder then
    begin
      OQBEngineIBO1.DoSql;
      reSqlInput.Lines.Text := OQBEngineIBO1.GeneratedSQL;
    end;
    if Assigned(fISQLObj) then fISQLObj.Free;
    reSQLOutput.Clear;
    fISQLObj := TIBOSqlObj.Create (Self);
    fISQLObj.Query := reSQLInput.Lines;
    fISQLObj.DataModule := DataModule;
    fISQLObj.DataSet := FQryDataSet;
    fISQLObj.OnDataOutput := UpdateOutputWindow;
    pgcOutput.ActivePage := TabResults;
    Cursor := crSQLWait;
    fISQLObj.DoPrepare;
    Cursor := crDefault;
    MemoSQLErrors.Clear;
    pgcInput.ActivePage := TabSQLInput;
    if not fISQLObj.WaitForParams then fISQLObj.Free;
  except on
    E: EIsqlException do
    begin
      Cursor := crDefault;
      pgcOutput.ActivePage := TabSQLErrors;
      MemoSQLErrors.Lines.Text := e.Message;
    end;
  end;
end;

procedure TdlgWisql.dbgSQLResultsCellClick(Column: TColumn);
begin
  if Assigned(Column.Field) and (Column.Field.DataType in [ftMemo, ftBlob]) then
    Column.ButtonStyle := cbsEllipsis;
end;

procedure TdlgWisql.dbgSQLResultsDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
  with Sender as TDBGrid do
  begin
    if Column.Field = nil then
    begin
      with Canvas do
      begin
        font.color := clBlue;
        TextRect(Rect, Rect.Left, Rect.top, NULL_STR);
      end
    end
    else
    begin
      if Column.Field.IsNull then
      begin
        with Canvas do
        begin
          font.color := clBlue;
          TextRect(Rect, Rect.Left, Rect.top, NULL_STR);
        end;
      end;
    end;
  end;
end;

procedure TdlgWisql.dbgSQLResultsEditButtonClick(Sender: TObject);
var
  FieldObj: TField;
begin
  with Sender as TDBGrid do begin
    FieldObj := SelectedField;
    if FieldObj = nil then
      LMMessageDlg(getprompt(66),mtInformation,[mbok],0)
    else begin
      case FieldObj.DataType of
        ftBlob:
           IBCDisplayBlob(self, TBlobField(FieldObj));
        ftMemo:
           IBCDisplayMemo(Self,FieldObj);
        else
          LMMessageDlg(FieldObj.DisplayName+' '+GetLangText('is unknown'),mtInformation,[mbok],0);
      end;
    end;
  end;
end;

procedure TdlgWisql.SetAutoDDL(const Value: boolean);
begin
  FAutoDDL := Value;
  if FAutoDDL then
    stbISQL.Panels[4].Text := 'AutoDDL: '+GetLangText('ON')
  else
    stbISQL.Panels[4].Text := 'AutoDDL: '+GetLangText('OFF');
end;

procedure TdlgWisql.SQLReference1Click(Sender: TObject);
var
  hlpPath: String;
begin
{$IFDEF MSWINDOWS}
  inherited;
  hlpPath := Format('%s%s',[ExtractFilePath(Application.ExeName), SQL_REFERENCE]);
  WinHelp(WindowHandle, PChar(hlpPath),HELP_FINDER,0);
{$ENDIF}
end;

procedure TdlgWisql.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  OpenWindows.UpdateWindowList(Self.Caption, TObject(Self), true);
end;

procedure TdlgWisql.FileCloseExecute(Sender: TObject);
begin
  Close;
end;

procedure TdlgWisql.Print1Click(Sender: TObject);
begin
{$IFDEF NOT_YET_IN_KYLIX}
  LMMessageDlg(GetPrompt(2), mtInformation, [mbOk], 0);
{$ELSE}
  if PrintDialog.Execute then
  begin
    SynEditPrint.SynEdit := reSqlInput;
    SynEditPrint.Print;
  end;
{$ENDIF}
end;

procedure TdlgWisql.Drop1Click(Sender: TObject);
begin
  if (CheckTransactionStatus (false) <> mrCancel) then
  begin
   if not FConnected then
      frmMain.DatabaseDrop.OnExecute (sender)
    else begin
      if LMMessageDlg(3,mtConfirmation, mbOkCancel, 0) = mrOK then
        DataModule.Connection.DropDatabase;
    end;

    if Assigned(DataModule) and not Assigned(DataModule.Connection.dbHandle) then
    begin
      OpenWindows.UpdateWindowList(Caption, TObject(Self), true);
      UpdateConnectStatus(false);
      OpenWindows.UpdateWindowList(Caption, TObject(Self));
    end;
  end;
end;

procedure TdlgWisql.Disconnect1Click(Sender: TObject);
begin
  if new_connection then
    DataModule.Connection.Connected:=False;
  if not new_connection then
    frmMain.DatabaseDisconnectExecute(Self);
end;

procedure TdlgWisql.Connect1Click(Sender: TObject);
begin
  if (CheckTransactionStatus (false) <> mrCancel) then
  begin
    new_connection:=false;
    if frmMain.ConnectAsDatabase(Self) then
    begin
      OpenWindows.UpdateWindowList(Caption, TObject(Self), true);
      UpdateConnectStatus(Assigned(DataModule) and Assigned(DataModule.Connection.dbHandle));
      OpenWindows.UpdateWindowList(Caption, TObject(Self));
      FConnected := false;
      Newconnection1.Enabled:=False;
    end;
    resqlInput.Lines.Clear;
    reSQLOutput.Lines.Clear;
    ResetISQLObj;
    fTablesloaded := False;
    UpdateListTables;
  end;
end;

procedure TdlgWisql.Create1Click(Sender: TObject);
begin
  New_Connection:=false;
  if (CheckTransactionStatus (false) <> mrCancel) then
  begin
    if CreateDatabase (Sender) then
    begin
      OpenWindows.UpdateWindowList(Caption, TObject(Self), true);
      UpdateConnectStatus(true);
      OpenWindows.UpdateWindowList(Caption, TObject(Self));
      FConnected := true;
    end;
    resqlInput.Lines.Clear;
    reSQLOutput.Lines.Clear;
    ResetISQLObj;
    fTablesloaded := False;
    UpdateListTables;
  end;
end;

function TdlgWisql.CheckTransactionStatus (const Closing: boolean): integer;
var
  retval: integer;

begin
  { If there are any outstanding transactions, ask for a commit.  If no
    commit is issued, then do not allow the form to close}
  result := mrYes;
  if Assigned (DataModule) then
  begin
    if gAppSettings[COMMIT_ON_EXIT] and Closing then
    begin
      if DataModule.Transaction.InTransaction then
        DataModule.Transaction.Commit;
      if DataModule.DDLTransaction.InTransaction then
        DataModule.DDLTransaction.Commit;
      result := mrYes;
    end
    else
    begin
      if DataModule.Transaction.TransactionIsActive or
         DataModule.DDLTransaction.TransactionIsActive then
      begin
        retval := LMMessageDlg (4,mtInformation,mbYesNoCancel, 0);
        case retval of
          mrYes:
          begin
            if DataModule.Transaction.InTransaction then
              DataModule.Transaction.Commit;
            if DataModule.DDLTransaction.InTransaction then
              DataModule.DDLTransaction.Commit;
            result := mrYes;
          end;
          mrNo:
          begin
            if DataModule.Transaction.InTransaction then
              DataModule.Transaction.Rollback;

            if DataModule.DDLTransaction.InTransaction then
              DataModule.DDLTransaction.Rollback;

            result := mrNo;
          end;
          mrCancel:
            result := mrCancel;
        end;
      end;
    end
  end;

  if (Result<>mrCancel) and Closing and Assigned(DataModule) then
  begin
    with DataModule.Connection do
    begin
      BeforeDisconnect := nil;
      if TransactionCount > 0 then
      begin
      end;
      { If a connection was made to a database (or a new database was created),
        disconnect from it now }
      if FConnected then
      begin
        DataModule.Connection.Connected := false;
        FConnected := false;
      end;
    end;
  end;
end;

procedure TdlgWisql.UpdateConnectStatus(const Connected: boolean);
var
  dbString: String;
begin
  if Assigned (sbData) then
  begin
    if Connected then
    begin
      lblFileName.Caption := DataModule.Connection.DatabaseName;
//{$IFNDEF NOT_YET_IN_KYLIX}
      dbString := MinimizeName(lblFileName.Caption, lblFileName.Canvas,
        sbData.Panels[0].Width + 10);
(*{$ELSE}
      dbString := lblFileName.Caption;
{$ENDIF}   *)
      sbData.Panels[0].Text := dbString;
      fTablesloaded := False;
      UpdateListTables;
    end
    else
    begin
      sbData.Panels[0].Text := GetLangText('Not Connected');
      reSqlInput.Lines.Clear;
      reSQLOutput.Lines.Clear;
      ResetISQLObj;
      FQueryBuffer.Clear;
      FConnected := false;
      fTablesloaded := False;
      ListBoxTables.Clear;
      ListBoxFields.Clear;
    end;
  end;
end;

procedure TdlgWisql.SetClientDialect(const Value: integer);
begin
  FCurrSQLDialect := value;
  stbISQL.Panels[2].Text := Format ('%s %d',[GetLangText('Client dialect'),FCurrSQLDialect]);
end;

procedure TdlgWisql.QueryPreviousUpdate(Sender: TObject);
begin
  if FQueryBuffer.BOC then
    if FQueryBuffer.Count <> 0 then
      (Sender as TAction).Enabled := reSqlInput.Modified
    else
      (Sender as TAction).Enabled := false
  else
    (Sender as TAction).Enabled := true;
end;

procedure TdlgWisql.ShowStatistics(const Stats: TStringList);
var
  Line,
  Option,
  Value: String;
  lCnt : integer;
  lvItem: TListItem;
begin

  lvStats.Items.BeginUpdate;
  lvStats.Items.Clear;
  for lCnt := 0 to Stats.Count - 1 do
  begin
    Line := Stats[lCnt];
    Option := GetNextField(Line, DEL);
    Value := GetNextField(Line, DEL);
    if Pos('PLAN', Value) = 1 then
      reSQLOutput.Lines.Append(Value);
    lvItem := lvStats.Items.Add;
    lvItem.Caption := Option;
    lvItem.SubItems.Add (Value);
  end;
  lvStats.Items.EndUpdate;
end;

procedure TdlgWisql.CheckDisconnect(Sender: TIB_COnnection);
begin
  if (CheckTransactionStatus (false) <> mrCancel) then
    exit;
  UpdateConnectStatus(false);
end;


procedure TdlgWisql.SaveOutputText(aFileName:String);
var
  lColDel,
  lStr : String;
  colWidth,
  i, lCnt: integer;
  BlobList,
  tmpList,
  Data: TStringList;
  blbStream: TStream;
  lBookMark: TBookMark;

begin
  Data := TStringList.Create;
  dbgSQLResults.Enabled := false;
  lBookMark := FQryDataset.GetBookmark;
  FQryDataset.First;
  with FQryDataset do
  begin
    DisableControls;
    while not EOF do
    begin
      { If this is the first record, write out the column headings }
      if BOF then
      begin
        for lCnt := 0 to FieldCount-1 do
        begin
          ColWidth := Max(Fields[lCnt].DataSize, Length(Fields[lCnt].FieldName));
          lStr := Format('%s%-*s',[lStr, ColWidth, Fields[lCnt].FieldName]);
          lStr := lStr + ' '+ ' '+ ' '+ ' ';
          for i := 0 to ColWidth-1 do
          begin
            lColDel := lColDel + '=';
          end;
          lColDel := lColDel + ' '+ ' '+ ' '+ ' ';
        end;
        Data.Add(lStr);
        Data.Add(lColDel);
      end;

      { Write the actual data }
      lStr := '';
      BlobList := nil;
      for lCnt := 0 to FieldCount - 1 do
      begin
        ColWidth := Max(Fields[lCnt].DataSize, Length(Fields[lCnt].FieldName));
        if Fields[lCnt].IsNull then
          lStr := Format('%s%-*s',[lStr, ColWidth, NULL_STR])
        else
        begin
          case Fields[lCnt].Datatype of
            ftString:
              lStr := Format('%s%-*s',[lStr, ColWidth, Fields[lCnt].AsString]);
            ftSmallint:
              lStr := Format('%s%*d',[lStr, ColWidth, Fields[lCnt].AsInteger]);
            ftInteger:
              lStr := Format('%s%*d',[lStr, ColWidth, Fields[lCnt].AsInteger]);
            ftLargeint:
            begin
              if Fields[lCnt] is TLargeintField then
                lStr := Format('%s%*d',[lStr, ColWidth, TLargeintField(Fields[lCnt]).AsLargeInt])
              else
                lStr := Format('%s%*s',[lStr, ColWidth, '????']);
            end;
            ftWord:
              lStr := Format('%s%*d',[lStr, ColWidth, Fields[lCnt].AsInteger]);
            ftFloat:
              lStr := Format('%s%*d',[lStr, ColWidth, Fields[lCnt].AsInteger]);
            ftBoolean:
              lStr := Format('%s%*s',[lStr, ColWidth, Fields[lCnt].AsString]);
            ftCurrency:
              lStr := Format('%s%*s',[lStr, ColWidth, Fields[lCnt].AsCurrency]);
            ftBCD:
              lStr := Format('%s%*s',[lStr, ColWidth, Fields[lCnt].AsString]);
            ftDate:
              lStr := Format('%s%*s',[lStr, ColWidth, DateToStr(Fields[lCnt].AsDateTime)]);
            ftTime:
              lStr := Format('%s%*s',[lStr, ColWidth, TimeToStr(Fields[lCnt].AsDateTime)]);
            ftDateTime:
              lStr := Format('%s%*s',[lStr, ColWidth, DateTimeToStr(Fields[lCnt].AsDateTime)]);
            ftMemo:
            begin
              if gAppSettings[BLOB_SUBTYPE] = 'Text' then
              begin
                tmpList := TStringList.Create;
                BlobList := TStringList.Create;
                blbStream := CreateBlobStream(Fields[lCnt], bmRead);
                tmpList.LoadFromStream(blbStream);
                tmpList.Insert(0, '====================================');
                tmpList.Insert(1, Fields[lCnt].FieldName);
                tmpList.Append('====================================');
                BlobList.AddStrings(tmpList);
                tmpList.Free;
                Continue;
              end;
              lStr := Format('%s%*s',[lStr, ColWidth, BLOB_STR]);
            end;
          end; { case }
        end; { else }
        lStr := lStr + ' '+ ' '+ ' '+ ' ';
      end;
      Data.Add(lStr);
      if Assigned (BlobList) then
      begin
        Data.AddStrings(BlobList);
        BlobList.Free;
      end;
      Next;
    end;
    Data.SaveToFile (aFileName);
    Data.Free;
    FQryDataset.GotoBookmark(lBookMark);
    FQryDataset.FreeBookmark(lBookMark);
    EnableControls;
    dbgSQLResults.Enabled := true;
    LMMessageDlg(5,[aFileName], mtInformation, [mbOk], 0);
  end;
end;

procedure TdlgWisql.SaveOutputCSV(aFileName:String);
var
  fValue,
  lStr : String;
  lCnt: integer;
  lBookMark: TBookMark;
  outfile:TextFile;

begin
  dbgSQLResults.Enabled := false;
  lBookMark := FQryDataset.GetBookmark;
  FQryDataset.First;
  AssignFile(outfile,aFileName);
  Rewrite(outfile);
  FQryDataset.DisableControls;
  while not FQryDataset.EOF do
  begin
    { If this is the first record, write out the column headings }
    if FQryDataset.BOF then
    begin
      lStr := '';
      for lCnt := 0 to FQryDataset.FieldCount-1 do
      if lStr='' then
        lStr := QuotedStr(FQryDataset.Fields[lCnt].FieldName)
      else
        lStr := lStr + ',' + QuotedStr(FQryDataset.Fields[lCnt].FieldName);
      Writeln(outfile,lStr);
    end;
    lStr := '';
    for lCnt := 0 to FQryDataset.FieldCount - 1 do
    begin
      if FQryDataset.Fields[lCnt].IsBlob and (FQryDataset.Fields[lCnt].DataType <> ftMemo) then
        fValue := ''
      else
        fValue := QuotedStr(FQryDataset.Fields[lCnt].AsString);
      if lStr='' then
        lStr := fValue
      else
        lStr := lStr + ',' + fValue;
    end;
    Writeln(outfile,lStr);
    FQryDataset.Next;
  end;
  CloseFile(outfile);
  FQryDataset.GotoBookmark(lBookMark);
  FQryDataset.FreeBookmark(lBookMark);
  FQryDataset.EnableControls;
  dbgSQLResults.Enabled := true;
  LMMessageDlg(5,[aFileName], mtInformation, [mbOk], 0);
end;

function HtmlEncode(input:String):String;
begin
  Result := StringReplace(input,'&','&amp;',[rfReplaceAll]);
  Result := StringReplace(Result,'<','&gt;',[rfReplaceAll]);
  Result := StringReplace(Result,'>','&lt;',[rfReplaceAll]);
  Result := StringReplace(Result,'"','&quot;',[rfReplaceAll]);
  Result := StringReplace(Result,'','&#169;',[rfReplaceAll]);
  Result := StringReplace(Result,'','&#174;',[rfReplaceAll]);
end;

const
htmlhead =
'<html><head><meta http-equiv="CONTENT-TYPE" CONTENT="text/html%s">'+
'<title>IBOConsole Query Output </title>'+
'</head>'+
'<body>';

opentable =
'<table border="1" cellpadding="1" cellspacing="1" style="page-break-before: always">'+
'<thead><tr valign="top">';

closetablehead =
'</tr>'+
'</thead>'+
'<tbody>';

closehtml =
'</tbody>'+
'</table>'+
'</body>'+
'</html>';


procedure TdlgWisql.SaveOutputHTML(aFileName:String);
var
  fValue: String;
  lCnt: integer;
  lBookMark: TBookMark;
  outfile:TextFile;
begin
  dbgSQLResults.Enabled := false;
  lBookMark := FQryDataset.GetBookmark;
  FQryDataset.First;
  AssignFile(outfile,aFileName);
  Rewrite(outfile);
  if FQryDataSet.IB_Connection.CharSet<>'' then
    Writeln(outfile,Format(htmlhead,['; charset='+FQryDataSet.IB_Connection.CharSet]))
  else
    Writeln(outfile,Format(htmlhead,['']));
  Writeln(outfile,opentable);
  FQryDataset.DisableControls;
  while not FQryDataset.EOF do
  begin
    { If this is the first record, write out the column headings }
    if FQryDataset.BOF then
    begin
      for lCnt := 0 to FQryDataset.FieldCount-1 do
        Writeln(outfile,Format('<th valign="top">%s</th>',[HtmlEncode(FQryDataset.Fields[lCnt].FieldName)]));
      Writeln(outfile,closetablehead);
    end;
    Writeln(outfile,'<tr>');
    for lCnt := 0 to FQryDataset.FieldCount - 1 do
    begin
      fValue := FQryDataset.Fields[lCnt].AsString;
      if fValue = '' then fValue := '&nbsp;'
      else fValue := HtmlEncode(fValue);
      Writeln(outfile,Format('<td valign="top">%s</td>',[fvalue]));
    end;
    Writeln(outfile,'</tr>');
    FQryDataset.Next;
  end;
  Writeln(outfile,closehtml);
  CloseFile(outfile);
  FQryDataset.GotoBookmark(lBookMark);
  FQryDataset.FreeBookmark(lBookMark);
  FQryDataset.EnableControls;
  dbgSQLResults.Enabled := true;
  LMMessageDlg(5,[aFileName], mtInformation, [mbOk], 0);
end;

const
xmlhead =
'<?xml version="1.0"?>'+slinebreak+
'<!-- filename:%s -->'+slinebreak+
'<!-- IBOConsole Query Output -->'+slinebreak+
'<queryresult>';

closexml =
'</queryresult>';


procedure TdlgWisql.SaveOutputXML(aFileName:String);
var
  lCnt: integer;
  lBookMark: TBookMark;
  outfile:TextFile;
  Option :string;
  Value :string;

begin
  dbgSQLResults.Enabled := false;
  lBookMark := FQryDataset.GetBookmark;
  FQryDataset.First;
  AssignFile(outfile,aFileName);
  Rewrite(outfile);
  Writeln(outfile,format(xmlhead,[aFileName]));
  Writeln(outfile,Format('<database><![CDATA[%s]]></database>',[FQryDataset.IB_Connection.Database]));
  Writeln(outfile,Format('<sql><![CDATA[%s]]></sql>',[FQryDataset.sql.text]));
  FQryDataset.DisableControls;
  Writeln(outfile,'<result>');
  while not FQryDataset.EOF do
  begin
    { If this is the first record, write out the column headings }
    Writeln(outfile,'<row>');
    for lCnt := 0 to FQryDataset.FieldCount - 1 do
    begin
      Writeln(outfile,Format('<field><name><![CDATA[%s]]></name><value><![CDATA[%s]]></value><datatype><![CDATA[%s]]></datatype></field>',
                             [FQryDataset.Fields[lCnt].FieldName,
                              FQryDataset.Fields[lCnt].asString,
                              GetEnumName(TypeInfo(TFieldType), Integer(FQryDataset.Fields[lCnt].DataType))]));
    end;
    Writeln(outfile,'</row>');
    FQryDataset.Next;
  end;
  Writeln(outfile,'</result>');

  Writeln(outfile,'<statistics>');
  for lCnt := 0 to lvStats.Items.Count - 1 do
  try
    Option := lvStats.Items[lCnt].Caption;
    Value := lvStats.Items[lCnt].SubItems[0];
    Writeln(outfile,Format('<item><option><![CDATA[%s]]></option><value><![CDATA[%s]]></value></item>',[Option,Value]));
  except
  end;
  Writeln(outfile,'</statistics>');

  Writeln(outfile,closexml);
  CloseFile(outfile);
  FQryDataset.GotoBookmark(lBookMark);
  FQryDataset.FreeBookmark(lBookMark);
  FQryDataset.EnableControls;
  dbgSQLResults.Enabled := true;
  LMMessageDlg(5,[aFileName], mtInformation, [mbOk], 0);
end;


const
dlgFilters =
             'Text files (*.txt)|*.TXT'+            //1
             '|Comma sep.values (*.csv)|*.csv'+      //2
             '|HTML files|*.htm;*.html'+               //3
             '|XML files|*.xml'               //4
{$ifdef MSWINDOWS}
             +'|XLS files (*.xls)|*.xls'             //5
{$endif}
             ;

procedure TdlgWisql.dlgSaveOutputTypeChange(Sender: TObject);
begin
// Original Idea was supplied by Akim Kalwa - for excel files
// I've applied to all types - Lorenzo
  with dlgSaveOutput do
    case FilterIndex of
      1  : begin FileName := 'noname.txt';  DefaultExt := 'txt'; end;
      2  : begin FileName := 'noname.csv';  DefaultExt := 'csv'; end;
      3  : begin FileName := 'noname.html'; DefaultExt := 'html'; end;
      4  : begin FileName := 'noname.xml'; DefaultExt := 'xml'; end;
{$ifdef MSWINDOWS}
      5  : begin FileName := 'noname.xls';  DefaultExt := 'xls'; end;
{$endif}
      else begin FileName := 'noname.';     DefaultExt := '';    end;
    end;
end;

procedure TdlgWisql.SaveOutput;
var ext:string;
begin
{$IFDEF MSWINDOWS}
    dlgSaveOutput.Options := [ofPathMustExist, ofHideReadOnly, ofOverwritePrompt];
{$ENDIF}
{$IFDEF LINUX}
    dlgSaveOutput.Options := [ofPathMustExist, ofOverwritePrompt];
{$ENDIF}
    dlgSaveOutput.Filter := dlgFilters;
    dlgSaveOutput.Title := GetPrompt(7);
    if dlgSaveOutput.Execute then
    begin
      ext := LowerCase(ExtractFileExt(dlgSaveOutPut.FileName));
      if ext='.txt' then SaveOutputText(dlgSaveOutput.FileName)
      else
      if ext='.csv' then SaveOutputCSV(dlgSaveOutput.FileName)
      else
      if ext='.htm' then SaveOutputHTML(dlgSaveOutput.FileName)
      else
      if ext='.html' then SaveOutputHTML(dlgSaveOutput.FileName)
      else
      if ext='.xml' then SaveOutputXML(dlgSaveOutput.FileName)
{$ifdef MSWINDOWS}
      else
      if ext='.xls' then SaveOutputToExcel(dlgSaveOutput.FileName)
{$ENDIF}
      else LMMessageDlg(6,mtError,[mbOk],0);
    end;
end;

procedure TdlgWisql.QuerySaveOutputUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := (Assigned(FQryDataset) and
                                 (FQryDataset.StatementType = stSelect));
end;

procedure TdlgWisql.DatabaseDisconnectUpdate(Sender: TObject);
begin
  if Assigned (DataModule) then
    (Sender as TAction).Enabled := DataModule.Connection.Connected
  else
    (Sender as TAction).Enabled := false;
end;

procedure TdlgWisql.DatabaseConnectAsUpdate(Sender: TObject);
begin
  if Assigned(frmMain.CurrSelDatabase) and
     Assigned(frmMain.CurrSelDatabase.DataModule) then
    (Sender as TAction).Enabled := true
  else
    (Sender as TAction).Enabled := false;
end;

procedure TdlgWisql.FindDialog1Find(Sender: TObject);
var
  Options: TSynSearchOptions;
begin
  Options := [];
  if not (frDown in FindDialog1.Options) then
    Include(Options, ssoBackwards);
  if frMatchCase in FindDialog1.Options then
    Include(Options, ssoMatchCase);
  if frWholeWord in FindDialog1.Options then
    Include(Options, ssoWholeWord);
  if reSqlInput.SearchReplace(FindDialog1.FindText, '', Options) = 0 then
  begin
    LMMessageDlg(67,[FindDialog1.FindText],mtInformation,[mbok],0);
    if ssoBackwards in Options then
      reSqlInput.BlockEnd := reSqlInput.BlockBegin
    else
      reSqlInput.BlockBegin := reSqlInput.BlockEnd;
    reSqlInput.CaretXY := reSqlInput.BlockBegin;
  end;
end;

procedure TdlgWisql.mnuPrevPopup(Sender: TObject);
var
  i, line : Integer;
  t : TMenuItem;
  sList : TStrings;
begin
  while mnuPrev.Items.Count > 0 do
    mnuPrev.Items[0].Free;
  if FQueryBuffer.JustPast or
     ((reSqlInput.Text = '') or (reSqlInput.Modified)) then
    i := FQueryBuffer.Current
  else
    i := FQueryBuffer.Current - 1;
  while (i >= 0) and (i >= FQueryBuffer.Current - 10) do
  begin
    t := TMenuItem.Create(mnuPrev);
    mnuPrev.Items.Add(t);
    {First non blank line}
    line := 0;
    sList := FQueryBuffer[i];
    while (line < sList.Count) and (Trim(sList[line]) = '') do
      Inc(Line);
    t.Caption := Trim(sList[line]);
    t.Tag := i;
    t.OnClick := NavMenuClick;
    Dec(i);
  end;
end;

procedure TdlgWisql.NavMenuClick(Sender: TObject);
var
  iQry: TStrings;
begin
  iQry := FQueryBuffer.Items[TMenuItem(Sender).Tag];
  FQueryBuffer.Current := TMenuItem(Sender).Tag;
  if Assigned(iQry) then
    reSQLInput.Lines := iQry
  else
    reSQLInput.Lines.Clear;
  ResetISQLObj;
  reSQLInput.Modified := FALSE;
end;

procedure TdlgWisql.mnuNextPopup(Sender: TObject);
var
  i, line : Integer;
  t : TMenuItem;
  sList : TStrings;
begin
  while mnuNext.Items.Count > 0 do
    mnuNext.Items[0].Free;
  if FQueryBuffer.JustPast then
    i := FQueryBuffer.Current
  else
    i := FQueryBuffer.Current + 1;
  while (FQueryBuffer.Count > 0) and
        (i < FQueryBuffer.Count) and
        (i < FQueryBuffer.Current + 10) do
  begin
    t := TMenuItem.Create(mnuPrev);
    mnuNext.Items.Add(t);
    {First non blank line}
    line := 0;
    sList := FQueryBuffer[i];
    while (line < sList.Count) and (Trim(sList[line]) = '') do
      Inc(Line);
    t.Caption := Trim(sList[line]);
    t.Tag := i;
    t.OnClick := NavMenuClick;
    Inc(i);
  end;
end;

function TdlgWisql.ConnectAsDatabase(Sender: Tobject): boolean;
begin
  result := false;
  if Assigned(frmMain.CurrSelDatabase) and
      frmMain.CurrSelDatabase.DataModule.Connection.Connected then
  begin
    if not Assigned(DataModule) or (DataModule <> frmMain.CurrSelDatabase.DataModule) then
      DataModule := frmMain.CurrSelDatabase.DataModule;
    result := true;
  end
  else
  begin
    try
      if Assigned(frmMain.CurrSelServer) and Assigned(frmMain.CurrSelDatabase) then
      begin
        if not frmMain.CurrSelDatabase.DataModule.Connection.Connected then
          frmMain.DoDBConnect(frmMain.CurrSelServer, frmMain.CurrSelDatabase, false, false);
      end;
      if not Assigned(DataModule) or (DataModule <> frmMain.CurrSelDatabase.DataModule) then
        DataModule := frmMain.CurrSelDatabase.DataModule;
      result := true;
    except
    end;
  end;
end;

function TdlgWisql.CreateDatabase(Sender: TObject): boolean;
begin
  result := false;
  try
    if frmMain.DoDatabaseCreate then
      if Assigned (frmMain.CurrSelDatabase) then
      begin
        DataModule := frmMain.CurrSelDatabase.DataModule;
        result := True;
      end;
  except
  end;
end;

procedure TdlgWisql.Newconnection1Click(Sender: TObject);
begin
  if (CheckTransactionStatus (false) <> mrCancel) then
  begin
    new_connection := true;
    if ConnectAsDatabase(Self) then
    begin
      OpenWindows.UpdateWindowList(Caption, TObject(Self), true);
      UpdateConnectStatus(Assigned(DataModule.Connection.dbHandle));
      OpenWindows.UpdateWindowList(Caption, TObject(Self));
      FConnected := false;
      Newconnection1.Enabled := False;
    end;
    resqlInput.Lines.Clear;
    ResetISQLObj;
    reSQLOutput.Lines.Clear;
    Caption  :=  GetLangText('Interactive SQL')+' - ' + ExtractFileName(DataModule.Connection.DatabaseName);
  end;
end;

procedure TdlgWisql.reSqlInputStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
var
  pb:TBufferCoord;
begin
  pb := reSqlInput.CaretXY;
  stbISQL.Panels[0].Text := Format('%6d:%3d', [pb.Line, pb.Char]);
  if reSQlInput.Modified then
    stbISQL.Panels[1].Text := GetLangText('Modified')
  else
    stbISQL.Panels[1].text := '';
end;

procedure TdlgWisql.EditFontExecute(Sender: TObject);
begin
  FontDialog1.Font.Assign(reSqlInput.Font);
  if FontDialog1.Execute then
  begin
    reSqlInput.Font.Assign(FontDialog1.Font);
    reSqlInput.SetFocus;
  end;
end;

procedure TdlgWisql.EditFindUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (reSqlInput.Text <> '');
end;

procedure TdlgWisql.SaveSQLHistoryExecute(Sender: TObject);
begin
  if dlgHistorySave.Execute then
  begin
    if FileExists(dlgHistorySave.FileName) then
      if LMMessageDlg(0, [dlgHistorySave.FileName],mtConfirmation, mbYesNoCancel, 0) <> mrYes then Exit;
    FQueryBuffer.SaveToFile(dlgHistorySave.FileName);
  end;
end;

procedure TdlgWisql.LoadSQLHistoryExecute(Sender: TObject);
begin
  if dlgHistoryLoad.Execute then
  begin
    try
      Screen.Cursor := crHourGlass;
      try
        FQueryBuffer.LoadFromFile(dlgHistoryLoad.FileName);
      except
        on E:Exception do
        begin
          LMMessageDlg(E.Message + #10#13+ Format(getPrompt(1),[dlgHistoryLoad.FileName]), mtError, [mbOK], 0);
          Exit;
        end;
      end;
      reSQLInput.SetFocus;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TdlgWisql.QueryFetchAllUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := Assigned(GridSource.DataSet) and
    (GridSource.DataSet is TIBOQuery) and
    (TIBOQuery(GridSource.DataSet).StatementType in [stSelect, stSelectForUpdate]) and
    (not Assigned(lvStats.FindCaption(0, GetLangText('Rows Affected'), false, false, false)));
end;

procedure TdlgWisql.QueryFetchAllExecute(Sender: TObject);
var
  temp : TListItem;
begin
  TIBOQuery(GridSource.DataSet).FetchAll;
  temp := lvStats.FindCaption(0, GetLangText('Rows Affected'), false, false, false);
  if not Assigned(temp) then
  begin
    temp := lvStats.Items.Add;
    temp.Caption := GetLangText('Rows Affected');
    temp.SubItems.Add (IntToStr(TIBOQuery(GridSource.DataSet).RecordCount));
  end;
end;

procedure TdlgWisql.DB_KEYGetText(Sender: TField; var Text: String;
  DisplayText: Boolean);
var
  i : Integer;
  p, c : Pointer;
begin
  GetMem(c, Sender.Size * 2);
  try
    Sender.DataSet.GetFieldData(Sender, c, true);
    for i := 0 to (Sender.Size div 4) - 1 do
    begin
      p := Pointer(Integer(c) + i * 4);
      Text := Text + Format('%-8.8x', [Integer(p^)]);
    end;
  finally
    FreeMem(c, Sender.Size * 2);
  end;
end;

procedure TdlgWisql.SaveOutputToExcel(aFileName: String);
begin
// from original by Kalwa
  with TXLSExport.Create(Self) do
  try
    DataSet := dbgSQLResults.DataSource.DataSet;
    FileName := aFileName;
    ExportDataSet();
  finally
    Free;
  end;
(* old code:
  scExcelExport1.Dataset := dbgSQLResults.DataSource.DataSet;
  scExcelExport1.ExportDataset();
*)
end;

procedure TdlgWisql.EditCopy1Execute(Sender: TObject);
begin
  reSqlInput.CopyToClipboard;
end;

procedure TdlgWisql.EditCut1Execute(Sender: TObject);
begin
  reSqlInput.CutToClipboard;
end;

procedure TdlgWisql.EditPaste1Execute(Sender: TObject);
begin
  reSqlInput.PasteFromClipboard;
end;

procedure TdlgWisql.EditSelectAll1Execute(Sender: TObject);
begin
  reSqlInput.SelectAll;
end;

procedure TdlgWisql.EditUndo1Execute(Sender: TObject);
begin
  reSqlInput.Undo;
end;

procedure TdlgWisql.EditCopy1Update(Sender: TObject);
begin
  EditCopy1.Enabled := reSqlInput.SelAvail;
end;

procedure TdlgWisql.EditCut1Update(Sender: TObject);
begin
  EditCut1.Enabled := reSqlInput.SelAvail;
end;

procedure TdlgWisql.EditPaste1Update(Sender: TObject);
begin
  EditPaste1.Enabled := reSqlInput.CanPaste;
end;

procedure TdlgWisql.EditUndo1Update(Sender: TObject);
begin
  EditUndo1.Enabled := reSqlInput.CanUndo;
end;

procedure TdlgWisql.EditRedoExecute(Sender: TObject);
begin
  reSqlInput.Redo;
end;

procedure TdlgWisql.EditRedoUpdate(Sender: TObject);
begin
  EditRedo.Enabled := reSqlInput.CanRedo;
end;

procedure TdlgWisql.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := CheckTransactionStatus (true) <> mrCancel;
end;

procedure TdlgWisql.SetDataModule(const Value: TDmN);
var xValue: TDmN;
begin
  if value <> DataModule then
    xValue := DataModule
  else
    xValue := nil;
  Inherited SetDataModule(Value);
  if Assigned(DataModule) then
  begin
    IB_TransactionBarDefault.IB_Transaction := DataModule.Transaction;
    IB_TransactionBarDDL.IB_Transaction := DataModule.DDLTransaction;
    OQBEngineIBO1.Connection := DataModule.Connection;
    OQBEngineIBO1.Transaction := DataModule.Transaction;
    if Assigned(fQBArea) then fQBArea.QBDialog := OQBuilderDialog1;
    if Assigned(fQBArea) then fQBGrid.QBDialog := OQBuilderDialog1;
  end
  else
  begin
    IB_TransactionBarDefault.IB_Transaction := Nil;
    IB_TransactionBarDDL.IB_Transaction := Nil;
    OQBEngineIBO1.Connection := Nil;
    OQBEngineIBO1.Transaction := Nil;
    //if Assigned(fQBArea) then fQBArea.QBDialog := OQBuilderDialog1;
    //if Assigned(fQBArea) then fQBGrid.QBDialog := OQBuilderDialog1;
  end;
  if fOwnedDataModule and assigned(xValue) then xValue.Free;
  fOwnedDataModule := false;
end;

procedure TdlgWisql.DatabaseCreateUpdate(Sender: TObject);
begin
  DatabaseCreate.Enabled := Assigned(frmMain.CurrSelServer) and frmMain.CurrSelServer.Alive;
end;

procedure TdlgWisql.UpdateListTables;
begin
  if not fTablesloaded and Assigned(DataModule) then
  begin
    Application.ProcessMessages;
    ListBoxTables.Clear;
    ListBoxFields.Clear;
    ib_schema.SchemaRelationNames(DataModule.Connection,DataModule.Transaction,gAppSettings[SYSTEM_DATA],True,True,ListBoxTables.Items);
    fTablesloaded:=true;
    ListBoxTables.Refresh;
  end;
end;

procedure TdlgWisql.FormShow(Sender: TObject);
begin
  pgcOutput.ActivePageIndex := 0;
  if Start then
  begin
    if (fpgcOutputHeight>0) then pgcOutput.Height := fpgcOutputHeight;
    UpdateListTables;
  end;
end;

function TdlgWisql.GetExtra: Word;
begin
  Result := pgcOutput.Height;
end;

procedure TdlgWisql.SetExtra(const Value: Word);
begin
  fpgcOutputHeight := Value;
end;

const Spacing = 4;
      EditsGap = 8;
      TotalHeight = 33;
      ControlsHeight = 21;
      MaskEditWidth = 225;
      RadioGroupWidth = 105;
      LabelWidth = 110;
      ComboBoxWidth = 75;
      CheckBoxWidth = 113;

procedure TdlgWisql.CreateParamEditControls;
var TopLeftPoint:TPoint;
    n:integer;
    fLabel:TLabel;
    maxw:integer;
begin
  if not assigned(fISQLObj) then exit;
  TopLeftPoint.X := Spacing;
  TopLeftPoint.Y := Spacing;
  fLabel:= TLabel.Create(ScrollBoxParams);
  try
    fLabel.Parent := ScrollBoxParams;
    fLabel.AutoSize := true;
    fLabel.Layout := tlCenter;
    fLabel.Top := 0;
    fLabel.Left := 0;
    maxw:=20;
    for n:=0 to High(fISQLObj.params) do
    begin
      fLabel.Caption := fISQLObj.params[n].Name;
      if maxw<fLabel.Width then
        maxw:=fLabel.Width;
    end;
  finally
    fLabel.Free;
  end;
  fLabelsWidth:=maxw;

  for n:=0 to High(fISQLObj.params) do
  begin
    CreateParamEdit(n,TopLeftPoint);
  end;
end;


const
  EditLabelWidth = 150;
  DBMemoWidth = 320;
  DBMemoHeight = DBMemoWidth * 3 div 4;

procedure TdlgWisql.CreateParamEdit(ParamIndex:integer; var TopLeftPoint:TPoint);
var
  fEdit: TEdit;
  fLabel: TLabel;
  X,Y:integer;
begin
  X := TopLeftPoint.X;
  Y := TopLeftPoint.Y;

  fLabel:= TLabel.Create(ScrollBoxParams);
  fLabel.Parent := ScrollBoxParams;
  fLabel.AutoSize := False;
  fLabel.Layout := tlCenter;
  fLabel.Top := Y;
  fLabel.Left := X;
  fLabel.Width := fLabelsWidth;
  fLabel.Height := ControlsHeight;
  fLabel.Caption := fISQLObj.params[ParamIndex].Name;
  X := X + Spacing + fLabel.Width;

  fEdit:= TEdit.Create(ScrollBoxParams);
  fEdit.Parent := ScrollBoxParams;
  fEdit.Top := Y;
  fEdit.Left := X;
  fEdit.Width := MaskEditWidth;
  fEdit.Height := ControlsHeight;
  fEdit.Tag := ParamIndex;
  fEdit.OnKeyDown := ParamEditKeyDown;
  Y := Y + fEdit.Height + Spacing;

  TopLeftPoint.Y := Y;
end;

procedure TdlgWisql.DestroyParamControls;
begin
  while (ScrollBoxParams.ComponentCount>0) do
  try
    try
      ScrollBoxParams.Components[0].Free;
    finally
    end;
  except
  end;
  tsParameters.TabVisible := False;
  pgcOutput.ActivePage := TabData;
end;

function TdlgWisql.ParseDBCreate: boolean;
var
  lLine: String;
  lStart:integer;
  lEnd:integer;
begin
  lLine := AnsiUpperCase(Trim(reSQLInput.Lines.Text));
  lStart := Pos('/*', lLine);
  while (lStart >0) and (lLine<>'') do
  begin
    lEnd := PosEx('*/', lLine, lStart);
    if lend>0 then
    begin
      delete(lline,lStart,lEnd-lStart+2);
    end;
    lStart := Pos('/*', lLine);
  end;
  (* A database can be created using CREATE DATABASE or CREATE SCHEMA *)
  result := (Pos ('CREATE DATABASE', lLine) >0)
            or (Pos ('CREATE SCHEMA', lLine) >0);
end;

procedure TdlgWisql.reSqlInputChange(Sender: TObject);
begin
  ResetISQLObj;
end;

procedure TdlgWisql.ResetISQLObj;
begin
  if Assigned(fISQLObj) and fISQLObj.WaitForParams then
  begin
    FreeAndNil(fISQLObj);
    DestroyParamControls;
  end;
end;


procedure TdlgWisql.ParamEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_RETURN) and Assigned(fISQLObj) and fISQLObj.WaitForParams then
    QueryExecute.Execute;
end;


procedure TdlgWisql.QueryExecuteUpdate(Sender: TObject);
begin
  if pgcInput.ActivePage = TabQueryBuilder then
    (Sender as TAction).Enabled := OQBuilderDialog1.CanGenerateSQL
  else
    (Sender as TAction).Enabled :=
        (reSQlInput.Lines.Count > 0)
        or (Assigned(fISQLObj) and fISQLObj.HasParams)
        or ParseDBCreate;
end;

procedure TdlgWisql.QuerySaveScriptUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := (reSQlInput.Lines.Count > 0);
end;

procedure TdlgWisql.QueryPrepareUpdate(Sender: TObject);
begin
  if pgcInput.ActivePage = TabQueryBuilder then
    (Sender as TAction).Enabled := OQBuilderDialog1.CanGenerateSQL
  else
    (Sender as TAction).Enabled := (reSQlInput.Lines.Count > 0) or (Assigned(fISQLObj) and fISQLObj.HasParams);
end;

procedure TdlgWisql.SpeedButton2Click(Sender: TObject);
var
  pt: TPoint;
begin
  pt := PanelTopButtons.ClientToScreen(SpeedButton2.BoundsRect.TopLeft);
  pt.Y := pt.Y + SpeedButton2.Height+1;
  mnuPrev.Popup(pt.X, pt.Y);
end;

procedure TdlgWisql.SpeedButton4Click(Sender: TObject);
var
  pt: TPoint;
begin
  pt := PanelTopButtons.ClientToScreen(SpeedButton4.BoundsRect.TopLeft);
  pt.Y := pt.Y + SpeedButton4.Height+1;
  mnuNext.Popup(pt.X, pt.Y);
end;

procedure TdlgWisql.FormCreate(Sender: TObject);
var n:integer;
begin
  for n:= Low(ReservedTokens) to High(ReservedTokens) do
  begin
    SynCompletionProposal1.InsertList.Add(ReservedTokens[n]);
    SynCompletionProposal1.ItemList.Add(ReservedTokens[n]);
  end;

  fTablesloaded:=False;
  fOwnedDataModule := false;

  qbSelectAll   := GetLangText(qbSelectAll);
  qbUnselectAll := GetLangText(qbUnselectAll );
  qbUnlink      := GetLangText(qbUnlink      );
  qbClose       := GetLangText(qbClose       );
  qbLinkOptions := GetLangText(qbLinkOptions );
  //qbShow        := GetLangText(qbShow        );
  //qbGroup       := GetLangText(qbGroup       );
  //qbField       := GetLangText(qbField       );
  //qbTable       := GetLangText(qbTable       );
  //qbSort        := GetLangText(qbSort        );
  //qbFunction    := GetLangText(qbFunction    );
  sNotValidTableParent :=GetPrompt(127);
  sTableAlreadyInserted:=GetPrompt(128);
  sTableAlreadyLinked  :=GetPrompt(129);
  qbFileMismatch       :=GetPrompt(130);
  qbColumnsNotSelected :=GetPrompt(131);


end;

procedure TdlgWisql.aAddTableUpdate(Sender: TObject);
begin
  aAddTable.Enabled := ListBoxTables.ItemIndex<>-1;
end;

procedure GetPoint(se:TSynEdit;s:string;var p:TBufferCoord);
begin
  if se.SearchReplace(s,'',[ssoEntireScope])>0 then
  begin
    p := se.CaretXY
  end
  else
  begin
    p.Line := 0;
    p.Char := 0;
  end
end;

procedure TdlgWisql.aAddTableExecute(Sender: TObject);
var ps,pf:TBufferCoord;
    s:string;
begin
  if ListBoxTables.ItemIndex<>-1 then
  begin
    s:= DataModule.Connection.mkIdent(ListBoxTables.Items[ListBoxTables.itemindex]);
    GetPoint(reSqlInput,'select',ps);
    GetPoint(reSqlInput,'from',pf);
    if pf.Line>0 then
    begin
      if pf.Line>=(reSqlInput.Lines.Count-1) then
        reSqlInput.Lines.add('join '+s)
      else
        reSqlInput.Lines.Insert(pf.Line+1,'join '+s);
    end
    else
      reSqlInput.Lines.Add('from '+s);
    reSqlInput.Modified := true;
  end;
end;

procedure TdlgWisql.ListBoxTablesClick(Sender: TObject);
begin
  if (ListBoxTables.ItemIndex<>-1) and Assigned(DataModule) then
  begin
    ListBoxFields.Clear;
    ib_schema.SchemaFieldNames(DataModule.Connection,DataModule.Transaction,ListBoxFields.Items,ListBoxTables.Items[ListBoxTables.itemindex]);
    ListBoxFields.Items.Insert(0,'*');
  end;
end;

procedure TdlgWisql.aAddFieldUpdate(Sender: TObject);
begin
  aAddField.Enabled := ListBoxFields.ItemIndex<>-1;
end;

procedure TdlgWisql.aAddFieldExecute(Sender: TObject);
var ps,pf,pj:TBufferCoord;
    sl:TStringList;
    usealias:boolean;

    function CheckName(const Name:string):string;
    begin
      Result:=DataModule.Connection.mkIdent(Name);
      if (FCurrSQLDialect=3) then
      begin
        if AnsiPos(' '+Result+' ',ReservedTokens2)>0 then
          Result:='"'+Result+'"';
      end;
    end;

    procedure AddFields;
    var
      n:integer;
    begin
      for n:=0 to sl.Count-1 do
      begin
        if (n=0) and (ps.Line=0) then
          reSqlInput.Lines.Add('select '+sl[n])
        else
          reSqlInput.Lines.Add('     , '+sl[n]);
      end
    end;

    procedure InsertFields(const Start:integer);
    var
      n:integer;
      s:string;
    begin
      for n:=0 to sl.Count-1 do
      begin
        if (n=0) and (ps.Line=0) then
          s:= 'select '
        else
          s:= '     , ';
        reSqlInput.Lines.Insert(Start-1+n,s+sl[n])
      end
    end;

var
  n:integer;
begin
  if ListBoxFields.SelCount>0 then
  begin
    sl:=TStringList.Create;
    try
      if ListBoxFields.Selected[0] then
        sl.Add('*')
      else
      begin
        GetPoint(reSqlInput,'join',pj);
        usealias := CheckBoxUseAlias.Checked or (pj.Line>0);
        for n:=0 to ListBoxFields.Count-1 do
          if ListBoxFields.Selected[n] then
          begin
            if usealias then
            begin
              sl.Add(CheckName(ListBoxTables.Items[ListBoxTables.itemindex]) +
                  '.'+ CheckName(ListBoxFields.Items[n]));
            end
            else
              sl.Add(CheckName(ListBoxFields.Items[n]))
          end;
      end;
      GetPoint(reSqlInput,'select',ps);
      GetPoint(reSqlInput,'from',pf);
      if pf.Line=0 then
        AddFields
      else
        InsertFields(pf.Line);
      reSqlInput.Modified := true;
    finally
      sl.Free;
    end;
  end;
end;

procedure TdlgWisql.PanelLeftResize(Sender: TObject);
begin
  ButtonAddTable.Width := PanelAddTable.ClientWidth;
  CheckBoxUseAlias.Width := PanelAddTable.ClientWidth;
  ButtonAddField.Width := PanelAddField.ClientWidth;
end;

procedure TdlgWisql.ListBoxTablesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key:=0;
    aAddTable.Execute;
  end;
end;

procedure TdlgWisql.ListBoxFieldsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key:=0;
    aAddField.Execute;
  end;
end;

function TdlgWisql.GetPagesHeight: Integer;
begin
  Result := pgcOutput.Height;
end;

function TdlgWisql.GetQBArea: TOQBArea;
begin
  Result := fQBArea;
end;

function TdlgWisql.GetQBButtons: TOQBbuttons;
begin
  Result := [bSelectDBDialog, bOpenDialog, bSaveDialog, bRunQuery, bSaveResultsDialog];
end;

function TdlgWisql.GetQBDialog: TOQBuilderDialog;
begin
  Result := OQBuilderDialog1;
end;

function TdlgWisql.GetQBGrid: TOQBGrid;
begin
  result := fQBGrid;
end;

function TdlgWisql.GetQBModified: boolean;
begin
  result := fQBModified;
end;

function TdlgWisql.GetQBOptions: TOQBOptions;
begin
  result := [opShowTables, opShowPages];
end;

function TdlgWisql.GetQBTables: TListBox;
begin
  Result := ListBoxTables;
end;

function TdlgWisql.GetQBTablesWidth: Integer;
begin
  Result := ListBoxTables.Width;
end;

procedure TdlgWisql.SetFormScreenPosition(const aTop, aLeft, aHeight, aWidth:Integer; aWindowState:TWindowState);
begin
  // nothing to do
end;

procedure TdlgWisql.SetPagesHeight(const Value: Integer);
begin
  // nothing to do
end;

procedure TdlgWisql.SetQBButtons(const Value: TOQBbuttons);
begin
  // nothing to do
end;

procedure TdlgWisql.SetQBDialog(const Value: TOQBuilderDialog);
begin
  // nothing to do
end;

procedure TdlgWisql.SetQBModified(const Value: boolean);
begin
  fQBModified := Value;
end;

procedure TdlgWisql.SetQBOptions(const Value: TOQBOptions);
begin
  // nothing to do
end;

procedure TdlgWisql.SetQBTablesWidth(const Value: Integer);
begin
  // nothing to do
end;

procedure TdlgWisql.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
end;

procedure TdlgWisql.ClearQBuilder;
var
  i : integer;
  TempTable : TOQBTable;
begin
  for i:=fQBArea.ControlCount-1 downto 0 do
    if fQBArea.Controls[i] is TOQBTable then
      begin
        TempTable:=TOQBTable(fQBArea.Controls[i]);
        fQBGrid.RemoveColumn4Alias(TempTable.TableAlias);
        TempTable.Free;
      end
    else
      fQBArea.Controls[i].Free; // QBLink
  fQBModified := False;
end;


procedure TdlgWisql.DoOnStart;
begin
  OQBuilderDialog1.QBForm := Self;

  fQBArea := TOQBArea.Create(Self);
  fQBGrid := TOQBGrid.Create(Self);

  fQBArea.Parent := TabQueryBuilder;
  fQBArea.Align := alClient;
  fQBArea.Color := clAqua;
  fQBArea.Visible := true;

  fQBGrid.Parent := TabColumns;
  fQBGrid.Align := alClient;
  fQBGrid.Visible := true;

  fQBGrid.QBDialog := OQBuilderDialog1;
  fQBArea.QBDialog := OQBuilderDialog1;


  if Assigned(DataModule) then
  begin
    OQBEngineIBO1.Connection := DataModule.Connection;
    OQBEngineIBO1.Transaction := DataModule.Transaction;
  end;
  fQBModified := False;
end;

procedure TdlgWisql.TabQueryBuilderShow(Sender: TObject);
begin
  pgcOutput.ActivePage := TabColumns;
end;

procedure TdlgWisql.QueryLoadScriptHint(var HintStr: String;
  var CanShow: Boolean);
begin
  if pgcInput.ActivePage = TabQueryBuilder then
    HintStr := 'Load SQL Model'
  else
    HintStr := 'Load SQL Script';
end;

procedure TdlgWisql.QuerySaveScriptHint(var HintStr: String;
  var CanShow: Boolean);
begin
  if pgcInput.ActivePage = TabQueryBuilder then
    HintStr := 'Save SQL Model'
  else
    HintStr := 'Save SQL Script';
end;

procedure TdlgWisql.pgcInputChange(Sender: TObject);
begin
  if pgcInput.ActivePage = TabQueryBuilder then
    pgcOutput.ActivePage := TabColumns;
end;

procedure TdlgWisql.FormDestroy(Sender: TObject);
begin
  if fOwnedDataModule and Assigned(DataModule) then
  begin
    fOwnedDataModule := false;
    DataModule.Free;
    inherited DataModule := Nil;
  end
end;

end.


